#include "actlist.h"

ActorList::ActorList(){
  listSize=0;
  first=NULL;
  end=NULL;
}

ActorList::~ActorList(){
  ALLDelete();
}

int ActorList::ContactRect(BirdActor *act1,BirdActor *act2){
  int flag0=0;
  int Xs1,Xe1,Ys1,Ye1;
  int Xs2,Xe2,Ys2,Ye2;

  Xs1=act1->px-(act1->width/2);
  Ys1=act1->py-(act1->height/2);
  Xe1=Xs1+act1->width;
  Ye1=Ys1+act1->height;

  Xs2=act2->px-(act2->width/2);
  Ys2=act2->py-(act2->height/2);
  Xe2=Xs2+act2->width;
  Ye2=Ys2+act2->height;

  if(Xs1<Xe2){
    if(Ys1<Ye2){
      if(Xs2<Xe1){
	if(Ys2<Ye1){
	  flag0=1;
	}
      }
    }
  }

  return flag0;
}

void ActorList::Append(BirdActor *node){
  if(end==NULL){
    /*
    std::cout<<"APPEND FIRST"<<std::endl;
    */
    first=node;
    end=node;
    node->next=NULL;
    node->prev=NULL;
  }
  else{
    //   std::cout<<"APPEND NORMAL"<<std::endl;
    if(end->next==NULL){
      end->next=node;
      node->prev=end;
      node->next=NULL;
      end=node;
    }
    else{
      //     std::cout<<"APPEND ERROR"<<std::endl;
    }
  }
  listSize++;
}

void ActorList::Prepend(BirdActor *node){
  if(first==NULL){
    first=node;
    end=node;
    node->prev=NULL;
    node->next=NULL;
  }
  else{
    node->next=first;
    node->prev=NULL;
    first->prev=node;
    first=node;
  }
  listSize++;
}

void ActorList::Insert(BirdActor *node,BirdActor *target){
  if(target->prev==NULL){
    node->next=target;
    node->prev=NULL;
    target->prev=node;
    first=node;
  }
  else{
    node->next=target;
    node->prev=target->prev;
    (target->prev)->next=node;
    target->prev=node;
  }
  listSize++;
}

void ActorList::Reject(BirdActor *node){
  if(node->next==NULL){
    if(node->prev==NULL){
      //	std::cout<<"ALL REJECT"<<std::endl;
      first=NULL;
      end=NULL;
    }
    else{
      //	std::cout<<"END REJECT"<<std::endl;
      (node->prev)->next=NULL;
      end=node->prev;
    }
  }
  else{
    if(node->prev==NULL){
      /*
	std::cout<<"REJECT FIRST"<<std::endl;
	std::cout<<"NODE_NEXT :"<<(node->next)->num<<std::endl;
      */
      (node->next)->prev=NULL;
      first=node->next;
    }
    else{
      /*
	std::cout<<"REJECT NORMAL"<<std::endl;
      std::cout<<"NODE_NEXT :"<<(node->next)->num<<std::endl;
      std::cout<<"NODE_PREV :"<<(node->prev)->num<<std::endl;
      */
      (node->next)->prev=node->prev;
      (node->prev)->next=node->next;
    }
  }
  node->next=NULL;
  node->prev=NULL;

  listSize--;
}

void ActorList::ALLDelete(){
  BirdActor *node;
  BirdActor *tmp;

  node=first;
  while(node){
    tmp=node->next;
    ActorList::Reject(node);
    delete node;
    node=tmp;
  }
  if(listSize==0){
    std::cout<<"ACTOR ALL DELETE!"<<std::endl;  
  }
  else{
       std::cout<<"ACTOR ERROR NO ALL DELETE"<<std::endl;
  }
}


void DistA_OneX(int dx,int dy,int *mx,int *my,int l){
  int a;
  a=dx*10/dy;
  
  *mx=l;
  *my=l*10/a;
}
void DistA_OneY(int dx,int dy,int *mx,int *my,int l){
  int a;
  a=dy*10/dx;
  *mx=l*10/a;
  *my=l;
}
void DistA_OneXY(int dx,int dy,int *mx,int *my,int l){
  *mx=l;
  *my=l;
}

void (*DISTAPPROX_ONE[4])(int dx,int dy,int *mx,int *my,int l)={
  DistA_OneX,DistA_OneY,
  DistA_OneXY,DistA_OneXY
};

void DistA_One(int dx,int dy,int *mx,int *my,int l){
  int flag;
  flag=(dy==dx)<<1;
  flag+=(dy>dx);

  (*DISTAPPROX_ONE[flag])(dx,dy,mx,my,l);
}

void DistA_TwoX(int dx,int dy,int *mx,int *my,int l){
  int a;
  a=dx*-10/dy;  
  *mx=-l;
  *my=l*10/a;
}
void DistA_TwoY(int dx,int dy,int *mx,int *my,int l){
  int a;
  a=dy*-10/dx;
  *mx=-l*10/a;
  *my=l;
}
void DistA_TwoXY(int dx,int dy,int *mx,int *my,int l){
  *mx=-l;
  *my=l;
}

void (*DISTAPPROX_TWO[4])(int dx,int dy,int *mx,int *my,int l)={
  DistA_TwoX,DistA_TwoY,
  DistA_TwoXY,DistA_TwoXY
};

void DistA_Two(int dx,int dy,int *mx,int *my,int l){
  int flag;
  flag=(dy==-1*dx)<<1;
  flag+=(dy>-1*dx);

  (*DISTAPPROX_TWO[flag])(dx,dy,mx,my,l);
}

void DistA_ThrX(int dx,int dy,int *mx,int *my,int l){
  int a;
  a=dx*-10/dy;
  *mx=l;
  *my=-l*10/a;
}
void DistA_ThrY(int dx,int dy,int *mx,int *my,int l){
  int a;
  a=dy*-10/dx;
  *mx=l*10/a;
  *my=-l;
}
void DistA_ThrXY(int dx,int dy,int *mx,int *my,int l){
  *mx=l;
  *my=-l;
}

void (*DISTAPPROX_THR[4])(int dx,int dy,int *mx,int *my,int l)={
  DistA_ThrX,DistA_ThrY,
  DistA_ThrXY,DistA_ThrXY
};

void DistA_Thr(int dx,int dy,int *mx,int *my,int l){
  int flag;
  flag=(-1*dy==dx)<<1;
  flag+=(-1*dy>dx);

  (*DISTAPPROX_THR[flag])(dx,dy,mx,my,l);
}

void DistA_FouX(int dx,int dy,int *mx,int *my,int l){
  int a;
  a=dx*10/dy;
  *mx=-l;
  *my=-l*10/a;
}
void DistA_FouY(int dx,int dy,int *mx,int *my,int l){
  int a;
  a=dy*10/dx;
  *mx=-l*10/a;
  *my=-l;
}
void DistA_FouXY(int dx,int dy,int *mx,int *my,int l){
  *mx=-l;
  *my=-l;
}

void (*DISTAPPROX_FOU[4])(int dx,int dy,int *mx,int *my,int l)={
  DistA_FouX,DistA_FouY,
  DistA_FouXY,DistA_FouXY
};

void DistA_Fou(int dx,int dy,int *mx,int *my,int l){
  int flag;
  flag=(-1*dy==-1*dx)<<1;
  flag+=(-1*dy>-1*dx);

  (*DISTAPPROX_FOU[flag])(dx,dy,mx,my,l);
}

void DistA_0x_Py(int dx,int dy,int *mx,int *my,int l){
  *my=l;
  *mx=0;
}
void DistA_0x_My(int dx,int dy,int *mx,int *my,int l){
  *my=-l;
  *mx=0;
}
void DistA_0y_Px(int dx,int dy,int *mx,int *my,int l){
  *my=0;
  *mx=l;
}
void DistA_0y_Mx(int dx,int dy,int *mx,int *my,int l){
  *my=0;
  *mx=-l;
}

void (*DISTAPPROX[16])(int dx,int dy,int *mx,int *my,int l)={
  DistA_Fou,DistA_Two,DistA_Thr,DistA_One,
  DistA_0y_Mx,DistA_0y_Mx,DistA_0y_Px,DistA_0y_Px,
  DistA_0x_My,DistA_0x_Py,DistA_0x_My,DistA_0x_Py,
  DistA_0x_My,DistA_0x_Py,DistA_0x_My,DistA_0x_Py
};

void DistApprox(int *sx,int *sy,int tx,int ty,int force){
  int dx,dy,flag;
  dx=tx-*sx;
  dy=ty-*sy;
  
  flag=(dx==0)<<1;
  flag=(flag+(dy==0))<<1;
  flag=(flag+(dx>0))<<1;
  flag=(flag+(dy>0));
  (*DISTAPPROX[flag])(dx,dy,sx,sy,force);
}

int ActorList::TwoDimensionSpace(BirdActor *act,BirdActor *target){
  int  space0;

  if(act->py<target->py){
    if(act->px<target->px){
      space0=1;
    }
    else{
      space0=2;
    }
  }
  else{
    if(act->px<target->px){
      space0=3;
    }
    else{
      space0=4;
    }
  }
  return space0;
}
