#ifndef BIRD_BOSS_BASE_H_
#define BIRD_BOSS_BASE_H_

#include <gtkmm.h>
#include <cmath>
#include "actlist.h"
#include "basestage.h"

#define ANGLE_MAX 360
#define ANGLE_FLOAT 16384

#define MATH_FLOAT 256

#define BOSS_ACT_INIT 0
#define BOSS_ACT_BGRUN 1
#define BOSS_ACT_BGSTOP 2
#define BOSS_ACT_END 3

class BirdPoint{
 public:
  int x;
  int y;
};

class BossBase {
 public:
  int SIN[ANGLE_MAX];
  int COS[ANGLE_MAX];
  int bossMode;
  int bossState;
  int bossMove;
  int bossAngle;
  int bossAttack;
  int bossExplode;
  int bossCount;
  int bossTarget;
  int bossATarget;
  int bossAttackFreq;
  int bossTarX;
  int bossTarY;
  int bossATarX;
  int bossATarY;
  int bossMoveCount;
  int bossAngleCount;
  int bossAttackCount;
  int bossTargetCount;
  int bossATargetCount;
  int bossExplodeCount;
  BirdActor *boss;
  Glib::RefPtr<Gdk::GC> blueGC;
  Glib::RefPtr<Gdk::GC> yellowGC;
  Glib::RefPtr<Gdk::GC> redGC;
  Glib::RefPtr<Gdk::GC> orangeGC;
  Glib::RefPtr<Gdk::GC> lifeColorGC;
  BirdMap *Map;
  BirdColor *color;
  BirdText *text;
  BirdControl *control;
  BirdPlayer *player;
  PlayerFire *pfireList;
  EnemyFire *efireList;
  BirdEnemy *enemyList;
  BirdLand *landList;
  BaseStage *baseStage;
  Glib::RefPtr<Gdk::Pixmap> frame;
  Glib::RefPtr<Gdk::Window> mWindow;
  BossBase();
  ~BossBase();
  void BaseCreate(BaseStage *baseStage0,
	      Glib::RefPtr<Gdk::Window> mWindow0,
	      Glib::RefPtr<Gdk::Pixmap> frame0);

  void LifeView(int life,int maxLife);

  int ReachPoint(BirdActor *act,int sx,int sy);
  int CompareFigR(int sx,int sy,BirdPoint p1,BirdPoint p2);
  
  int FigureRange(int sx,int sy,BirdPoint *point,int n);
  /*
  void ContactFire();
  */
  void TouchPlayer();

};

#endif
