#include "bosscrowd.h"

BossCrowd::BossCrowd(){
  lifeList[BOSS_CROWD_MODE_VEASY]=200;
  lifeList[BOSS_CROWD_MODE_EASY]=300;
  lifeList[BOSS_CROWD_MODE_NORMAL]=300;
  lifeList[BOSS_CROWD_MODE_HARD]=400;
  lifeList[BOSS_CROWD_MODE_VHARD]=400;

  formChange[BOSS_CROWD_MODE_VEASY]=BOSS_CROWD_VEASY_FORM_CHANGE;
  formChange[BOSS_CROWD_MODE_EASY]=BOSS_CROWD_EASY_FORM_CHANGE;
  formChange[BOSS_CROWD_MODE_NORMAL]
    =BOSS_CROWD_NORMAL_FORM_CHANGE;
  formChange[BOSS_CROWD_MODE_HARD]=BOSS_CROWD_HARD_FORM_CHANGE;
  formChange[BOSS_CROWD_MODE_VHARD]=BOSS_CROWD_VHARD_FORM_CHANGE;

  fireChange[BOSS_CROWD_MODE_VEASY]=BOSS_CROWD_VEASY_FIRE_CHANGE;
  fireChange[BOSS_CROWD_MODE_EASY]=BOSS_CROWD_EASY_FIRE_CHANGE;
  fireChange[BOSS_CROWD_MODE_NORMAL]
    =BOSS_CROWD_NORMAL_FIRE_CHANGE;
  fireChange[BOSS_CROWD_MODE_HARD]=BOSS_CROWD_HARD_FIRE_CHANGE;
  fireChange[BOSS_CROWD_MODE_VHARD]=BOSS_CROWD_VHARD_FIRE_CHANGE;

  moveChange[BOSS_CROWD_MODE_VEASY]=BOSS_CROWD_VEASY_MOV_CHANGE;
  moveChange[BOSS_CROWD_MODE_EASY]=BOSS_CROWD_EASY_MOV_CHANGE;
  moveChange[BOSS_CROWD_MODE_NORMAL]
    =BOSS_CROWD_NORMAL_MOV_CHANGE;
  moveChange[BOSS_CROWD_MODE_HARD]=BOSS_CROWD_HARD_MOV_CHANGE;
  moveChange[BOSS_CROWD_MODE_VHARD]=BOSS_CROWD_VHARD_MOV_CHANGE;

  formFlock[BOSS_CROWD_MODE_VEASY]=BOSS_CROWD_VEASY_FORM_FLOCK;
  formFlock[BOSS_CROWD_MODE_EASY]=BOSS_CROWD_EASY_FORM_FLOCK;
  formFlock[BOSS_CROWD_MODE_NORMAL]
    =BOSS_CROWD_NORMAL_FORM_FLOCK;
  formFlock[BOSS_CROWD_MODE_HARD]=BOSS_CROWD_HARD_FORM_FLOCK;
  formFlock[BOSS_CROWD_MODE_VHARD]=BOSS_CROWD_VHARD_FORM_FLOCK;
  tIndex=0;
}

BossCrowd::~BossCrowd(){
  if(boss){
    delete boss;
  }
}

void BossCrowd::Create(){
  
}

void BossCrowd::AddBirdVEasy(int px0,int py0){
  BirdActor *act;
  int life0;
  life0=rand()%3+2;

  act=enemyList->Appear
    (px0,py0,8,8,
     0,0,rand()%5+8,rand()%2+1,life0,life0*5,
     EN_CROW,EN_MOV_ORDER,
     EN_TOUCH_BLOW,-1,
     EN_FORM_ORDER,1000,
     EN_ITEMDROP_ALL,100);
  act->target=boss;
}
void BossCrowd::AddBirdEasy(int px0,int py0){
  BirdActor *act;
  int life0;
  life0=rand()%5+2;

  act=enemyList->Appear
    (px0,py0,8,8,
     0,0,rand()%5+8,rand()%1+1,life0,life0*5,
     EN_CROW,EN_MOV_ORDER,
     EN_TOUCH_BLOW,-1,
     EN_FORM_ORDER,1000,
     EN_ITEMDROP_ALL,100);
  act->target=boss;
}
void BossCrowd::AddBirdNormal(int px0,int py0){
  BirdActor *act;
  int life0;
  life0=rand()%5+2;

  act=enemyList->Appear
    (px0,py0,8,8,
     0,0,rand()%5+8,rand()%1+1,life0,life0*5,
     EN_CROW,EN_MOV_ORDER,
     EN_TOUCH_BLOW,-1,
     EN_FORM_ORDER,1000,
     EN_ITEMDROP_ALL,100);
  act->target=boss;
}
void BossCrowd::AddBirdHard(int px0,int py0){
  BirdActor *act;
  int life0;
  life0=rand()%5+2;

  act=enemyList->Appear
    (px0,py0,8,8,
     0,0,rand()%5+10,rand()%1+1,life0,life0*5,
     EN_CROW,EN_MOV_ORDER,
     EN_TOUCH_BLOW,-1,
     EN_FORM_ORDER,1000,
     EN_ITEMDROP_ALL,100);
  act->target=boss;
}
void BossCrowd::AddBirdVHard(int px0,int py0){
  BirdActor *act;
  int life0;
  life0=rand()%5+2;

  act=enemyList->Appear
    (px0,py0,8,8,
     0,0,rand()%5+10,rand()%1+1,life0,life0*5,
     EN_CROW,EN_MOV_ORDER,
     EN_TOUCH_BLOW,-1,
     EN_FORM_ORDER,1000,
     EN_ITEMDROP_ALL,100);
  act->target=boss;
}
void (BossCrowd::*BossCrowd::
      BOSS_CROWD_ADDBIRD_SELECT[BOSS_CROWD_MODE_NUM])(int px0,int py0)={
	&BossCrowd::AddBirdVEasy,
	&BossCrowd::AddBirdEasy,
	&BossCrowd::AddBirdNormal,
	&BossCrowd::AddBirdHard,
	&BossCrowd::AddBirdVHard
      };

BirdActor *BossCrowd::NextThrow(BirdActor *target,int flag){
  if(target!=NULL){
    if((target->move==EN_MOV_ORDER)
       &&(target->life>0)){
      boss->target=target->next;
    }
    else{
      target=NextThrow(target->next,flag);
    }
  }
  else{
    if(flag){
      std::cout<<"NEXT THROW NULL"<<std::endl;
      target=NULL;
      boss->target=NULL;
    }
    else{
      std::cout<<"NEXT FIRST"<<std::endl;
      flag=1;
      target=NextThrow(enemyList->first,flag);
    }
  }
  return target;
}

/*
  ATTACK
*/

void BossCrowd::NoFire(int *enemyCount0){
  boss->form=EN_FORM_NOFIRE;
  if(bossAngleCount>0){
    bossAngleCount--;
  }
  else{
    bossAngle=fireChange[bossMode];
  }
}
void BossCrowd::TargetFire(int *enemyCount0){
  int num0,num1;
  num0=*enemyCount0;
  num1=lifeList[bossMode]-*enemyCount0;

  if(bossCount>0){
    boss->form=EN_FORM_NOFIRE;
  }
  else{
    if(bossCount>bossATarY*-1){
      if(num0>0){
	boss->fire=EN_FORM_FREQ*num1/(bossATarY*num0);
      }
      else{
	boss->fire=0;
      }
      boss->form=EN_FORM_TAR_SMALL;
    }
    else{
      boss->form=EN_FORM_NOFIRE;
      bossCount=bossATarX;      
    }
  }
  bossCount--;

  if(bossAngleCount>0){
    bossAngleCount--;
  }
  else{
    bossAngle=fireChange[bossMode];
  }
}
void BossCrowd::CrossFire(int *enemyCount0){
  int num0,num1;
  num0=*enemyCount0;
  num1=lifeList[bossMode]-*enemyCount0;

  if(bossCount>0){
    boss->form=EN_FORM_NOFIRE;
  }
  else{
    if(bossCount>bossATarY*-1){
      if(num0>0){
	boss->fire=EN_FORM_FREQ*num1/(bossATarY*num0*4);
      }
      else{
	boss->fire=0;
      }
      boss->form=EN_FORM_CROSS_SMALL;
    }
    else{
      boss->form=EN_FORM_NOFIRE;
      bossCount=bossATarX;
    }
  }
  bossCount--;

  if(bossAngleCount>0){
    bossAngleCount--;
  }
  else{
    bossAngle=fireChange[bossMode];
  }
}
void BossCrowd::XRevFire(int *enemyCount0){
  int num0,num1;
  num0=*enemyCount0;
  num1=lifeList[bossMode]-*enemyCount0;

  if(bossCount>0){
    boss->form=EN_FORM_NOFIRE;
  }
  else{
    if(bossCount>bossATarY*-1){
      if(num0>0){
	boss->fire=EN_FORM_FREQ*num1/(bossATarY*num0*4);
      }
      else{
	boss->fire=0;
      }
      boss->form=EN_FORM_XREV_SMALL;
    }
    else{
      boss->form=EN_FORM_NOFIRE;
      bossCount=bossATarX;
    }
  }
  bossCount--;

  if(bossAngleCount>0){
    bossAngleCount--;
  }
  else{
    bossAngle=fireChange[bossMode];
  }
}

/*
  ANGLE
*/

void BossCrowd::FlockForm(int *enemyCount0){
  if(bossAttackCount>0){
    boss->tmp=EN_MOV_XYACCE;
    bossAttackCount--;
  }
  else{
    bossAttack=formChange[bossMode];
  }
}
void BossCrowd::StraightForm(int *enemyCount0){
  if(bossAttackCount>0){
    boss->tmp=EN_MOV_ALLSTR;
  }
  else{
    if(bossAttackCount>(bossAttackFreq*-1)){
      boss->tmp=EN_MOV_XYACCE;
    }
    else{
      bossAttack=formChange[bossMode];
    }
  }
  bossAttackCount--;
}
void BossCrowd::ReverseForm(int *enemyCount0){
  if(bossAttackCount>0){
    boss->tmp=EN_MOV_ALLREV;
  }
  else{
    if(bossAttackCount>(bossAttackFreq*-1)){
      boss->tmp=EN_MOV_XYACCE;
    }
    else{
      bossAttack=formChange[bossMode];
    }
  }
  bossAttackCount--;
}
void BossCrowd::ThrowForm(int *enemyCount0){
  int num0,i;
  BirdActor *act;
  BirdActor *node;
  if(bossAttackCount>0){
    if(rand()%(BOSS_CROWD_ATTACK_THROW_FREQ)<bossAttackFreq){      
      act=NextThrow(boss->target,0);
      if(act){
	act->move=EN_MOV_XYACCE;
	act->target=player;
	act->form=EN_FORM_NOFIRE;
	act->touch=EN_TOUCH_CH_NOSTR;
	act->fire=0;
	act->tcount=rand()%50+100;
	act->tmp=0;
      }
      else{
	std::cout<<"NOT FOUND NEXT THROW"<<std::endl;
      }
    }
    bossAttackCount--;
  }
  else{
    bossAttack=formChange[bossMode];
  }
}

/*
  MOVE
*/

void BossCrowd::StopMove(int *enemyCount0){
  int i,max0,rest0;
  int pxW,pyW,pxH,pyH;
  int flag=0;

  if(boss->px<WIDTH/2){
    if(boss->py<HEIGHT/2){
      pxW=0;
      pyW=rand()%(HEIGHT/2);
      pxH=rand()%(WIDTH/2);
      pyH=0;
    }
    else{
      pxW=0;
      pyW=rand()%(HEIGHT/2)+HEIGHT/2;
      pxH=rand()%(WIDTH/2);
      pyH=HEIGHT;
    }
  }
  else{
    if(boss->py<HEIGHT/2){
      pxW=WIDTH;
      pyW=rand()%(HEIGHT/2);
      pxH=rand()%(WIDTH/2)+(WIDTH/2);
      pyH=0;
    }
    else{
      pxW=WIDTH;
      pyW=rand()%(HEIGHT/2)+HEIGHT/2;
      pxH=rand()%(WIDTH/2)+(WIDTH/2);
      pyH=HEIGHT;
    }
  }

  max0=boss->my/BOSS_CROWD_BIRD_FREQ;
  rest0=boss->my%BOSS_CROWD_BIRD_FREQ;

  i=0;
  while(i<max0){
    if(*enemyCount0>=lifeList[bossMode]){
      break;
    }
    if(rand()%2==0){
      (this->*BOSS_CROWD_ADDBIRD_SELECT[bossMode])(pxW,pyW);
    }
    else{
      (this->*BOSS_CROWD_ADDBIRD_SELECT[bossMode])(pxH,pyH);
    }
    i++;
  }

  if(*enemyCount0>=lifeList[bossMode]){
    
  }
  else{
    if(rand()%BOSS_CROWD_BIRD_FREQ<rest0){
      if(rand()%2==0){
	(this->*BOSS_CROWD_ADDBIRD_SELECT[bossMode])(pxW,pyW);
      }
      else{
	(this->*BOSS_CROWD_ADDBIRD_SELECT[bossMode])(pxH,pyH);
      }
    }
  }

  if(bossMoveCount>0){
    bossMoveCount--;
  }
  else{
    bossMove=moveChange[bossMode];
  }
}
void BossCrowd::TargetMove(int *enemyCount0){
  int sx,sy;
  sx=boss->px;
  sy=boss->py;

  DistApprox(&sx,&sy,bossTarX,bossTarY,boss->mx);

  boss->px+=sx;
  boss->py+=sy;

  if(ReachPoint(boss,bossTarX,bossTarY)==1){
    bossMove=moveChange[bossMode];
  }
}
void BossCrowd::HomingMove(int *enemyCount0){
  int sx,sy;
  sx=boss->px;
  sy=boss->py;
  
  DistApprox(&sx,&sy,player->px,player->py,boss->mx);
  
  boss->px+=sx;
  boss->py+=sy;
  
  if(bossMoveCount>0){
    bossMoveCount--;
  }
  else{
    bossMove=moveChange[bossMode];
  }
}
void BossCrowd::RapidMove(int *enemyCount0){
  boss->px=bossTarX;
  boss->py=bossTarY;

  if(bossMoveCount>0){
    bossMoveCount--;
  }
  else{
    bossMove=moveChange[bossMode];
  }
}

/*
  STATE
*/

int BossCrowd::StartState(int bgBoss0,int mode0,int *enemyCount0){
  bgBoss0=(this->*BOSS_CROWD_START_SELECT[mode0])
    (bgBoss0,mode0,enemyCount0);

  return bgBoss0;
}
int BossCrowd::ActionState(int bgBoss0,int mode0,int *enemyCount0){
  (this->*BOSS_CROWD_ACTION_SELECT[bossMode])(enemyCount0);
  
  if(*enemyCount0>0){
    LifeView((*enemyCount0),lifeList[bossMode]);
  }
  else{
    boss->life=0;
    bossState=BOSS_CROWD_STATE_DEAD;
    bossCount=150;
    bgBoss0=BOSS_ACT_BGSTOP;
  }  
  
  return bgBoss0;
}
int BossCrowd::DeadState(int bgBoss0,int mode0,int *enemyCount0){
  if(bossCount>0){
    bossCount--;
  }
  else{
    if(boss){
      delete boss;
    }
    boss=NULL;
    bossState=BOSS_CROWD_STATE_START;
    bgBoss0=BOSS_ACT_END;
  }
  return bgBoss0;
}
int (BossCrowd::*BossCrowd::
     BOSS_CROWD_STATE_SELECT[BOSS_CROWD_STATE_NUM])
  (int bgBoss0,int mode0,int *enemyCount0)={
    &BossCrowd::StartState,
    &BossCrowd::ActionState,
    &BossCrowd::DeadState
};

int BossCrowd::Act(int bgBoss0,int mode0,int *enemyCount0){
  if(boss){
    if(boss->target!=NULL){
      if((boss->target)->life>0){
	
      }
      else{
	std::cout<<"TARGET LIFE0!!"<<std::endl;
	boss->target=NULL;
      }
    }
  }
  
  bgBoss0=(this->*BOSS_CROWD_STATE_SELECT[bossState])
    (bgBoss0,mode0,enemyCount0);
  /*
  frame->draw_arc(redGC,true,
		  boss->px-8,
		  boss->py-8,
		  16,
		  16,
		  0,360*64);
  */
  return bgBoss0;
}

/*
  START
*/

int BossCrowd::VEasyStart(int bgBoss0,int mode0,int *enemyCount0){
  int i;
  if(!boss){
    bossMode=mode0;
    boss= new BirdActor();
    
    boss->px=WIDTH*3/2;
    boss->py=HEIGHT*1/2;
    boss->width=10;
    boss->height=10;
    boss->move=EN_MOV_BOSS;
    boss->touch=EN_TOUCH_THROUGH;
    boss->life=lifeList[bossMode];
    boss->direct=0;
    boss->mx=0;
    boss->my=0;
    boss->target=NULL;
    boss->next=NULL;
    boss->prev=NULL;

    bossMove=BOSS_CROWD_VEASY_MOV_CHANGE;
    bossAngle=BOSS_CROWD_VEASY_FIRE_CHANGE;
    bossAttack=BOSS_CROWD_VEASY_FORM_CHANGE;
    bossTarX=0;
    bossTarY=0;
    bossATarY=0;
    bossATarY=0;
    bossMoveCount=0;
    bossAngleCount=0;
    bossAttackCount=0;
    
    boss->tmp=EN_MOV_XYACCE;
    boss->form=EN_FORM_NOFIRE;
  }

  if((*enemyCount0)>0){
    LifeView((*enemyCount0),lifeList[bossMode]);
  }

  if((*enemyCount0)<lifeList[bossMode]){
    i=0;
    while(i<10){
      (this->*BOSS_CROWD_ADDBIRD_SELECT[bossMode])
	(WIDTH*5/4+rand()%(WIDTH/2),HEIGHT/4+rand()%(HEIGHT/2));
      if(*enemyCount0>=lifeList[bossMode]){
	break;
      }
      i++;
    }    
  }
  else{
    bossState=BOSS_CROWD_STATE_ACTION;
    bossMove=BOSS_CROWD_VEASY_MOV_TARGET;
    bossAngle=BOSS_CROWD_VEASY_FIRE_CHANGE;
    bossAttack=BOSS_CROWD_VEASY_FORM_FLOCK;
    boss->mx=5;
    bossTarX=WIDTH*3/4;
    bossTarY=HEIGHT/2;
    bossATarY=0;
    bossATarY=0;
    bossMoveCount=100;
    bossAngleCount=0;
    bossAttackCount=100;
  }  

  return bgBoss0;
}
int BossCrowd::EasyStart(int bgBoss0,int mode0,int *enemyCount0){
  int i;
  if(!boss){
    bossMode=mode0;
    boss= new BirdActor();
    
    boss->px=WIDTH*3/2;
    boss->py=HEIGHT*1/2;
    boss->width=10;
    boss->height=10;
    boss->move=EN_MOV_BOSS;
    boss->touch=EN_TOUCH_THROUGH;
    boss->life=lifeList[bossMode];
    boss->direct=0;
    boss->mx=0;
    boss->my=0;
    boss->target=NULL;
    boss->next=NULL;
    boss->prev=NULL;

    bossMove=BOSS_CROWD_EASY_MOV_CHANGE;
    bossAngle=BOSS_CROWD_EASY_FIRE_CHANGE;
    bossAttack=BOSS_CROWD_EASY_FORM_CHANGE;
    bossTarX=0;
    bossTarY=0;
    bossATarY=0;
    bossATarY=0;
    bossMoveCount=0;
    bossAngleCount=0;
    bossAttackCount=0;
    
    boss->tmp=EN_MOV_XYACCE;
    boss->form=EN_FORM_NOFIRE;
  }

  if((*enemyCount0)>0){
    LifeView((*enemyCount0),lifeList[bossMode]);
  }

  if((*enemyCount0)<lifeList[bossMode]){
    i=0;
    while(i<10){
      (this->*BOSS_CROWD_ADDBIRD_SELECT[bossMode])
	(WIDTH*5/4+rand()%(WIDTH/2),HEIGHT/4+rand()%(HEIGHT/2));
      if(*enemyCount0>=lifeList[bossMode]){
	break;
      }
      i++;
    }    
  }
  else{
    bossState=BOSS_CROWD_STATE_ACTION;
    bossMove=BOSS_CROWD_EASY_MOV_TARGET;
    bossAngle=BOSS_CROWD_EASY_FIRE_CHANGE;
    bossAttack=BOSS_CROWD_EASY_FORM_FLOCK;
    boss->mx=5;
    bossTarX=WIDTH*3/4;
    bossTarY=HEIGHT/2;
    bossATarY=0;
    bossATarY=0;
    bossMoveCount=100;
    bossAngleCount=0;
    bossAttackCount=100;
  }  

  return bgBoss0;
}
int BossCrowd::NormalStart(int bgBoss0,int mode0,int *enemyCount0){
  int i;
  if(!boss){
    bossMode=mode0;
    boss= new BirdActor();
    
    boss->px=WIDTH*3/2;
    boss->py=HEIGHT*1/2;
    boss->width=10;
    boss->height=10;
    boss->move=EN_MOV_BOSS;
    boss->touch=EN_TOUCH_THROUGH;
    boss->life=lifeList[bossMode];
    boss->direct=0;
    boss->mx=0;
    boss->my=0;
    boss->target=NULL;
    boss->next=NULL;
    boss->prev=NULL;

    bossMove=BOSS_CROWD_NORMAL_MOV_CHANGE;
    bossAngle=BOSS_CROWD_NORMAL_FIRE_CHANGE;
    bossAttack=BOSS_CROWD_NORMAL_FORM_CHANGE;
    bossTarX=0;
    bossTarY=0;
    bossATarY=0;
    bossATarY=0;
    bossMoveCount=0;
    bossAngleCount=0;
    bossAttackCount=0;
    
    boss->tmp=EN_MOV_XYACCE;
    boss->form=EN_FORM_NOFIRE;
  }

  if((*enemyCount0)>0){
    LifeView((*enemyCount0),lifeList[bossMode]);
  }

  if((*enemyCount0)<lifeList[bossMode]){
    i=0;
    while(i<10){
      (this->*BOSS_CROWD_ADDBIRD_SELECT[bossMode])
	(WIDTH*5/4+rand()%(WIDTH/2),HEIGHT/4+rand()%(HEIGHT/2));
      if(*enemyCount0>=lifeList[bossMode]){
	break;
      }
      i++;
    }    
  }
  else{
    bossState=BOSS_CROWD_STATE_ACTION;
    bossMove=BOSS_CROWD_VHARD_MOV_TARGET;
    bossAngle=BOSS_CROWD_VHARD_FIRE_CHANGE;
    bossAttack=BOSS_CROWD_VHARD_FORM_FLOCK;
    boss->mx=5;
    bossTarX=WIDTH*3/4;
    bossTarY=HEIGHT/2;
    bossATarY=0;
    bossATarY=0;
    bossMoveCount=100;
    bossAngleCount=0;
    bossAttackCount=500;
  }  

  return bgBoss0;
}
int BossCrowd::HardStart(int bgBoss0,int mode0,int *enemyCount0){
  int i;
  if(!boss){
    bossMode=mode0;
    boss= new BirdActor();
    
    boss->px=WIDTH*3/2;
    boss->py=HEIGHT*1/2;
    boss->width=10;
    boss->height=10;
    boss->move=EN_MOV_BOSS;
    boss->touch=EN_TOUCH_THROUGH;
    boss->life=lifeList[bossMode];
    boss->direct=0;
    boss->mx=0;
    boss->my=0;
    boss->target=NULL;
    boss->next=NULL;
    boss->prev=NULL;

    bossMove=BOSS_CROWD_HARD_MOV_CHANGE;
    bossAngle=BOSS_CROWD_HARD_FIRE_CHANGE;
    bossAttack=BOSS_CROWD_HARD_FORM_CHANGE;
    bossTarX=0;
    bossTarY=0;
    bossATarY=0;
    bossATarY=0;
    bossMoveCount=0;
    bossAngleCount=0;
    bossAttackCount=0;
    
    boss->tmp=EN_MOV_XYACCE;
    boss->form=EN_FORM_NOFIRE;
  }

  if((*enemyCount0)>0){
    LifeView((*enemyCount0),lifeList[bossMode]);
  }

  if((*enemyCount0)<lifeList[bossMode]){
    i=0;
    while(i<10){
      (this->*BOSS_CROWD_ADDBIRD_SELECT[bossMode])
	(WIDTH*5/4+rand()%(WIDTH/2),HEIGHT/4+rand()%(HEIGHT/2));
      if(*enemyCount0>=lifeList[bossMode]){
	break;
      }
      i++;
    }    
  }
  else{
    bossState=BOSS_CROWD_STATE_ACTION;
    bossMove=BOSS_CROWD_HARD_MOV_RAPID;
    bossAngle=BOSS_CROWD_HARD_FIRE_CHANGE;
    bossAttack=BOSS_CROWD_HARD_FORM_FLOCK;
    bossTarX=WIDTH*3/4;
    bossTarY=HEIGHT/2;
    bossATarY=0;
    bossATarY=0;
    bossMoveCount=100;
    bossAngleCount=0;
    bossAttackCount=500;
  }  

  return bgBoss0;
}
int BossCrowd::VHardStart(int bgBoss0,int mode0,int *enemyCount0){
  int i;
  if(!boss){
    bossMode=mode0;
    boss= new BirdActor();
    
    boss->px=WIDTH*3/2;
    boss->py=HEIGHT*1/2;
    boss->width=10;
    boss->height=10;
    boss->move=EN_MOV_BOSS;
    boss->touch=EN_TOUCH_THROUGH;
    boss->life=lifeList[bossMode];
    boss->direct=0;
    boss->mx=0;
    boss->my=0;
    boss->target=NULL;
    boss->next=NULL;
    boss->prev=NULL;

    bossMove=BOSS_CROWD_VHARD_MOV_CHANGE;
    bossAngle=BOSS_CROWD_VHARD_FIRE_CHANGE;
    bossAttack=BOSS_CROWD_VHARD_FORM_CHANGE;
    bossTarX=0;
    bossTarY=0;
    bossATarY=0;
    bossATarY=0;
    bossMoveCount=0;
    bossAngleCount=0;
    bossAttackCount=0;
    
    boss->tmp=EN_MOV_XYACCE;
    boss->form=EN_FORM_NOFIRE;
  }

  if((*enemyCount0)>0){
    LifeView((*enemyCount0),lifeList[bossMode]);
  }

  if((*enemyCount0)<lifeList[bossMode]){
    i=0;
    while(i<10){
      (this->*BOSS_CROWD_ADDBIRD_SELECT[bossMode])
	(WIDTH*5/4+rand()%(WIDTH/2),HEIGHT/4+rand()%(HEIGHT/2));
      if(*enemyCount0>=lifeList[bossMode]){
	break;
      }
      i++;
    }    
  }
  else{
    bossState=BOSS_CROWD_STATE_ACTION;
    bossMove=BOSS_CROWD_VHARD_MOV_RAPID;
    bossAngle=BOSS_CROWD_VHARD_FIRE_CHANGE;
    bossAttack=BOSS_CROWD_VHARD_FORM_FLOCK;
    bossTarX=WIDTH*3/4;
    bossTarY=HEIGHT/2;
    bossATarY=0;
    bossATarY=0;
    bossMoveCount=100;
    bossAngleCount=0;
    bossAttackCount=500;
  }  

  return bgBoss0;
}
int (BossCrowd::*BossCrowd::BOSS_CROWD_START_SELECT[BOSS_CROWD_MODE_NUM])
  (int bgBoss0,int mode0,int *enemyCount0)={
    &BossCrowd::VEasyStart,
    &BossCrowd::EasyStart,
    &BossCrowd::NormalStart,
    &BossCrowd::HardStart,
    &BossCrowd::VHardStart
};

/*
  ACTION
*/

void BossCrowd::VEasyAction(int *enemyCount0){
  (this->*BOSS_CROWD_VEASY_MOVE_SELECT[bossMove])(enemyCount0);
  
  (this->*BOSS_CROWD_VEASY_FORM_SELECT[bossAttack])(enemyCount0);

  (this->*BOSS_CROWD_VEASY_FIRE_SELECT[bossAngle])(enemyCount0);
}
void BossCrowd::EasyAction(int *enemyCount0){
  (this->*BOSS_CROWD_EASY_MOVE_SELECT[bossMove])(enemyCount0);
  
  (this->*BOSS_CROWD_EASY_FORM_SELECT[bossAttack])(enemyCount0);

  (this->*BOSS_CROWD_EASY_FIRE_SELECT[bossAngle])(enemyCount0);
}
void BossCrowd::NormalAction(int *enemyCount0){
  (this->*BOSS_CROWD_NORMAL_MOVE_SELECT[bossMove])(enemyCount0);
  
  (this->*BOSS_CROWD_NORMAL_FORM_SELECT[bossAttack])(enemyCount0);

  (this->*BOSS_CROWD_NORMAL_FIRE_SELECT[bossAngle])(enemyCount0);
}
void BossCrowd::HardAction(int *enemyCount0){
  (this->*BOSS_CROWD_HARD_MOVE_SELECT[bossMove])(enemyCount0);
  
  (this->*BOSS_CROWD_HARD_FORM_SELECT[bossAttack])(enemyCount0);
  
  (this->*BOSS_CROWD_HARD_FIRE_SELECT[bossAngle])(enemyCount0);
}
void BossCrowd::VHardAction(int *enemyCount0){
  (this->*BOSS_CROWD_VHARD_MOVE_SELECT[bossMove])(enemyCount0);
  
  (this->*BOSS_CROWD_VHARD_FORM_SELECT[bossAttack])(enemyCount0);
  
  (this->*BOSS_CROWD_VHARD_FIRE_SELECT[bossAngle])(enemyCount0);
}
void (BossCrowd::*BossCrowd::BOSS_CROWD_ACTION_SELECT
      [BOSS_CROWD_MODE_NUM])(int *enemyCount0)={
	&BossCrowd::VEasyAction,
	&BossCrowd::EasyAction,
	&BossCrowd::NormalAction,
	&BossCrowd::HardAction,
	&BossCrowd::VHardAction
      };

/*
  VEASY
*/

void BossCrowd::VEasyFireChange(int *enemyCount0){
  int tFire,tFreq;
  int lifeRate0;

  tFire=BOSS_CROWD_VEASY_FIRE_TARGET;
  bossAngle=rand()%(tFire)+1;
  
  if(bossAngle==BOSS_CROWD_VEASY_FIRE_NO){
    bossAngleCount=rand()%(50)+50;
  }
  else if(bossAngle==BOSS_CROWD_VEASY_FIRE_TARGET){
    bossAngleCount=rand()%(100)+100;
    bossATarX=rand()%20+80;
    bossATarY=rand()%10+10;
    boss->fire=0;
  }
}
void (BossCrowd::*BossCrowd::BOSS_CROWD_VEASY_FIRE_SELECT
      [BOSS_CROWD_VEASY_FIRE_NUM])(int *enemyCount0)={
	&BossCrowd::VEasyFireChange,
	&BossCrowd::NoFire,
	&BossCrowd::TargetFire
      };

void BossCrowd::VEasyFormChange(int *enemyCount0){
  int tForm=0;
  int tFreq=0;

  tForm=BOSS_CROWD_VEASY_FORM_STRAIGHT;

  bossAttack=rand()%(tForm)+1;

  if(bossAttack==BOSS_CROWD_VEASY_FORM_FLOCK){
    bossAttackCount=rand()%(100)+100;
  }
  else if(bossAttack==BOSS_CROWD_VEASY_FORM_STRAIGHT){
    tFreq=rand()%(30)+30;
    bossAttackCount=tFreq;
    bossAttackFreq=tFreq*3;
  }
}
void (BossCrowd::*BossCrowd::BOSS_CROWD_VEASY_FORM_SELECT
      [BOSS_CROWD_VEASY_FORM_NUM])(int *enemyCount0)={
	&BossCrowd::VEasyFormChange,
	&BossCrowd::FlockForm,
	&BossCrowd::StraightForm
      };
void BossCrowd::VEasyMoveChange(int *enemyCount0){
  int num0,num1;
  bossMove=rand()%(BOSS_CROWD_VEASY_MOV_NUM-1)+1;
  
  num0=*enemyCount0;
  num1=lifeList[bossMode]-num0;

  if(bossMove==BOSS_CROWD_VEASY_MOV_STOP){
    if(num1>0){
      //    boss->my=700*num1/lifeList[bossMode]+300;
      boss->my=0;
    }
    else{
      boss->my=0;
    }
    bossMoveCount=rand()%(25)+25;
  }
  else if(bossMove==BOSS_CROWD_VEASY_MOV_TARGET){
    boss->mx=3+rand()%3;
    bossTarX=rand()%WIDTH;
    bossTarY=rand()%HEIGHT;
  }
  else if(bossMove==BOSS_CROWD_VEASY_MOV_HOMING){
    boss->mx=3+rand()%2;
    bossMoveCount=(rand()%100+100)/boss->mx;
  }
  else if(bossMove==BOSS_CROWD_VEASY_MOV_RAPID){
    bossTarX=rand()%WIDTH;
    bossTarY=rand()%HEIGHT;
    bossMoveCount=rand()%(50)+100;
  }
}
void (BossCrowd::*BossCrowd::BOSS_CROWD_VEASY_MOVE_SELECT
      [BOSS_CROWD_VEASY_MOV_NUM])(int *enemyCount0)={
	&BossCrowd::VEasyMoveChange,
	&BossCrowd::StopMove,
	&BossCrowd::TargetMove,
	&BossCrowd::HomingMove,
	&BossCrowd::RapidMove
      };

/*
  EASY
*/

void BossCrowd::EasyFireChange(int *enemyCount0){
  int tFire,tFreq;
  int lifeRate0;

  tFire=BOSS_CROWD_EASY_FIRE_TARGET;
  bossAngle=rand()%(tFire)+1;
  
  if(bossAngle==BOSS_CROWD_EASY_FIRE_NO){
    bossAngleCount=rand()%(50)+50;
  }
  else if(bossAngle==BOSS_CROWD_EASY_FIRE_TARGET){
    bossAngleCount=rand()%(100)+100;
    bossATarX=rand()%20+80;
    bossATarY=rand()%10+10;
    boss->fire=0;
  }
}
void (BossCrowd::*BossCrowd::BOSS_CROWD_EASY_FIRE_SELECT
      [BOSS_CROWD_EASY_FIRE_NUM])(int *enemyCount0)={
	&BossCrowd::EasyFireChange,
	&BossCrowd::NoFire,
	&BossCrowd::TargetFire
      };

void BossCrowd::EasyFormChange(int *enemyCount0){
  int tForm=0;
  int tFreq=0;

  tForm=BOSS_CROWD_EASY_FORM_STRAIGHT;

  bossAttack=rand()%(tForm)+1;

  if(bossAttack==BOSS_CROWD_EASY_FORM_FLOCK){
    bossAttackCount=rand()%(100)+100;
  }
  else if(bossAttack==BOSS_CROWD_EASY_FORM_STRAIGHT){
    tFreq=rand()%(30)+30;
    bossAttackCount=tFreq;
    bossAttackFreq=tFreq*3;
  }
}
void (BossCrowd::*BossCrowd::BOSS_CROWD_EASY_FORM_SELECT
      [BOSS_CROWD_EASY_FORM_NUM])(int *enemyCount0)={
	&BossCrowd::EasyFormChange,
	&BossCrowd::FlockForm,
	&BossCrowd::StraightForm
      };
void BossCrowd::EasyMoveChange(int *enemyCount0){
  int num0,num1;
  bossMove=rand()%(BOSS_CROWD_EASY_MOV_NUM-1)+1;
  
  num0=*enemyCount0;
  num1=lifeList[bossMode]-num0;

  if(bossMove==BOSS_CROWD_EASY_MOV_STOP){
    if(num1>0){
      boss->my=700*num1/lifeList[bossMode]+300;
    }
    else{
      boss->my=0;
    }
    bossMoveCount=rand()%(25)+25;
  }
  else if(bossMove==BOSS_CROWD_EASY_MOV_TARGET){
    boss->mx=3+rand()%3;
    bossTarX=rand()%WIDTH;
    bossTarY=rand()%HEIGHT;
  }
  else if(bossMove==BOSS_CROWD_EASY_MOV_HOMING){
    boss->mx=3+rand()%2;
    bossMoveCount=(rand()%100+100)/boss->mx;
  }
  else if(bossMove==BOSS_CROWD_EASY_MOV_RAPID){
    bossTarX=rand()%WIDTH;
    bossTarY=rand()%HEIGHT;
    bossMoveCount=rand()%(50)+100;
  }
}
void (BossCrowd::*BossCrowd::BOSS_CROWD_EASY_MOVE_SELECT
      [BOSS_CROWD_EASY_MOV_NUM])(int *enemyCount0)={
	&BossCrowd::EasyMoveChange,
	&BossCrowd::StopMove,
	&BossCrowd::TargetMove,
	&BossCrowd::HomingMove,
	&BossCrowd::RapidMove
      };

/*
  NORMAL
*/

void BossCrowd::NormalFireChange(int *enemyCount0){
  int tFire,tFreq;
  int lifeRate0;

  tFire=BOSS_CROWD_NORMAL_FIRE_XREV;
  bossAngle=rand()%(tFire)+1;
  
  if(bossAngle==BOSS_CROWD_NORMAL_FIRE_NO){
    bossAngleCount=rand()%(25)+25;
  }
  else if(bossAngle==BOSS_CROWD_NORMAL_FIRE_TARGET){
    bossAngleCount=rand()%(100)+100;
    bossATarX=rand()%20+60;
    bossATarY=rand()%10+10;
    boss->fire=0;
  }
  else if(bossAngle==BOSS_CROWD_NORMAL_FIRE_CROSS){
    bossAngleCount=rand()%(100)+100;
    bossATarX=rand()%20+70;
    bossATarY=rand()%10+10;
    boss->fire=0;
  }
  else if(bossAngle==BOSS_CROWD_NORMAL_FIRE_XREV){
    bossAngleCount=rand()%(100)+100;
    bossATarX=rand()%20+80;
    bossATarY=rand()%10+10;
    boss->fire=0;
  }
}
void (BossCrowd::*BossCrowd::BOSS_CROWD_NORMAL_FIRE_SELECT
      [BOSS_CROWD_NORMAL_FIRE_NUM])(int *enemyCount0)={
	&BossCrowd::NormalFireChange,
	&BossCrowd::NoFire,
	&BossCrowd::TargetFire,
	&BossCrowd::CrossFire,
	&BossCrowd::XRevFire
      };

void BossCrowd::NormalFormChange(int *enemyCount0){

  int tForm=0;
  int tFreq=0;

  tForm=BOSS_CROWD_NORMAL_FORM_STRAIGHT;

  bossAttack=rand()%(tForm)+1;

  if(bossAttack==BOSS_CROWD_NORMAL_FORM_FLOCK){
    bossAttackCount=rand()%(100)+100;
  }
  else if(bossAttack==BOSS_CROWD_NORMAL_FORM_STRAIGHT){
    tFreq=rand()%(30)+30;
    bossAttackCount=tFreq;
    bossAttackFreq=tFreq*3;
  }
}
void (BossCrowd::*BossCrowd::BOSS_CROWD_NORMAL_FORM_SELECT
      [BOSS_CROWD_NORMAL_FORM_NUM])(int *enemyCount0)={
	&BossCrowd::NormalFormChange,
	&BossCrowd::FlockForm,
	&BossCrowd::StraightForm
      };
void BossCrowd::NormalMoveChange(int *enemyCount0){
  int num0,num1;
  bossMove=rand()%(BOSS_CROWD_NORMAL_MOV_NUM-1)+1;
  
  num0=*enemyCount0;
  num1=lifeList[bossMode]-num0;

  if(bossMove==BOSS_CROWD_NORMAL_MOV_STOP){
    if(num1>0){
      boss->my=700*num1/lifeList[bossMode]+300;
    }
    else{
      boss->my=0;
    }
    bossMoveCount=rand()%(25)+25;
  }
  else if(bossMove==BOSS_CROWD_NORMAL_MOV_TARGET){
    boss->mx=3+rand()%3;
    bossTarX=rand()%WIDTH;
    bossTarY=rand()%HEIGHT;
  }
  else if(bossMove==BOSS_CROWD_NORMAL_MOV_HOMING){
    boss->mx=3+rand()%2;
    bossMoveCount=(rand()%100+100)/boss->mx;
  }
  else if(bossMove==BOSS_CROWD_NORMAL_MOV_RAPID){
    bossTarX=rand()%WIDTH;
    bossTarY=rand()%HEIGHT;
    bossMoveCount=rand()%(50)+100;
  }
}
void (BossCrowd::*BossCrowd::BOSS_CROWD_NORMAL_MOVE_SELECT
      [BOSS_CROWD_NORMAL_MOV_NUM])(int *enemyCount0)={
	&BossCrowd::NormalMoveChange,
	&BossCrowd::StopMove,
	&BossCrowd::TargetMove,
	&BossCrowd::HomingMove,
	&BossCrowd::RapidMove
      };

/*
  HARD
*/

void BossCrowd::HardFireChange(int *enemyCount0){
  int tFire,tFreq;
  int lifeRate0;

  tFire=BOSS_CROWD_HARD_FIRE_TARGET;
  bossAngle=rand()%(tFire)+1;
  
  if(bossAngle==BOSS_CROWD_HARD_FIRE_NO){
    bossAngleCount=rand()%(50)+50;
  }
  else if(bossAngle==BOSS_CROWD_HARD_FIRE_TARGET){
    bossAngleCount=rand()%(100)+100;
    bossATarX=rand()%20+80;
    bossATarY=rand()%10+10;
    boss->fire=0;
  }
}
void (BossCrowd::*BossCrowd::BOSS_CROWD_HARD_FIRE_SELECT
      [BOSS_CROWD_HARD_FIRE_NUM])(int *enemyCount0)={
	&BossCrowd::HardFireChange,
	&BossCrowd::NoFire,
	&BossCrowd::TargetFire
      };

void BossCrowd::HardFormChange(int *enemyCount0){
  int tForm=0;
  int tFreq=0;

  if((*enemyCount0)>lifeList[bossMode]*2/3){
    tForm=BOSS_CROWD_HARD_FORM_THROW;
  }
  else{
    tForm=BOSS_CROWD_HARD_FORM_REVERSE;
  }

  bossAttack=rand()%(tForm)+1;

  if(bossAttack==BOSS_CROWD_HARD_FORM_FLOCK){
    bossAttackCount=rand()%(100)+100;
  }
  else if(bossAttack==BOSS_CROWD_HARD_FORM_STRAIGHT){
    tFreq=rand()%(20)+20;
    bossAttackCount=tFreq;
    bossAttackFreq=tFreq*3;
  }
  else if(bossAttack==BOSS_CROWD_HARD_FORM_REVERSE){
    tFreq=rand()%(20)+20;
    bossAttackCount=tFreq;
    bossAttackFreq=tFreq*2;
  }
  else if(bossAttack==BOSS_CROWD_HARD_FORM_THROW){
    bossAttackCount=rand()%(50)+50;
    bossAttackFreq=500;
  }
}
void (BossCrowd::*BossCrowd::BOSS_CROWD_HARD_FORM_SELECT
      [BOSS_CROWD_HARD_FORM_NUM])(int *enemyCount0)={
	&BossCrowd::HardFormChange,
	&BossCrowd::FlockForm,
	&BossCrowd::StraightForm,
	&BossCrowd::ReverseForm,
	&BossCrowd::ThrowForm
      };
void BossCrowd::HardMoveChange(int *enemyCount0){
  int num0,num1;
  bossMove=rand()%(BOSS_CROWD_HARD_MOV_NUM-1)+1;
  
  num0=*enemyCount0;
  num1=lifeList[bossMode]-num0;

  if(bossMove==BOSS_CROWD_HARD_MOV_STOP){
    if(num1>0){
      boss->my=1400*num1/lifeList[bossMode]+600;
    }
    else{
      boss->my=0;
    }
    bossMoveCount=rand()%(25)+25;
  }
  else if(bossMove==BOSS_CROWD_HARD_MOV_TARGET){
    boss->mx=4+rand()%4;
    bossTarX=rand()%WIDTH;
    bossTarY=rand()%HEIGHT;
  }
  else if(bossMove==BOSS_CROWD_HARD_MOV_HOMING){
    boss->mx=4+rand()%3;
    bossMoveCount=(rand()%100+100)/boss->mx;
  }
  else if(bossMove==BOSS_CROWD_HARD_MOV_RAPID){
    bossTarX=rand()%WIDTH;
    bossTarY=rand()%HEIGHT;
    bossMoveCount=rand()%(50)+100;
  }
}
void (BossCrowd::*BossCrowd::BOSS_CROWD_HARD_MOVE_SELECT
      [BOSS_CROWD_HARD_MOV_NUM])(int *enemyCount0)={
	&BossCrowd::HardMoveChange,
	&BossCrowd::StopMove,
	&BossCrowd::TargetMove,
	&BossCrowd::HomingMove,
	&BossCrowd::RapidMove
      };

/*
  VHARD
*/

void BossCrowd::VHardFireChange(int *enemyCount0){
  int tFire,tFreq;
  int lifeRate0;

  tFire=BOSS_CROWD_VHARD_FIRE_XREV;
  bossAngle=rand()%(tFire)+1;
  
  if(bossAngle==BOSS_CROWD_VHARD_FIRE_NO){
    bossAngleCount=rand()%(25)+25;
  }
  else if(bossAngle==BOSS_CROWD_VHARD_FIRE_TARGET){
    bossAngleCount=rand()%(100)+100;
    bossATarX=rand()%20+60;
    bossATarY=rand()%10+10;
    boss->fire=0;
  }
  else if(bossAngle==BOSS_CROWD_VHARD_FIRE_CROSS){
    bossAngleCount=rand()%(100)+100;
    bossATarX=rand()%20+70;
    bossATarY=rand()%10+10;
    boss->fire=0;
  }
  else if(bossAngle==BOSS_CROWD_VHARD_FIRE_XREV){
    bossAngleCount=rand()%(100)+100;
    bossATarX=rand()%20+80;
    bossATarY=rand()%10+10;
    boss->fire=0;
  }
}
void (BossCrowd::*BossCrowd::BOSS_CROWD_VHARD_FIRE_SELECT
      [BOSS_CROWD_VHARD_FIRE_NUM])(int *enemyCount0)={
	&BossCrowd::VHardFireChange,
	&BossCrowd::NoFire,
	&BossCrowd::TargetFire,
	&BossCrowd::CrossFire,
	&BossCrowd::XRevFire
      };

void BossCrowd::VHardFormChange(int *enemyCount0){
  int tForm=0;
  int tFreq=0;

  if((*enemyCount0)>lifeList[bossMode]*2/3){
    tForm=BOSS_CROWD_VHARD_FORM_THROW;
  }
  else{
    tForm=BOSS_CROWD_VHARD_FORM_REVERSE;
  }

  bossAttack=rand()%(tForm)+1;

  if(bossAttack==BOSS_CROWD_VHARD_FORM_FLOCK){
    bossAttackCount=rand()%(100)+100;
  }
  else if(bossAttack==BOSS_CROWD_VHARD_FORM_STRAIGHT){
    tFreq=rand()%(20)+20;
    bossAttackCount=tFreq;
    bossAttackFreq=tFreq*3;
  }
  else if(bossAttack==BOSS_CROWD_VHARD_FORM_REVERSE){
    tFreq=rand()%(20)+20;
    bossAttackCount=tFreq;
    bossAttackFreq=tFreq*2;
  }
  else if(bossAttack==BOSS_CROWD_VHARD_FORM_THROW){
    bossAttackCount=rand()%(50)+50;
    bossAttackFreq=500;
  }
}
void (BossCrowd::*BossCrowd::BOSS_CROWD_VHARD_FORM_SELECT
      [BOSS_CROWD_VHARD_FORM_NUM])(int *enemyCount0)={
	&BossCrowd::VHardFormChange,
	&BossCrowd::FlockForm,
	&BossCrowd::StraightForm,
	&BossCrowd::ReverseForm,
	&BossCrowd::ThrowForm
      };
void BossCrowd::VHardMoveChange(int *enemyCount0){
  int num0,num1;
  bossMove=rand()%(BOSS_CROWD_VHARD_MOV_NUM-1)+1;
  
  num0=*enemyCount0;
  num1=lifeList[bossMode]-num0;

  if(bossMove==BOSS_CROWD_VHARD_MOV_STOP){
    if(num1>0){
      boss->my=1400*num1/lifeList[bossMode]+600;
    }
    else{
      boss->my=0;
    }
    bossMoveCount=rand()%(25)+25;
  }
  else if(bossMove==BOSS_CROWD_VHARD_MOV_TARGET){
    boss->mx=4+rand()%4;
    bossTarX=rand()%WIDTH;
    bossTarY=rand()%HEIGHT;
  }
  else if(bossMove==BOSS_CROWD_VHARD_MOV_HOMING){
    boss->mx=4+rand()%3;
    bossMoveCount=(rand()%100+100)/boss->mx;
  }
  else if(bossMove==BOSS_CROWD_VHARD_MOV_RAPID){
    bossTarX=rand()%WIDTH;
    bossTarY=rand()%HEIGHT;
    bossMoveCount=rand()%(50)+100;
  }
}
void (BossCrowd::*BossCrowd::BOSS_CROWD_VHARD_MOVE_SELECT
      [BOSS_CROWD_VHARD_MOV_NUM])(int *enemyCount0)={
	&BossCrowd::VHardMoveChange,
	&BossCrowd::StopMove,
	&BossCrowd::TargetMove,
	&BossCrowd::HomingMove,
	&BossCrowd::RapidMove
      };
