#include "bosspractice.h"

BossPractice::BossPractice(){
  bossSilkhat= new BossSilkHat();
  bossCrowd= new BossCrowd();
  bossEagle= new BossEagle();

  bossName[BOSSPRACTICE_BOSS_SILKHAT]="SilkHat";
  bossName[BOSSPRACTICE_BOSS_CROWD]="Crowd";
  bossName[BOSSPRACTICE_BOSS_EAGLE]="Eagle";

  bossModeName[BOSSPRACTICE_BOSSMODE_VEASY]="Very Easy";
  bossModeName[BOSSPRACTICE_BOSSMODE_EASY]="Easy";
  bossModeName[BOSSPRACTICE_BOSSMODE_NORMAL]="Normal";
  bossModeName[BOSSPRACTICE_BOSSMODE_HARD]="Hard";
  bossModeName[BOSSPRACTICE_BOSSMODE_VHARD]="Very Hard";

  bossType=0;
  bossMode=0;
}

BossPractice::~BossPractice(){
  
  if(bossSilkhat){
    delete bossSilkhat;
    bossSilkhat=NULL;
  }
  
  if(bossCrowd){
    delete bossCrowd;
    bossCrowd=NULL;
  }
  
  if(bossEagle){
    delete bossEagle;
    bossEagle=NULL;
  }
  
}

void BossPractice::Create(){
  StageCreate();
  player->InitPlayer(STAGE_FLIPLIFE_MAX);
  bossSilkhat->BaseCreate(this,mWindow,frame);
  bossSilkhat->Create();
  bossCrowd->BaseCreate(this,mWindow,frame);
  bossCrowd->Create();
  bossEagle->BaseCreate(this,mWindow,frame);
  bossEagle->Create();
}

int BossPractice::CalcBossID(){
  int value0;

  value0=bossType*8+bossMode;

  return value0;
}

void BossPractice::BossTypeSelect(){
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);
  std::stringstream ss;
  int px0,py0;
  int px1,py1;
  int tmpX;

  frame->draw_rectangle(blackGC,true,0,0,WIDTH,HEIGHT);
  
  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(350)/MAP_YMAX;
  text->DrawString("BOSS SELECT",color->white,px0,py0,
		   FONT_LINE_CENTER,20,
		   FONT_SERIF,FONT_FACE_ITALIC);

  px1=WIDTH*(BOSSPRACTICE_BOSSTYPE_PX1)/MAP_XMAX;
  px0=px1;
  py0=HEIGHT*(BOSSPRACTICE_BOSSTYPE_PY1+BOSSPRACTICE_BOSSTYPE_MY1
	      *BOSSPRACTICE_BOSS_SILKHAT)/MAP_YMAX;
  text->DrawString
    ("SILKHAT",color->white,px0,py0,
     BOSSPRACTICE_BOSSTYPE_LF1,BOSSPRACTICE_BOSSTYPE_SF1,
     BOSSPRACTICE_BOSSTYPE_TF1,BOSSPRACTICE_BOSSTYPE_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  px1=WIDTH*(BOSSPRACTICE_BOSSTYPE_PX1)/MAP_XMAX;
  px0=px1;
  py0=HEIGHT*(BOSSPRACTICE_BOSSTYPE_PY1+BOSSPRACTICE_BOSSTYPE_MY1
	      *BOSSPRACTICE_BOSS_CROWD)/MAP_YMAX;
  text->DrawString
    ("CROWD",color->white,px0,py0,
     BOSSPRACTICE_BOSSTYPE_LF1,BOSSPRACTICE_BOSSTYPE_SF1,
     BOSSPRACTICE_BOSSTYPE_TF1,BOSSPRACTICE_BOSSTYPE_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  px1=WIDTH*(BOSSPRACTICE_BOSSTYPE_PX1)/MAP_XMAX;
  px0=px1;
  py0=HEIGHT*(BOSSPRACTICE_BOSSTYPE_PY1+BOSSPRACTICE_BOSSTYPE_MY1
	      *BOSSPRACTICE_BOSS_EAGLE)/MAP_YMAX;
  text->DrawString
    ("EAGLE",color->white,px0,py0,
     BOSSPRACTICE_BOSSTYPE_LF1,BOSSPRACTICE_BOSSTYPE_SF1,
     BOSSPRACTICE_BOSSTYPE_TF1,BOSSPRACTICE_BOSSTYPE_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  StepSelectAction(&tmpX,&Map->valueY[BOSSPRACTICE_VY_STATE_BOSSTYPE]);

  if(Map->valueY[BOSSPRACTICE_VY_STATE_BOSSTYPE]<0){
    Map->valueY[BOSSPRACTICE_VY_STATE_BOSSTYPE]=BOSSPRACTICE_BOSS_NUM-1;
  }
  else if(Map->valueY[BOSSPRACTICE_VY_STATE_BOSSTYPE]>=
	  BOSSPRACTICE_BOSS_NUM){
    Map->valueY[BOSSPRACTICE_VY_STATE_BOSSTYPE]=0;
  }

  enemyList->DrawSprite
    (EN_REV_BIRD,EN_WAY_B,2,
     WIDTH*(400)/MAP_XMAX,
     HEIGHT*(BOSSPRACTICE_BOSSTYPE_PY1
	     +BOSSPRACTICE_BOSSTYPE_MY1
	     *Map->valueY[BOSSPRACTICE_VY_STATE_BOSSTYPE])/MAP_YMAX);

  mWindow->invalidate_rect(rect,false);
  
  if(control->okValue>0){
    control->okValue=0;
    bossType=Map->valueY[BOSSPRACTICE_VY_STATE_BOSSTYPE];
    Map->state=BOSSPRACTICE_STATE_BOSSMODE;
  }
  else if(control->cancelValue>0){
    control->cancelValue=0;
    Map->ChangeType(SELECT_MAP_TITLE);
  }
}

void BossPractice::BossModeSelect(){
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);
  std::stringstream ss;
  int px0,py0;
  int px1,py1;
  int tmpX;

  frame->draw_rectangle(blackGC,true,0,0,WIDTH,HEIGHT);
  
  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(350)/MAP_YMAX;
  text->DrawString(bossName[bossType],color->white,px0,py0,
		   FONT_LINE_CENTER,20,
		   FONT_SERIF,FONT_FACE_ITALIC);

  px1=WIDTH*(BOSSPRACTICE_BOSSMODE_PX1)/MAP_XMAX;
  px0=px1;
  py0=HEIGHT*(BOSSPRACTICE_BOSSMODE_PY1+BOSSPRACTICE_BOSSMODE_MY1
	      *BOSSPRACTICE_BOSSMODE_VEASY)/MAP_YMAX;
  text->DrawString
    ("VERY EASY",color->white,px0,py0,
     BOSSPRACTICE_BOSSMODE_LF1,BOSSPRACTICE_BOSSMODE_SF1,
     BOSSPRACTICE_BOSSMODE_TF1,BOSSPRACTICE_BOSSMODE_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  px1=WIDTH*(BOSSPRACTICE_BOSSMODE_PX1)/MAP_XMAX;
  px0=px1;
  py0=HEIGHT*(BOSSPRACTICE_BOSSMODE_PY1+BOSSPRACTICE_BOSSMODE_MY1
	      *BOSSPRACTICE_BOSSMODE_EASY)/MAP_YMAX;
  text->DrawString
    ("EASY",color->white,px0,py0,
     BOSSPRACTICE_BOSSMODE_LF1,BOSSPRACTICE_BOSSMODE_SF1,
     BOSSPRACTICE_BOSSMODE_TF1,BOSSPRACTICE_BOSSMODE_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  px1=WIDTH*(BOSSPRACTICE_BOSSMODE_PX1)/MAP_XMAX;
  px0=px1;
  py0=HEIGHT*(BOSSPRACTICE_BOSSMODE_PY1+BOSSPRACTICE_BOSSMODE_MY1
	      *BOSSPRACTICE_BOSSMODE_NORMAL)/MAP_YMAX;
  text->DrawString
    ("NORMAL",color->white,px0,py0,
     BOSSPRACTICE_BOSSMODE_LF1,BOSSPRACTICE_BOSSMODE_SF1,
     BOSSPRACTICE_BOSSMODE_TF1,BOSSPRACTICE_BOSSMODE_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  px1=WIDTH*(BOSSPRACTICE_BOSSMODE_PX1)/MAP_XMAX;
  px0=px1;
  py0=HEIGHT*(BOSSPRACTICE_BOSSMODE_PY1+BOSSPRACTICE_BOSSMODE_MY1
	      *BOSSPRACTICE_BOSSMODE_HARD)/MAP_YMAX;
  text->DrawString
    ("HARD",color->white,px0,py0,
     BOSSPRACTICE_BOSSMODE_LF1,BOSSPRACTICE_BOSSMODE_SF1,
     BOSSPRACTICE_BOSSMODE_TF1,BOSSPRACTICE_BOSSMODE_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  px1=WIDTH*(BOSSPRACTICE_BOSSMODE_PX1)/MAP_XMAX;
  px0=px1;
  py0=HEIGHT*(BOSSPRACTICE_BOSSMODE_PY1+BOSSPRACTICE_BOSSMODE_MY1
	      *BOSSPRACTICE_BOSSMODE_VHARD)/MAP_YMAX;
  text->DrawString
    ("VERY HARD",color->white,px0,py0,
     BOSSPRACTICE_BOSSMODE_LF1,BOSSPRACTICE_BOSSMODE_SF1,
     BOSSPRACTICE_BOSSMODE_TF1,BOSSPRACTICE_BOSSMODE_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  StepSelectAction(&tmpX,&Map->valueY[BOSSPRACTICE_VY_STATE_BOSSMODE]);

  if(Map->valueY[BOSSPRACTICE_VY_STATE_BOSSMODE]<0){
    Map->valueY[BOSSPRACTICE_VY_STATE_BOSSMODE]=
      BOSSPRACTICE_BOSSMODE_NUM-1;
  }
  else if(Map->valueY[BOSSPRACTICE_VY_STATE_BOSSMODE]>=
	  BOSSPRACTICE_BOSSMODE_NUM){
    Map->valueY[BOSSPRACTICE_VY_STATE_BOSSMODE]=0;
  }

  enemyList->DrawSprite
    (EN_REV_BIRD,EN_WAY_B,2,
     WIDTH*(400)/MAP_XMAX,
     HEIGHT*(BOSSPRACTICE_BOSSMODE_PY1
	     +BOSSPRACTICE_BOSSMODE_MY1
	     *Map->valueY[BOSSPRACTICE_VY_STATE_BOSSMODE])/MAP_YMAX);

  mWindow->invalidate_rect(rect,false);
  
  if(control->okValue>0){
    control->okValue=0;

    bossMode=Map->valueY[BOSSPRACTICE_VY_STATE_BOSSMODE];
    Map->state=BOSSPRACTICE_STATE_START;
  }
  else if(control->cancelValue>0){
    control->cancelValue=0;
    Map->state=BOSSPRACTICE_STATE_BOSSTYPE;
  }
}

void BossPractice::StartSlide(){
  int px0,py0;
  std::stringstream ss;
  std::string str;
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);

  frame->draw_rectangle(blackGC,true,0,0,WIDTH,HEIGHT);

  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(500)/MAP_YMAX;
  ss<<"BOSS "<<bossName[bossType]<<" "<<bossModeName[bossMode];
  str=ss.str();
  text->DrawString
    (str,(color->white),px0,py0,FONT_LINE_CENTER,
     35,FONT_SERIF,FONT_FACE_REGULAR);
  ss.str("");
  ss.clear(std::stringstream::goodbit);
  
  mWindow->invalidate_rect(rect,false);
  
  if(control->okValue>0){
    Map->state=BOSSPRACTICE_STATE_BOSS;

    if(LoadBackGround("image/bosspractice.png")==0){
      FigureBackGround(10000,1000,0,0);
    }
    else{
      std::cout<<"ERROR BACKGROUND"<<std::endl;
    }

    Map->minW=(-500)*WIDTH/WIDTH_RATE;
    Map->maxW=(1500)*WIDTH/WIDTH_RATE;  
    Map->minH=(-500)*HEIGHT/HEIGHT_RATE;
    Map->maxH=(1500)*HEIGHT/HEIGHT_RATE;
    bgBoss=0;
  }
}
void BossPractice::PauseMap(){
  PauseMenuView(&Map->valueY[BOSSPRACTICE_VY_STATE_PAUSE],
		STAGE_CHANGE_TYPE,SELECT_MAP_TITLE);
}

int BossPractice::BossSilkHatAction(){  
  int flag=0;

  bgBoss=bossSilkhat->Act(bgBoss,bossMode);

  return flag;
}
int BossPractice::BossCrowdAction(){
  int flag=0;
  
  bgBoss=bossCrowd->Act
    (bgBoss,bossMode,&(enemyList->listSize));

  return flag;
}
int BossPractice::BossEagleAction(){
  int flag=0;
  
  bgBoss=bossEagle->Act(bgBoss,bossMode);

  return flag;
}
int (BossPractice::*BossPractice::
     BOSSPRACTICE_BOSS_SELECT[BOSSPRACTICE_BOSS_NUM])()={
  &BossPractice::BossSilkHatAction,
  &BossPractice::BossCrowdAction,
  &BossPractice::BossEagleAction
};

void BossPractice::BossMap(){
  std::stringstream ss;
  std::string str;
  int enemyCount,playerFireCount,enemyFireCount,landCount,itemCount;
  int px0,py0;
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);

  RunBackGround();
  
  landCount=landList->Animate();
  enemyCount=enemyList->Animate();
  playerFireCount=pfireList->Animate();
  enemyFireCount=efireList->Animate();
  player->Animate();
  itemCount=itemList->Animate();

  if(bgBoss==BOSS_ACT_INIT){
    bgPW=0;
    bgPH=0;
    Map->speedX=-4;
    Map->speedY=-1;
    BossBGMoveSet(2000,250);
    bgBoss=BOSS_ACT_BGRUN;
  }
  else if(bgBoss==BOSS_ACT_BGRUN){
    (this->*BOSSPRACTICE_BOSS_SELECT[bossType])();
    BGMoveReverse(4,1);
  }
  else if(bgBoss==BOSS_ACT_BGSTOP){
    (this->*BOSSPRACTICE_BOSS_SELECT[bossType])();
    Map->speedX=0;
    Map->speedY=0;
  }
  else if(bgBoss==BOSS_ACT_END){
    Map->state=BOSSPRACTICE_STATE_END; 
  }

  GameStatusView(STAGE_STATUSVIEW_DEAD);
  
  if(control->cancelValue==1){
    control->cancelValue=0;
    Map->state0=Map->state;
    Map->state=BOSSPRACTICE_STATE_PAUSE;
  }
  
  mWindow->invalidate_rect(rect,false);
  /*
  std::cout<<"(MODE,BG)=("<<Map->mode<<","<<bgBoss<<")"<<std::endl;
  */
  Map->sec++;
}
void BossPractice::EndSlide(){
  NameDialog diag;
  int value;
  int px0,py0;

  std::stringstream ss;
  std::string str;
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);

  frame->draw_rectangle(blackGC,true,0,0,WIDTH,HEIGHT);

  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(400)/MAP_YMAX;
  ss<<"BOSS "<<bossName[bossType]<<" "<<bossModeName[bossMode];
  str=ss.str();
  text->DrawString
    (str,(color->white),px0,py0,FONT_LINE_CENTER,35,
     FONT_SERIF,FONT_FACE_REGULAR);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(600)/MAP_YMAX;
  ss<<"DEAD : "<<(player->life-STAGE_FLIPLIFE_MAX)*-1;
  str=ss.str();
  text->DrawString
    (str,(color->white),px0,py0,FONT_LINE_CENTER,
     15,FONT_SERIF,FONT_FACE_REGULAR);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(700)/MAP_YMAX;
  ss<<"SEC : "<<Map->sec/50<<"."<<(Map->sec/5)%10<<(Map->sec*2)%10;
  str=ss.str();
  text->DrawString
    (str,(color->white),px0,py0,FONT_LINE_CENTER,
     15,FONT_SERIF,FONT_FACE_REGULAR);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(800)/MAP_YMAX;
  ss<<"SCORE : "<<player->score;
  str=ss.str();
  text->DrawString
    (str,(color->white),px0,py0,FONT_LINE_CENTER,
     15,FONT_SERIF,FONT_FACE_REGULAR);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  mWindow->invalidate_rect(rect,false);

  while(value=diag.Run()){
    if(value==Gtk::RESPONSE_OK){
      scoreFile->WriteFile
	(player->score,(player->life-STAGE_FLIPLIFE_MAX),
	 Map->sec,SCORE_MODE_BOSSPRACTICE,CalcBossID(),
	 bossName[Map->mode],diag.GetName());
      break;
    }
    else if(value==Gtk::RESPONSE_DELETE_EVENT){
      
    }
  }

  Map->ChangeType(SELECT_MAP_TITLE);
}

void (BossPractice::*BossPractice::BOSSPRACTICE_STATE_SELECT
      [BOSSPRACTICE_STATE_NUM])()={
	&BossPractice::BossTypeSelect,
	&BossPractice::BossModeSelect,
	&BossPractice::StartSlide,
	&BossPractice::PauseMap,
	&BossPractice::BossMap,
	&BossPractice::EndSlide
};

void BossPractice::ViewMap(){
  (this->*BOSSPRACTICE_STATE_SELECT[Map->state])();
}
