#ifndef BIRD_BOSS_PRACRICE_H_
#define BIRD_BOSS_PRACRICE_H_

#include "basestage.h"
#include "namedialog.h"
#include "bosssilkhat.h"
#include "bosscrowd.h"
#include "bosseagle.h"

#define BOSSPRACTICE_STATE_BOSSTYPE 0
#define BOSSPRACTICE_STATE_BOSSMODE 1
#define BOSSPRACTICE_STATE_START 2
#define BOSSPRACTICE_STATE_PAUSE 3
#define BOSSPRACTICE_STATE_BOSS 4
#define BOSSPRACTICE_STATE_END 5
#define BOSSPRACTICE_STATE_NUM 6

#define BOSSPRACTICE_BOSSTYPE_PX1 420
#define BOSSPRACTICE_BOSSTYPE_PY1 500
#define BOSSPRACTICE_BOSSTYPE_MX1 0
#define BOSSPRACTICE_BOSSTYPE_MY1 60
#define BOSSPRACTICE_BOSSTYPE_SX1 0
#define BOSSPRACTICE_BOSSTYPE_SY1 0
#define BOSSPRACTICE_BOSSTYPE_SF1 12
#define BOSSPRACTICE_BOSSTYPE_LF1 FONT_LINE_LEFT
#define BOSSPRACTICE_BOSSTYPE_TF1 FONT_SERIF
#define BOSSPRACTICE_BOSSTYPE_FF1 FONT_FACE_BOLD

#define BOSSPRACTICE_BOSS_SILKHAT 0
#define BOSSPRACTICE_BOSS_CROWD 1
#define BOSSPRACTICE_BOSS_EAGLE 2
#define BOSSPRACTICE_BOSS_NUM 3

#define BOSSPRACTICE_BOSSMODE_PX1 420
#define BOSSPRACTICE_BOSSMODE_PY1 500
#define BOSSPRACTICE_BOSSMODE_MX1 0
#define BOSSPRACTICE_BOSSMODE_MY1 60
#define BOSSPRACTICE_BOSSMODE_SX1 0
#define BOSSPRACTICE_BOSSMODE_SY1 0
#define BOSSPRACTICE_BOSSMODE_SF1 12
#define BOSSPRACTICE_BOSSMODE_LF1 FONT_LINE_LEFT
#define BOSSPRACTICE_BOSSMODE_TF1 FONT_SERIF
#define BOSSPRACTICE_BOSSMODE_FF1 FONT_FACE_BOLD

#define BOSSPRACTICE_BOSSMODE_VEASY 0
#define BOSSPRACTICE_BOSSMODE_EASY 1
#define BOSSPRACTICE_BOSSMODE_NORMAL 2
#define BOSSPRACTICE_BOSSMODE_HARD 3
#define BOSSPRACTICE_BOSSMODE_VHARD 4
#define BOSSPRACTICE_BOSSMODE_NUM 5

#define BOSSPRACTICE_VY_STATE_PAUSE 0
#define BOSSPRACTICE_VY_STATE_BOSSTYPE 1
#define BOSSPRACTICE_VY_STATE_BOSSMODE 2

class BossPractice : public BaseStage {
 public:
  BossSilkHat *bossSilkhat;
  BossCrowd *bossCrowd;
  BossEagle *bossEagle;
  int bossType;
  int bossMode;
  std::string bossName[BOSSPRACTICE_BOSS_NUM];
  std::string bossModeName[BOSSPRACTICE_BOSSMODE_NUM];
  BossPractice();
  ~BossPractice();
  void Create();

  int CalcBossID();

  void BossTypeSelect();
  void BossModeSelect();

  void StartSlide();
  void PauseMap();

  int NoBossAction();
  int BossSilkHatAction();
  int BossCrowdAction();
  int BossEagleAction();
  static int(BossPractice::*BOSSPRACTICE_BOSS_SELECT
       [BOSSPRACTICE_BOSS_NUM])();

  void BossMap();
  void EndSlide();
  
  static void(BossPractice::*BOSSPRACTICE_STATE_SELECT
	      [BOSSPRACTICE_STATE_NUM])();

  void ViewMap();
};

#endif
