#ifndef BIRD_BOSS_SILKHAT_H_
#define BIRD_BOSS_SILKHAT_H_

#include <gtkmm.h>
#include "bossbase.h"

#define BOSS_SILKHAT_ATTACK_FREQ_MAX 1000

#define BOSS_SILKHAT_MODE_VEASY 0
#define BOSS_SILKHAT_MODE_EASY 1
#define BOSS_SILKHAT_MODE_NORMAL 2
#define BOSS_SILKHAT_MODE_HARD 3
#define BOSS_SILKHAT_MODE_VHARD 4
#define BOSS_SILKHAT_MODE_NUM 5

#define BOSS_SILKHAT_STATE_START 0
#define BOSS_SILKHAT_STATE_ACT 1
#define BOSS_SILKHAT_STATE_EXPLODE 2
#define BOSS_SILKHAT_STATE_DEAD 3
#define BOSS_SILKHAT_STATE_NUM 4

#define BOSS_SILKHAT_EXPLODE_START 40
#define BOSS_SILKHAT_EXPLODE_INTERVAL 1

/*
  VEASY
*/

#define BOSS_SILKHAT_VEASY_ATTACK_CHANGE 0
#define BOSS_SILKHAT_VEASY_ATTACK_STRBIRD 1
#define BOSS_SILKHAT_VEASY_ATTACK_NUM 2

#define BOSS_SILKHAT_VEASY_ANGLE_CHANGE 0
#define BOSS_SILKHAT_VEASY_ANGLE_STOP 1
#define BOSS_SILKHAT_VEASY_ANGLE_TARGET 2
#define BOSS_SILKHAT_VEASY_ANGLE_HOMING 3
#define BOSS_SILKHAT_VEASY_ANGLE_ROTATE 4
#define BOSS_SILKHAT_VEASY_ANGLE_NUM 5

#define BOSS_SILKHAT_VEASY_MOV_CHANGE 0
#define BOSS_SILKHAT_VEASY_MOV_STOP 1
#define BOSS_SILKHAT_VEASY_MOV_STRAIGHT 2
#define BOSS_SILKHAT_VEASY_MOV_TARGET 3
#define BOSS_SILKHAT_VEASY_MOV_HOMING 4
#define BOSS_SILKHAT_VEASY_MOV_AVOID 5
#define BOSS_SILKHAT_VEASY_MOV_NUM 6

/*
  EASY
*/

#define BOSS_SILKHAT_EASY_ATTACK_CHANGE 0
#define BOSS_SILKHAT_EASY_ATTACK_STRBIRD 1
#define BOSS_SILKHAT_EASY_ATTACK_NUM 2

#define BOSS_SILKHAT_EASY_ANGLE_CHANGE 0
#define BOSS_SILKHAT_EASY_ANGLE_STOP 1
#define BOSS_SILKHAT_EASY_ANGLE_TARGET 2
#define BOSS_SILKHAT_EASY_ANGLE_HOMING 3
#define BOSS_SILKHAT_EASY_ANGLE_ROTATE 4
#define BOSS_SILKHAT_EASY_ANGLE_NUM 5

#define BOSS_SILKHAT_EASY_MOV_CHANGE 0
#define BOSS_SILKHAT_EASY_MOV_STOP 1
#define BOSS_SILKHAT_EASY_MOV_STRAIGHT 2
#define BOSS_SILKHAT_EASY_MOV_TARGET 3
#define BOSS_SILKHAT_EASY_MOV_HOMING 4
#define BOSS_SILKHAT_EASY_MOV_AVOID 5
#define BOSS_SILKHAT_EASY_MOV_NUM 6

/*
  NORMAL
*/

#define BOSS_SILKHAT_NORMAL_ATTACK_CHANGE 0
#define BOSS_SILKHAT_NORMAL_ATTACK_STRBIRD 1
#define BOSS_SILKHAT_NORMAL_ATTACK_REVBIRD 2
#define BOSS_SILKHAT_NORMAL_ATTACK_HOMBIRD 3
#define BOSS_SILKHAT_NORMAL_ATTACK_NUM 4

#define BOSS_SILKHAT_NORMAL_ANGLE_CHANGE 0
#define BOSS_SILKHAT_NORMAL_ANGLE_STOP 1
#define BOSS_SILKHAT_NORMAL_ANGLE_HOMING 2
#define BOSS_SILKHAT_NORMAL_ANGLE_ROTATE 3
#define BOSS_SILKHAT_NORMAL_ANGLE_AVOID 4
#define BOSS_SILKHAT_NORMAL_ANGLE_NUM 5

#define BOSS_SILKHAT_NORMAL_MOV_CHANGE 0
#define BOSS_SILKHAT_NORMAL_MOV_STOP 1
#define BOSS_SILKHAT_NORMAL_MOV_STRAIGHT 2
#define BOSS_SILKHAT_NORMAL_MOV_TARGET 3
#define BOSS_SILKHAT_NORMAL_MOV_HOMING 4
#define BOSS_SILKHAT_NORMAL_MOV_AVOID 5
#define BOSS_SILKHAT_NORMAL_MOV_NUM 6

/*
  HARD
*/

#define BOSS_SILKHAT_HARD_ATTACK_CHANGE 0
#define BOSS_SILKHAT_HARD_ATTACK_STRBIRD 1
#define BOSS_SILKHAT_HARD_ATTACK_NUM 2

#define BOSS_SILKHAT_HARD_ANGLE_CHANGE 0
#define BOSS_SILKHAT_HARD_ANGLE_STOP 1
#define BOSS_SILKHAT_HARD_ANGLE_TARGET 2
#define BOSS_SILKHAT_HARD_ANGLE_HOMING 3
#define BOSS_SILKHAT_HARD_ANGLE_ROTATE 4
#define BOSS_SILKHAT_HARD_ANGLE_NUM 5

#define BOSS_SILKHAT_HARD_MOV_CHANGE 0
#define BOSS_SILKHAT_HARD_MOV_STOP 1
#define BOSS_SILKHAT_HARD_MOV_STRAIGHT 2
#define BOSS_SILKHAT_HARD_MOV_TARGET 3
#define BOSS_SILKHAT_HARD_MOV_HOMING 4
#define BOSS_SILKHAT_HARD_MOV_AVOID 5
#define BOSS_SILKHAT_HARD_MOV_NUM 6

/*
  VHARD
*/

#define BOSS_SILKHAT_VHARD_ATTACK_CHANGE 0
#define BOSS_SILKHAT_VHARD_ATTACK_STRBIRD 1
#define BOSS_SILKHAT_VHARD_ATTACK_REVBIRD 2
#define BOSS_SILKHAT_VHARD_ATTACK_HOMBIRD 3
#define BOSS_SILKHAT_VHARD_ATTACK_NUM 4

#define BOSS_SILKHAT_VHARD_ANGLE_CHANGE 0
#define BOSS_SILKHAT_VHARD_ANGLE_STOP 1
#define BOSS_SILKHAT_VHARD_ANGLE_HOMING 2
#define BOSS_SILKHAT_VHARD_ANGLE_ROTATE 3
#define BOSS_SILKHAT_VHARD_ANGLE_AVOID 4
#define BOSS_SILKHAT_VHARD_ANGLE_NUM 5

#define BOSS_SILKHAT_VHARD_MOV_CHANGE 0
#define BOSS_SILKHAT_VHARD_MOV_STOP 1
#define BOSS_SILKHAT_VHARD_MOV_STRAIGHT 2
#define BOSS_SILKHAT_VHARD_MOV_TARGET 3
#define BOSS_SILKHAT_VHARD_MOV_HOMING 4
#define BOSS_SILKHAT_VHARD_MOV_AVOID 5
#define BOSS_SILKHAT_VHARD_MOV_NUM 6

class BossSilkHat :public BossBase{
 public:
  Glib::RefPtr<Gdk::GC> darkBlueGC;
  int lifeList[BOSS_SILKHAT_MODE_NUM];
  int attackChange[BOSS_SILKHAT_MODE_NUM];
  int angleChange[BOSS_SILKHAT_MODE_NUM];
  int moveChange[BOSS_SILKHAT_MODE_NUM];
  int moveStraight[BOSS_SILKHAT_MODE_NUM];
  std::vector<Gdk::Point> hatPoints;
  std::vector<Gdk::Point> edgePoints;
  std::vector<Gdk::Point> passPoints;
  std::vector<Gdk::Point> damagePoints;
  BossSilkHat();
  ~BossSilkHat();
  void Create();

  void CallStrBird();
  void CallRevBird();
  void CallHomBird();

  void StrBirdAttackFreq();
  void RevBirdAttackFreq();
  void HomBirdAttackFreq();

  void SilkHatAngleStop();
  void SilkHatAngleTarget();
  void SilkHatAngleHoming();
  void SilkHatAngleRotate();
  void SilkHatAngleAvoid();

  void SilkHatMoveStop();
  void SilkHatMoveStraight();
  void SilkHatMoveTarget();
  void SilkHatMoveHoming();
  void SilkHatMoveAvoid();

  void Draw();


  int StartState(int bgBoss,int mode0);
  int ActState(int bgBoss,int mode0);
  int ExplodeState(int bgBoss,int mode0);
  int DeadState(int bgBoss,int mode0);
  static int
    (BossSilkHat::*BOSS_SILKHAT_STATE_SELECT[BOSS_SILKHAT_STATE_NUM])
    (int bgBoss,int mode0);
  
  int Act(int bgBoss0,int mode0);

  void VEasyStart();
  void EasyStart();
  void NormalStart();
  void HardStart();
  void VHardStart();
  static void
    (BossSilkHat::*BOSS_SILKHAT_START_SELECT[BOSS_SILKHAT_MODE_NUM])();

  void VEasyAct();
  void EasyAct();
  void NormalAct();
  void HardAct();
  void VHardAct();
  static void
    (BossSilkHat::*BOSS_SILKHAT_ACT_SELECT[BOSS_SILKHAT_MODE_NUM])();

  void VEasyAttackChange();
  void VEasyAngleChange();
  void VEasyMoveChange();
  static void(BossSilkHat::*BOSS_SILKHAT_VEASY_ATTACK_SELECT
	      [BOSS_SILKHAT_VEASY_ATTACK_NUM])();
  static void(BossSilkHat::*BOSS_SILKHAT_VEASY_ANGLE_SELECT
	      [BOSS_SILKHAT_VEASY_ANGLE_NUM])();
  static void(BossSilkHat::*BOSS_SILKHAT_VEASY_MOV_SELECT
	      [BOSS_SILKHAT_VEASY_MOV_NUM])();

  void EasyAttackChange();
  void EasyAngleChange();
  void EasyMoveChange();
  static void(BossSilkHat::*BOSS_SILKHAT_EASY_ATTACK_SELECT
	      [BOSS_SILKHAT_EASY_ATTACK_NUM])();
  static void(BossSilkHat::*BOSS_SILKHAT_EASY_ANGLE_SELECT
	      [BOSS_SILKHAT_EASY_ANGLE_NUM])();
  static void(BossSilkHat::*BOSS_SILKHAT_EASY_MOV_SELECT
	      [BOSS_SILKHAT_EASY_MOV_NUM])();

  void NormalAttackChange();
  void NormalAngleChange();
  void NormalMoveChange();
  static void(BossSilkHat::*BOSS_SILKHAT_NORMAL_ATTACK_SELECT
	      [BOSS_SILKHAT_NORMAL_ATTACK_NUM])();
  static void(BossSilkHat::*BOSS_SILKHAT_NORMAL_ANGLE_SELECT
	      [BOSS_SILKHAT_NORMAL_ANGLE_NUM])();
  static void(BossSilkHat::*BOSS_SILKHAT_NORMAL_MOV_SELECT
	      [BOSS_SILKHAT_NORMAL_MOV_NUM])();

  void HardAttackChange();
  void HardAngleChange();
  void HardMoveChange();
  static void(BossSilkHat::*BOSS_SILKHAT_HARD_ATTACK_SELECT
	      [BOSS_SILKHAT_HARD_ATTACK_NUM])();
  static void(BossSilkHat::*BOSS_SILKHAT_HARD_ANGLE_SELECT
	      [BOSS_SILKHAT_HARD_ANGLE_NUM])();
  static void(BossSilkHat::*BOSS_SILKHAT_HARD_MOV_SELECT
	      [BOSS_SILKHAT_HARD_MOV_NUM])();

  void VHardAttackChange();
  void VHardAngleChange();
  void VHardMoveChange();
  static void(BossSilkHat::*BOSS_SILKHAT_VHARD_ATTACK_SELECT
	      [BOSS_SILKHAT_VHARD_ATTACK_NUM])();
  static void(BossSilkHat::*BOSS_SILKHAT_VHARD_ANGLE_SELECT
	      [BOSS_SILKHAT_VHARD_ANGLE_NUM])();
  static void(BossSilkHat::*BOSS_SILKHAT_VHARD_MOV_SELECT
	      [BOSS_SILKHAT_VHARD_MOV_NUM])();
};

#endif
