#include "control.h"
#include <gdk/gdkkeysyms.h>

BirdControl::BirdControl(){
  keyFlag=0;
  keyValue=-1;
  okKeyValue=0;
  cancelKeyValue=0;
  upKeyValue=0;
  downKeyValue=0;
  leftKeyValue=0;
  rightKeyValue=0;
  okKey1=GDK_Return;
  okKey2=GDK_KP_Enter;
  cancelKey=GDK_space;
  upKey=GDK_Up;
  downKey=GDK_Down;
  leftKey=GDK_Left;
  rightKey=GDK_Right;
  selectValue=0;
  okValue=0;
  cancelValue=0;
}

BirdControl::~BirdControl(){
  
}

void BirdControl::Create(Gtk::Window *window0){
  window0->signal_key_press_event().connect
    (sigc::mem_fun(*this,&BirdControl::KeyPressEvent),false);
  window0->signal_key_release_event().connect
    (sigc::mem_fun(*this,&BirdControl::KeyReleaseEvent),false);
}

std::string BirdControl::GetKeyName(guint value0){
  std::string name0;
  name0=gdk_keyval_name(value0);

  return name0;
}

guint BirdControl::GetOkKey(){
  return okKey2;
}
guint BirdControl::GetCancelKey(){
  return cancelKey;
}
guint BirdControl::GetLeftKey(){
  return leftKey;
}
guint BirdControl::GetRightKey(){
  return rightKey;
}
guint BirdControl::GetUpKey(){
  return upKey;
}
guint BirdControl::GetDownKey(){
  return downKey;
}

void BirdControl::SetOkKey(guint key0){
  okKey2=key0;
}
void BirdControl::SetCancelKey(guint key0){
  cancelKey=key0;
}
void BirdControl::SetLeftKey(guint key0){
  leftKey=key0;
}
void BirdControl::SetRightKey(guint key0){
  rightKey=key0;
}
void BirdControl::SetUpKey(guint key0){
  upKey=key0;
}
void BirdControl::SetDownKey(guint key0){
  downKey=key0;
}

void BirdControl::ChangeKeyFlag(int flag0){
  keyFlag=flag0;
  keyValue=-1;
}
int BirdControl::GetKeyValue(int &value0){
  value0=keyValue;
  return keyFlag;
}

void BirdControl::GameKeyPress(GdkEventKey *event){
    if(event->keyval==okKey1||event->keyval==okKey2){
    if(okKeyValue==0){
      okValue=1;
    }
    okKeyValue++;
  }
  else if(event->keyval==cancelKey){
    if(cancelKeyValue==0){
      cancelValue=1;
    }
    cancelKeyValue++;
  }
  else if(event->keyval==leftKey){
    if(leftKeyValue==0){
      selectValue=selectValue|1;
    }
    leftKeyValue++;
  }
  else if(event->keyval==upKey){
    if(upKeyValue==0){
      selectValue=selectValue|2;
    }
    upKeyValue++;
  }
  else if(event->keyval==rightKey){
    if(rightKeyValue==0){
      selectValue=selectValue|4;
    }
    rightKeyValue++;
  }
  else if(event->keyval==downKey){
    if(downKeyValue==0){
      selectValue=selectValue|8;
    }
    downKeyValue++;
  }
}

void BirdControl::ReceiveKeyPress(GdkEventKey *event){
  keyValue=event->keyval;
}

bool BirdControl::KeyPressEvent(GdkEventKey *event){
  /*
  std::cout<<"KEY PRESS"<<std::endl;
  std::cout<<"keyval: "<<event->keyval<<std::endl;
  std::cout<<"string: <"<<event->string<<">"<<std::endl;
  std::cout<<"keyname: <"<<gdk_keyval_name(event->keyval)
	   <<">"<<std::endl;
  std::cout<<"length: "<<event->length<<std::endl;
  std::cout<<"h-keycode: "<<event->hardware_keycode<<std::endl;
  */
  if(keyFlag==CONTROL_KEYFLAG_NO){
    GameKeyPress(event);
  }
  else if(keyFlag==CONTROL_KEYFLAG_RECEIVE){
    ReceiveKeyPress(event);
  }
}

void BirdControl::GameKeyRelease(GdkEventKey *event){
  if(event->keyval==okKey1||event->keyval==okKey2){
    if(okKeyValue>0){
      /*
      std::cout<<"OK KEY RELEASE"<<std::endl;
      */
      okKeyValue=0;
      okValue=0;
    }
  }
  else if(event->keyval==cancelKey){
    if(cancelKeyValue>0){
      /*
      std::cout<<"CANCEL KEY RELEASE"<<std::endl;
      */
      cancelKeyValue=0;
      cancelValue=0;
    }
  }
  else if(event->keyval==leftKey){
    if(leftKeyValue>0){
      /*
      std::cout<<"LEFT KEY RELEASE"<<std::endl;
      */
      leftKeyValue=0;
      selectValue-=selectValue&1;
    }
  }
  else if(event->keyval==upKey){
    if(upKeyValue>0){
      /*
      std::cout<<"UP KEY RELEASE"<<std::endl;
      */
      upKeyValue=0;
      selectValue-=selectValue&2;
    }
  }
  else if(event->keyval==rightKey){
    if(rightKeyValue>0){
      /*
      std::cout<<"RIGHT KEY RELEASE"<<std::endl;
      */
      rightKeyValue=0;
      selectValue-=selectValue&4;
    }
  }
  else if(event->keyval==downKey){
    if(downKeyValue>0){
      /*
      std::cout<<"DOWN KEY RELEASE"<<std::endl;
      */
      downKeyValue=0;
      selectValue-=selectValue&8;
    }
  }  
}

bool BirdControl::KeyReleaseEvent(GdkEventKey *event){
  /*
  std::cout<<"KEY RELEASE"<<std::endl;
  std::cout<<"keyval: "<<event->keyval<<std::endl;
  std::cout<<"string: "<<event->string<<std::endl;
  std::cout<<"length: "<<event->length<<std::endl;
  std::cout<<"h-keycode: "<<event->hardware_keycode<<std::endl;
  */

  if(keyFlag==CONTROL_KEYFLAG_NO){
    GameKeyRelease(event);
  }
  else if(keyFlag==CONTROL_KEYFLAG_RECEIVE){
    
  }

}


