#include "createbase.h"
#include "xpm/create.h"
#include "xpm/bird.h"

CreateBase::CreateBase(){

  mIcon=Gdk::Pixbuf::create_from_xpm_data((char **)bird_b2_xpm);

  points.push_back(Gdk::Point(0,0));
  points.push_back(Gdk::Point(0,0));
  points.push_back(Gdk::Point(0,0));
  points.push_back(Gdk::Point(0,0));
  points.push_back(Gdk::Point(0,0));

  waitSprite.xpm=(char **)waitmodal_xpm;
  endSprite.xpm=(char **)endmodal_xpm;

  waitSprite.pixbuf=Gdk::Pixbuf::create_from_xpm_data(waitSprite.xpm);
  waitSprite.width=(waitSprite.pixbuf)->get_width();
  waitSprite.height=(waitSprite.pixbuf)->get_height();
  
  endSprite.pixbuf=Gdk::Pixbuf::create_from_xpm_data(endSprite.xpm);
  endSprite.width=(endSprite.pixbuf)->get_width();
  endSprite.height=(endSprite.pixbuf)->get_height();

  try{
    wood=Gdk::Pixbuf::create_from_file("image/wood.png");
  }
  catch(...){
    wood.clear();
  }

  try{
    rock=Gdk::Pixbuf::create_from_file("image/rock.png");
  }
  catch(...){
    rock.clear();
  }

}

CreateBase::~CreateBase(){
  
}

void CreateBase::SetStage(BaseStage *baseStage0,
			  Glib::RefPtr<Gdk::Window> mWindow0,
			  Glib::RefPtr<Gdk::Pixmap> frame0){
  int i;
  baseStage=baseStage0;
  frame=frame0;
  mWindow=mWindow0;
  
  Map=baseStage->Map;

  text=baseStage->text;
  control=baseStage->control;
  color=baseStage->color;

  enemyList=baseStage->enemyList;
  landList=baseStage->landList;

 
  brownGC=Gdk::GC::create(mWindow);
  brownGC->set_rgb_fg_color(*(color->brown));
 
  grayGC=Gdk::GC::create(mWindow);
  grayGC->set_rgb_fg_color(*(color->gray));
 
  blackGC=Gdk::GC::create(mWindow);
  blackGC->set_rgb_fg_color(*(color->black));

  whiteGC=Gdk::GC::create(mWindow);
  whiteGC->set_rgb_fg_color(*(color->white));

  yellowGC=Gdk::GC::create(mWindow);
  yellowGC->set_rgb_fg_color(*(color->yellow)); 

  skyGC=Gdk::GC::create(mWindow);
  skyGC->set_rgb_fg_color(*(color->sky)); 

  i=0;
  while(i<CREATE_GC_NUM){
    GCList[i]=Gdk::GC::create(mWindow);
    i++;
  }
  GCList[CREATE_GC_BLACK]->set_rgb_fg_color(*(color->black)); 
  GCList[CREATE_GC_GRAY]->set_rgb_fg_color(*(color->gray));
  GCList[CREATE_GC_SKY]->set_rgb_fg_color(*(color->sky));
  GCList[CREATE_GC_RED]->set_rgb_fg_color(*(color->red));
  GCList[CREATE_GC_YELLOW]->set_rgb_fg_color(*(color->yellow));
  GCList[CREATE_GC_WHITE]->set_rgb_fg_color(*(color->white));
}

Gdk::Color CreateBase::ColorSelect
(int *A,int *A0,int An,Gdk::Color *colorA,
 int *B,int *B0,int Bn,Gdk::Color *colorB,
 Gdk::Color *color0){

  Gdk::Color *color;
  int i;
  int flagA=0;
  int flagB=0;
  
  if(An==0){
    flagA=1;
  }
  else{
    i=0;
    while(i<An){
      if(*(A+i)!=*(A0+i)){
	flagA=1;
	break;
      }
      i++;
    }
  }

  if(Bn==0){
    flagB=1;
  }
  else{
    i=0;
    while(i<Bn){
      if(*(B+i)!=*(B0+i)){
	flagB=1;
	break;
      }
      i++;
    }
  }

  if(flagA==0){
    color=colorA;
  }
  else if(flagB==0){
    color=colorB;
  }
  else{
    color=color0;
  }

  return *(color);
}

Gdk::Color *CreateBase::ColorSelect0
(int *A,int *A0,int An,Gdk::Color *colorA,
 int *B,int *B0,int Bn,Gdk::Color *colorB,
 Gdk::Color *color0){

  Gdk::Color *color;
  int i;
  int flagA=0;
  int flagB=0;
  
  if(An==0){
    flagA=1;
  }
  else{
    i=0;
    while(i<An){
      if(*(A+i)!=*(A0+i)){
	flagA=1;
	break;
      }
      i++;
    }
  }

  if(Bn==0){
    flagB=1;
  }
  else{
    i=0;
    while(i<Bn){
      if(*(B+i)!=*(B0+i)){
	flagB=1;
	break;
      }
      i++;
    }
  }

  if(flagA==0){
    color=colorA;
  }
  else if(flagB==0){
    color=colorB;
  }
  else{
    color=color0;
  }

  return color;
}

Glib::RefPtr<Gdk::GC> CreateBase::CursorGC
(int *A,int *A0,int An,int colorA,
 int *B,int *B0,int Bn,int colorB,
 int color0){
  Glib::RefPtr<Gdk::GC> gc;
  int i;
  int flagA=0;
  int flagB=0;
  
  if(An==0){
    flagA=1;
  }
  else{
    i=0;
    while(i<An){
      if(*(A+i)!=*(A0+i)){
	flagA=1;
	break;
      }
      i++;
    }
  }

  if(Bn==0){
    flagB=1;
  }
  else{
    i=0;
    while(i<Bn){
      if(*(B+i)!=*(B0+i)){
	flagB=1;
	break;
      }
      i++;
    }
  }

  if(flagA==0){
    gc=GCList[colorA];
  }
  else if(flagB==0){
    gc=GCList[colorB];
  }
  else{
    gc=GCList[color0];
  }

  return gc;
}

void CreateBase::RunWoodBG(int px0,int py0,int width0,int height0){
  if(wood){
    frame->draw_pixbuf
      (baseStage->mGC,wood,0,0,px0,py0,width0,height0,
       Gdk::RGB_DITHER_NONE,0,0);
  }
  else{
    frame->draw_rectangle(brownGC,true,px0,py0,width0,height0);
  }
}
void CreateBase::RunRockBG(int px0,int py0,int width0,int height0){
  if(rock){
    frame->draw_pixbuf
      (baseStage->mGC,rock,0,0,px0,py0,width0,height0,
       Gdk::RGB_DITHER_NONE,0,0);
  }
  else{
    frame->draw_rectangle(grayGC,true,px0,py0,width0,height0);
  }
}

void CreateBase::DrawCrowd(int px,int py,int type,int way){
  if(type!=0){
    enemyList->DrawSprite
      (baseStage->crowdStyle[type],way,baseStage->crowdSeq[type],px,py);
  }

}

void CreateBase::ScaleCrowd(int px,int py,int type,int way,
			    int width,int height){
  if(type!=0){
    enemyList->DrawScale
      (baseStage->crowdStyle[type],way,baseStage->crowdSeq[type],
       px,py,width,height);    
  }
}

void CreateBase::DrawNoLand(int px,int py,
			       int width,int height,
			       int color){

}
void CreateBase::DrawLandLeft(int px,int py,
			       int width,int height,
			       int color){
  points[0].set_x(px-width/2);
  points[0].set_y(py);
  points[1].set_x(px+width/2);
  points[1].set_y(py-height/2);
  points[2].set_x(px+width/2);
  points[2].set_y(py+height/2);
  points[3].set_x(px-width/2);
  points[3].set_y(py);
  
  frame->draw_polygon
    (landList->gcList[color],true,points);
}

void CreateBase::DrawLandRight(int px,int py,
			       int width,int height,
			       int color){
  points[0].set_x(px+width/2);
  points[0].set_y(py);
  points[1].set_x(px-width/2);
  points[1].set_y(py-height/2);
  points[2].set_x(px-width/2);
  points[2].set_y(py+height/2);
  points[3].set_x(px+width/2);
  points[3].set_y(py);
  
  frame->draw_polygon
    (landList->gcList[color],true,points);
}
void CreateBase::DrawLandUp(int px,int py,
			       int width,int height,
			       int color){
  points[0].set_x(px);
  points[0].set_y(py-height/2);
  points[1].set_x(px+width/2);
  points[1].set_y(py+height/2);
  points[2].set_x(px-width/2);
  points[2].set_y(py+height/2);
  points[3].set_x(px);
  points[3].set_y(py-height/2);
  
  frame->draw_polygon
    (landList->gcList[color],true,points);
}
void CreateBase::DrawLandDown(int px,int py,
			       int width,int height,
			       int color){
  points[0].set_x(px);
  points[0].set_y(py+height/2);
  points[1].set_x(px-width/2);
  points[1].set_y(py-height/2);
  points[2].set_x(px+width/2);
  points[2].set_y(py-height/2);
  points[3].set_x(px);
  points[3].set_y(py+height/2);
  
  frame->draw_polygon
    (landList->gcList[color],true,points);
}

void (CreateBase::*CreateBase::CREATE_DRAW_LAND_VIEW
      [MODAL_LAND_TYPE_NUM])
  (int px,int py,int width,int height,int color)={
    &CreateBase::DrawNoLand,
    &CreateBase::DrawLandLeft,
    &CreateBase::DrawLandRight,
    &CreateBase::DrawLandUp,
    &CreateBase::DrawLandDown
  };


void CreateBase::DrawLandView(int type,int color,
			       int px,int py,int width,int height){
  (this->*CREATE_DRAW_LAND_VIEW[type])(px,py,width,height,color);
}

void CreateBase::DrawModalView(StageModal *modal,
			       int px,int py,int width,int height){
  Glib::RefPtr<Gdk::Pixbuf> tBuf;
  std::stringstream ss;
  std::string str;

  if((modal->type==MODAL_TYPE_WSTATE)||
     (modal->type==MODAL_TYPE_WMAP)){
    tBuf=(waitSprite.pixbuf)->
      scale_simple(width,height,Gdk::INTERP_NEAREST);

  frame->draw_pixbuf(baseStage->mGC,tBuf,0,0,
		     px-(width/2),py-(height/2),
		     width,height,
		     Gdk::RGB_DITHER_NONE,0,0);
  }
  else if((modal->type==MODAL_TYPE_CHSTATE)||
	  (modal->type==MODAL_TYPE_WMAP)){
    tBuf=(endSprite.pixbuf)->
      scale_simple(width,height,Gdk::INTERP_NEAREST);
    
    frame->draw_pixbuf(baseStage->mGC,tBuf,0,0,
		     px-(width/2),py-(height/2),
		     width,height,
		     Gdk::RGB_DITHER_NONE,0,0);
  }
  else if(modal->type==MODAL_TYPE_SEL){
    if(modal->nLand>0){
      DrawLandView
      ((baseStage->mLand[modal->indexLand[0]]).type,
       (baseStage->mLand[modal->indexLand[0]]).color,
       px,py,width,height);
    }
    ScaleCrowd
      (px,py,
       (baseStage->mCrowd[modal->indexCrowd[0]]).type/CROWD_WAY_NUM,
       (baseStage->mCrowd[modal->indexCrowd[0]]).type%CROWD_WAY_NUM,
       32,32);
    
    ss<<"X:"<<modal->speedX*-1;
    str=ss.str(); 
    text->DrawDownCenter
      (str,*(color->white),px,py,10,FONT_TIMES);
    ss.str("");
    ss.clear(std::stringstream::goodbit);
    
    ss<<"Y:"<<modal->speedY*-1;
    str=ss.str(); 
    text->DrawUpCenter
      (str,*(color->white),px,py,10,FONT_TIMES);
    ss.str("");
    ss.clear(std::stringstream::goodbit);
  }
}

void CreateBase::CrowdIndexMap(int minW,int maxW,
			       int minH,int maxH){
  std::stringstream ss;
  std::string str; 
  int width,i;
  int item;
  int px,py,mx,my,n;

  int cursorA[10];
  int cursorA0[10];
  int cursorB[10];
  int cursorB0[10];

  int num0,num1;

  item=20;
  width=100;

  px=width+item*3/2;
  py=(minH+maxH)/2;
  mx=item*6/2;

  n=((maxW-minW)-width)/mx;

  if(Map->valueX[CREATE_VX_STATE_CROWDINDEX]<
     Map->valueX[CREATE_VX_STATE_CROWDINDEXPOS]){
    Map->valueX[CREATE_VX_STATE_CROWDINDEXPOS]
      =Map->valueX[CREATE_VX_STATE_CROWDINDEX];
  }
  else if(Map->valueX[CREATE_VX_STATE_CROWDINDEX]>=
	  Map->valueX[CREATE_VX_STATE_CROWDINDEXPOS]+n){
    Map->valueX[CREATE_VX_STATE_CROWDINDEXPOS]
      =Map->valueX[CREATE_VX_STATE_CROWDINDEX]-n+1;
  }

  num0=Map->valueX[CREATE_VX_STATE_CROWDINDEXPOS];
  num1=Map->valueX[CREATE_VX_STATE_CROWDINDEX];

  frame->draw_rectangle
    (blackGC,true,minW,minH,(maxW-minW),(maxH-minH));
  text->DrawCenter
    ("Crowd",*(color->white),width/2,py,20,FONT_SANS);

  cursorB[0]=Map->valueX[CREATE_VX_STATE_CROWDINDEX];
  cursorB0[0]=num0;
  cursorB[1]=Map->state;
  cursorB0[1]=CREATE_STATE_CROWDINDEX;

  i=0;
  while(i<n){
    cursorB0[0]=num0+i;
    frame->draw_rectangle
      (CursorGC(&cursorA[0],&cursorA0[0],0,CREATE_GC_RED,
		&cursorB[0],&cursorB0[0],2,CREATE_GC_YELLOW,
		CREATE_GC_SKY),
       true,(px+mx*i)-item,py-item,item*2,item*2);

    ss<<num0+i;
    str=ss.str(); 
    text->DrawDownCenter
      (str,*(color->white),(px+mx*i),py-item,10,FONT_TIMES);
    ss.str("");
    ss.clear(std::stringstream::goodbit);

    ScaleCrowd((px+mx*i),py,
	       (baseStage->mCrowd[num0+i]).type/CROWD_WAY_NUM,
	       (baseStage->mCrowd[num0+i]).type%CROWD_WAY_NUM,
	       32,32);

    ss<<(baseStage->mCrowd[num0+i]).type/CROWD_WAY_NUM;
    str=ss.str(); 
    text->DrawCenter
      (str,*(color->white),(px+mx*i),py,10,FONT_TIMES);
    ss.str("");
    ss.clear(std::stringstream::goodbit);


    i++;
  }

}

void CreateBase::LandIndexMap(int minW,int maxW,
			       int minH,int maxH){
  std::stringstream ss;
  std::string str; 
  int width,i;
  int item;
  int px,py,mx,my,n;

  int cursorA[10];
  int cursorA0[10];
  int cursorB[10];
  int cursorB0[10];

  int num0,num1;

  item=20;
  width=100;

  px=width+item*3/2;
  py=(minH+maxH)/2;
  mx=item*6/2;

  n=((maxW-minW)-width)/mx;

  if(Map->valueX[CREATE_VX_STATE_LANDINDEX]<
     Map->valueX[CREATE_VX_STATE_LANDINDEXPOS]){
    Map->valueX[CREATE_VX_STATE_LANDINDEXPOS]
      =Map->valueX[CREATE_VX_STATE_LANDINDEX];
  }
  else if(Map->valueX[CREATE_VX_STATE_LANDINDEX]>=
	  Map->valueX[CREATE_VX_STATE_LANDINDEXPOS]+n){
    Map->valueX[CREATE_VX_STATE_LANDINDEXPOS]
      =Map->valueX[CREATE_VX_STATE_LANDINDEX]-n+1;
  }

  num0=Map->valueX[CREATE_VX_STATE_LANDINDEXPOS];
  num1=Map->valueX[CREATE_VX_STATE_LANDINDEX];

  frame->draw_rectangle
    (blackGC,true,minW,minH,(maxW-minW),(maxH-minH));
  text->DrawCenter
    ("Land",*(color->white),width/2,py,20,FONT_SANS);

  cursorB[0]=Map->valueX[CREATE_VX_STATE_LANDINDEX];
  cursorB0[0]=num0;
  cursorB[1]=Map->state;
  cursorB0[1]=CREATE_STATE_LANDINDEX;

  i=0;
  while(i<n){
    cursorB0[0]=num0+i;
    frame->draw_rectangle
      (CursorGC(&cursorA[0],&cursorA0[0],0,CREATE_GC_RED,
		&cursorB[0],&cursorB0[0],2,CREATE_GC_YELLOW,
		CREATE_GC_SKY),
       true,(px+mx*i)-item,py-item,item*2,item*2);

    ss<<num0+i;
    str=ss.str(); 
    text->DrawDownCenter
      (str,*(color->white),(px+mx*i),py-item,10,FONT_TIMES);
    ss.str("");
    ss.clear(std::stringstream::goodbit);

    DrawLandView((baseStage->mLand[num0+i]).type,
		 (baseStage->mLand[num0+i]).color,
		 px+mx*i,py,item*2,item*2);

    ss<<(baseStage->mLand[num0+i]).type;
    str=ss.str(); 
    text->DrawCenter
      (str,*(color->white),(px+mx*i),py,10,FONT_TIMES);
    ss.str("");
    ss.clear(std::stringstream::goodbit);

    i++;
  }

}

void CreateBase::ModalIndexMap(int minW,int maxW,
			       int minH,int maxH){
  std::stringstream ss;
  std::string str; 
  int width,i;
  int item;
  int px,py,mx,my,n;

  int cursorA[10];
  int cursorA0[10];
  int cursorB[10];
  int cursorB0[10];

  int num0,num1;

  item=20;
  width=100;

  px=width+item*3/2;
  py=(minH+maxH)/2;
  mx=item*6/2;

  n=((maxW-minW)-width)/mx;

  if(Map->valueX[CREATE_VX_STATE_MODALINDEX]<0){
    Map->valueX[CREATE_VX_STATE_MODALINDEX]=STAGE_MODAL_MAX-1;
    Map->keyCount=1;
  }
  else if(Map->valueX[CREATE_VX_STATE_MODALINDEX]>=STAGE_MODAL_MAX){
    Map->valueX[CREATE_VX_STATE_MODALINDEX]=0;
    Map->keyCount=1;
  }

  if(Map->valueX[CREATE_VX_STATE_MODALINDEX]<
     Map->valueX[CREATE_VX_STATE_MODALINDEXPOS]){
    Map->valueX[CREATE_VX_STATE_MODALINDEXPOS]
      =Map->valueX[CREATE_VX_STATE_MODALINDEX];
  }
  else if(Map->valueX[CREATE_VX_STATE_MODALINDEX]>=
	  Map->valueX[CREATE_VX_STATE_MODALINDEXPOS]+n){
    Map->valueX[CREATE_VX_STATE_MODALINDEXPOS]
      =Map->valueX[CREATE_VX_STATE_MODALINDEX]-n+1;
  }

  num0=Map->valueX[CREATE_VX_STATE_MODALINDEXPOS];
  num1=Map->valueX[CREATE_VX_STATE_MODALINDEX];

  frame->draw_rectangle
    (blackGC,true,minW,minH,(maxW-minW),(maxH-minH));
  text->DrawCenter
    ("Modal",*(color->white),width/2,py,20,FONT_SANS);

  cursorB[0]=Map->valueX[CREATE_VX_STATE_MODALINDEX];
  cursorB0[0]=num0;
  cursorB[1]=Map->state;
  cursorB0[1]=CREATE_STATE_MODALINDEX;

  i=0;
  while(i<n){
    cursorB0[0]=num0+i;
    frame->draw_rectangle
      (CursorGC(&cursorA[0],&cursorA0[0],0,CREATE_GC_RED,
		&cursorB[0],&cursorB0[0],2,CREATE_GC_YELLOW,
		CREATE_GC_SKY),
       true,(px+mx*i)-item,py-item,item*2,item*2);

    ss<<num0+i;
    str=ss.str(); 
    text->DrawDownCenter
      (str,*(color->white),(px+mx*i),py-item,10,FONT_TIMES);
    ss.str("");
    ss.clear(std::stringstream::goodbit);
    
    DrawModalView(&(baseStage->mModal[num0+i]),
		  (px+mx*i),py,item*2,item*2);

    i++;
  }

}
