#ifndef BIRD_CREATE_LAND_H_
#define BIRD_CREATE_LAND_H_

#include <gtkmm.h>
#include "basestage.h"
#include "createbase.h"

#define CREATE_LAND_PX1 400
#define CREATE_LAND_PY1 500
#define CREATE_LAND_MX1 150
#define CREATE_LAND_MY1 480
#define CREATE_LAND_SX1 325
#define CREATE_LAND_SY1 450
#define CREATE_LAND_SF1 17
#define CREATE_LAND_LF1 FONT_LINE_RIGHT
#define CREATE_LAND_TF1 FONT_SERIF
#define CREATE_LAND_FF1 FONT_FACE_BOLD

#define CREATE_LAND_DW1 5
#define CREATE_LAND_DH1 5

#define CREATE_LAND_PX2 850
#define CREATE_LAND_PY2 100
#define CREATE_LAND_MX2 150
#define CREATE_LAND_MY2 120
#define CREATE_LAND_SX2 100
#define CREATE_LAND_SY2 50
#define CREATE_LAND_SF2 15
#define CREATE_LAND_LF2 FONT_LINE_CENTER
#define CREATE_LAND_TF2 FONT_SERIF
#define CREATE_LAND_FF2 FONT_FACE_BOLD

#define CREATE_LAND_DW2 5
#define CREATE_LAND_DH2 5

#define CREATE_LAND_TLINE 0
#define CREATE_LAND_MODAL 1
#define CREATE_LAND_CROWD 2
#define CREATE_LAND_TOP 3
#define CREATE_LAND_COPY 4
#define CREATE_LAND_LOAD 5
#define CREATE_LAND_RNUM 6

#define CREATE_LANDST_PX1 135
#define CREATE_LANDST_PY1 115
#define CREATE_LANDST_MX1 110
#define CREATE_LANDST_MY1 55
#define CREATE_LANDST_SX1 100
#define CREATE_LANDST_SY1 50
#define CREATE_LANDST_SF1 12
#define CREATE_LANDST_LF1 FONT_LINE_LEFT
#define CREATE_LANDST_TF1 FONT_SERIF
#define CREATE_LANDST_FF1 FONT_FACE_BOLD

#define CREATE_LANDST_PX2 245
#define CREATE_LANDST_PY2 115
#define CREATE_LANDST_MX2 100
#define CREATE_LANDST_MY2 55
#define CREATE_LANDST_SF2 15

#define CREATE_LANDST_TYPE 0
#define CREATE_LANDST_COLOR 1
#define CREATE_LANDST_FREQ 2
#define CREATE_LANDST_MINL 3
#define CREATE_LANDST_MAXL 4
#define CREATE_LANDST_MINR 5
#define CREATE_LANDST_MAXR 6
#define CREATE_LANDST_MINU 7
#define CREATE_LANDST_MAXU 8
#define CREATE_LANDST_MIND 9
#define CREATE_LANDST_MAXD 10
#define CREATE_LANDST_MINPX 11
#define CREATE_LANDST_MAXPX 12
#define CREATE_LANDST_MINPY 13
#define CREATE_LANDST_MAXPY 14
#define CREATE_LANDST_NUM 15

#define CREATE_LAND_SHIFT_EDIT 0
#define CREATE_LAND_SHIFT_COPY 1
#define CREATE_LAND_SHIFT_NUM 2

class CreateLand : public CreateBase{
  public:
  std::string landType[MODAL_LAND_TYPE_NUM];
  std::string landColor[LAND_COLOR_NUM];
  CreateLand();
  ~CreateLand();
  void Create();

  void LandStructText
    (int px1,int py1,int px2,int py2,Gdk::Color *color0,
     std::string name,std::string value);

  void LandTimeLineSelect();
  void LandModalSelect();
  void LandCrowdSelect();
  void LandTopSelect();
  void LandCopySelect();
  void LandLoadSelect();

  void LandLeftSelect();
  void LandRightSelect();

  void LandStructTypeRange(StageLand *land);
  void LandStructColorRange(StageLand *land);
  void LandStructFrequenceRange(StageLand *land);
  void LandStructMinLRange(StageLand *land);
  void LandStructMaxLRange(StageLand *land);
  void LandStructMinRRange(StageLand *land);
  void LandStructMaxRRange(StageLand *land);
  void LandStructMinURange(StageLand *land);
  void LandStructMaxURange(StageLand *land);
  void LandStructMinDRange(StageLand *land);
  void LandStructMaxDRange(StageLand *land);
  void LandStructMinPXRange(StageLand *land);
  void LandStructMaxPXRange(StageLand *land);
  void LandStructMinPYRange(StageLand *land);
  void LandStructMaxPYRange(StageLand *land);

  void ShiftLandSelect();
  void ShiftLandCopy();
  void ShiftLandStruct();

  void LandMenu();
};


#endif
