#ifndef BIRD_CREATE_MODAL_H_
#define BIRD_CREATE_MODAL_H_

#include <gtkmm.h>
#include "basestage.h"
#include "createbase.h"

#define CREATE_MODAL_PX1 400
#define CREATE_MODAL_PY1 500
#define CREATE_MODAL_MX1 150
#define CREATE_MODAL_MY1 480
#define CREATE_MODAL_SX1 325
#define CREATE_MODAL_SY1 450
#define CREATE_MODAL_SF1 17
#define CREATE_MODAL_LF1 FONT_LINE_RIGHT
#define CREATE_MODAL_TF1 FONT_SERIF
#define CREATE_MODAL_FF1 FONT_FACE_BOLD

#define CREATE_MODAL_DW1 5
#define CREATE_MODAL_DH1 5

#define CREATE_MODAL_PX2 850
#define CREATE_MODAL_PY2 100
#define CREATE_MODAL_MX2 150
#define CREATE_MODAL_MY2 120
#define CREATE_MODAL_SX2 100
#define CREATE_MODAL_SY2 50
#define CREATE_MODAL_SF2 15
#define CREATE_MODAL_LF2 FONT_LINE_CENTER
#define CREATE_MODAL_TF2 FONT_SERIF
#define CREATE_MODAL_FF2 FONT_FACE_BOLD

#define CREATE_MODAL_DW2 5
#define CREATE_MODAL_DH2 5

#define CREATE_MODAL_TLINE 0
#define CREATE_MODAL_LAND 1
#define CREATE_MODAL_CROWD 2
#define CREATE_MODAL_TOP 3
#define CREATE_MODAL_COPY 4
#define CREATE_MODAL_LOAD 5
#define CREATE_MODAL_RNUM 6

#define CREATE_MODALST_PX1 135
#define CREATE_MODALST_PY1 115
#define CREATE_MODALST_MX1 135
#define CREATE_MODALST_MY1 55
#define CREATE_MODALST_SF1 11
#define CREATE_MODALST_LF1 FONT_LINE_LEFT
#define CREATE_MODALST_TF1 FONT_SERIF
#define CREATE_MODALST_FF1 FONT_FACE_BOLD

#define CREATE_MODALST_PX2 280
#define CREATE_MODALST_PY2 115
#define CREATE_MODALST_MX2 100
#define CREATE_MODALST_MY2 55
#define CREATE_MODALST_SF2 15
#define CREATE_MODALST_LF2 FONT_LINE_LEFT
#define CREATE_MODALST_TF2 FONT_SERIF
#define CREATE_MODALST_FF2 FONT_FACE_BOLD

#define CREATE_MODALST_PX3 300
#define CREATE_MODALST_PY3 CREATE_MODALST_PY1+CREATE_MODALST_MY1*11
#define CREATE_MODALST_MX3 42
#define CREATE_MODALST_MY3 42
#define CREATE_MODALST_SX3 12
#define CREATE_MODALST_SY3 12
#define CREATE_MODALST_SF3 15

#define CREATE_MODALST_PX4 300
#define CREATE_MODALST_PY4 CREATE_MODALST_PY1+CREATE_MODALST_MY1*9
#define CREATE_MODALST_MX4 42
#define CREATE_MODALST_MY4 42
#define CREATE_MODALST_SX4 12
#define CREATE_MODALST_SY4 12
#define CREATE_MODALST_SF4 15

#define CREATE_MODALST_SPEEDX 0
#define CREATE_MODALST_SPEEDY 1
#define CREATE_MODALST_MINW 2
#define CREATE_MODALST_MAXW 3
#define CREATE_MODALST_MINH 4
#define CREATE_MODALST_MAXH 5
#define CREATE_MODALST_CRFREQ 6
#define CREATE_MODALST_NLAND 7
#define CREATE_MODALST_INDEXLAND 8
#define CREATE_MODALST_INDEXCR 9
#define CREATE_MODALST_ALLCROWD 10
#define CREATE_MODALST_NUM 11

#define CREATE_MODAL_SHIFT_EDIT 0
#define CREATE_MODAL_SHIFT_COPY 1
#define CREATE_MODAL_SHIFT_NUM 2

class CreateModal : public CreateBase{
  public:

  int StructPY[CREATE_MODALST_NUM];
  CreateModal();
  ~CreateModal();
  void Create();

  void ModalTimeLineSelect();
  void ModalLandSelect();
  void ModalCrowdSelect();
  void ModalTopSelect();
  void ModalCopySelect();
  void ModalLoadSelect();

  void ModalLeftSelect();
  void ModalRightSelect();

  void StructReturnSelect();
  void StructIndexCrowdSelect();
  void StructIndexLandSelect();

  void ModalStructSpeedXRange(StageModal *modal);
  void ModalStructSpeedYRange(StageModal *modal);
  void ModalStructMinWRange(StageModal *modal);
  void ModalStructMaxWRange(StageModal *modal);
  void ModalStructMinHRange(StageModal *modal);
  void ModalStructMaxHRange(StageModal *modal);
  void ModalStructCrowdFreqRange(StageModal *modal);
  void ModalStructNLandRange(StageModal *modal);
  void ModalStructIndexCrowdRange(StageModal *modal);
  void ModalStructALLCrowdRange(StageModal *modal);
  void ModalStructIndexLandRange(StageModal *modal);

  void ShiftModalSelect();
  void ShiftModalCopy();
  void ShiftModalStruct();
  void ShiftCrowdIndex();
  void ShiftLandIndex();

  void IndexCrowdView(int num,int index);
  void IndexLandView(int num,int index);

  void ModalStructText
    (int px1,int py1,int px2,int py2,Gdk::Color *color0,
     std::string name,std::string value);

  void ModalMenu();
};


#endif
