#include "createstage.h"

CreateStage::CreateStage(){
  createTop= new CreateTop();
  createCrowd= new CreateCrowd();
  createLand= new CreateLand();
  createModal= new CreateModal();
  createTimeLine= new CreateTimeLine();
  createBackGround= new CreateBackGround();
}

CreateStage::~CreateStage(){
  delete createTop;
  delete createCrowd;
  delete createLand;
  delete createModal;
  delete createTimeLine;
  delete createBackGround;
}

void CreateStage::Create(){
  StageCreate();

  createTop->SetStage(this,mWindow,frame);
  createCrowd->SetStage(this,mWindow,frame);
  createLand->SetStage(this,mWindow,frame);
  createModal->SetStage(this,mWindow,frame);
  createTimeLine->SetStage(this,mWindow,frame);
  createBackGround->SetStage(this,mWindow,frame);

  Map->sec=0;
  Map->state=0;
  Map->InitValue();

  Map->valueX[CREATE_STATE_TOP]=1;
  Map->valueY[CREATE_VY_CROWD_LPLACE]=1;
  Map->valueY[CREATE_VY_CROWD_LPOS]=1;
  Map->valueY[CREATE_VY_LAND_LPLACE]=1;
  Map->valueY[CREATE_VY_MODAL_LPLACE]=1;
  Map->valueY[CREATE_VY_TIMELINE_SHIFTTYPE]=CREATE_TIMELINE_LINETYPE_10S;
  Map->valueX[CREATE_VX_STATE_EXIT]=CREATE_EXIT_NO;
  Map->valueY[CREATE_VY_STATE_STATUS]=CREATE_VX_STATUS_NAME;

  SetModal();
}

void CreateStage::TopView(){
  createTop->TopMenu();
}
void CreateStage::CrowdView(){
  createCrowd->CrowdMenu();
}
void CreateStage::LandView(){
  createLand->LandMenu();
}
void CreateStage::ModalView(){
  createModal->ModalMenu();
}
void CreateStage::TimeLineView(){
  createTimeLine->Menu();
}
void CreateStage::BackGroundView(){
  createBackGround->Menu();
}
void CreateStage::GameView(){
  std::stringstream ss;
  std::string str;
  int enemyCount,playerFireCount,enemyFireCount,landCount,itemCount;
  int px0,py0;
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);

  RunBackGround();
  
  ModalTypeSelect(Map->sec);
  
  landCount=landList->Animate();
  enemyCount=enemyList->Animate();
  playerFireCount=pfireList->Animate();
  enemyFireCount=efireList->Animate();
  player->Animate();
  itemCount=itemList->Animate();
  
  GameStatusView(STAGE_STATUSVIEW_DEAD);

  mWindow->invalidate_rect(rect,false);
  Map->sec++;

  if(control->cancelValue==1){
    control->cancelValue=0;
    Map->state0=Map->state;
    Map->state=CREATE_STATE_PAUSE;
  }
}
void CreateStage::PauseView(){
  PauseMenuView(&Map->valueY[CREATE_VY_PAUSE_MENU],
		STAGE_CHANGE_STATE,CREATE_STATE_GAMEEND);
}
void CreateStage::GameStartSlide(){
  int px0,py0;
  int tmpY;
  int *movX0;
  std::stringstream ss;
  std::string str;
  
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);

  frame->draw_rectangle(blackGC,true,0,0,WIDTH,HEIGHT);
  
  ss<<"TestPlay "<<GetName(stageName);
  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(400)/MAP_YMAX;
  text->DrawString
    (ss.str(),(color->white),px0,py0,FONT_LINE_CENTER,
     35,FONT_SERIF,FONT_FACE_ITALIC);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  movX0=&Map->valueX[CREATE_VX_GAMESTART_POINT];

  VariableSelectAction
    (movX0,&tmpY,SELECTKEY_VARIABLE1);
  if(*movX0<0){
    *movX0=0;
  }
  else if(*movX0>(endLine/50)){
    *movX0=endLine/50;
  }
  
  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(600)/MAP_YMAX;
  ss<<"start : "<<(*movX0)<<"sec"<<" (end : "<<endLine/50<<"sec"<<")";
  str=ss.str();
  text->DrawString
    (str,(color->white),px0,py0,FONT_LINE_CENTER,
     12,FONT_SERIF,FONT_FACE_BOLD);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  mWindow->invalidate_rect(rect,false);

  if(control->okValue==1){
    control->okValue=0;
    enemyList->ALLDelete();
    efireList->ALLDelete();
    pfireList->ALLDelete();
    landList->ALLDelete();
    itemList->ALLDelete();
    
    player->InitPlayer(STAGE_FLIPLIFE_MAX,initFire,initForm);
    bgPX=bgStartX;
    bgPY=bgStartY;

    Map->sec=(*movX0)*50;

    CalcStageDistancePoint(Map->sec,bgPX,bgPY);

    Map->state=CREATE_STATE_PLAY;
  }
  else if(control->cancelValue==1){
    control->cancelValue=0;
    Map->state=CREATE_STATE_TOP;
  }
}
void CreateStage::GameEndSlide(){
  int px0,py0;
  std::stringstream ss;
  std::string str;
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);
  
  frame->draw_rectangle(blackGC,true,0,0,WIDTH,HEIGHT);

  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(400)/MAP_YMAX;
  ss<<GetName(stageName);
  text->DrawString
    (ss.str(),(color->white),px0,py0,FONT_LINE_CENTER,
     35,FONT_SERIF,FONT_FACE_ITALIC);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(600)/MAP_YMAX;
  ss<<"SCORE : "<<player->score;
  str=ss.str();
  text->DrawString
    (str,(color->white),px0,py0,FONT_LINE_CENTER,
     15,FONT_SERIF,FONT_FACE_REGULAR);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(700)/MAP_YMAX;
  ss<<"DEAD : "<<(player->life-STAGE_FLIPLIFE_MAX)*-1;
  str=ss.str();
  text->DrawString
    (str,(color->white),px0,py0,FONT_LINE_CENTER,
     15,FONT_SERIF,FONT_FACE_REGULAR);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  mWindow->invalidate_rect(rect,false);

  if(control->okValue==1){
    control->okValue=0;
    enemyList->ALLDelete();
    efireList->ALLDelete();
    pfireList->ALLDelete();
    landList->ALLDelete();
    itemList->ALLDelete();

    player->InitPlayer(0);
    bgPX=bgStartX;
    bgPY=bgStartY;
    Map->sec=0;
    Map->state=CREATE_STATE_TOP;
  }
}

void CreateStage::ExitYesSelect(int *mov0,int changeFlag,int value){
  if(changeFlag==STAGE_CHANGE_STATE){
    Map->state=value;
  }
  else if(changeFlag==STAGE_CHANGE_TYPE){
    Map->ChangeType(value);
  }
}
void CreateStage::ExitNoSelect(int *mov0,int changeFlag,int value){
  *mov0=CREATE_EXIT_NO;
  Map->state=Map->state0;
}
void (CreateStage::*CreateStage::CREATE_EXIT_SELECT[CREATE_EXIT_NUM])
  (int *mov0,int changeFlag,int value)={
  &CreateStage::ExitYesSelect,
  &CreateStage::ExitNoSelect
};

void CreateStage::ExitSlide(){
  int px0,py0;
  int px1,py1;
  int tmpY;
  int *movX0;
  
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);

  frame->draw_rectangle(blackGC,true,WIDTH/4,HEIGHT/4,WIDTH/2,HEIGHT/2);
  
  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(440)/MAP_YMAX;
  text->DrawString
    ("EXIT ?",(color->white),px0,py0,FONT_LINE_CENTER,
     30,FONT_SERIF,FONT_FACE_ITALIC);

  movX0=&Map->valueX[CREATE_VX_STATE_EXIT];

  StepSelectAction(movX0,&tmpY);
  if(*movX0<0){
    *movX0=0;
  }
  else if(*movX0>=(CREATE_EXIT_NUM)){
    *movX0=CREATE_EXIT_NUM-1;
  }
  
  py1=HEIGHT*(CREATE_EXIT_PY1)/MAP_YMAX;
  
  px0=WIDTH*(CREATE_EXIT_PX1
	     +CREATE_EXIT_MX1*CREATE_EXIT_YES)/MAP_XMAX;
  py0=py1;
  text->DrawString
    ("YES",(color->white),px0,py0,
     CREATE_EXIT_LF1,CREATE_EXIT_SF1,
     CREATE_EXIT_TF1,CREATE_EXIT_FF1);

  px0=WIDTH*(CREATE_EXIT_PX1
	     +CREATE_EXIT_MX1*CREATE_EXIT_NO)/MAP_XMAX;
  py0=py1;
  text->DrawString
    ("NO",(color->white),px0,py0,
     CREATE_EXIT_LF1,CREATE_EXIT_SF1,
     CREATE_EXIT_TF1,CREATE_EXIT_FF1);

  enemyList->DrawSprite
    (EN_REV_BIRD,EN_WAY_B,2,
     WIDTH*(380+CREATE_EXIT_MX1*(*movX0))/MAP_XMAX,py1);
  mWindow->invalidate_rect(rect,false);

  if(control->okValue==1){
    control->okValue=0;
    (this->*CREATE_EXIT_SELECT[*(movX0)])
      (movX0,STAGE_CHANGE_TYPE,SELECT_MAP_TITLE);
  }
  else if(control->cancelValue==1){
    control->cancelValue=0;
    *movX0=CREATE_EXIT_NO;
    Map->state=Map->state0;
  }
}
void CreateStage::StatusView(){
  std::stringstream ss;
  std::string str;
  int px0,py0;
  int px1,py1;
  int px2,py2;
  int *movX0,*movY0;
  
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);

  frame->draw_rectangle(blackGC,true,WIDTH/4,HEIGHT/4,WIDTH/2,HEIGHT/2);
  
  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(350)/MAP_YMAX;
  text->DrawString
    ("STAGE STATUS",(color->white),px0,py0,FONT_LINE_CENTER,
     20,FONT_SERIF,FONT_FACE_ITALIC);


  movY0=&Map->valueY[CREATE_VY_STATE_STATUS];
  
  VariableSelectAction
    (&Map->valueX[Map->valueY[CREATE_VY_STATE_STATUS]],movY0,
     SELECTKEY_VARIABLE1);

  if(*movY0<CREATE_VX_STATUS_NAME){
    *movY0=CREATE_VX_STATUS_FORM;
  }
  else if(*movY0>CREATE_VX_STATUS_FORM){
    *movY0=CREATE_VX_STATUS_NAME;
  }

  if(Map->valueX[CREATE_VX_STATUS_NAME]!=0){
    Map->valueX[CREATE_VX_STATUS_NAME]=0;
  }

  if(Map->valueX[CREATE_VX_STATUS_LIFE]<1){
    Map->valueX[CREATE_VX_STATUS_LIFE]=1;
  }
  else if(Map->valueX[CREATE_VX_STATUS_LIFE]>100){
    Map->valueX[CREATE_VX_STATUS_LIFE]=100;
  }

  if(Map->valueX[CREATE_VX_STATUS_FIRE]<0){
    Map->valueX[CREATE_VX_STATUS_FIRE]=0;
  }
  else if(Map->valueX[CREATE_VX_STATUS_FIRE]>=PF_TYPE_NUM){
    Map->valueX[CREATE_VX_STATUS_FIRE]=PLAYER_TYPE_NUM-1;
  }

  if(Map->valueX[CREATE_VX_STATUS_FORM]<0){
    Map->valueX[CREATE_VX_STATUS_FORM]=0;
  }
  else if(Map->valueX[CREATE_VX_STATUS_FORM]>=PLAYER_FORM_NUM){
    Map->valueX[CREATE_VX_STATUS_FORM]=PLAYER_FORM_NUM-1;
  }
  
  initLife=Map->valueX[CREATE_VX_STATUS_LIFE];
  initFire=Map->valueX[CREATE_VX_STATUS_FIRE];
  initForm=Map->valueX[CREATE_VX_STATUS_FORM];

  px1=WIDTH*(CREATE_STATUS_PX1)/MAP_XMAX;
  px2=WIDTH*(CREATE_STATUS_PX2)/MAP_XMAX;
  py1=HEIGHT*(CREATE_STATUS_PY1
	      +CREATE_STATUS_MY1*CREATE_STATUS_NAME)/MAP_YMAX;
  px0=px1;
  py0=py1;
  text->DrawString
    ("NAME",(color->white),px0,py0,
     CREATE_STATUS_LF1,CREATE_STATUS_SF1,
     CREATE_STATUS_TF1,CREATE_STATUS_FF1);
  px0=px2;
  py0=py1;
  ss<<": "<<GetName(stageName);
  text->DrawString
    (ss.str(),(color->white),px0,py0,
     CREATE_STATUS_LF2,CREATE_STATUS_SF2,
     CREATE_STATUS_TF2,CREATE_STATUS_FF2);
  ss.str("");
  ss.clear(std::stringstream::goodbit); 
  
  py1=HEIGHT*(CREATE_STATUS_PY1
	      +CREATE_STATUS_MY1*CREATE_STATUS_LIFE)/MAP_YMAX;
  px0=px1;
  py0=py1;
  text->DrawString
    ("LIFE",(color->white),px0,py0,
     CREATE_STATUS_LF1,CREATE_STATUS_SF1,
     CREATE_STATUS_TF1,CREATE_STATUS_FF1);
  px0=px2;
  py0=py1;
  ss<<": "<<initLife;
  text->DrawString
    (ss.str(),(color->white),px0,py0,
     CREATE_STATUS_LF2,CREATE_STATUS_SF2,
     CREATE_STATUS_TF2,CREATE_STATUS_FF2);
  ss.str("");
  ss.clear(std::stringstream::goodbit);
  
  py1=HEIGHT*(CREATE_STATUS_PY1
	      +CREATE_STATUS_MY1*CREATE_STATUS_FIRE)/MAP_YMAX;
  px0=px1;
  py0=py1;
  text->DrawString
    ("FIRE",(color->white),px0,py0,
     CREATE_STATUS_LF1,CREATE_STATUS_SF1,
     CREATE_STATUS_TF1,CREATE_STATUS_FF1);
  px0=px2;
  py0=py1;
  ss<<": "<<pfireList->FireName(initFire);
  text->DrawString
    (ss.str(),(color->white),px0,py0,
     CREATE_STATUS_LF2,CREATE_STATUS_SF2,
     CREATE_STATUS_TF2,CREATE_STATUS_FF2);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  py1=HEIGHT*(CREATE_STATUS_PY1
	      +CREATE_STATUS_MY1*CREATE_STATUS_FORM)/MAP_YMAX;
  px0=px1;
  py0=py1;
  text->DrawString
    ("FORM",(color->white),px0,py0,
     CREATE_STATUS_LF1,CREATE_STATUS_SF1,
     CREATE_STATUS_TF1,CREATE_STATUS_FF1);
  px0=px2;
  py0=py1;
  ss<<": "<<player->FormName(initForm);
  text->DrawString
    (ss.str(),(color->white),px0,py0,
     CREATE_STATUS_LF2,CREATE_STATUS_SF2,
     CREATE_STATUS_TF2,CREATE_STATUS_FF2);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  enemyList->DrawSprite
    (EN_REV_BIRD,EN_WAY_B,2,WIDTH*(400)/MAP_XMAX,
     HEIGHT*(CREATE_STATUS_PY1+CREATE_STATUS_MY1*
	     (*(movY0)-CREATE_VX_STATUS_NAME))/MAP_YMAX);
  mWindow->invalidate_rect(rect,false);

  if(control->okValue==1){
    control->okValue=0;
    if(*movY0==CREATE_VX_STATUS_NAME){
      int value;
      NameDialog diag;
      
      while(value=diag.Run()){
	if(value==Gtk::RESPONSE_OK){
	  stageName=diag.GetName();
	  break;
	}
	else if(value==Gtk::RESPONSE_DELETE_EVENT){
	  
	}
      }
    }
    else{
      Map->state=Map->state0;
    }
  }
  else if(control->cancelValue==1){
    control->cancelValue=0;
    Map->state=Map->state0;
  }
}
void (CreateStage::*CreateStage::CREATE_MENU_SELECT
      [CREATE_STATE_NUM])()={
  &CreateStage::TopView,
  &CreateStage::CrowdView,
  &CreateStage::CrowdView,
  &CreateStage::LandView,
  &CreateStage::LandView,
  &CreateStage::ModalView,
  &CreateStage::ModalView,
  &CreateStage::ModalView,
  &CreateStage::ModalView,
  &CreateStage::TimeLineView,
  &CreateStage::TimeLineView,
  &CreateStage::GameView,
  &CreateStage::PauseView,
  &CreateStage::BackGroundView,
  &CreateStage::GameStartSlide,
  &CreateStage::GameEndSlide,
  &CreateStage::ExitSlide,
  &CreateStage::StatusView
};

void CreateStage::ViewMap(){
  (this->*CREATE_MENU_SELECT[Map->state])();
}

void CreateStage::SetModal(){
  mModal[CREATE_MODAL_WAITMAP].type=MODAL_TYPE_WSTATE;
  mModal[CREATE_MODAL_WAITMAP].value=CREATE_STATE_GAMEEND;
  
  mModal[CREATE_MODAL_CHANGEMAP].type=MODAL_TYPE_CHSTATE;
  mModal[CREATE_MODAL_CHANGEMAP].value=CREATE_STATE_GAMEEND;
}
