#ifndef BIRD_CREATE_TOP_H_
#define BIRD_CREATE_TOP_H_

#include <gtkmm.h>
#include <fstream>
#include "basestage.h"
#include "createbase.h"

#define CREATE_TOP_CX1 400
#define CREATE_TOP_CY1 135
#define CREATE_TOP_MX1 100
#define CREATE_TOP_MY1 185
#define CREATE_TOP_SX1 300
#define CREATE_TOP_SY1 80
#define CREATE_TOP_SF1 25
#define CREATE_TOP_LF1 FONT_LINE_CENTER
#define CREATE_TOP_TF1 FONT_SERIF
#define CREATE_TOP_FF1 FONT_FACE_BOLD

#define CREATE_TOP_DX1 5
#define CREATE_TOP_DY1 5

#define CREATE_TOP_CX2 820
#define CREATE_TOP_CY2 110
#define CREATE_TOP_MX2 150
#define CREATE_TOP_MY2 160
#define CREATE_TOP_SX2 80
#define CREATE_TOP_SY2 60
#define CREATE_TOP_SF2 15
#define CREATE_TOP_LF2 FONT_LINE_CENTER
#define CREATE_TOP_TF2 FONT_SERIF
#define CREATE_TOP_FF2 FONT_FACE_BOLD

#define CREATE_TOP_DX2 5
#define CREATE_TOP_DY2 5

#define CREATE_TOP_SAVE 0
#define CREATE_TOP_LOAD 1
#define CREATE_TOP_PLAY 2
#define CREATE_TOP_STATUS 3
#define CREATE_TOP_EXIT 4
#define CREATE_TOP_RNUM 5

#define CREATE_TOP_BACKGROUND 0
#define CREATE_TOP_TLINE 1
#define CREATE_TOP_MODAL 2
#define CREATE_TOP_LAND 3
#define CREATE_TOP_CROWD 4
#define CREATE_TOP_LNUM 5

class CreateTop : public CreateBase{
  public:
  CreateTop();
  ~CreateTop();
  void Create();

  void TopBackGroundSelect();
  void TopTimeLineSelect();
  void TopModalSelect();
  void TopLandSelect();
  void TopCrowdSelect();
  static void(CreateTop::*CREATE_TOP_LEFT_SELECT[CREATE_TOP_LNUM])();

  void TopSaveSelect();
  void TopLoadSelect();
  void TopPlaySelect();
  void TopStatusSelect();
  void TopExitSelect();
  static void(CreateTop::*CREATE_TOP_RIGHT_SELECT[CREATE_TOP_RNUM])();

  void TopLeftSelect();
  void TopRightSelect();
  static void(CreateTop::*CREATE_TOP_PLACE_SELECT[CREATE_TOP_NPLACE])();

  void TopMenu();

};


#endif
