#include "enemyfire.h"
#include "xpm/smallEF.h"
#include "xpm/bigEF.h"
#include "xpm/wideEF.h"
#include "xpm/lineEF.h"

EnemyFire::EnemyFire(){
  CreateStrSmallEnemyFire();
  CreateRevSmallEnemyFire();
  CreateHomSmallEnemyFire();

  CreateStrBigEnemyFire();
  CreateRevBigEnemyFire();
  CreateHomBigEnemyFire();

  CreateStrWideEnemyFire();
  CreateRevWideEnemyFire();
  CreateHomWideEnemyFire();

  CreateStrLineEnemyFire();
  CreateRevLineEnemyFire();
  CreateHomLineEnemyFire();
}

EnemyFire::~EnemyFire(){
  delete efireBox[EF_STR_SMALL];
  delete efireBox[EF_REV_SMALL];
  delete efireBox[EF_HOM_SMALL];

  delete efireBox[EF_STR_BIG];
  delete efireBox[EF_REV_BIG];
  delete efireBox[EF_HOM_BIG];

  delete efireBox[EF_STR_WIDE];
  delete efireBox[EF_REV_WIDE];
  delete efireBox[EF_HOM_WIDE];

  delete efireBox[EF_STR_LINE];
  delete efireBox[EF_REV_LINE];
  delete efireBox[EF_HOM_LINE];
}

void EnemyFire::Create(Glib::RefPtr<Gdk::Pixmap> frame0,
		       Glib::RefPtr<Gdk::GC> mGC0,
		       BirdPlayer *player0,
		       BirdLand *landList0){
  frame=frame0;
  mGC=mGC0;
  player=player0;
  landList=landList0;
}

int EnemyFire::ContactLand(BirdActor *act){
  BirdRhoum *node;
  BirdRhoum *tmp;
  int flag0=0;
  int aX=0,aY=0;

  node=landList->first;
  while(node){
    tmp=node->next;

    flag0=landList->ContactActor(node,act,&aX,&aY);
    
    if(flag0>0){
      break;
    }
    node=tmp;
  }
  
  return flag0;
}

int EnemyFire::ContactLand(BirdActor *act,int *tX,int *tY){
  BirdRhoum *node;
  BirdRhoum *tmp;
  int aX=0,aY=0;
  int flag0=0;

  node=landList->first;
  while(node){
    tmp=node->next;

    flag0=landList->ContactActor(node,act,&aX,&aY);
    
    if(flag0>0){
      *tX=aX;
      *tY=aY;
      break;
    }
    node=tmp;
  }
  
  return flag0;
}

BirdActor *EnemyFire::Appear(int px,int py,int width,int height,
		       int mx,int my,int tx,int ty,
		       int style,int move,int touch,
		       int form,int tcount){
  BirdActor *act;
  act= new BirdActor();
  act->px=px;
  act->py=py;
  act->width=width;
  act->height=height;
  act->mx=mx;
  act->my=my;
  act->tx=tx;
  act->ty=ty;
  act->life=10;
  act->style=style;
  act->move=move;
  act->touch=touch;
  act->tcount=tcount;

  act->dcount=0;
  act->direct=0;
  act->seq=0;
  act->next=NULL;
  act->prev=NULL;
  Append(act);

  return act;
}
/*
void EnemyFire::Appear(int px,int py,int width,int height,
		       int mx,int my,int life,
		       int style,int move,int touch,
		       int form,int tcount){
  BirdActor *act;
  act= new BirdActor();
  act->px=px;
  act->py=py;
  act->width=width;
  act->height=height;
  act->mx=mx;
  act->my=my;
  act->life=life;  
  act->style=style;
  act->move=move;
  act->touch=touch;
  act->tcount=tcount;

  act->dcount=0;
  act->direct=0;
  act->seq=0;
  if(move==EF_MOV_HOM){
    act->tmp=mx;
  }
  else{
    act->tmp=0;
  }

  act->next=NULL;
  act->prev=NULL;
  Append(act); 
}
*/
int EnemyFire::Animate(){
  BirdActor *node;
  BirdActor *tmp;
  SpriteBox *spriteBox0;
  int i;
  int landFlag=0;
  int pX,pY,playerFlag=0;

  i=0;
  node=first;
  while(node){
    tmp=node->next;
    spriteBox0=efireBox[node->style];

    if(node->life>0){
      (this->*ENEMY_FIRE_MOVE[node->move])(node,landFlag);
      
      playerFlag=ContactRect(player,node);
      
      (this->*ENEMY_FIRE_TOUCH[node->touch])(node,playerFlag);
    }

    if(node->life>0){
      node->seq++;
      if(node->seq>=spriteBox0->nSeq){
	node->seq=0;
      }
      spriteBox0->DrawSprite(frame,mGC,node->px,node->py,
			     node->seq+node->direct*spriteBox0->nSeq);
    }
    else{
      Reject(node);
      delete node;
    }

    node=tmp;
    i++;
  }
  return i;
}

void EnemyFire::StraightMove(BirdActor *act,int landFlag){
  if(act->life>0){
    if(act->form==PF_FORM_LR){
      act->px+=act->mx*powHFire[act->style]/EF_POW_WIDTH;
      act->py+=act->my*powVFire[act->style]/EF_POW_HEIGHT;
      if(act->mx>0){
	act->direct=EF_DIRECT_R;
      }
      else{
	act->direct=EF_DIRECT_U;
      }
    }
    else if(act->form==PF_FORM_UD){
      act->px+=act->mx*powVFire[act->style]/EF_POW_HEIGHT;
      act->py+=act->my*powHFire[act->style]/EF_POW_WIDTH;
      if(act->my>0){
	act->direct=EF_DIRECT_D;
      }
      else{
	act->direct=EF_DIRECT_U;
      }
    }
  }

  if(act->px<0){
    act->dcount=0;
    act->life=0;
  }
  else if(act->px>WIDTH){
    act->dcount=0;
    act->life=0;      
  }
  if(act->py<0){
    act->dcount=0;
    act->life=0;
  }
  else if(act->py>HEIGHT){
    act->dcount=0;
    act->life=0;
  }
}

void EnemyFire::NoStrMove(BirdActor *act,int landFlag){
  int tX,tY;

  if(act->life>0){

    
    if(act->form==EF_FORM_LR){
      act->px+=act->mx*powHFire[act->style]/EF_POW_WIDTH;
      act->py+=act->my*powVFire[act->style]/EF_POW_HEIGHT;
      if(act->mx>0){
	act->direct=EF_DIRECT_R;
      }
      else{
	act->direct=EF_DIRECT_L;
      }
    }
    else if(act->form==EF_FORM_UD){
      act->px+=act->mx*powVFire[act->style]/EF_POW_HEIGHT;
      act->py+=act->my*powHFire[act->style]/EF_POW_WIDTH;
      if(act->my>0){
	act->direct=EF_DIRECT_D;
      }
      else{
	act->direct=EF_DIRECT_U;
      }
    }
  }

  if(act->px<0){
    act->dcount=0;
    act->life=0;
  }
  else if(act->px>WIDTH){
    act->dcount=0;
    act->life=0;      
  }
  if(act->py<0){
    act->dcount=0;
    act->life=0;
  }
  else if(act->py>HEIGHT){
    act->dcount=0;
    act->life=0;
  }

  landFlag=ContactLand(act,&tX,&tY);

  if(landFlag){
    act->life=0;
  }


}

void EnemyFire::ReverseMove(BirdActor *act,int landFlag){
  int tX,tY;
  int powH=0;
  int powV=0;

  if(act->life>0){
    if(act->form==EF_FORM_LR){
      powH=powHFire[act->style]/EF_POW_WIDTH;
      powV=powVFire[act->style]/EF_POW_HEIGHT;
      act->px+=act->mx*powH;
      act->py+=act->my*powV;
      if(act->mx>0){
	act->direct=EF_DIRECT_R;
      }
      else{
	act->direct=EF_DIRECT_L;
      }
    }
    else if(act->form==EF_FORM_UD){
      powH=powVFire[act->style]/EF_POW_HEIGHT;
      powV=powHFire[act->style]/EF_POW_WIDTH;
      act->px+=act->mx*powH;
      act->py+=act->my*powV;
      if(act->my>0){
	act->direct=EF_DIRECT_D;
      }
      else{
	act->direct=EF_DIRECT_U;
      }
    }
  }

  if(act->px<0){
    act->dcount=0;
    act->life=0;
  }
  else if(act->px>WIDTH){
    act->dcount=0;
    act->life=0;
  }
  
  if(act->py<0){
    act->py=0;
    act->my=abs(act->my);
    act->tcount--;
  }
  else if(act->py>HEIGHT){
    act->py=HEIGHT;
    act->my=abs(act->my)*-1;
    act->tcount--;
  }
  
  landFlag=ContactLand(act,&tX,&tY);
  
  if(landFlag==1){
    if(abs(act->my*powV)>abs(tY-act->py)){
      act->py=tY;
      act->my=abs(act->my); 
    }
    else{
      act->px+=abs(act->mx)*powH;
      act->py+=abs(act->my)*powV;
      act->mx=abs(act->mx);
      act->my=abs(act->my);
    }
    act->tcount--;
  }
  else if(landFlag==2){
    if(abs(act->my*powV)>abs(tY-act->py)){
      act->py=tY;
      act->my=abs(act->my);
    }
    else{
      act->px-=abs(act->mx)*powH;
      act->py+=abs(act->my)*powV;
      act->mx=abs(act->mx)*-1;
      act->my=abs(act->my);
    }
    act->tcount--;
  }
  else if(landFlag==3){
    if(abs(act->my*powV)>abs(tY-act->py)){
      act->py=tY;
      act->my=abs(act->my)*-1;
    }
    else{
      act->px+=abs(act->mx)*powH;
      act->py-=abs(act->my)*powV;
      act->mx=abs(act->mx);
      act->my=abs(act->my)*-1;
    }
    act->tcount--;
  }
  else if(landFlag==4){
    if(abs(act->my*powH)>abs(tY-act->py)){
      act->py=tY;
      act->my=abs(act->my)*-1;
    }
    else{
      act->px-=abs(act->mx)*powH;
      act->py-=abs(act->my)*powV;
      act->mx=abs(act->mx)*-1;
      act->my=abs(act->my)*-1;
    }
    act->tcount--;
  }
  if(act->tcount==0){
    act->life=0;
  }
}

void EnemyFire::HomingMove(BirdActor *act,int landFlag){
  int sx,sy;
  int tX,tY;

  if(act->life>0){
    sx=act->px;
    sy=act->py;

    DistApprox(&sx,&sy,player->px,player->py,act->tx);

    act->mx=sx;
    act->my=sy;
    
    if(act->form==EF_FORM_LR){
      act->px+=act->mx*powHFire[act->style]/EF_POW_WIDTH;
      act->py+=act->my*powVFire[act->style]/EF_POW_HEIGHT;
      if(sx>0){
	act->direct=EF_DIRECT_R;
      }
      else{
	act->direct=EF_DIRECT_L;
      }
    }
    else if(act->form==EF_FORM_UD){
      act->px+=act->mx*powVFire[act->style]/EF_POW_HEIGHT;
      act->py+=act->my*powHFire[act->style]/EF_POW_WIDTH;
      if(sy>0){
	act->direct=EF_DIRECT_D;
      }
      else{
	act->direct=EF_DIRECT_U;
      }
    }

    if(act->tcount>0){
      act->tcount--;
    }
    else{
      if((abs(act->mx)<act->tx)
	 &&(abs(act->my)<act->tx)){
	if(act->mx>0){
	  act->mx=act->tx;
	}
	else{
	  act->mx=act->tx*-1;
	}
      }
      act->move=EF_MOV_NOSTR;
    }
  }

  if(act->px<0){
    act->dcount=0;
    act->life=0;
  }
  else if(act->px>WIDTH){
    act->dcount=0;
    act->life=0;
  }
  
  if(act->py<0){
    act->dcount=0;
    act->life=0;
  }
  else if(act->py>HEIGHT){
    act->dcount=0;
    act->life=0;
  }

  landFlag=ContactLand(act,&tX,&tY);

  if(landFlag){
    act->life=0;
  }
}
void EnemyFire::ALLRevMove(BirdActor *act,int landFlag){
  int tX,tY;
  int powH=0;
  int powV=0;

  if(act->life>0){
    if(act->form==EF_FORM_LR){
      powH=powHFire[act->style]/EF_POW_WIDTH;
      powV=powVFire[act->style]/EF_POW_HEIGHT;
      act->px+=act->mx*powH;
      act->py+=act->my*powV;
      if(act->mx>0){
	act->direct=EF_DIRECT_R;
      }
      else{
	act->direct=EF_DIRECT_L;
      }
    }
    else if(act->form==EF_FORM_UD){
      powH=powVFire[act->style]/EF_POW_HEIGHT;
      powV=powHFire[act->style]/EF_POW_WIDTH;
      act->px+=act->mx*powH;
      act->py+=act->my*powV;
      if(act->my>0){
	act->direct=EF_DIRECT_D;
      }
      else{
	act->direct=EF_DIRECT_U;
      }
    }
  }
  
  if(act->tmp==EF_DIRECT_L){
    if(act->px<0){
      act->dcount=0;
      act->life=0;
    }
    else if(act->px>WIDTH){
      act->px=WIDTH;
      act->mx=abs(act->mx)*-1;
    }
    if(act->py<0){
      act->py=0;
      act->my=abs(act->my);
    }
    else if(act->py>HEIGHT){
      act->py=HEIGHT;
      act->my=abs(act->my)*-1;
    }
  }
  else if(act->tmp==EF_DIRECT_R){
    if(act->px<0){
      act->px=0;
      act->mx=abs(act->mx);
    }
    else if(act->px>WIDTH){
      act->dcount=0;
      act->life=0;
    }
    if(act->py<0){
      act->py=0;
      act->my=abs(act->my);
    }
    else if(act->py>HEIGHT){
      act->py=HEIGHT;
      act->my=abs(act->my)*-1;
    }
  }
  else if(act->tmp==EF_DIRECT_U){
    if(act->px<0){
      act->px=0;
      act->mx=abs(act->mx);
    }
    else if(act->px>WIDTH){
      act->px=WIDTH;
      act->mx=abs(act->mx)*-1;
    }
    if(act->py<0){
      act->dcount=0;
      act->life=0;
    }
    else if(act->py>HEIGHT){
      act->py=HEIGHT;
      act->my=abs(act->my)*-1;
    }
  }
  else if(act->tmp==EF_DIRECT_D){
    if(act->px<0){
      act->px=0;
      act->mx=abs(act->mx);
    }
    else if(act->px>WIDTH){
      act->px=WIDTH;
      act->mx=abs(act->mx)*-1;
    }
    if(act->py<0){
      act->py=0;
      act->my=abs(act->my);
    }
    else if(act->py>HEIGHT){
      act->dcount=0;
      act->life=0;
    }
  }
}
void EnemyFire::AccelerateMove(BirdActor *act,int landFlag){
  int sx,sy;
  int ttx;

  if(act->life>0){
    sx=act->px;
    sy=act->py;

    DistApprox(&sx,&sy,player->px,player->py,act->ty);

    act->mx+=sx;
    act->my+=sy;
   
    if(abs(act->mx)>act->tx){
      if(act->mx>0){
	act->mx=act->tx;
      }
      else{
	act->mx=act->tx*-1;
      }
    }
    else{
      
    }

    if(abs(act->my)>act->tx){
      if(act->my>0){
	act->my=act->tx;
      }
      else{
	act->my=act->tx*-1;
      }
    }
    else{
      
    }
 
    if(act->form==EF_FORM_LR){
      act->px+=act->mx*powHFire[act->style]/EF_POW_WIDTH;
      act->py+=act->my*powVFire[act->style]/EF_POW_HEIGHT;
      if(act->mx>0){
	act->direct=EF_DIRECT_R;
      }
      else{
	act->direct=EF_DIRECT_L;
      }
    }
    else if(act->form==EF_FORM_UD){
      act->px+=act->mx*powVFire[act->style]/EF_POW_HEIGHT;
      act->py+=act->my*powHFire[act->style]/EF_POW_WIDTH;
      if(act->my>0){
	act->direct=EF_DIRECT_D;
      }
      else{
	act->direct=EF_DIRECT_U;
      }
    }

    ttx=act->tx;

    if(act->tmp==1){
      if((act->px>player->px)
	 &&(act->py>player->py)){

	act->move=EF_MOV_NOSTR;
	if((abs(act->mx)<ttx)
	   &&(abs(act->my)<ttx)){
	  if(act->mx>0){
	    act->mx=ttx;
	  }
	  else{
	    act->mx=ttx*-1;
	  }
	}

      }
    }
    else if(act->tmp==2){
      if((act->px<player->px)
	 &&(act->py>player->py)){

	act->move=EF_MOV_NOSTR;
	if((abs(act->mx)<ttx)
	   &&(abs(act->my)<ttx)){
	  if(act->mx>0){
	    act->mx=ttx;
	  }
	  else{
	    act->mx=ttx*-1;
	  }
	}

      }
    }
    else if(act->tmp==3){
      if((act->px>player->px)
	 &&(act->py<player->py)){

	act->move=EF_MOV_NOSTR;
	if((abs(act->mx)<ttx)
	   &&(abs(act->my)<ttx)){
	  if(act->mx>0){
	    act->mx=ttx;
	  }
	  else{
	    act->mx=ttx*-1;
	  }
	}

      }
    }
    else if(act->tmp==4){
      if((act->px<player->px)
	 &&(act->py<player->py)){

	act->move=EF_MOV_NOSTR;
	if((abs(act->mx)<ttx)
	   &&(abs(act->my)<ttx)){
	  if(act->mx>0){
	    act->mx=ttx;
	  }
	  else{
	    act->mx=ttx*-1;
	  }
	}
	
      }
    }
  }
}
void (EnemyFire::*EnemyFire::ENEMY_FIRE_MOVE[EF_MOV_NUM])
  (BirdActor *act,int landFlag)={
    &EnemyFire::StraightMove,
    &EnemyFire::ReverseMove,
    &EnemyFire::HomingMove,
    &EnemyFire::NoStrMove,
    &EnemyFire::ALLRevMove,
    &EnemyFire::AccelerateMove
  };


void EnemyFire::PainTouch(BirdActor *act,int playerFlag){
  if(playerFlag>0){
    
    if(player->dcount>0){
      
    }
    else{
      player->dcount=PLAYER_T_DMG;
    }
  }
}

void EnemyFire::ReverseTouch(BirdActor *act,int playerFlag){

  if(playerFlag>0){
    act->my*=-1;
    if(player->dcount>0){
      
    }
    else{
      player->dcount=PLAYER_T_DMG;
    }
   
  }
}

void EnemyFire::ChangeNoStrTouch(BirdActor *act,int playerFlag){
  if(playerFlag>0){
    act->move=EF_MOV_NOSTR;
    if((abs(act->mx)<act->tx)
       &&(abs(act->my)<act->ty)){
      if(act->mx>0){
	act->mx=act->tx;
      }
      else{
	act->mx=act->tx*-1;
      }
    }
    if(player->dcount>0){
      
    }
    else{
      player->dcount=PLAYER_T_DMG;
    }
  }
}

void EnemyFire::BlowTouch(BirdActor *act,int playerFlag){
  if(playerFlag>0){

    if(player->px>act->px){
      player->px+=act->width;
    }
    else{
      player->px-=act->width;
    }
    if(player->py>act->py){
      player->py+=act->height;
    }
    else{
      player->py-=act->height;
    }
    
    if(player->dcount>0){
      
    }
    else{
      player->dcount=PLAYER_T_DMG;   
    }
   
  }
}
void (EnemyFire::*EnemyFire::ENEMY_FIRE_TOUCH[EF_TOUCH_NUM])
  (BirdActor *act,int playerFlag)={
    &EnemyFire::PainTouch,
    &EnemyFire::ReverseTouch,
    &EnemyFire::ChangeNoStrTouch,
    &EnemyFire::BlowTouch
  };

void EnemyFire::CreateStrSmallEnemyFire(){
  strsmallEF[0].xpm=(char **)strsmallEF_fbud1_xpm;
  strsmallEF[1].xpm=(char **)strsmallEF_fbud1_xpm;
  strsmallEF[2].xpm=(char **)strsmallEF_fbud1_xpm;
  strsmallEF[3].xpm=(char **)strsmallEF_fbud1_xpm;
  strsmallEF[4].xpm=(char **)strsmallEF_fbud1_xpm;
  strsmallEF[5].xpm=(char **)strsmallEF_fbud1_xpm;
  strsmallEF[6].xpm=(char **)strsmallEF_fbud1_xpm;
  strsmallEF[7].xpm=(char **)strsmallEF_fbud1_xpm;
  efireBox[EF_STR_SMALL]= new SpriteBox(strsmallEF,1,8);
  efireBox[EF_STR_SMALL]->SetSprite();
  powHFire[EF_STR_SMALL]=10;
  powVFire[EF_STR_SMALL]=10;
}

void EnemyFire::CreateRevSmallEnemyFire(){
  revsmallEF[0].xpm=(char **)revsmallEF_fbud1_xpm;
  revsmallEF[1].xpm=(char **)revsmallEF_fbud1_xpm;
  revsmallEF[2].xpm=(char **)revsmallEF_fbud1_xpm;
  revsmallEF[3].xpm=(char **)revsmallEF_fbud1_xpm;
  revsmallEF[4].xpm=(char **)revsmallEF_fbud1_xpm;
  revsmallEF[5].xpm=(char **)revsmallEF_fbud1_xpm;
  revsmallEF[6].xpm=(char **)revsmallEF_fbud1_xpm;
  revsmallEF[7].xpm=(char **)revsmallEF_fbud1_xpm;
  efireBox[EF_REV_SMALL]= new SpriteBox(revsmallEF,1,8);
  efireBox[EF_REV_SMALL]->SetSprite();
  powHFire[EF_REV_SMALL]=10;
  powVFire[EF_REV_SMALL]=10;
}

void EnemyFire::CreateHomSmallEnemyFire(){
  homsmallEF[0].xpm=(char **)homsmallEF_fbud1_xpm;
  homsmallEF[1].xpm=(char **)homsmallEF_fbud1_xpm;
  homsmallEF[2].xpm=(char **)homsmallEF_fbud1_xpm;
  homsmallEF[3].xpm=(char **)homsmallEF_fbud1_xpm;
  homsmallEF[4].xpm=(char **)homsmallEF_fbud1_xpm;
  homsmallEF[5].xpm=(char **)homsmallEF_fbud1_xpm;
  homsmallEF[6].xpm=(char **)homsmallEF_fbud1_xpm;
  homsmallEF[7].xpm=(char **)homsmallEF_fbud1_xpm;
  efireBox[EF_HOM_SMALL]= new SpriteBox(homsmallEF,1,8);
  efireBox[EF_HOM_SMALL]->SetSprite();
  powHFire[EF_HOM_SMALL]=10;
  powVFire[EF_HOM_SMALL]=10;
}

void EnemyFire::CreateStrBigEnemyFire(){
  strbigEF[0].xpm=(char **)strbigEF_fbud1_xpm;
  strbigEF[1].xpm=(char **)strbigEF_fbud1_xpm;
  strbigEF[2].xpm=(char **)strbigEF_fbud1_xpm;
  strbigEF[3].xpm=(char **)strbigEF_fbud1_xpm;
  strbigEF[4].xpm=(char **)strbigEF_fbud1_xpm;
  strbigEF[5].xpm=(char **)strbigEF_fbud1_xpm;
  strbigEF[6].xpm=(char **)strbigEF_fbud1_xpm;
  strbigEF[7].xpm=(char **)strbigEF_fbud1_xpm;
  efireBox[EF_STR_BIG]= new SpriteBox(strbigEF,1,8);
  efireBox[EF_STR_BIG]->SetSprite();
  powHFire[EF_STR_BIG]=15;
  powVFire[EF_STR_BIG]=15;
}

void EnemyFire::CreateRevBigEnemyFire(){
  revbigEF[0].xpm=(char **)revbigEF_fbud1_xpm;
  revbigEF[1].xpm=(char **)revbigEF_fbud1_xpm;
  revbigEF[2].xpm=(char **)revbigEF_fbud1_xpm;
  revbigEF[3].xpm=(char **)revbigEF_fbud1_xpm;
  revbigEF[4].xpm=(char **)revbigEF_fbud1_xpm;
  revbigEF[5].xpm=(char **)revbigEF_fbud1_xpm;
  revbigEF[6].xpm=(char **)revbigEF_fbud1_xpm;
  revbigEF[7].xpm=(char **)revbigEF_fbud1_xpm;
  efireBox[EF_REV_BIG]= new SpriteBox(revbigEF,1,8);
  efireBox[EF_REV_BIG]->SetSprite();
  powHFire[EF_REV_BIG]=15;
  powVFire[EF_REV_BIG]=15;
}

void EnemyFire::CreateHomBigEnemyFire(){
  hombigEF[0].xpm=(char **)hombigEF_fbud1_xpm;
  hombigEF[1].xpm=(char **)hombigEF_fbud1_xpm;
  hombigEF[2].xpm=(char **)hombigEF_fbud1_xpm;
  hombigEF[3].xpm=(char **)hombigEF_fbud1_xpm;
  hombigEF[4].xpm=(char **)hombigEF_fbud1_xpm;
  hombigEF[5].xpm=(char **)hombigEF_fbud1_xpm;
  hombigEF[6].xpm=(char **)hombigEF_fbud1_xpm;
  hombigEF[7].xpm=(char **)hombigEF_fbud1_xpm;
  efireBox[EF_HOM_BIG]= new SpriteBox(hombigEF,1,8);
  efireBox[EF_HOM_BIG]->SetSprite();
  powHFire[EF_HOM_BIG]=15;
  powVFire[EF_HOM_BIG]=15;
}

void EnemyFire::CreateStrWideEnemyFire(){
  strwideEF[0].xpm=(char **)strwideEF_f1_xpm;
  strwideEF[1].xpm=(char **)strwideEF_b1_xpm;
  strwideEF[2].xpm=(char **)strwideEF_u1_xpm;
  strwideEF[3].xpm=(char **)strwideEF_d1_xpm;
  strwideEF[4].xpm=(char **)strwideEF_f1_xpm;
  strwideEF[5].xpm=(char **)strwideEF_b1_xpm;
  strwideEF[6].xpm=(char **)strwideEF_u1_xpm;
  strwideEF[7].xpm=(char **)strwideEF_d1_xpm;
  efireBox[EF_STR_WIDE]= new SpriteBox(strwideEF,1,8);
  efireBox[EF_STR_WIDE]->SetSprite();
  powHFire[EF_STR_WIDE]=10;
  powVFire[EF_STR_WIDE]=30;
}

void EnemyFire::CreateRevWideEnemyFire(){
  revwideEF[0].xpm=(char **)revwideEF_f1_xpm;
  revwideEF[1].xpm=(char **)revwideEF_b1_xpm;
  revwideEF[2].xpm=(char **)revwideEF_u1_xpm;
  revwideEF[3].xpm=(char **)revwideEF_d1_xpm;
  revwideEF[4].xpm=(char **)revwideEF_f1_xpm;
  revwideEF[5].xpm=(char **)revwideEF_b1_xpm;
  revwideEF[6].xpm=(char **)revwideEF_u1_xpm;
  revwideEF[7].xpm=(char **)revwideEF_d1_xpm;
  efireBox[EF_REV_WIDE]= new SpriteBox(revwideEF,1,8);
  efireBox[EF_REV_WIDE]->SetSprite();
  powHFire[EF_REV_WIDE]=10;
  powVFire[EF_REV_WIDE]=30;
}

void EnemyFire::CreateHomWideEnemyFire(){
  homwideEF[0].xpm=(char **)homwideEF_f1_xpm;
  homwideEF[1].xpm=(char **)homwideEF_b1_xpm;
  homwideEF[2].xpm=(char **)homwideEF_u1_xpm;
  homwideEF[3].xpm=(char **)homwideEF_d1_xpm;
  homwideEF[4].xpm=(char **)homwideEF_f1_xpm;
  homwideEF[5].xpm=(char **)homwideEF_b1_xpm;
  homwideEF[6].xpm=(char **)homwideEF_u1_xpm;
  homwideEF[7].xpm=(char **)homwideEF_d1_xpm;
  efireBox[EF_HOM_WIDE]= new SpriteBox(homwideEF,1,8);
  efireBox[EF_HOM_WIDE]->SetSprite();
  powHFire[EF_HOM_WIDE]=10;
  powVFire[EF_HOM_WIDE]=30;
}

void EnemyFire::CreateStrLineEnemyFire(){
  strlineEF[0].xpm=(char **)strlineEF_fb1_xpm;
  strlineEF[1].xpm=(char **)strlineEF_fb1_xpm;
  strlineEF[2].xpm=(char **)strlineEF_ud1_xpm;
  strlineEF[3].xpm=(char **)strlineEF_ud1_xpm;
  strlineEF[4].xpm=(char **)strlineEF_fb1_xpm;
  strlineEF[5].xpm=(char **)strlineEF_fb1_xpm;
  strlineEF[6].xpm=(char **)strlineEF_ud1_xpm;
  strlineEF[7].xpm=(char **)strlineEF_ud1_xpm;
  efireBox[EF_STR_LINE]= new SpriteBox(strlineEF,1,8);
  efireBox[EF_STR_LINE]->SetSprite();
  powHFire[EF_STR_LINE]=30;
  powVFire[EF_STR_LINE]=10;
}

void EnemyFire::CreateRevLineEnemyFire(){
  revlineEF[0].xpm=(char **)revlineEF_fb1_xpm;
  revlineEF[1].xpm=(char **)revlineEF_fb1_xpm;
  revlineEF[2].xpm=(char **)revlineEF_ud1_xpm;
  revlineEF[3].xpm=(char **)revlineEF_ud1_xpm;
  revlineEF[4].xpm=(char **)revlineEF_fb1_xpm;
  revlineEF[5].xpm=(char **)revlineEF_fb1_xpm;
  revlineEF[6].xpm=(char **)revlineEF_ud1_xpm;
  revlineEF[7].xpm=(char **)revlineEF_ud1_xpm;
  efireBox[EF_REV_LINE]= new SpriteBox(revlineEF,1,8);
  efireBox[EF_REV_LINE]->SetSprite();
  powHFire[EF_REV_LINE]=30;
  powVFire[EF_REV_LINE]=10;
}

void EnemyFire::CreateHomLineEnemyFire(){
  homlineEF[0].xpm=(char **)homlineEF_fb1_xpm;
  homlineEF[1].xpm=(char **)homlineEF_fb1_xpm;
  homlineEF[2].xpm=(char **)homlineEF_ud1_xpm;
  homlineEF[3].xpm=(char **)homlineEF_ud1_xpm;
  homlineEF[4].xpm=(char **)homlineEF_fb1_xpm;
  homlineEF[5].xpm=(char **)homlineEF_fb1_xpm;
  homlineEF[6].xpm=(char **)homlineEF_ud1_xpm;
  homlineEF[7].xpm=(char **)homlineEF_ud1_xpm;
  efireBox[EF_HOM_LINE]= new SpriteBox(homlineEF,1,8);
  efireBox[EF_HOM_LINE]->SetSprite();
  powHFire[EF_HOM_LINE]=30;
  powVFire[EF_HOM_LINE]=10;
}
