#ifndef BIRD_ENEMY_FIRE_H_
#define BIRD_ENEMY_FIRE_H_

#include<gtkmm.h>

#include "sprite.h"
#include "actlist.h"
#include "player.h"
#include "land.h"


#define EF_POW_WIDTH 10
#define EF_POW_HEIGHT 10

#define EF_STR_SMALL 0
#define EF_REV_SMALL 1
#define EF_HOM_SMALL 2
#define EF_STR_BIG 3
#define EF_REV_BIG 4
#define EF_HOM_BIG 5
#define EF_STR_WIDE 6
#define EF_REV_WIDE 7
#define EF_HOM_WIDE 8
#define EF_STR_LINE 9
#define EF_REV_LINE 10
#define EF_HOM_LINE 11
#define EF_TYPE_NUM 12

#define EF_MOV_STR 0
#define EF_MOV_REV 1
#define EF_MOV_HOM 2
#define EF_MOV_NOSTR 3
#define EF_MOV_ALLREV 4
#define EF_MOV_ACCE 5
#define EF_MOV_NUM 6

#define EF_TOUCH_PAIN 0
#define EF_TOUCH_REV 1
#define EF_TOUCH_CH_NOSTR 2
#define EF_TOUCH_BLOW 3
#define EF_TOUCH_NUM 4

#define EF_FORM_LR 0
#define EF_FORM_UD 1
#define EF_FORM_NUM 2

#define EF_DIRECT_L 0
#define EF_DIRECT_R 1
#define EF_DIRECT_U 2
#define EF_DIRECT_D 3
#define EF_DIRECT_NUM 4

class BirdLand;
class BirdPlayer;

class EnemyFire :public ActorList {
 public:
  Glib::RefPtr<Gdk::Pixmap> frame;
  Glib::RefPtr<Gdk::GC> mGC;
  BirdSprite strsmallEF[8];
  BirdSprite revsmallEF[8];
  BirdSprite homsmallEF[8];
  BirdSprite strbigEF[8];
  BirdSprite revbigEF[8];
  BirdSprite hombigEF[8];
  BirdSprite strwideEF[8];
  BirdSprite revwideEF[8];
  BirdSprite homwideEF[8];
  BirdSprite strlineEF[8];
  BirdSprite revlineEF[8];
  BirdSprite homlineEF[8];
  SpriteBox *efireBox[EF_TYPE_NUM];
  int powHFire[EF_TYPE_NUM];
  int powVFire[EF_TYPE_NUM];
  BirdLand *landList;
  BirdPlayer *player;
  EnemyFire();
  ~EnemyFire();
  void Create(Glib::RefPtr<Gdk::Pixmap> frame0,
	      Glib::RefPtr<Gdk::GC> mGC0,
	      BirdPlayer *player0,
	      BirdLand *landList0);
  
  int ContactLand(BirdActor *act);
  int ContactLand(BirdActor *act,int *tX,int *tY);

  BirdActor *Appear(int px,int py,int width,int height,
		    int mx,int my,int tx,int ty,
		    int style,int move,int touch,
		    int form,int tcount);
  /*
  void Appear(int px,int py,int width,int height,
	      int mx,int my,int life,
	      int style,int move,int touch,
	      int form,int tcount);
  */
  int Animate();
  
  void StraightMove(BirdActor *act,int landFlag);
  void ReverseMove(BirdActor *act,int landFlag);
  void HomingMove(BirdActor *act,int landFlag);
  void NoStrMove(BirdActor *act,int landFlag);
  void ALLRevMove(BirdActor *act,int landFlag);
  void AccelerateMove(BirdActor *act,int landFlag);
  static void(EnemyFire::*ENEMY_FIRE_MOVE[EF_MOV_NUM])
    (BirdActor *act,int landFlag);

  void PainTouch(BirdActor *act,int playerFlag);
  void BlowTouch(BirdActor *act,int playerFlag);
  void ReverseTouch(BirdActor *act,int playerFlag);
  void ChangeNoStrTouch(BirdActor *act,int playerFlag);
  static void(EnemyFire::*ENEMY_FIRE_TOUCH[EF_TOUCH_NUM])
    (BirdActor *act,int playerFlag);
  
  void CreateStrSmallEnemyFire();
  void CreateRevSmallEnemyFire();
  void CreateHomSmallEnemyFire();

  void CreateStrBigEnemyFire();
  void CreateRevBigEnemyFire();
  void CreateHomBigEnemyFire();

  void CreateStrWideEnemyFire();
  void CreateRevWideEnemyFire();
  void CreateHomWideEnemyFire();

  void CreateStrLineEnemyFire();
  void CreateRevLineEnemyFire();
  void CreateHomLineEnemyFire();
};

#endif
