#ifndef BIRD_ITEM_H_
#define BIRD_ITEM_H_

#include <gtkmm.h>
#include "player.h"
#include "sprite.h"
#include "actlist.h"
#include "map.h"

#define ITEM_HEART 0
#define ITEM_BIG 1
#define ITEM_WIDE 2
#define ITEM_LINE 3
#define ITEM_CROSS 4
#define ITEM_XREV 5
#define ITEM_WAVE 6
#define ITEM_HOM 7
#define ITEM_DIVIDE 8
#define ITEM_DROP 9
#define ITEM_BOOST 10
#define ITEM_SPEED 11
#define ITEM_PASS 12
#define ITEM_TYPE_NUM 13

#define ITEM_FIRE_NUM 3
#define ITEM_FORM_NUM 6
#define ITEM_MODE_NUM 3

#define ITEM_TOUCH_ADD_LIFE 0
#define ITEM_TOUCH_CH_BIGFIRE 1
#define ITEM_TOUCH_CH_WIDEFIRE 2
#define ITEM_TOUCH_CH_LINEFIRE 3
#define ITEM_TOUCH_CH_CROSSFORM 4
#define ITEM_TOUCH_CH_XREVFORM 5
#define ITEM_TOUCH_CH_WAVEFORM 6
#define ITEM_TOUCH_CH_HOMFORM 7
#define ITEM_TOUCH_CH_BOOSTMODE 8
#define ITEM_TOUCH_CH_SPEEDMODE 9
#define ITEM_TOUCH_CH_PASSMODE 10

class BirdPlayer;

class BirdItem : public ActorList{
 public:
  Glib::RefPtr<Gdk::Pixmap> frame;
  Glib::RefPtr<Gdk::GC> mGC;
  BirdMap *Map;
  BirdPlayer *player;
  BirdSprite heartItem[8];
  BirdSprite bigItem[8];
  BirdSprite wideItem[8];
  BirdSprite lineItem[8];
  BirdSprite crossItem[8];
  BirdSprite xrevItem[8];
  BirdSprite waveItem[8];
  BirdSprite homingItem[8];
  BirdSprite divideItem[8];
  BirdSprite dropItem[8];
  BirdSprite boostItem[8];
  BirdSprite speedItem[8];
  BirdSprite passItem[8];
  SpriteBox *itemBox[ITEM_TYPE_NUM];
  BirdItem();
  ~BirdItem();
  void Create(Glib::RefPtr<Gdk::Pixmap> frame0,
	      Glib::RefPtr<Gdk::GC> mGC0,
	      BirdMap *Map0,
	      BirdPlayer *player0);
  
  void Appear(int px,int py,int width,int height,
	      int style,int touch,int tcount);
  int Animate();

  void TouchAddLife(BirdActor *act,int playerFlag);
  void TouchChangeBigFire(BirdActor *act,int playerFlag);
  void TouchChangeWideFire(BirdActor *act,int playerFlag);
  void TouchChangeLineFire(BirdActor *act,int playerFlag);
  void TouchChangeCrossForm(BirdActor *act,int playerFlag);
  void TouchChangeXRevForm(BirdActor *act,int playerFlag);
  void TouchChangeWaveForm(BirdActor *act,int playerFlag);
  void TouchChangeHomingForm(BirdActor *act,int playerFlag);
  void TouchChangeDivideForm(BirdActor *act,int playerFlag);
  void TouchChangeDropForm(BirdActor *act,int playerFlag);
  void TouchChangeBoostMode(BirdActor *act,int playerFlag);
  void TouchChangeSpeedMode(BirdActor *act,int playerFlag);
  void TouchChangePassMode(BirdActor *act,int playerFlag);

  static void(BirdItem::*ITEM_TOUCH[ITEM_TYPE_NUM])
    (BirdActor *act,int playerFlag);

  void CreateHeartItem();
  void CreateBigItem();
  void CreateWideItem();
  void CreateLineItem();
  void CreateCrossItem();
  void CreateXRevItem();
  void CreateWaveItem();
  void CreateHomingItem();
  void CreateDivideItem();
  void CreateDropItem();
  void CreateBoostItem();
  void CreateSpeedItem();
  void CreatePassItem();
};

#endif
