#include "keyconfig.h"
#include <sstream>
#include <fstream>

KeyConfig::KeyConfig(){
  jsShift=-1;
  kbShift=-1;
}

KeyConfig::~KeyConfig(){
  
}

void KeyConfig::Create(MainSDL *mainSDL0){

  mainSDL=mainSDL0;

  Map->sec=0;
  Map->state=KEYCONFIG_STATE_TOP;
  Map->InitValue();

  blackGC=Gdk::GC::create(mWindow);
  blackGC->set_rgb_fg_color(*(color->black));

  whiteGC=Gdk::GC::create(mWindow);
  whiteGC->set_rgb_fg_color(*(color->white));
}

void KeyConfig::KeyBoardSelect(){
  Map->state=KEYCONFIG_STATE_KEYBOARD;
}
void KeyConfig::JoyStickSelect(){
  if(mainSDL->GetJSNum()>0){
    Map->state=KEYCONFIG_STATE_JOYSTICK;
  }
}
void (KeyConfig::*KeyConfig::KEYCONFIG_TOP_SELECT[KEYCONFIG_TOP_NUM])()={
  &KeyConfig::KeyBoardSelect,
  &KeyConfig::JoyStickSelect
};

void KeyConfig::TopMenu(){
  int px0,py0;
  int px1,py1;
  int tmpX;
  int *movY0;

  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(400)/MAP_YMAX;
  text->DrawString("KEY CONFIG",color->white,px0,py0,
		   FONT_LINE_CENTER,20,
		   FONT_SERIF,FONT_FACE_ITALIC);
  
  px1=WIDTH*(KEYCONFIG_TOP_PX1)/MAP_XMAX;

  px0=px1;
  py0=HEIGHT*(KEYCONFIG_TOP_PY1
	      +KEYCONFIG_TOP_MY1*KEYCONFIG_TOP_KEYBOARD)/MAP_YMAX;
  text->DrawString("KEYBOARD",color->white,px0,py0,
		   KEYCONFIG_TOP_LF1,KEYCONFIG_TOP_SF1,
		   KEYCONFIG_TOP_TF1,KEYCONFIG_TOP_FF1);
  
  px0=px1;
  py0=HEIGHT*(KEYCONFIG_TOP_PY1
	      +KEYCONFIG_TOP_MY1*KEYCONFIG_TOP_JOYSTICK)/MAP_YMAX;
  text->DrawString("JOYSTICK",color->white,px0,py0,
		   KEYCONFIG_TOP_LF1,KEYCONFIG_TOP_SF1,
		   KEYCONFIG_TOP_TF1,KEYCONFIG_TOP_FF1);
  
  movY0=&Map->valueY[KEYCONFIG_VY_STATE_TOP];

  StepSelectAction(&tmpX,movY0);
  
  if(*movY0<0){
    *movY0=KEYCONFIG_TOP_NUM-1;
  }
  else if(*movY0>=KEYCONFIG_TOP_NUM){
    *movY0=0;
  }
  
  enemyList->DrawSprite
    (EN_REV_BIRD,EN_WAY_B,2,
     WIDTH*(380)/MAP_XMAX,
     HEIGHT*(KEYCONFIG_TOP_PY1+KEYCONFIG_TOP_MY1
	     *(*movY0))/MAP_YMAX);

  if(control->okValue){
    control->okValue=0;
    (this->*KEYCONFIG_TOP_SELECT[*movY0])();
  }
  else if(control->cancelValue){
    control->cancelValue=0;
    Map->ChangeType(SELECT_MAP_TITLE);
  }
}

void KeyConfig::NameSelect(){
  JSData data0;

  jsShift=KEYCONFIG_JOYSTICK_NAME;
  mainSDL->GetMainJSData(&data0);
  
  Map->valueY[KEYCONFIG_VY_JOYSTICK_NAME]=data0.index;
}
void KeyConfig::HAxisSelect(){
  jsShift=KEYCONFIG_JOYSTICK_HAXIS;
  mainSDL->ChangeJSFlag(MAINSDL_JSFLAG_JAXIS);
}
void KeyConfig::VAxisSelect(){
  jsShift=KEYCONFIG_JOYSTICK_VAXIS;
  mainSDL->ChangeJSFlag(MAINSDL_JSFLAG_JAXIS);
}
void KeyConfig::OkSelect(){
  jsShift=KEYCONFIG_JOYSTICK_OK; 
  mainSDL->ChangeJSFlag(MAINSDL_JSFLAG_JBUTTON);
}
void KeyConfig::CancelSelect(){
  jsShift=KEYCONFIG_JOYSTICK_CANCEL;
  mainSDL->ChangeJSFlag(MAINSDL_JSFLAG_JBUTTON);
}
void (KeyConfig::*KeyConfig::KEYCONFIG_JOYSTICK_SELECT
      [KEYCONFIG_JOYSTICK_NUM])()={
	&KeyConfig::NameSelect,
	&KeyConfig::HAxisSelect,
	&KeyConfig::VAxisSelect,
	&KeyConfig::OkSelect,
	&KeyConfig::CancelSelect
};

void KeyConfig::JoyStickMenuShift(){
  int *movY0;
  int tmpX;

  movY0=&Map->valueY[KEYCONFIG_VY_STATE_JOYSTICK];
  StepSelectAction(&tmpX,movY0);
  
  if(*movY0<0){
    *movY0=KEYCONFIG_JOYSTICK_NUM-1;
  }
  else if(*movY0>=KEYCONFIG_JOYSTICK_NUM){
    *movY0=0;
  }

  if(control->okValue){
    control->okValue=0;
    (this->*KEYCONFIG_JOYSTICK_SELECT[*movY0])();    
  }
  else if(control->cancelValue){
    control->cancelValue=0;
    Map->state=KEYCONFIG_STATE_TOP;
  }
}

void KeyConfig::JoyStickNameShift(){
  int *movY0;
  int tmpX;

  movY0=&Map->valueY[KEYCONFIG_VY_JOYSTICK_NAME];
  StepSelectAction(&tmpX,movY0);
  
  if(*movY0<0){
    *movY0=mainSDL->GetJSNum()-1;
  }
  else if(*movY0>=mainSDL->GetJSNum()){
    *movY0=0;
  }

  if(control->okValue){
    control->okValue=0;
    mainSDL->SetJoyStick(*movY0);
    jsShift=-1;
  }
  else if(control->cancelValue){
    control->cancelValue=0;
    jsShift=-1;
  }
}
void KeyConfig::JoyStickHAxisShift(){
  int value0=-1;
  mainSDL->GetJSValue(value0);
  if(value0<0){
    
  }
  else{
    mainSDL->SetAxisXKey(value0);
    mainSDL->ChangeJSFlag(MAINSDL_JSFLAG_NO);
    jsShift=-1;
  }
}
void KeyConfig::JoyStickVAxisShift(){
  int value0=-1;
  mainSDL->GetJSValue(value0);
  if(value0<0){
    
  }
  else{
    mainSDL->SetAxisYKey(value0);
    mainSDL->ChangeJSFlag(MAINSDL_JSFLAG_NO);
    jsShift=-1;
  }
}
void KeyConfig::JoyStickOkShift(){
  int value0=-1;
  mainSDL->GetJSValue(value0);
  if(value0<0){
    
  }
  else{
    mainSDL->SetOkKey(value0);
    mainSDL->ChangeJSFlag(MAINSDL_JSFLAG_NO);
    jsShift=-1;
  }
}
void KeyConfig::JoyStickCancelShift(){
  int value0=-1;
  mainSDL->GetJSValue(value0);
  if(value0<0){
    
  }
  else{
    mainSDL->SetCancelKey(value0);
    mainSDL->ChangeJSFlag(MAINSDL_JSFLAG_NO);
    jsShift=-1;
  }
}
void (KeyConfig::*KeyConfig::KEYCONFIG_JOYSTICK_SHIFT
      [KEYCONFIG_JOYSTICK_NUM])()={
	&KeyConfig::JoyStickNameShift,
	&KeyConfig::JoyStickHAxisShift,
	&KeyConfig::JoyStickVAxisShift,
	&KeyConfig::JoyStickOkShift,
	&KeyConfig::JoyStickCancelShift
};

void KeyConfig::JoyStickMenu(){
  std::stringstream ss0;
  int jsIndex0;
  int px0,py0;
  int px1,py1;
  int px2,py2;
  int cur0;

  JSData data0;

  mainSDL->GetMainJSData(&data0);
  
  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(150)/MAP_YMAX;
  text->DrawString("JOY STICK",color->white,px0,py0,
		   FONT_LINE_CENTER,25,
		   FONT_SERIF,FONT_FACE_ITALIC);
  
  px1=WIDTH*(KEYCONFIG_JOYSTICK_PX1)/MAP_XMAX;
  px2=WIDTH*(KEYCONFIG_JOYSTICK_PX2)/MAP_XMAX;

  py1=HEIGHT*(KEYCONFIG_JOYSTICK_PY1
	      +KEYCONFIG_JOYSTICK_MY1
	      *KEYCONFIG_JOYSTICK_NAME)/MAP_YMAX;
  px0=px1;
  py0=py1;
  text->DrawString("NAME",color->white,px0,py0,
		   KEYCONFIG_JOYSTICK_LF1,KEYCONFIG_JOYSTICK_SF1,
		   KEYCONFIG_JOYSTICK_TF1,KEYCONFIG_JOYSTICK_FF1);
  px0=px2;
  py0=py1;
  if(jsShift==KEYCONFIG_JOYSTICK_NAME){
    jsIndex0=Map->valueY[KEYCONFIG_VY_JOYSTICK_NAME];
  }
  else{
    jsIndex0=data0.index;
  }

  ss0<<": ("<<jsIndex0<<"). "<<mainSDL->GetJSName(jsIndex0);
  text->DrawString(ss0.str(),color->white,px0,py0,
		   KEYCONFIG_JOYSTICK_LF1,KEYCONFIG_JOYSTICK_SF1,
		   KEYCONFIG_JOYSTICK_TF1,KEYCONFIG_JOYSTICK_FF1);
  ss0.str("");
  ss0.clear(std::stringstream::goodbit);
  
  py1=HEIGHT*(KEYCONFIG_JOYSTICK_PY1
	      +KEYCONFIG_JOYSTICK_MY1
	      *KEYCONFIG_JOYSTICK_HAXIS)/MAP_YMAX;
  px0=px1;
  py0=py1;
  text->DrawString("H_AXIS",color->white,px0,py0,
		   KEYCONFIG_JOYSTICK_LF1,KEYCONFIG_JOYSTICK_SF1,
		   KEYCONFIG_JOYSTICK_TF1,KEYCONFIG_JOYSTICK_FF1);
  
  ss0<<": "<<(int)mainSDL->GetAxisXKey()<<" Axis";
  px0=px2;
  py0=py1;
  text->DrawString(ss0.str(),color->white,px0,py0,
		   KEYCONFIG_JOYSTICK_LF1,KEYCONFIG_JOYSTICK_SF1,
		   KEYCONFIG_JOYSTICK_TF1,KEYCONFIG_JOYSTICK_FF1);
  ss0.str("");
  ss0.clear(std::stringstream::goodbit);

  py1=HEIGHT*(KEYCONFIG_JOYSTICK_PY1
	      +KEYCONFIG_JOYSTICK_MY1
	      *KEYCONFIG_JOYSTICK_VAXIS)/MAP_YMAX;
  px0=px1;
  py0=py1;
  text->DrawString("V_AXIS",color->white,px0,py0,
		   KEYCONFIG_JOYSTICK_LF1,KEYCONFIG_JOYSTICK_SF1,
		   KEYCONFIG_JOYSTICK_TF1,KEYCONFIG_JOYSTICK_FF1);
  ss0<<": "<<(int)mainSDL->GetAxisYKey()<<" Axis";
  px0=px2;
  py0=py1;
  text->DrawString(ss0.str(),color->white,px0,py0,
		   KEYCONFIG_JOYSTICK_LF1,KEYCONFIG_JOYSTICK_SF1,
		   KEYCONFIG_JOYSTICK_TF1,KEYCONFIG_JOYSTICK_FF1);
  ss0.str("");
  ss0.clear(std::stringstream::goodbit);

  py1=HEIGHT*(KEYCONFIG_JOYSTICK_PY1
	      +KEYCONFIG_JOYSTICK_MY1
	      *KEYCONFIG_JOYSTICK_OK)/MAP_YMAX;
  px0=px1;
  py0=py1;
  text->DrawString("OK BUTTON",color->white,px0,py0,
		   KEYCONFIG_JOYSTICK_LF1,KEYCONFIG_JOYSTICK_SF1,
		   KEYCONFIG_JOYSTICK_TF1,KEYCONFIG_JOYSTICK_FF1);
  ss0<<": "<<(int)mainSDL->GetOkKey()<<" Button";
  px0=px2;
  py0=py1;
  text->DrawString(ss0.str(),color->white,px0,py0,
		   KEYCONFIG_JOYSTICK_LF1,KEYCONFIG_JOYSTICK_SF1,
		   KEYCONFIG_JOYSTICK_TF1,KEYCONFIG_JOYSTICK_FF1);
  ss0.str("");
  ss0.clear(std::stringstream::goodbit);

  py1=HEIGHT*(KEYCONFIG_JOYSTICK_PY1
	      +KEYCONFIG_JOYSTICK_MY1
	      *KEYCONFIG_JOYSTICK_CANCEL)/MAP_YMAX;
  px0=px1;
  py0=py1;
  text->DrawString("CANCEL BUTTON",color->white,px0,py0,
		   KEYCONFIG_JOYSTICK_LF1,KEYCONFIG_JOYSTICK_SF1,
		   KEYCONFIG_JOYSTICK_TF1,KEYCONFIG_JOYSTICK_FF1);
  ss0<<": "<<(int)mainSDL->GetCancelKey()<<" Button";
  px0=px2;
  py0=py1;
  text->DrawString(ss0.str(),color->white,px0,py0,
		   KEYCONFIG_JOYSTICK_LF1,KEYCONFIG_JOYSTICK_SF1,
		   KEYCONFIG_JOYSTICK_TF1,KEYCONFIG_JOYSTICK_FF1);
  ss0.str("");
  ss0.clear(std::stringstream::goodbit);

  if(jsShift<0){
    JoyStickMenuShift();  
    cur0=EN_REV_BIRD;
  }
  else{
    (this->*KEYCONFIG_JOYSTICK_SHIFT[jsShift])();
    cur0=EN_HOM_BIRD;
  }
  enemyList->DrawSprite
    (cur0,EN_WAY_B,2,
     WIDTH*(100)/MAP_XMAX,
     HEIGHT*(KEYCONFIG_JOYSTICK_PY1+KEYCONFIG_JOYSTICK_MY1
	     *(Map->valueY[KEYCONFIG_VY_STATE_JOYSTICK]))/MAP_YMAX);
}

void KeyConfig::KBOkSelect(){
  kbShift=KEYCONFIG_KEYBOARD_OK;
  control->ChangeKeyFlag(CONTROL_KEYFLAG_RECEIVE);
}
void KeyConfig::KBCancelSelect(){
  kbShift=KEYCONFIG_KEYBOARD_CANCEL;
  control->ChangeKeyFlag(CONTROL_KEYFLAG_RECEIVE);
}
void KeyConfig::KBLeftSelect(){
  kbShift=KEYCONFIG_KEYBOARD_LEFT;
  control->ChangeKeyFlag(CONTROL_KEYFLAG_RECEIVE);
}
void KeyConfig::KBRightSelect(){
  kbShift=KEYCONFIG_KEYBOARD_RIGHT;
  control->ChangeKeyFlag(CONTROL_KEYFLAG_RECEIVE);
}
void KeyConfig::KBUpSelect(){
  kbShift=KEYCONFIG_KEYBOARD_UP;
  control->ChangeKeyFlag(CONTROL_KEYFLAG_RECEIVE);
}
void KeyConfig::KBDownSelect(){
  kbShift=KEYCONFIG_KEYBOARD_DOWN;
  control->ChangeKeyFlag(CONTROL_KEYFLAG_RECEIVE);
}
void (KeyConfig::*KeyConfig::KEYCONFIG_KEYBOARD_SELECT
      [KEYCONFIG_KEYBOARD_NUM])()={
	&KeyConfig::KBOkSelect,
	&KeyConfig::KBCancelSelect,
	&KeyConfig::KBLeftSelect,
	&KeyConfig::KBRightSelect,
	&KeyConfig::KBUpSelect,
	&KeyConfig::KBDownSelect
};

void KeyConfig::KeyBoardMenuShift(){
  int *movY0;
  int tmpX;

  movY0=&Map->valueY[KEYCONFIG_VY_STATE_KEYBOARD];
  StepSelectAction(&tmpX,movY0);
  
  if(*movY0<0){
    *movY0=KEYCONFIG_KEYBOARD_NUM-1;
  }
  else if(*movY0>=KEYCONFIG_KEYBOARD_NUM){
    *movY0=0;
  }

  if(control->okValue){
    control->okValue=0;
    (this->*KEYCONFIG_KEYBOARD_SELECT[*movY0])();    
  }
  else if(control->cancelValue){
    control->cancelValue=0;
    Map->state=KEYCONFIG_STATE_TOP;
  }
}

void KeyConfig::KBOkShift(){
  int value0=-1;
  control->GetKeyValue(value0);
  if(value0<0){
    
  }
  else{
    control->SetOkKey(value0);
    control->ChangeKeyFlag(CONTROL_KEYFLAG_NO);
    kbShift=-1;
  }
}
void KeyConfig::KBCancelShift(){
  int value0=-1;
  control->GetKeyValue(value0);
  if(value0<0){
    
  }
  else{
    control->SetCancelKey(value0);
    control->ChangeKeyFlag(CONTROL_KEYFLAG_NO);
    kbShift=-1;
  }
}
void KeyConfig::KBLeftShift(){
  int value0=-1;
  control->GetKeyValue(value0);
  if(value0<0){
    
  }
  else{
    control->SetLeftKey(value0);
    control->ChangeKeyFlag(CONTROL_KEYFLAG_NO);
    kbShift=-1;
  }
}
void KeyConfig::KBRightShift(){
  int value0=-1;
  control->GetKeyValue(value0);
  if(value0<0){
    
  }
  else{
    control->SetRightKey(value0);
    control->ChangeKeyFlag(CONTROL_KEYFLAG_NO);
    kbShift=-1;
  }
}
void KeyConfig::KBUpShift(){
  int value0=-1;
  control->GetKeyValue(value0);
  if(value0<0){
    
  }
  else{
    control->SetUpKey(value0);
    control->ChangeKeyFlag(CONTROL_KEYFLAG_NO);
    kbShift=-1;
  }
}
void KeyConfig::KBDownShift(){
  int value0=-1;
  control->GetKeyValue(value0);
  if(value0<0){
    
  }
  else{
    control->SetDownKey(value0);
    control->ChangeKeyFlag(CONTROL_KEYFLAG_NO);
    kbShift=-1;
  }
}
void (KeyConfig::*KeyConfig::KEYCONFIG_KEYBOARD_SHIFT
      [KEYCONFIG_KEYBOARD_NUM])()={
	&KeyConfig::KBOkShift,
	&KeyConfig::KBCancelShift,
	&KeyConfig::KBLeftShift,
	&KeyConfig::KBRightShift,
	&KeyConfig::KBUpShift,
	&KeyConfig::KBDownShift
      };

void KeyConfig::KeyBoardMenu(){
  std::stringstream ss0;
  int px0,py0;
  int px1,py1;
  int px2,py2;
  int cur0;
  
  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(150)/MAP_YMAX;
  text->DrawString("KEYBOARD",color->white,px0,py0,
		   FONT_LINE_CENTER,25,
		   FONT_SERIF,FONT_FACE_ITALIC);
  
  px1=WIDTH*(KEYCONFIG_KEYBOARD_PX1)/MAP_XMAX;
  px2=WIDTH*(KEYCONFIG_KEYBOARD_PX2)/MAP_XMAX;

  py1=HEIGHT*(KEYCONFIG_KEYBOARD_PY1
	      +KEYCONFIG_KEYBOARD_MY1
	      *KEYCONFIG_KEYBOARD_OK)/MAP_YMAX;
  px0=px1;
  py0=py1;
  text->DrawString("OK BUTTON",color->white,px0,py0,
		   KEYCONFIG_KEYBOARD_LF1,KEYCONFIG_KEYBOARD_SF1,
		   KEYCONFIG_KEYBOARD_TF1,KEYCONFIG_KEYBOARD_FF1);
  px0=px2;
  py0=py1;
  ss0<<": "<<control->GetKeyName(control->GetOkKey());
  text->DrawString(ss0.str(),color->white,px0,py0,
		   KEYCONFIG_KEYBOARD_LF1,KEYCONFIG_KEYBOARD_SF1,
		   KEYCONFIG_KEYBOARD_TF1,KEYCONFIG_KEYBOARD_FF1);
  ss0.str("");
  ss0.clear(std::stringstream::goodbit);
  
  py1=HEIGHT*(KEYCONFIG_KEYBOARD_PY1
	      +KEYCONFIG_KEYBOARD_MY1
	      *KEYCONFIG_KEYBOARD_CANCEL)/MAP_YMAX;
  px0=px1;
  py0=py1;
  text->DrawString("CANCEL BUTTON",color->white,px0,py0,
		   KEYCONFIG_KEYBOARD_LF1,KEYCONFIG_KEYBOARD_SF1,
		   KEYCONFIG_KEYBOARD_TF1,KEYCONFIG_KEYBOARD_FF1);
  px0=px2;
  py0=py1;
  ss0<<": "<<control->GetKeyName(control->GetCancelKey());
  text->DrawString(ss0.str(),color->white,px0,py0,
		   KEYCONFIG_KEYBOARD_LF1,KEYCONFIG_KEYBOARD_SF1,
		   KEYCONFIG_KEYBOARD_TF1,KEYCONFIG_KEYBOARD_FF1);
  ss0.str("");
  ss0.clear(std::stringstream::goodbit);
  
  py1=HEIGHT*(KEYCONFIG_KEYBOARD_PY1
	      +KEYCONFIG_KEYBOARD_MY1
	      *KEYCONFIG_KEYBOARD_LEFT)/MAP_YMAX;
  px0=px1;
  py0=py1;
  text->DrawString("LEFT BUTTON",color->white,px0,py0,
		   KEYCONFIG_KEYBOARD_LF1,KEYCONFIG_KEYBOARD_SF1,
		   KEYCONFIG_KEYBOARD_TF1,KEYCONFIG_KEYBOARD_FF1);
  px0=px2;
  py0=py1;
  ss0<<": "<<control->GetKeyName(control->GetLeftKey());
  text->DrawString(ss0.str(),color->white,px0,py0,
		   KEYCONFIG_KEYBOARD_LF1,KEYCONFIG_KEYBOARD_SF1,
		   KEYCONFIG_KEYBOARD_TF1,KEYCONFIG_KEYBOARD_FF1);
  ss0.str("");
  ss0.clear(std::stringstream::goodbit);

  py1=HEIGHT*(KEYCONFIG_KEYBOARD_PY1
	      +KEYCONFIG_KEYBOARD_MY1
	      *KEYCONFIG_KEYBOARD_RIGHT)/MAP_YMAX;
  px0=px1;
  py0=py1;
  text->DrawString("RIGHT BUTTON",color->white,px0,py0,
		   KEYCONFIG_KEYBOARD_LF1,KEYCONFIG_KEYBOARD_SF1,
		   KEYCONFIG_KEYBOARD_TF1,KEYCONFIG_KEYBOARD_FF1);
  px0=px2;
  py0=py1;
  ss0<<": "<<control->GetKeyName(control->GetRightKey());
  text->DrawString(ss0.str(),color->white,px0,py0,
		   KEYCONFIG_KEYBOARD_LF1,KEYCONFIG_KEYBOARD_SF1,
		   KEYCONFIG_KEYBOARD_TF1,KEYCONFIG_KEYBOARD_FF1);
  ss0.str("");
  ss0.clear(std::stringstream::goodbit);

  py1=HEIGHT*(KEYCONFIG_KEYBOARD_PY1
	      +KEYCONFIG_KEYBOARD_MY1
	      *KEYCONFIG_KEYBOARD_UP)/MAP_YMAX;
  px0=px1;
  py0=py1;
  text->DrawString("UP BUTTON",color->white,px0,py0,
		   KEYCONFIG_KEYBOARD_LF1,KEYCONFIG_KEYBOARD_SF1,
		   KEYCONFIG_KEYBOARD_TF1,KEYCONFIG_KEYBOARD_FF1);
  px0=px2;
  py0=py1;
  ss0<<": "<<control->GetKeyName(control->GetUpKey());
  text->DrawString(ss0.str(),color->white,px0,py0,
		   KEYCONFIG_KEYBOARD_LF1,KEYCONFIG_KEYBOARD_SF1,
		   KEYCONFIG_KEYBOARD_TF1,KEYCONFIG_KEYBOARD_FF1);
  ss0.str("");
  ss0.clear(std::stringstream::goodbit);

  py1=HEIGHT*(KEYCONFIG_KEYBOARD_PY1
	      +KEYCONFIG_KEYBOARD_MY1
	      *KEYCONFIG_KEYBOARD_DOWN)/MAP_YMAX;
  px0=px1;
  py0=py1;
  text->DrawString("DOWN BUTTON",color->white,px0,py0,
		   KEYCONFIG_KEYBOARD_LF1,KEYCONFIG_KEYBOARD_SF1,
		   KEYCONFIG_KEYBOARD_TF1,KEYCONFIG_KEYBOARD_FF1);
  px0=px2;
  py0=py1;
  ss0<<": "<<control->GetKeyName(control->GetDownKey());
  text->DrawString(ss0.str(),color->white,px0,py0,
		   KEYCONFIG_KEYBOARD_LF1,KEYCONFIG_KEYBOARD_SF1,
		   KEYCONFIG_KEYBOARD_TF1,KEYCONFIG_KEYBOARD_FF1);
  ss0.str("");
  ss0.clear(std::stringstream::goodbit);

  if(kbShift<0){
    KeyBoardMenuShift();  
    cur0=EN_REV_BIRD;
  }
  else{
    (this->*KEYCONFIG_KEYBOARD_SHIFT[kbShift])();
    cur0=EN_HOM_BIRD;
  }
  enemyList->DrawSprite
    (cur0,EN_WAY_B,2,
     WIDTH*(100)/MAP_XMAX,
     HEIGHT*(KEYCONFIG_KEYBOARD_PY1+KEYCONFIG_KEYBOARD_MY1
	     *(Map->valueY[KEYCONFIG_VY_STATE_KEYBOARD]))/MAP_YMAX);
}

void (KeyConfig::*KeyConfig::KEYCONFIG_STATE_SELECT[KEYCONFIG_STATE_NUM])
  ()={
    &KeyConfig::TopMenu,
    &KeyConfig::KeyBoardMenu,
    &KeyConfig::JoyStickMenu
  };

void KeyConfig::ViewMap(){
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);
  int px0,py0;
 
  frame->draw_rectangle(blackGC,true,0,0,WIDTH,HEIGHT);
  
  (this->*KEYCONFIG_STATE_SELECT[Map->state])();
  
  mWindow->invalidate_rect(rect,false);
}
