#ifndef BIRD_LAND_H_
#define BIRD_LAND_H_

#include <gtkmm.h>

#include "rhoumbus.h"
#include "actlist.h"
#include "color.h"
#include "player.h"
#include "map.h"

#define LAND_COLOR_MOUNTAIN 0
#define LAND_COLOR_FOREST 1
#define LAND_COLOR_ROCK 2
#define LAND_COLOR_ICE 3
#define LAND_COLOR_NUM 4

class BirdPlayer;

class BirdLand : public RhoumList {
 public:
  BirdMap *Map;
  BirdPlayer *player;
  BirdColor *color;
  Glib::RefPtr<Gdk::Pixmap> frame;
  Glib::RefPtr<Gdk::GC> gcList[LAND_COLOR_NUM];
  std::vector<Gdk::Point> points;

  BirdLand();
  ~BirdLand();
  void Create(Glib::RefPtr<Gdk::Pixmap> frame0,
	      Glib::RefPtr<Gdk::Window> window0,
	      BirdMap *Map0,
	      BirdColor *color0,
	      BirdPlayer *player0);
  
  int FirstCoordinate(BirdRhoum *rhoum,int *px,int *py);
  int SecondCoordinate(BirdRhoum *rhoum,int *px,int *py);
  int ThirdCoordinate(BirdRhoum *rhoum,int *px,int *py);
  int FourthCoordinate(BirdRhoum *rhoum,int *px,int *py);

  int ActFirstCoordinate(BirdRhoum *rhoum,BirdActor *act,
			 int *tX,int *tY);
  int ActSecondCoordinate(BirdRhoum *rhoum,BirdActor *act,
			  int *tX,int *tY);
  int ActThirdCoordinate(BirdRhoum *rhoum,BirdActor *act,
			 int *tX,int *tY);
  int ActFourthCoordinate(BirdRhoum *rhoum,BirdActor *act,
			  int *tX,int *tY);
  
  int ContactPoint(BirdRhoum *rhoum,int *px,int *py);
  int ContactActor(BirdRhoum *rhoum,BirdActor *act,int *tX,int *tY);

  void Appear(BirdRhoum *rhoum);
  void Appear(int px,int py,
	      int left,int up,int right,int down,int color);
  int Animate();
};

#endif
