#ifndef BIRD_MAINSDL_H_
#define BIRD_MAINSDL_H_

#include <iostream>
#include "SDL.h"

#define MAINSDL_JSFLAG_NO 0
#define MAINSDL_JSFLAG_JAXIS 1
#define MAINSDL_JSFLAG_JBUTTON 2
#define MAINSDL_JSFLAG_NUM 3

class JSData{
 public:
  int index;
  std::string name;
  int nAxis;
  int nButton;
};

class MainSDL{
 public:
  int jsFlag;
  int jsValue;
 private:
  SDL_Joystick *mainJS;
  int initFlag;
  int jsNum;
  Uint8 axisXKey;
  Uint8 axisYKey;
  Uint8 okKey;
  Uint8 cancelKey;
  int leftKeyValue;
  int rightKeyValue;
  int upKeyValue;
  int downKeyValue;
  int okKeyValue;
  int cancelKeyValue;
  int *okValue;
  int *cancelValue;
  int *selectValue;
 public:
  MainSDL();
  ~MainSDL();
  void Create(int *okValue0,int *cancelValue0,int *selectValue0);
  int GetJSNum();
  std::string GetJSName(int index0);
  int SetJoyStick(int index0);
  int GetMainJSData(JSData *data0);

  Uint8 GetAxisXKey();
  Uint8 GetAxisYKey();
  Uint8 GetOkKey();
  Uint8 GetCancelKey();

  void SetAxisXKey(Uint8 key0);
  void SetAxisYKey(Uint8 key0);
  void SetOkKey(Uint8 key0);
  void SetCancelKey(Uint8 key0);

  void ChangeJSFlag(int flag0);
  int GetJSValue(int &value0);

  void ReceiveEvent();

  void JSAxisReceive(SDL_JoyAxisEvent *jaxis0);
  void JSButtonPressReceive(SDL_JoyButtonEvent *jbutton0);

  void JSAxisEvent(SDL_JoyAxisEvent *jaxis0);
  void JSButtonPressEvent(SDL_JoyButtonEvent *jbutton0);
  void JSButtonReleaseEvent(SDL_JoyButtonEvent *jbutton0);
};

#endif
