#include "playcreate.h"

PlayCreate::PlayCreate(){
  waitCount=0;
  stageID=0;
}

PlayCreate::~PlayCreate(){

}

void PlayCreate::Create(){
  StageCreate();

  Map->sec=0;
  Map->state=0;
  Map->InitValue();
}

void PlayCreate::InitSlide(){
  int width0,height0,rotate0,flip0;
  std::string path0,path;
  std::string file;
  std::string name;
  std::string folder;
  int value;

  Gtk::FileChooserDialog diag
    ("LOAD STAGE",Gtk::FILE_CHOOSER_ACTION_OPEN);
  diag.add_button(Gtk::Stock::OPEN, Gtk::RESPONSE_OK);
  diag.add_button(Gtk::Stock::CANCEL, Gtk::RESPONSE_CANCEL);
  
  Gtk::FileFilter filt;
  filt.set_name("stage");
  filt.add_pattern("*.stage");
  diag.add_filter(filt);

  path0=diag.get_current_folder();

  path=path0+"/stage";

  if(diag.set_current_folder(path)){
    std::cout<<"FIND FOLDER:"<<path<<std::endl;
  }
  else{
    std::cout<<"FALSE FOLDER:"<<diag.get_current_folder()<<std::endl;
  }

  while(value=diag.run()){
    if(value==Gtk::RESPONSE_OK){
      file=diag.get_filename();
      folder=diag.get_current_folder();

      name=file;
      name.erase(name.find(folder,0),folder.size()+1);
      name.erase(name.find(".stage",0),6);

      if(folder.find(path0,0)!=std::string::npos){
	folder.erase(folder.find(path0,0),path0.size()+1);
      }

      std::cout<<"FILE:"<<file<<std::endl;
      std::cout<<"FOLDER:"<<folder<<std::endl;
      std::cout<<"NAME:"<<name<<std::endl;
      
      if(LoadStage(folder,name,&width0,&height0,&rotate0,&flip0)!=0){
	Map->ChangeType(SELECT_MAP_TITLE);
      }
      else{
	folderPath=folder;
	namePath=name;
	player->InitPlayer(initLife,initFire,initForm);
	Map->state=PLAYCREATE_STATE_GAMESTART;
      }
      break;
    }
    else if(value==Gtk::RESPONSE_CANCEL){
      Map->ChangeType(SELECT_MAP_TITLE);
      break;
    }
    else if(value==Gtk::RESPONSE_DELETE_EVENT){
      Map->ChangeType(SELECT_MAP_TITLE);
      break;
    }
  }
 
  diag.show();
  /*
  diag.resize(200,100);
  */

  waitCount=0;
}
void PlayCreate::StartSlide(){
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);
  std::stringstream ss;
  int px0,py0;
  
  frame->draw_rectangle(blackGC,true,0,0,WIDTH,HEIGHT);
  
  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(350)/MAP_YMAX;
  text->DrawString(stageName,color->white,px0,py0,
		   FONT_LINE_CENTER,35,
		   FONT_SERIF,FONT_FACE_ITALIC);
  
  player->DrawSprite(PLAYER_NORMAL_CRAFT,0,
		     WIDTH*(450)/MAP_XMAX,
		     HEIGHT*(600)/MAP_YMAX);

  ss<<"x "<<player->life;
  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(600)/MAP_YMAX;
  text->DrawString(ss.str(),color->white,px0,py0,
		   FONT_LINE_LEFT,15,
		   FONT_SERIF,FONT_FACE_BOLD);
  ss.str("");
  ss.clear(std::stringstream::goodbit);
  
  ss<<"score : "<<player->score;
  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(700)/MAP_YMAX;
  text->DrawString(ss.str(),color->white,px0,py0,
		   FONT_LINE_CENTER,15,
		   FONT_SERIF,FONT_FACE_BOLD);
  ss.str("");
  ss.clear(std::stringstream::goodbit);
  
  mWindow->invalidate_rect(rect,false);
  
  if(waitCount>0){
    
    enemyList->ALLDelete();
    efireList->ALLDelete();
    pfireList->ALLDelete();
    landList->ALLDelete();
    itemList->ALLDelete();

    if(LoadBirdWatch
       (folderPath,namePath,
	998,999,STAGE_CHANGE_STATE,PLAYCREATE_STATE_GAMEEND)!=0){
      Map->ChangeType(SELECT_MAP_TITLE);
    }
    else{
      Map->state=PLAYCREATE_STATE_GAME;
      Map->sec=0;
    }
  }
  waitCount++;
}
void PlayCreate::GameView(){
  int enemyCount,playerFireCount,enemyFireCount,landCount,itemCount;
  int px0,py0;
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);

  RunBackGround();
  
  ModalTypeSelect(Map->sec);
  
  landCount=landList->Animate();
  enemyCount=enemyList->Animate();
  playerFireCount=pfireList->Animate();
  enemyFireCount=efireList->Animate();
  player->Animate();
  itemCount=itemList->Animate();
  
  GameStatusView(STAGE_STATUSVIEW_LIFE);

  mWindow->invalidate_rect(rect,false);
  Map->sec++;

  if(control->cancelValue==1){
    control->cancelValue=0;
    Map->state0=Map->state;
    Map->state=PLAYCREATE_STATE_PAUSE;
  }
  if(player->life<=0){
    Map->state=PLAYCREATE_STATE_GAMEOVER;
  }
}
void PlayCreate::PauseView(){
  PauseMenuView(&Map->valueY[PLAYCREATE_VY_STATE_PAUSE],
		STAGE_CHANGE_TYPE,SELECT_MAP_TITLE);  
}
void PlayCreate::EndSlide(){
  NameDialog diag;
  int value;
  int px0,py0;

  std::stringstream ss;
  std::string str;
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);

  frame->draw_rectangle(blackGC,true,0,0,WIDTH,HEIGHT);

  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(350)/MAP_YMAX;
  text->DrawString
    ("GAME END",(color->white),px0,py0,FONT_LINE_CENTER,35,
     FONT_SERIF,FONT_FACE_ITALIC);

  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(600)/MAP_YMAX;
  text->DrawString
    (stageName,(color->white),px0,py0,FONT_LINE_CENTER,
     20,FONT_SERIF,FONT_FACE_BOLD);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(700)/MAP_YMAX;
  ss<<"SCORE : "<<player->score;
  str=ss.str();
  text->DrawString
    (str,(color->white),px0,py0,FONT_LINE_CENTER,
     15,FONT_SERIF,FONT_FACE_BOLD);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  mWindow->invalidate_rect(rect,false);

  
  while(value=diag.Run()){
    if(value==Gtk::RESPONSE_OK){
      scoreFile->WriteFile
	(player->score,player->life,Map->sec,SCORE_MODE_CREATESTAGE,
	 CalcStageID(),stageName,diag.GetName());
      break;
    }
    else if(value==Gtk::RESPONSE_DELETE_EVENT){
      
    }
  }
  
  Map->ChangeType(SELECT_MAP_TITLE);
  
}
void PlayCreate::GameOver(){
  NameDialog diag;
  int value;
  int px0,py0;
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);
  
  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(500)/MAP_YMAX;
  text->DrawString
    ("GAME OVER",(color->black),px0,py0,
     FONT_LINE_CENTER,35,
     FONT_SERIF,FONT_FACE_ITALIC);

  mWindow->invalidate_rect(rect,false);
  
  while(value=diag.Run()){
    if(value==Gtk::RESPONSE_OK){
      scoreFile->WriteFile
	(player->score,player->life,Map->sec,SCORE_MODE_CREATESTAGE,
	 CalcStageID(),stageName,diag.GetName());
      break;
    }
    else if(value==Gtk::RESPONSE_DELETE_EVENT){
      
    }
  }
  
  Map->ChangeType(SELECT_MAP_TITLE);
}
void (PlayCreate::*PlayCreate::
      PLAYCREATE_STATE_SELECT[PLAYCREATE_STATE_NUM])()={
	&PlayCreate::InitSlide,
	&PlayCreate::StartSlide,
	&PlayCreate::GameView,
	&PlayCreate::PauseView,
	&PlayCreate::EndSlide,
	&PlayCreate::GameOver
      };

void PlayCreate::ViewMap(){
  (this->*PLAYCREATE_STATE_SELECT[Map->state])();
}
