#include "scorefile.h"

ScoreFile::ScoreFile(){
  file="BIRD_SCORE.data";
  listSize=0;
  first=NULL;
  end=NULL;
}

ScoreFile::~ScoreFile(){
  ALLDelete();
}

void ScoreFile::Create(){
  
}

int ScoreFile::CalcString(const char *str,int length){
  int i,same;

  same=0;
  i=0;
  while(i<length){
    same+=(int)*(str+i);

    i++;
  }
  return same;
}

int ScoreFile::CalcID(int score0,int sec0,int mode0,
		      std::string stage,std::string name){
  int id0;
  int nameValue,stageValue;
  
  nameValue=CalcString(stage.c_str(),stage.size());
  stageValue=CalcString(name.c_str(),name.size());

  id0=nameValue+stageValue+score0+sec0+SCORE_CALCID_POWMODE*mode0;

  return id0;
}

void ScoreFile::Append(BirdScore *node){
  if(end==NULL){
    first=node;
    end=node;
    node->next=NULL;
    node->prev=NULL;
  }
  else{
    if(end->next==NULL){
      end->next=node;
      node->prev=end;
      node->next=NULL;
      end=node;
    }
    else{
      std::cout<<"APPEND ERROR"<<std::endl;
    }
  }
  listSize++;
}

void ScoreFile::Prepend(BirdScore *node){
  if(first==NULL){
    first=node;
    end=node;
    node->prev=NULL;
    node->next=NULL;
  }
  else{
    node->next=first;
    node->prev=NULL;
    first->prev=node;
    first=node;
  }
  listSize++;
}

void ScoreFile::Insert(BirdScore *node,BirdScore *target){
  if(target->prev==NULL){
    node->next=target;
    node->prev=NULL;
    target->prev=node;
    first=node;
  }
  else{
    node->next=target;
    node->prev=target->prev;
    (target->prev)->next=node;
    target->prev=node;
  }
  listSize++;
}

void ScoreFile::Reject(BirdScore *node){
  if(node->next==NULL){
      if(node->prev==NULL){
	first=NULL;
	end=NULL;
      }
      else{
	(node->prev)->next=NULL;
	end=node->prev;
      }
  }
  else{
    if(node->prev==NULL){
      (node->next)->prev=NULL;
      first=node->next;
    }
    else{
      (node->next)->prev=node->prev;
      (node->prev)->next=node->next;
    }
  }
  node->next=NULL;
  node->prev=NULL;

  listSize--;
}

void ScoreFile::ALLDelete(){
  BirdScore *node;
  BirdScore *tmp;

  node=first;
  while(node){
    tmp=node->next;
    Reject(node);
    delete node;
    node=tmp;
  }
  if(listSize==0){
    std::cout<<"SCORE ALL DELETE!"<<std::endl;  
  }
  else{
    std::cout<<"SCORE ERROR NO ALL DELETE"<<std::endl;
  }
}

void ScoreFile::WriteFile(int score0,int life0,int sec0,int mode0,
			  int stageID0,std::string stage,
			  std::string name){
  std::ofstream FO;
  time_t times;
  int id0=0;

  id0=CalcID(score0,sec0,mode0,stage,name);
  
  time(&times);
  FO.open(file.c_str(),std::ios::out|std::ios::app);
  FO<<score0<<"\t";
  FO<<life0<<"\t";
  FO<<sec0<<"\t";
  FO<<mode0<<"\t";
  FO<<id0<<"\t";
  FO<<stageID0<<"\t";
  FO<<times<<"\t";
  FO<<stage<<"\t";
  FO<<name<<std::endl;
  FO.close();
}

void ScoreFile::EnterScore(std::string *data,int length){
  BirdScore *node;
  int score0,life0,sec0,mode0,id1,id2,time0,stageID0;
  std::string name0,stage0;

  if(length==SCORE_ELEMENT_NUM){
    score0=atoi((data+SCORE_ELEMENT_SCORE)->c_str());
    life0=atoi((data+SCORE_ELEMENT_LIFE)->c_str());
    sec0=atoi((data+SCORE_ELEMENT_SEC)->c_str());
    mode0=atoi((data+SCORE_ELEMENT_MODE)->c_str());
    id1=atoi((data+SCORE_ELEMENT_ID)->c_str());
    stageID0=atoi((data+SCORE_ELEMENT_STAGEID)->c_str());
    time0=atoi((data+SCORE_ELEMENT_TIME)->c_str());
    stage0=*(data+SCORE_ELEMENT_STAGE);
    name0=*(data+SCORE_ELEMENT_NAME);
    id2=CalcID(score0,sec0,mode0,stage0,name0);

    if(id1==id2){
      node= new BirdScore;
      
      node->score=score0;
      node->life=life0;
      node->sec=sec0;
      node->mode=mode0;
      node->id=id1;
      node->stageID=stageID0;
      node->time=time0;
      node->stage=stage0;
      node->name=name0;
      Append(node);
    }
    else{
      std::cout<<"WRONG SCORE ID"<<std::endl;
    }
  }
  else{
    std::cout<<"WRONG SCORE ELEMENT"<<std::endl;
  }
}

void ScoreFile::ReadFile(){
  std::ifstream FI;
  char ch;
  char str[255];
  char *s0;
  std::string READ[SCORE_ELEMENT_NUM];
  std::string *RP;
  int strCount=0;
  int tabCount=0;
  int enterCount=0;
  
  RP=&READ[0];
  s0=&str[0];

  FI.open(file.c_str(),std::ios::in);
  if(!(FI)){
    std::cout<<"CAN'T OPEN "<<file<<std::endl;
  }
  else{
    std::cout<<"OPEN "<<file<<std::endl;
    while(FI.get(ch)){
      
      if(ch=='\t'){
	*(s0+strCount)='\0';
	*(RP+tabCount)=s0;

	tabCount++;
	strCount=0;
      }
      else if(ch=='\n'){
	*(s0+strCount)='\0';
	*(RP+tabCount)=s0;
	
	EnterScore(RP,tabCount+1);
	enterCount++;
	tabCount=0;
	strCount=0;
      }
      else{
	*(s0+strCount)=ch;
	strCount++;
      }
    }
    std::cout<<"NUM :"<<enterCount<<std::endl;
    FI.close();
  }
}

void ScoreFile::ViewList(){
  BirdScore *node;
  BirdScore *tmp;
  int i=0;

  node=first;
  while(node){
    tmp=node->next;
    std::cout<<"["<<i<<"]:"<<"\t";
    std::cout<<node->score<<"\t";
    std::cout<<node->life<<"\t";
    std::cout<<node->sec<<"\t";
    std::cout<<node->mode<<"\t";
    std::cout<<node->id<<"\t";
    std::cout<<node->stageID<<"\t";
    std::cout<<node->time<<"\t";
    std::cout<<node->stage<<"\t";
    std::cout<<node->name<<std::endl;
    i++;
    node=tmp;
  }
}

void ScoreFile::SortList(int element,int form){
  BirdScore *iNode;
  BirdScore *jNode;
  BirdScore *iTmp;
  BirdScore *jTmp;
  int flag0=0;

  iNode=first;
  while(iNode){
    iTmp=iNode->next;

    jNode=first;
    while(iNode!=jNode){
      jTmp=jNode->next;
      
      flag0=CompareSelect(iNode,jNode,element);
      
      if(form==SCORE_FORM_ASCEND){
	if(flag0>0){
	  Reject(iNode);
	  Insert(iNode,jNode);
	  break;
	}
      }
      else if(form==SCORE_FORM_DESCEND){
	if(flag0<0){
	  Reject(iNode);
	  Insert(iNode,jNode);
	  break;
	}
      }
      jNode=jTmp;
    }
    
    iNode=iTmp;
  }

}

int ScoreFile::ScoreCompare(BirdScore *node,BirdScore *target){
  int flag=0;
  if(node->score>target->score){
    flag=1;
  }
  else if(node->score<target->score){
    flag=-1;
  }
  else{
    flag=0;
  }
  return flag;
}
int ScoreFile::LifeCompare(BirdScore *node,BirdScore *target){
  int flag=0;
  if(node->life>target->life){
    flag=1;
  }
  else if(node->life<target->life){
    flag=-1;
  }
  else{
    flag=0;
  }
  return flag;
}
int ScoreFile::SecCompare(BirdScore *node,BirdScore *target){
  int flag=0;
  if(node->sec>target->sec){
    flag=1;
  }
  else if(node->sec<target->sec){
    flag=-1;
  }
  else{
    flag=0;
  }
  return flag;
}
int ScoreFile::ModeCompare(BirdScore *node,BirdScore *target){
  int flag=0;
  if(node->mode>target->mode){
    flag=1;
  }
  else if(node->mode<target->mode){
    flag=-1;
  }
  else{
    flag=0;
  }
  return flag;
}
int ScoreFile::IDCompare(BirdScore *node,BirdScore *target){
  int flag=0;
  if(node->id>target->id){
    flag=1;
  }
  else if(node->id<target->id){
    flag=-1;
  }
  else{
    flag=0;
  }
  return flag;
}
int ScoreFile::StageIDCompare
(BirdScore *node,BirdScore *target){
  int flag=0;
  if(node->stageID>target->stageID){
    flag=1;
  }
  else if(node->stageID<target->stageID){
    flag=-1;
  }
  else{
    flag=0;
  }
  return flag;
}
int ScoreFile::TimeCompare(BirdScore *node,BirdScore *target){
  int flag=0;
  if(node->time>target->time){
    flag=1;
  }
  else if(node->time<target->time){
    flag=-1;
  }
  else{
    flag=0;
  }
  return flag;
}
int ScoreFile::StageCompare(BirdScore *node,BirdScore *target){
  int flag=0;
  int nodeValue,targetValue;

  nodeValue=CalcString((node->stage).c_str(),(node->stage).size());
  targetValue=CalcString((target->stage).c_str(),(target->stage).size());
  
  if(nodeValue>targetValue){
    flag=1;
  }
  else if(nodeValue<targetValue){
    flag=-1;
  }
  else{
    flag=0;
  }
  return flag;
}
int ScoreFile::NameCompare(BirdScore *node,BirdScore *target){
  int flag=0;
  int nodeValue,targetValue;

  nodeValue=CalcString((node->name).c_str(),(node->name).size());
  targetValue=CalcString((target->name).c_str(),(target->name).size());
  
  if(nodeValue>targetValue){
    flag=1;
  }
  else if(nodeValue<targetValue){
    flag=-1;
  }
  else{
    flag=0;
  }
  return flag;
}

int (ScoreFile::*ScoreFile::SCORE_COMPARE_SELECT[SCORE_ELEMENT_NUM])
  (BirdScore *node,BirdScore *target)={
    &ScoreFile::ScoreCompare,
    &ScoreFile::LifeCompare,
    &ScoreFile::SecCompare,
    &ScoreFile::ModeCompare,
    &ScoreFile::IDCompare,
    &ScoreFile::StageIDCompare,
    &ScoreFile::TimeCompare,
    &ScoreFile::StageCompare,
    &ScoreFile::NameCompare
  };
int ScoreFile::CompareSelect(BirdScore *node,BirdScore *target,
			     int element){
  return (this->*SCORE_COMPARE_SELECT[element])(node,target);
}

int ScoreFile::ScoreValue(BirdScore *score0){
  return score0->score;
}
int ScoreFile::LifeValue(BirdScore *score0){
  return score0->life;
}
int ScoreFile::SecValue(BirdScore *score0){
  return score0->sec;
}
int ScoreFile::ModeValue(BirdScore *score0){
  return score0->mode;
}
int ScoreFile::IDValue(BirdScore *score0){
  return score0->id;
}
int ScoreFile::StageIDValue(BirdScore *score0){
  return score0->stageID;
}
int ScoreFile::TimeValue(BirdScore *score0){
  return score0->time;
}
int ScoreFile::StageValue(BirdScore *score0){
  int value0;

  value0=CalcString((score0->stage).c_str(),(score0->stage).size());
  return value0;
}
int ScoreFile::NameValue(BirdScore *score0){
  int value0;

  value0=CalcString((score0->name).c_str(),(score0->name).size());
  return value0;
}
int (ScoreFile::*ScoreFile::SCORE_VALUE_SELECT[SCORE_ELEMENT_NUM])
  (BirdScore *score0)={
    &ScoreFile::ScoreValue,
    &ScoreFile::LifeValue,
    &ScoreFile::SecValue,
    &ScoreFile::ModeValue,
    &ScoreFile::IDValue,
    &ScoreFile::StageIDValue,
    &ScoreFile::TimeValue,
    &ScoreFile::StageValue,
    &ScoreFile::NameValue
  };
int ScoreFile::ValueSelect(BirdScore *score0,int element){
  return (this->*SCORE_VALUE_SELECT[element])(score0);
}
