#ifndef BIRD_SCORE_MAP_H_
#define BIRD_SCORE_MAP_H_

#include "basemap.h"

#define SCOREMAP_LIST_MAX 100
#define SCOREMAP_MAP_MAX 100

#define SCOREMAP_STATE_SCORETYPE 0
#define SCOREMAP_STATE_BOSSTYPE 1
#define SCOREMAP_STATE_SCOREVIEW 2
#define SCOREMAP_STATE_SCORESHIFT 3
#define SCOREMAP_STATE_NUM 4

#define SCOREMAP_SCORETYPE_PX1 420
#define SCOREMAP_SCORETYPE_PY1 500
#define SCOREMAP_SCORETYPE_MX1 0
#define SCOREMAP_SCORETYPE_MY1 60
#define SCOREMAP_SCORETYPE_SX1 0
#define SCOREMAP_SCORETYPE_SY1 0
#define SCOREMAP_SCORETYPE_SF1 12
#define SCOREMAP_SCORETYPE_LF1 FONT_LINE_LEFT
#define SCOREMAP_SCORETYPE_TF1 FONT_SERIF
#define SCOREMAP_SCORETYPE_FF1 FONT_FACE_BOLD

#define SCOREMAP_SCORETYPE_STREAM 0
#define SCOREMAP_SCORETYPE_BOSSPRACTICE 1
#define SCOREMAP_SCORETYPE_CREATESTAGE 2
#define SCOREMAP_SCORETYPE_NUM 3

#define SCOREMAP_BOSSTYPE_PX1 420
#define SCOREMAP_BOSSTYPE_PY1 500
#define SCOREMAP_BOSSTYPE_MX1 0
#define SCOREMAP_BOSSTYPE_MY1 60
#define SCOREMAP_BOSSTYPE_SX1 0
#define SCOREMAP_BOSSTYPE_SY1 0
#define SCOREMAP_BOSSTYPE_SF1 12
#define SCOREMAP_BOSSTYPE_LF1 FONT_LINE_LEFT
#define SCOREMAP_BOSSTYPE_TF1 FONT_SERIF
#define SCOREMAP_BOSSTYPE_FF1 FONT_FACE_BOLD

#define SCOREMAP_BOSSTYPE_SILKHAT 0
#define SCOREMAP_BOSSTYPE_CROWD 1
#define SCOREMAP_BOSSTYPE_EAGLE 2
#define SCOREMAP_BOSSTYPE_NUM 3

#define SCOREMAP_BOSSPRACTICE_PX1 180
#define SCOREMAP_BOSSPRACTICE_PY1 230
#define SCOREMAP_BOSSPRACTICE_MX1 200
#define SCOREMAP_BOSSPRACTICE_MY1 0
#define SCOREMAP_BOSSPRACTICE_SX1 0
#define SCOREMAP_BOSSPRACTICE_SY1 0
#define SCOREMAP_BOSSPRACTICE_SF1 20
#define SCOREMAP_BOSSPRACTICE_LF1 FONT_LINE_CENTER
#define SCOREMAP_BOSSPRACTICE_TF1 FONT_SERIF
#define SCOREMAP_BOSSPRACTICE_FF1 FONT_FACE_BOLD

#define SCOREMAP_BOSSPRACTICE_PX2 180
#define SCOREMAP_BOSSPRACTICE_PY2 320
#define SCOREMAP_BOSSPRACTICE_MX2 200
#define SCOREMAP_BOSSPRACTICE_MY2 60
#define SCOREMAP_BOSSPRACTICE_SX2 0
#define SCOREMAP_BOSSPRACTICE_SY2 0
#define SCOREMAP_BOSSPRACTICE_SF2 15
#define SCOREMAP_BOSSPRACTICE_LF2 FONT_LINE_CENTER
#define SCOREMAP_BOSSPRACTICE_TF2 FONT_SERIF
#define SCOREMAP_BOSSPRACTICE_FF2 FONT_FACE_BOLD

#define SCOREMAP_BOSSPRACTICE_MAX 25

#define SCOREMAP_BOSSPRACTICE_RANK 0
#define SCOREMAP_BOSSPRACTICE_DEAD 1
#define SCOREMAP_BOSSPRACTICE_SEC 2
#define SCOREMAP_BOSSPRACTICE_NAME 3
#define SCOREMAP_BOSSPRACTICE_NUM 4

#define SCOREMAP_STREAM_PX1 180
#define SCOREMAP_STREAM_PY1 230
#define SCOREMAP_STREAM_MX1 200
#define SCOREMAP_STREAM_MY1 0
#define SCOREMAP_STREAM_SX1 0
#define SCOREMAP_STREAM_SY1 0
#define SCOREMAP_STREAM_SF1 20
#define SCOREMAP_STREAM_LF1 FONT_LINE_CENTER
#define SCOREMAP_STREAM_TF1 FONT_SERIF
#define SCOREMAP_STREAM_FF1 FONT_FACE_BOLD

#define SCOREMAP_STREAM_PX2 180
#define SCOREMAP_STREAM_PY2 320
#define SCOREMAP_STREAM_MX2 200
#define SCOREMAP_STREAM_MY2 60
#define SCOREMAP_STREAM_SX2 0
#define SCOREMAP_STREAM_SY2 0
#define SCOREMAP_STREAM_SF2 15
#define SCOREMAP_STREAM_LF2 FONT_LINE_CENTER
#define SCOREMAP_STREAM_TF2 FONT_SERIF
#define SCOREMAP_STREAM_FF2 FONT_FACE_BOLD

#define SCOREMAP_STREAM_MAX 25

#define SCOREMAP_STREAM_RANK 0
#define SCOREMAP_STREAM_SCORE 1
#define SCOREMAP_STREAM_STAGE 2
#define SCOREMAP_STREAM_NAME 3
#define SCOREMAP_STREAM_NUM 4

#define SCOREMAP_CREATESTAGE_PX1 200
#define SCOREMAP_CREATESTAGE_PY1 230
#define SCOREMAP_CREATESTAGE_MX1 200
#define SCOREMAP_CREATESTAGE_MY1 0
#define SCOREMAP_CREATESTAGE_SX1 0
#define SCOREMAP_CREATESTAGE_SY1 0
#define SCOREMAP_CREATESTAGE_SF1 20
#define SCOREMAP_CREATESTAGE_LF1 FONT_LINE_CENTER
#define SCOREMAP_CREATESTAGE_TF1 FONT_SERIF
#define SCOREMAP_CREATESTAGE_FF1 FONT_FACE_BOLD

#define SCOREMAP_CREATESTAGE_PX2 SCOREMAP_CREATESTAGE_PX1
#define SCOREMAP_CREATESTAGE_PY2 320
#define SCOREMAP_CREATESTAGE_MX2 SCOREMAP_CREATESTAGE_MX1
#define SCOREMAP_CREATESTAGE_MY2 60
#define SCOREMAP_CREATESTAGE_SX2 0
#define SCOREMAP_CREATESTAGE_SY2 0
#define SCOREMAP_CREATESTAGE_SF2 15
#define SCOREMAP_CREATESTAGE_LF2 FONT_LINE_CENTER
#define SCOREMAP_CREATESTAGE_TF2 FONT_SERIF
#define SCOREMAP_CREATESTAGE_FF2 FONT_FACE_BOLD

#define SCOREMAP_CREATESTAGE_MAX 25

#define SCOREMAP_CREATESTAGE_RANK 0
#define SCOREMAP_CREATESTAGE_SCORE 1
#define SCOREMAP_CREATESTAGE_SEC 2
#define SCOREMAP_CREATESTAGE_NAME 3
#define SCOREMAP_CREATESTAGE_NUM 4

#define SCOREMAP_VY_STATE_SCORETYPE 0
#define SCOREMAP_VY_STATE_BOSSTYPE 1
#define SCOREMAP_VY_STATE_SCOREVIEW 2
#define SCOREMAP_VY_STATE_STREAM 4
#define SCOREMAP_VY_STATE_BOSSSILKHAT 5
#define SCOREMAP_VY_STATE_BOSSCROWD 6
#define SCOREMAP_VY_STATE_BOSSEAGLE 7
#define SCOREMAP_VY_STATE_BOSS 8

class ScoreMap :public BaseMap{
 public:
  int listIndex;
  int listSize;
  int scoreType;
  int bossType;
  int mapNum;
  int mapMax;
  int mapID[SCOREMAP_MAP_MAX];
  std::string mapName[SCOREMAP_MAP_MAX];
  BirdScore *scoreList[SCOREMAP_LIST_MAX];
  Glib::RefPtr<Gdk::GC> backGC;
  Glib::RefPtr<Gdk::GC> blackGC;
  Glib::RefPtr<Gdk::Pixbuf> background;
  ScoreMap();
  ~ScoreMap();
  void Create();

  void ScoreMapSelectAction0(int *valueX,int *valueY,int force);
  void ScoreMapSelectAction1(int *valueX,int *valueY,int force);
  void ScoreMapSelectAction2(int *valueX,int *valueY,int force);
  void ScoreMapSelectAction3(int *valueX,int *valueY,int force);
  void ScoreMapSelectAction4(int *valueX,int *valueY,int force);
  void ScoreMapSelectAction5(int *valueX,int *valueY,int force);
  void ScoreMapSelectAction6(int *valueX,int *valueY,int force);
  void ScoreMapSelectAction7(int *valueX,int *valueY,int force);
  void ScoreMapSelectAction8(int *valueX,int *valueY,int force);
  void ScoreMapSelectAction9(int *valueX,int *valueY,int force);
  void ScoreMapSelectAction10(int *valueX,int *valueY,int force);
  void ScoreMapSelectAction11(int *valueX,int *valueY,int force);
  void ScoreMapSelectAction12(int *valueX,int *valueY,int force);
  void ScoreMapSelectAction13(int *valueX,int *valueY,int force);
  void ScoreMapSelectAction14(int *valueX,int *valueY,int force);
  void ScoreMapSelectAction15(int *valueX,int *valueY,int force);
  static void(ScoreMap::*SCOREMAP_SELECT_ACTION[16])
    (int *valueX,int *valueY,int force);

  void ScoreMapSelectAction
    (int selectValue,int *valueX,int *valueY,int force);

  void DeleteList();

  void SetScoreElement(int *element,int *value,int length);
  void SetScore(int *mode,int length);

  void TypeStreamSelect();
  void TypeBossPracticeSelect();
  void TypeCreateStageSelect();
  static void(ScoreMap::*SCOREMAP_SCORETYPE_SELECT
	      [SCOREMAP_SCORETYPE_NUM])();
  void ScoreTypeSelect();

  void BossTypeSilkHatSelect();
  void BossTypeCrowdSelect();
  void BossTypeEagleSelect();
  static void(ScoreMap::*SCOREMAP_BOSSTYPE_SELECT
	      [SCOREMAP_BOSSTYPE_NUM])();
  void BossTypeSelect();

  void TypeStreamView();
  void TypeBossPracticeView();
  void TypeCreateStageView();
  static void(ScoreMap::*SCOREMAP_TYPEVIEW_SELECT
	      [SCOREMAP_SCORETYPE_NUM])();
  void ScoreView();

  void TypeStreamShift();
  void TypeBossPracticeShift();
  void TypeCreateStageShift();
  static void(ScoreMap::*SCOREMAP_TYPESHIFT_SELECT
	      [SCOREMAP_SCORETYPE_NUM])();
  void ShiftScore();

  static void(ScoreMap::*SCOREMAP_STATE_SELECT[SCOREMAP_STATE_NUM])();
  void ViewMap();

  void StreamList(std::string title,int *movY0);
  void BossPracticeList(std::string title,int *movY0);
  void CreateStageList(std::string title,int *movY0);

};

#endif
