#include"selectview.h"
#include "xpm/cursor.h"

SelectView::SelectView(Gtk::Window *window0,
		       Gtk::DrawingArea *drawing0){

  waitCount=0;
  slideTitle[SELECT_MAP_SLIDE]="BirdWatch...";
  slideTitle[SELECT_MAP_TITLE]="Title...";
  slideTitle[SELECT_MAP_STREAMSTAGE]="Stream Stage...";
  slideTitle[SELECT_MAP_BOSSPRACTICE]="Boss Practice...";
  slideTitle[SELECT_MAP_PLAYCREATE]="Play CreateStage...";
  slideTitle[SELECT_MAP_SCORE]="Score...";
  slideTitle[SELECT_MAP_CREATESTAGE]="Create Stage...";
  slideTitle[SELECT_MAP_KEYCONFIG]="Key Config...";

  waitCount=0;
  Map= new BirdMap();

  Map->sec=0;
  
  Map->InitValue();
  Map->type=SELECT_MAP_TITLE*MAP_CHANGE_VALUE;
  Map->type0=0;  
  Map->state=0;
  Map->minW=MIN_WIDTH;
  Map->maxW=MAX_WIDTH;
  Map->minH=MIN_HEIGHT;
  Map->maxH=MAX_HEIGHT;
  Map->px=0;
  Map->py=0;

  control= new BirdControl();
  control->Create(window0);
  
  color= new BirdColor();
  text= new BirdText(drawing0);

  mainSDL= new MainSDL();

  mainSDL->Create(&(control->okValue),
		  &(control->cancelValue),
		  &(control->selectValue));

  title=NULL;
  createMap=NULL;
  streamStage=NULL;
  bossPractice=NULL;
  scoreMap=NULL;
  playCreate=NULL;
  keyConfig=NULL;
}

SelectView::~SelectView(){
  delete mainSDL;
  delete text;
  delete color;
  delete control;
}

void SelectView::Create(Glib::RefPtr<Gdk::Window> mWindow0,
			Glib::RefPtr<Gdk::Pixmap> frame0,
			Glib::RefPtr<Gdk::GC> mGC0){
  mWindow=mWindow0;
  frame=frame0;
  mGC=mGC0;
  
  text->Create(mWindow,frame);
  blackGC=Gdk::GC::create(mWindow0);
  blackGC->set_rgb_fg_color(*(color->black));

  whiteGC=Gdk::GC::create(mWindow0);
  whiteGC->set_rgb_fg_color(*(color->white));

  curBuf=Gdk::Pixbuf::create_from_xpm_data((char **)cursor_xpm);
  
  mWindow->set_cursor
    (Gdk::Cursor(mWindow->get_display(),curBuf,8,8));
}


void SelectView::EraseSlide(){
  /*
    DUMMY
  */
}
void SelectView::EraseTitle(){
  if(title){
    delete title;
  }
  title=NULL;
}
void SelectView::EraseStreamStage(){
  if(streamStage){
    delete streamStage;
  }
  streamStage=NULL;
}
void SelectView::EraseBossPractice(){
  if(bossPractice){
    delete bossPractice;
  }
  bossPractice=NULL;
}
void SelectView::ErasePlayCreate(){
  if(playCreate){
    delete playCreate;
  }
  playCreate=NULL;
}
void SelectView::EraseScore(){
  if(scoreMap){
    delete scoreMap;
  }
  scoreMap=NULL;
}
void SelectView::EraseCreateStage(){
  if(createMap){
    delete createMap;
  }
  createMap=NULL;
}
void SelectView::EraseKeyConfig(){
  if(keyConfig){
    delete keyConfig;
  }
  keyConfig=NULL;
}
void (SelectView::*SelectView::SELECT_ERASE_MAP[SELECT_MAP_NUM])()={
  &SelectView::EraseSlide,
  &SelectView::EraseTitle,
  &SelectView::EraseStreamStage,
  &SelectView::EraseBossPractice,
  &SelectView::ErasePlayCreate,
  &SelectView::EraseScore,
  &SelectView::EraseCreateStage,
  &SelectView::EraseKeyConfig
};

void SelectView::SetSlide(){
  /*
    DUMMY
  */
  Map->InitValue();
  Map->sec=0;
  exit(0);
}
void SelectView::SetTitle(){
  if(!title){
    title= new BirdTitle();
    title->BaseCreate(mWindow,frame,mGC,Map,
		    control,text,color);
    title->Create();
    
    Map->InitValue();
    Map->sec=0;
    Map->state=0;
    Map->minW=-WIDTH*10/100;
    Map->maxW=WIDTH*110/100;
    Map->minH=-HEIGHT*10/100;
    Map->maxH=HEIGHT*110/100;
    Map->speedX=0;
    Map->speedY=0;
  }
}
void SelectView::SetStreamStage(){
  if(!streamStage){
    streamStage= new StreamStage();
    streamStage->BaseCreate(mWindow,frame,mGC,Map,
			    control,text,color);
    
    streamStage->Create();
    
    Map->sec=0;
    Map->state=0;
    Map->InitValue();
  }
}
void SelectView::SetBossPractice(){
  if(!bossPractice){
    bossPractice= new BossPractice();
    bossPractice->BaseCreate(mWindow,frame,mGC,Map,
			     control,text,color);
    
    bossPractice->Create();
    
    Map->sec=0;
    Map->state=0;
    Map->InitValue();
  }
}
void SelectView::SetPlayCreate(){
  if(!playCreate){
    playCreate= new PlayCreate();
    playCreate->BaseCreate
      (mWindow,frame,mGC,Map,control,text,color);      
    playCreate->Create();
    
    Map->sec=0;
    Map->state=0;
    Map->InitValue();
  }
}
void SelectView::SetScore(){
  if(!scoreMap){
    scoreMap= new ScoreMap();
    scoreMap->BaseCreate(mWindow,frame,mGC,Map,
			 control,text,color);
    scoreMap->Create();
    
    Map->InitValue();
    Map->sec=0;
    Map->state=0;
  }
}
void SelectView::SetCreateStage(){
  if(!createMap){
    createMap= new CreateStage();
    createMap->BaseCreate(mWindow,frame,mGC,Map,
			  control,text,color);
    
    createMap->Create();
  }
}
void SelectView::SetKeyConfig(){
  if(!keyConfig){
    keyConfig= new KeyConfig();
    keyConfig->BaseCreate(mWindow,frame,mGC,Map,
			  control,text,color);
    
    keyConfig->Create(mainSDL);
  }
}
void (SelectView::*SelectView::SELECT_SET_MAP[SELECT_MAP_NUM])()={
  &SelectView::SetSlide,
  &SelectView::SetTitle,
  &SelectView::SetStreamStage,
  &SelectView::SetBossPractice,
  &SelectView::SetPlayCreate,
  &SelectView::SetScore,
  &SelectView::SetCreateStage,
  &SelectView::SetKeyConfig
};

void SelectView::SlideView(){
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);
  int px0,py0;
  
  frame->draw_rectangle(blackGC,true,0,0,WIDTH,HEIGHT);
  
  px0=WIDTH*(SELECT_SLIDE_PX1)/MAP_XMAX;
  py0=HEIGHT*(SELECT_SLIDE_PY1)/MAP_YMAX;
  text->DrawString(slideTitle[Map->type/MAP_CHANGE_VALUE],
		   color->white,px0,py0,
		   SELECT_SLIDE_LF1,SELECT_SLIDE_SF1,
		   SELECT_SLIDE_TF1,SELECT_SLIDE_FF1);  
  mWindow->invalidate_rect(rect,false);
  
  waitCount++;
  if(waitCount>5){
    
    (this->*SELECT_ERASE_MAP[Map->type0])();

    (this->*SELECT_SET_MAP[Map->type/MAP_CHANGE_VALUE])();

    Map->type=Map->type/MAP_CHANGE_VALUE;
    waitCount=0;
  }
}
void SelectView::TitleView(){
  if(title!=NULL){
      title->ViewMap();
  }
}
void SelectView::StreamStageView(){
  if(streamStage!=NULL){
      streamStage->ViewMap();
  }
}
void SelectView::BossPracticeView(){
  if(bossPractice!=NULL){
      bossPractice->ViewMap();
  }
}
void SelectView::PlayCreateView(){
  if(playCreate!=NULL){
      playCreate->ViewMap();
  }
}
void SelectView::ScoreView(){
  if(scoreMap!=NULL){
      scoreMap->ViewMap();
  }
}
void SelectView::CreateStageView(){
  if(createMap!=NULL){
      createMap->ViewMap();
  }
}
void SelectView::KeyConfigView(){
  if(keyConfig!=NULL){
      keyConfig->ViewMap();
  }
}
void (SelectView::*SelectView::SELECT_VIEW[SELECT_MAP_NUM])()={
  &SelectView::SlideView,
  &SelectView::TitleView,
  &SelectView::StreamStageView,
  &SelectView::BossPracticeView,
  &SelectView::PlayCreateView,
  &SelectView::ScoreView,
  &SelectView::CreateStageView,
  &SelectView::KeyConfigView
};

void SelectView::SelectMap(){
  mainSDL->ReceiveEvent();
  (this->*SELECT_VIEW[Map->type%10])();
}

