#ifndef BIRD_SELECT_VIEW_H_
#define BIRD_SELECT_VIEW_H_

#include<gtkmm.h>
#include <iostream>
#include <sstream>
#include "actlist.h"
#include "enemy.h"
#include "land.h"
#include "color.h"
#include "text.h"
#include "control.h"
#include "player.h"
#include "playerfire.h"
#include "enemyfire.h"
#include "item.h"
#include "mainsdl.h"
#include "titlemap.h"
#include "scoremap.h"
#include "createstage.h"
#include "streamstage.h"
#include "bosspractice.h"
#include "playcreate.h"
#include "keyconfig.h"
#include "map.h"

#define SELECT_SLIDE_PX1 500
#define SELECT_SLIDE_PY1 500
#define SELECT_SLIDE_MX1 0
#define SELECT_SLIDE_MY1 0
#define SELECT_SLIDE_SX1 0
#define SELECT_SLIDE_SY1 0
#define SELECT_SLIDE_SF1 35
#define SELECT_SLIDE_LF1 FONT_LINE_CENTER
#define SELECT_SLIDE_TF1 FONT_SERIF
#define SELECT_SLIDE_FF1 FONT_FACE_ITALIC

class SelectView{
 private:
  std::string slideTitle[SELECT_MAP_NUM];
  int waitCount;
 public:
  BirdMap *Map;
  BirdControl *control;
  BirdColor *color;
  BirdText *text;
  MainSDL *mainSDL;
  BirdTitle *title;
  ScoreMap *scoreMap;
  KeyConfig *keyConfig;
  CreateStage *createMap;
  StreamStage *streamStage;
  BossPractice *bossPractice;
  PlayCreate *playCreate;
  Glib::RefPtr<Gdk::Window> mWindow;
  Glib::RefPtr<Gdk::Pixmap> frame;
  Glib::RefPtr<Gdk::GC> mGC;
  Glib::RefPtr<Gdk::GC> blackGC;
  Glib::RefPtr<Gdk::GC> whiteGC;
  Glib::RefPtr<Gdk::Pixmap> curPix;
  Glib::RefPtr<Gdk::Pixbuf> curBuf;
  Glib::RefPtr<Gdk::Bitmap> curMask;
  SelectView(Gtk::Window *window0,
	     Gtk::DrawingArea *drawing0);
  ~SelectView();
  void Create(Glib::RefPtr<Gdk::Window> mWindow0,
	      Glib::RefPtr<Gdk::Pixmap> frame0,
	      Glib::RefPtr<Gdk::GC> mGC0);

  void EraseSlide();
  void EraseTitle();
  void EraseStreamStage();
  void EraseBossPractice();
  void ErasePlayCreate();
  void EraseScore();
  void EraseCreateStage();
  void EraseKeyConfig();
  static void(SelectView::*SELECT_ERASE_MAP[SELECT_MAP_NUM])();

  void SetSlide();
  void SetTitle();
  void SetStreamStage();
  void SetBossPractice();
  void SetPlayCreate();
  void SetScore();
  void SetCreateStage();
  void SetKeyConfig();
  static void(SelectView::*SELECT_SET_MAP[SELECT_MAP_NUM])();

  void SlideView();
  void TitleView();
  void StreamStageView();
  void BossPracticeView();
  void PlayCreateView();
  void ScoreView();
  void CreateStageView();
  void KeyConfigView();
  static void(SelectView::*SELECT_VIEW[SELECT_MAP_NUM])();

  void SelectMap();
};

#endif
