#include "streamstage.h"

StreamStage::StreamStage(){
  silkhat= new BossSilkHat();
  bossCrowd= new BossCrowd();
  bossEagle= new BossEagle();
  stageNum=0;
  stageMode=0;
  waitCount=0;

  streamList[STREAM_MODE_VEASY].stage[0]="VeryEasy1";
  streamList[STREAM_MODE_VEASY].boss[0]=STREAM_BOSS_SILKHAT;
  streamList[STREAM_MODE_VEASY].bossMode[0]=BOSS_SILKHAT_MODE_VEASY;
  streamList[STREAM_MODE_VEASY].stage[1]="VeryEasy2";
  streamList[STREAM_MODE_VEASY].boss[1]=STREAM_BOSS_CROWD;
  streamList[STREAM_MODE_VEASY].bossMode[1]=BOSS_CROWD_MODE_VEASY;
  streamList[STREAM_MODE_VEASY].stage[2]="VeryEasy3";
  streamList[STREAM_MODE_VEASY].boss[2]=STREAM_BOSS_EAGLE;
  streamList[STREAM_MODE_VEASY].bossMode[2]=BOSS_EAGLE_MODE_VEASY;
  streamList[STREAM_MODE_VEASY].stage[3]="";
  streamList[STREAM_MODE_VEASY].boss[3]=STREAM_BOSS_NO;
  streamList[STREAM_MODE_VEASY].bossMode[3]=0;
  streamList[STREAM_MODE_VEASY].nStage=3;

  streamList[STREAM_MODE_EASY].stage[0]="Easy1";
  streamList[STREAM_MODE_EASY].boss[0]=STREAM_BOSS_SILKHAT;
  streamList[STREAM_MODE_EASY].bossMode[0]=BOSS_SILKHAT_MODE_VEASY;
  streamList[STREAM_MODE_EASY].stage[1]="Easy2";
  streamList[STREAM_MODE_EASY].boss[1]=STREAM_BOSS_CROWD;
  streamList[STREAM_MODE_EASY].bossMode[1]=BOSS_CROWD_MODE_VEASY;
  streamList[STREAM_MODE_EASY].stage[2]="Easy3";
  streamList[STREAM_MODE_EASY].boss[2]=STREAM_BOSS_EAGLE;
  streamList[STREAM_MODE_EASY].bossMode[2]=BOSS_EAGLE_MODE_VEASY;
  streamList[STREAM_MODE_EASY].stage[3]="";
  streamList[STREAM_MODE_EASY].boss[3]=STREAM_BOSS_NO;
  streamList[STREAM_MODE_EASY].bossMode[3]=0;
  streamList[STREAM_MODE_EASY].nStage=3;

  streamList[STREAM_MODE_NORMAL].stage[0]="Normal1";
  streamList[STREAM_MODE_NORMAL].boss[0]=STREAM_BOSS_SILKHAT;
  streamList[STREAM_MODE_NORMAL].bossMode[0]=BOSS_SILKHAT_MODE_EASY;
  streamList[STREAM_MODE_NORMAL].stage[1]="Normal2";
  streamList[STREAM_MODE_NORMAL].boss[1]=STREAM_BOSS_CROWD;
  streamList[STREAM_MODE_NORMAL].bossMode[1]=BOSS_CROWD_MODE_EASY;
  streamList[STREAM_MODE_NORMAL].stage[2]="Normal3";
  streamList[STREAM_MODE_NORMAL].boss[2]=STREAM_BOSS_EAGLE;
  streamList[STREAM_MODE_NORMAL].bossMode[2]=BOSS_EAGLE_MODE_EASY;
  streamList[STREAM_MODE_NORMAL].stage[3]="";
  streamList[STREAM_MODE_NORMAL].boss[3]=STREAM_BOSS_NO;
  streamList[STREAM_MODE_NORMAL].bossMode[3]=0;
  streamList[STREAM_MODE_NORMAL].nStage=3;

  streamList[STREAM_MODE_HARD].stage[0]="Hard1";
  streamList[STREAM_MODE_HARD].boss[0]=STREAM_BOSS_SILKHAT;
  streamList[STREAM_MODE_HARD].bossMode[0]=BOSS_SILKHAT_MODE_EASY;
  streamList[STREAM_MODE_HARD].stage[1]="Hard2";
  streamList[STREAM_MODE_HARD].boss[1]=STREAM_BOSS_CROWD;
  streamList[STREAM_MODE_HARD].bossMode[1]=BOSS_CROWD_MODE_EASY;
  streamList[STREAM_MODE_HARD].stage[2]="Hard3";
  streamList[STREAM_MODE_HARD].boss[2]=STREAM_BOSS_EAGLE;
  streamList[STREAM_MODE_HARD].bossMode[2]=BOSS_EAGLE_MODE_EASY;
  streamList[STREAM_MODE_HARD].stage[3]="";
  streamList[STREAM_MODE_HARD].boss[3]=STREAM_BOSS_NO;
  streamList[STREAM_MODE_HARD].bossMode[3]=0;
  streamList[STREAM_MODE_HARD].nStage=3;

  streamList[STREAM_MODE_VHARD].stage[0]="VeryHard1";
  streamList[STREAM_MODE_VHARD].boss[0]=STREAM_BOSS_SILKHAT;
  streamList[STREAM_MODE_VHARD].bossMode[0]=BOSS_SILKHAT_MODE_NORMAL;
  streamList[STREAM_MODE_VHARD].stage[1]="VeryHard2";
  streamList[STREAM_MODE_VHARD].boss[1]=STREAM_BOSS_CROWD;
  streamList[STREAM_MODE_VHARD].bossMode[1]=BOSS_CROWD_MODE_NORMAL;
  streamList[STREAM_MODE_VHARD].stage[2]="VeryHard3";
  streamList[STREAM_MODE_VHARD].boss[2]=STREAM_BOSS_EAGLE;
  streamList[STREAM_MODE_VHARD].bossMode[2]=BOSS_EAGLE_MODE_NORMAL;
  streamList[STREAM_MODE_VHARD].stage[3]="";
  streamList[STREAM_MODE_VHARD].boss[3]=STREAM_BOSS_NO;
  streamList[STREAM_MODE_VHARD].bossMode[3]=0;
  streamList[STREAM_MODE_VHARD].nStage=3;
}

StreamStage::~StreamStage(){
  if(silkhat){
    delete silkhat;
    silkhat=NULL;
  }
  
  if(bossCrowd){
    delete bossCrowd;
    bossCrowd=NULL;
  }
  
  if(bossEagle){
    delete bossEagle;
    bossEagle=NULL;
  }
}

void StreamStage::Create(){
  StageCreate();
  silkhat->BaseCreate(this,mWindow,frame);
  silkhat->Create();
  bossCrowd->BaseCreate(this,mWindow,frame);
  bossCrowd->Create();
  bossEagle->BaseCreate(this,mWindow,frame);
  bossEagle->Create();
  
}

void StreamStage::WriteScore(){
  NameDialog diag;
  int value;
  
  while(value=diag.Run()){
    if(value==Gtk::RESPONSE_OK){
      scoreFile->WriteFile
	(player->score,player->life,Map->sec,SCORE_MODE_STREAM,
	 stageMode,stageName,diag.GetName());
      break;
    }
    else if(value==Gtk::RESPONSE_DELETE_EVENT){
      
    }
  }
}

void StreamStage::SetModal(){
  /*
  SetChangeModal(998,MODAL_TYPE_WSTATE,STREAM_STATE_BOSS);
  SetChangeModal(999,MODAL_TYPE_CHSTATE,STREAM_STATE_BOSS);
  */
}

void StreamStage::ModeSelect(){
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);
  std::stringstream ss;
  int px0,py0;
  int px1,py1;
  int tmpX;

  frame->draw_rectangle(blackGC,true,0,0,WIDTH,HEIGHT);
  
  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(350)/MAP_YMAX;
  text->DrawString("STREAM MODE SELECT",color->white,px0,py0,
		   FONT_LINE_CENTER,20,
		   FONT_SERIF,FONT_FACE_ITALIC);

  px1=WIDTH*(STREAM_MODE_PX1)/MAP_XMAX;
  px0=px1;
  py0=HEIGHT*(STREAM_MODE_PY1
	      +STREAM_MODE_MY1*STREAM_MODE_VEASY)/MAP_YMAX;
  text->DrawString
    ("VERY EASY",color->white,px0,py0,
     STREAM_MODE_LF1,STREAM_MODE_SF1,
     STREAM_MODE_TF1,STREAM_MODE_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  px1=WIDTH*(STREAM_MODE_PX1)/MAP_XMAX;
  px0=px1;
  py0=HEIGHT*(STREAM_MODE_PY1
	      +STREAM_MODE_MY1*STREAM_MODE_EASY)/MAP_YMAX;
  text->DrawString
    ("EASY",color->white,px0,py0,
     STREAM_MODE_LF1,STREAM_MODE_SF1,
     STREAM_MODE_TF1,STREAM_MODE_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  px1=WIDTH*(STREAM_MODE_PX1)/MAP_XMAX;
  px0=px1;
  py0=HEIGHT*(STREAM_MODE_PY1
	      +STREAM_MODE_MY1*STREAM_MODE_NORMAL)/MAP_YMAX;
  text->DrawString
    ("NORMAL",color->white,px0,py0,
     STREAM_MODE_LF1,STREAM_MODE_SF1,
     STREAM_MODE_TF1,STREAM_MODE_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  px1=WIDTH*(STREAM_MODE_PX1)/MAP_XMAX;
  px0=px1;
  py0=HEIGHT*(STREAM_MODE_PY1
	      +STREAM_MODE_MY1*STREAM_MODE_HARD)/MAP_YMAX;
  text->DrawString
    ("HARD",color->white,px0,py0,
     STREAM_MODE_LF1,STREAM_MODE_SF1,
     STREAM_MODE_TF1,STREAM_MODE_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  px1=WIDTH*(STREAM_MODE_PX1)/MAP_XMAX;
  px0=px1;
  py0=HEIGHT*(STREAM_MODE_PY1
	      +STREAM_MODE_MY1*STREAM_MODE_VHARD)/MAP_YMAX;
  text->DrawString
    ("VERY HARD",color->white,px0,py0,
     STREAM_MODE_LF1,STREAM_MODE_SF1,
     STREAM_MODE_TF1,STREAM_MODE_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  StepSelectAction(&tmpX,&Map->valueY[STREAM_VY_STATE_MODESELECT]);

  if(Map->valueY[STREAM_VY_STATE_MODESELECT]<0){
    Map->valueY[STREAM_VY_STATE_MODESELECT]=STREAM_MODE_NUM-1;
  }
  else if(Map->valueY[STREAM_VY_STATE_MODESELECT]>=STREAM_MODE_NUM){
    Map->valueY[STREAM_VY_STATE_MODESELECT]=0;
  }

  enemyList->DrawSprite
    (EN_REV_BIRD,EN_WAY_B,2,
     WIDTH*(400)/MAP_XMAX,
     HEIGHT*(STREAM_MODE_PY1
	     +STREAM_MODE_MY1
	     *Map->valueY[STREAM_VY_STATE_MODESELECT])/MAP_YMAX);

  mWindow->invalidate_rect(rect,false);
  
  if(control->okValue>0){
    control->okValue=0;
    stageMode=Map->valueY[STREAM_VY_STATE_MODESELECT];
    stageNum=0;
    Map->state=STREAM_STATE_SHIFTINIT;
  }
  else if(control->cancelValue>0){
    control->cancelValue=0;
    Map->ChangeType(SELECT_MAP_TITLE);
  }
}
void StreamStage::ShiftInit(){
  int width0,height0,rotate0,flip0;
  if(LoadStage("stage",streamList[stageMode].stage[stageNum],
	       &width0,&height0,&rotate0,&flip0)){
    std::cout<<"ERROR LOAD STAGE"<<std::endl;
    if(stageNum>0){
      if(stageNum==streamList[stageMode].nStage){
	stageName="Clear";
      }
      else{

      }
      Map->state=STREAM_STATE_GAMEEND;
    }
    else{
      Map->state=STREAM_STATE_MODESELECT;
    }
  }
  else{
    std::cout<<"SUCCESS LOAD STAGE"<<std::endl;
    if(stageNum==0){
      player->InitPlayer(initLife,initFire,initForm);
    }
    waitCount=0;
    Map->state=STREAM_STATE_SHIFTSTAGE;
  }

}
void StreamStage::ShiftStage(){
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);
  std::stringstream ss;
  int px0,py0;
  
  frame->draw_rectangle(blackGC,true,0,0,WIDTH,HEIGHT);
  
  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(350)/MAP_YMAX;
  text->DrawString(stageName,color->white,px0,py0,
		   FONT_LINE_CENTER,35,
		   FONT_SERIF,FONT_FACE_ITALIC);

  player->DrawSprite(PLAYER_NORMAL_CRAFT,0,
		     WIDTH*(450)/MAP_XMAX,
		     HEIGHT*(600)/MAP_YMAX);

  ss<<"x "<<player->life;
  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(600)/MAP_YMAX;
  text->DrawString(ss.str(),color->white,px0,py0,
		   FONT_LINE_LEFT,15,
		   FONT_SERIF,FONT_FACE_BOLD);
  ss.str("");
  ss.clear(std::stringstream::goodbit);
  
  ss<<"score : "<<player->score;
  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(700)/MAP_YMAX;
  text->DrawString(ss.str(),color->white,px0,py0,
		   FONT_LINE_CENTER,15,
		   FONT_SERIF,FONT_FACE_BOLD);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  mWindow->invalidate_rect(rect,false);

  if(waitCount>1){
    std::cout<<"SHIFT STREAMSTAGE"<<std::endl;
    enemyList->ALLDelete();
    efireList->ALLDelete();
    pfireList->ALLDelete();
    landList->ALLDelete();
    itemList->ALLDelete();
    bgBoss=0;

    if(LoadBirdWatch
       ("stage",streamList[stageMode].stage[stageNum],
	998,999,STAGE_CHANGE_STATE,STREAM_STATE_BOSS)){
      Map->ChangeType(SELECT_MAP_TITLE);
    }
    else{
      Map->state=STREAM_STATE_GAME;
      Map->sec=0;
    }  
  }
  waitCount++;
}

void StreamStage::PauseMap(){
  PauseMenuView(&Map->valueY[STREAM_VY_STATE_PAUSE],
		STAGE_CHANGE_TYPE,SELECT_MAP_TITLE);
}

void StreamStage::GameMap(){
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);
  int enemyCount,playerFireCount,enemyFireCount,landCount,itemCount;

  RunBackGround();

  ModalTypeSelect(Map->sec);

  landCount=landList->Animate();
  enemyCount=enemyList->Animate();
  playerFireCount=pfireList->Animate();
  enemyFireCount=efireList->Animate();
  player->Animate();
  itemCount=itemList->Animate();

  GameStatusView(STAGE_STATUSVIEW_LIFE);

  mWindow->invalidate_rect(rect,false);
  Map->sec++;

  if(control->cancelValue==1){
    control->cancelValue=0;
    Map->state0=Map->state;
    Map->state=STREAM_STATE_PAUSE;
  }

  if(player->life<=0){
    Map->state=STREAM_STATE_GAMEOVER;
  }
}

int StreamStage::NoBossAction(){
  bgBoss=BOSS_ACT_END;
  return 0;
}
int StreamStage::BossSilkHatAction(){
  int flag=0;
  
  bgBoss=silkhat->Act(bgBoss,streamList[stageMode].bossMode[stageNum]);

  return flag;
}
int StreamStage::BossCrowdAction(){
  int flag=0;
  
  bgBoss=bossCrowd->Act
    (bgBoss,streamList[stageMode].bossMode[stageNum],
     &(enemyList->listSize));

  return flag;
}
int StreamStage::BossEagleAction(){
  int flag=0;
  
  bgBoss=bossEagle->Act(bgBoss,streamList[stageMode].bossMode[stageNum]);

  return flag;
}
int (StreamStage::*StreamStage::STREAM_BOSS_SELECT[STREAM_BOSS_NUM])()={
  &StreamStage::NoBossAction,
  &StreamStage::BossSilkHatAction,
  &StreamStage::BossCrowdAction,
  &StreamStage::BossEagleAction
};

void StreamStage::BossMap(){
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);
  int enemyCount,playerFireCount,enemyFireCount,landCount,itemCount;
  int bossFlag=0;

  RunBackGround();

  landCount=landList->Animate();
  enemyCount=enemyList->Animate();
  playerFireCount=pfireList->Animate();
  enemyFireCount=efireList->Animate();
  player->Animate();
  itemCount=itemList->Animate();

  if(bgBoss==BOSS_ACT_INIT){
    Map->speedX=-4;
    Map->speedY=-1;
    BossBGMoveSet(2000,250);
    bgBoss=1;
  }
  else if(bgBoss==BOSS_ACT_BGRUN){
    (this->*STREAM_BOSS_SELECT[streamList[stageMode].boss[stageNum]])();
    BGMoveReverse(4,1);
  }
  else if(bgBoss==BOSS_ACT_BGSTOP){
    (this->*STREAM_BOSS_SELECT[streamList[stageMode].boss[stageNum]])();
    Map->speedX=0;
    Map->speedY=0;
  }
  else if(bgBoss==BOSS_ACT_END){
    Map->state=STREAM_STATE_SHIFTINIT;
    Map->sec=0;
    stageNum++; 
  }

  GameStatusView(STAGE_STATUSVIEW_LIFE);

  mWindow->invalidate_rect(rect,false);

  Map->sec++;

  if(control->cancelValue==1){
    control->cancelValue=0;
    Map->state0=Map->state;
    Map->state=STREAM_STATE_PAUSE;
  }

  if(player->life<=0){
    Map->state=STREAM_STATE_GAMEOVER;
  }
}
void StreamStage::GameOverMap(){
  int px0,py0;
  /*
  int value;
  NameDialog diag;
  */

  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);

  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(500)/MAP_YMAX;
  text->DrawString
    ("GAME OVER",(color->black),px0,py0,
     FONT_LINE_CENTER,35,
     FONT_SERIF,FONT_FACE_ITALIC);

  mWindow->invalidate_rect(rect,false);

  WriteScore();

  Map->ChangeType(SELECT_MAP_TITLE);
}
void StreamStage::GameEndMap(){
  int px0,py0;
  
  std::stringstream ss;
  std::string str;
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);

  frame->draw_rectangle(blackGC,true,0,0,WIDTH,HEIGHT);

  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(350)/MAP_YMAX;
  text->DrawString
    ("GAME END",(color->white),px0,py0,FONT_LINE_CENTER,35,
     FONT_SERIF,FONT_FACE_ITALIC);

  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(600)/MAP_YMAX;
  text->DrawString
    (stageName,(color->white),px0,py0,FONT_LINE_CENTER,
     20,FONT_SERIF,FONT_FACE_BOLD);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(700)/MAP_YMAX;
  ss<<"SCORE : "<<player->score;
  str=ss.str();
  text->DrawString
    (str,(color->white),px0,py0,FONT_LINE_CENTER,
     15,FONT_SERIF,FONT_FACE_BOLD);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  mWindow->invalidate_rect(rect,false);

  WriteScore();

  Map->ChangeType(SELECT_MAP_TITLE);
}

void (StreamStage::*StreamStage::
      STREAM_STATE_SELECT[STREAM_STATE_NUM])()={
  &StreamStage::ModeSelect,
  &StreamStage::ShiftInit,
  &StreamStage::ShiftStage,
  &StreamStage::PauseMap,
  &StreamStage::GameMap,
  &StreamStage::BossMap,
  &StreamStage::GameOverMap,
  &StreamStage::GameEndMap,
};

void StreamStage::ViewMap(){
  (this->*STREAM_STATE_SELECT[Map->state])();
}
