#include "titlemap.h"
#include <ctime>

BirdTitle::BirdTitle(){
  
  try{
    plank=Gdk::Pixbuf::create_from_file("image/wood.png");
  }
  catch(...){
    plank.clear();
  }

  try{
  background=Gdk::Pixbuf::create_from_file("image/title.jpg");
  }
  catch(...){
    background.clear();
  }

  pSTime=0;
  nSTime=0;
  dSTime=0;

  pUTime=0;
  nUTime=0;
  dUTime=0;

  bench=3000;
  benchCount=0;
}

BirdTitle::~BirdTitle(){

}
void BirdTitle::Create(){
  backGC=Gdk::GC::create(mWindow);
  backGC->set_rgb_fg_color(*(color->sky));
  
  frontGC=Gdk::GC::create(mWindow);
  frontGC->set_rgb_fg_color(*(color->brown));
}

void BirdTitle::RegulateBird(int rate){
  int max,rest,i;
  max=rate/TITLE_BIRD_RATE;
  rest=rate%TITLE_BIRD_RATE;
  
  i=0;
  while(i<max){
    enemyList->Appear(MAX_WIDTH,rand()%HEIGHT,16,8,
		      rand()%6-14,2-rand()%5,0,0,2,10,
		      EN_STR_BIRD,EN_MOV_STR,
		      EN_TOUCH_BLOW,0,
		      EN_FORM_TAR_SMALL,0,0,0);
    i++;
  }
  if(rand()%TITLE_BIRD_RATE<rest){
    enemyList->Appear(MAX_WIDTH,rand()%HEIGHT,16,8,
		      rand()%6-14,2-rand()%5,0,0,2,10,
		      EN_STR_BIRD,EN_MOV_STR,
		      EN_TOUCH_BLOW,0,
		      EN_FORM_TAR_SMALL,0,0,0);
  }
}

int BirdTitle::GetCPUusage(){  

  
  if(benchCount>0){
    benchCount--;
  }
  else{
    if(nUTime>0){
      pUTime=nUTime;
      nUTime=clock();
    }
    else{
      nUTime=clock();
    }
    
    if(pUTime>0){
      dUTime=nUTime-pUTime;
    }
    else{
      dUTime=0;
    }  
    benchCount=5;
    /*
    std::cout<<"PREV="<<pUTime<<"\t"
	     <<"NEXT="<<nUTime<<"\t"
	     <<"DIS="<<dUTime<<"\t";
    */
    int tmpTime;

    tmpTime=dUTime/10000;
    tmpTime=3-tmpTime;

    if(tmpTime>0){
      bench+=tmpTime*100;
    }
    else{
      bench+=tmpTime*400;
    }


    // std::cout<<"BENCH="<<bench<<std::endl;
  }
}

void BirdTitle::GameSelect(){
  Map->state0=Map->state;
  Map->state=TITLE_STATE_GAME;
}
void BirdTitle::KeyConfigSelect(){
  Map->ChangeType(SELECT_MAP_KEYCONFIG);
}
void BirdTitle::ScoreSelect(){
  Map->ChangeType(SELECT_MAP_SCORE);
}
void BirdTitle::CreateSelect(){
  Map->ChangeType(SELECT_MAP_CREATESTAGE);
}
void BirdTitle::ExitSelect(){
  Map->ChangeType(0);
}

void (BirdTitle::*BirdTitle::TITLE_TOP_SELECT[TITLE_TOP_NUM])()={
  &BirdTitle::GameSelect,
  &BirdTitle::KeyConfigSelect,
  &BirdTitle::ScoreSelect,
  &BirdTitle::CreateSelect,
  &BirdTitle::ExitSelect
};

void BirdTitle::TopMenu(){
  int px0,py0;
  int px1,py1;
  int tmpX;

  px1=WIDTH*(TITLE_TOP_PX1)/MAP_XMAX;

  px0=px1;
  py0=HEIGHT*(TITLE_TOP_PY1+TITLE_TOP_MY1*TITLE_TOP_GAME)/MAP_YMAX;
  text->DrawString
    ("GAME",(color->white),px0,py0,
     TITLE_TOP_LF1,TITLE_TOP_SF1,
     TITLE_TOP_TF1,TITLE_TOP_FF1);

  px0=px1;
  py0=HEIGHT*(TITLE_TOP_PY1+TITLE_TOP_MY1*TITLE_TOP_KEYCONFIG)/MAP_YMAX;
  text->DrawString
    ("KEY CONFIG",(color->white),px0,py0,
     TITLE_TOP_LF1,TITLE_TOP_SF1,
     TITLE_TOP_TF1,TITLE_TOP_FF1);

  px0=px1;
  py0=HEIGHT*(TITLE_TOP_PY1+TITLE_TOP_MY1*TITLE_TOP_SCORE)/MAP_YMAX;
  text->DrawString
    ("SCORE",(color->white),px0,py0,
     TITLE_TOP_LF1,TITLE_TOP_SF1,
     TITLE_TOP_TF1,TITLE_TOP_FF1);

  px0=px1;
  py0=HEIGHT*(TITLE_TOP_PY1+TITLE_TOP_MY1*TITLE_TOP_CREATE)/MAP_YMAX;
  text->DrawString
    ("CREATE STAGE",(color->white),px0,py0,
     TITLE_TOP_LF1,TITLE_TOP_SF1,
     TITLE_TOP_TF1,TITLE_TOP_FF1);

  px0=px1;
  py0=HEIGHT*(TITLE_TOP_PY1+TITLE_TOP_MY1*TITLE_TOP_EXIT)/MAP_YMAX;
  text->DrawString
    ("EXIT",(color->white),px0,py0,
     TITLE_TOP_LF1,TITLE_TOP_SF1,
     TITLE_TOP_TF1,TITLE_TOP_FF1);

  StepSelectAction(&tmpX,&Map->valueY[TITLE_VY_STATE_TOP]);
   
  if(Map->valueX[TITLE_VX_STATE_TOP]!=0){
    Map->valueX[TITLE_VX_STATE_TOP]=0;
  }
  
  if(Map->valueY[TITLE_VY_STATE_TOP]<0){
    Map->valueY[TITLE_VY_STATE_TOP]=TITLE_TOP_NUM-1;
  }
  else if(Map->valueY[TITLE_VY_STATE_TOP]>=TITLE_TOP_NUM){
    Map->valueY[TITLE_VY_STATE_TOP]=0;
  }
  
  enemyList->DrawSprite
    (EN_REV_BIRD,EN_WAY_B,2,
     WIDTH*(400)/MAP_XMAX,
     HEIGHT*(TITLE_TOP_PY1
	     +TITLE_TOP_MY1*Map->valueY[TITLE_VY_STATE_TOP])/MAP_YMAX);

  if(control->okValue==1){
    control->okValue=0;
    (this->*TITLE_TOP_SELECT[Map->valueY[TITLE_VY_STATE_TOP]])();
  }
}

void BirdTitle::StreamGameSelect(){
  Map->ChangeType(SELECT_MAP_STREAMSTAGE);
}
void BirdTitle::BossPracticeGameSelect(){
  Map->ChangeType(SELECT_MAP_BOSSPRACTICE);
}
void BirdTitle::PlayCreateGameSelect(){
  Map->ChangeType(SELECT_MAP_PLAYCREATE);
}
void (BirdTitle::*BirdTitle::TITLE_GAME_SELECT[TITLE_GAME_NUM])()={
  &BirdTitle::StreamGameSelect,
  &BirdTitle::BossPracticeGameSelect,
  &BirdTitle::PlayCreateGameSelect
};

void BirdTitle::GameMenu(){
  int px0,py0;
  int px1,py1;
  int tmpX;

  px1=WIDTH*(TITLE_GAME_PX1)/MAP_XMAX;

  px0=px1;
  py0=HEIGHT*(TITLE_GAME_PY1+TITLE_GAME_MY1*TITLE_GAME_STREAM)/MAP_YMAX;
  text->DrawString
    ("STREAM",(color->white),px0,py0,
     TITLE_GAME_LF1,TITLE_GAME_SF1,
     TITLE_GAME_TF1,TITLE_GAME_FF1);

  px0=px1;
  py0=HEIGHT*(TITLE_GAME_PY1+TITLE_GAME_MY1*TITLE_GAME_BOSS)/MAP_YMAX;
  text->DrawString
    ("BOSS PRACTICE",(color->white),px0,py0,
     TITLE_GAME_LF1,TITLE_GAME_SF1,
     TITLE_GAME_TF1,TITLE_GAME_FF1);

  px0=px1;
  py0=HEIGHT*(TITLE_GAME_PY1
	      +TITLE_GAME_MY1*TITLE_GAME_PLAYCREATE)/MAP_YMAX;
  text->DrawString
    ("PLAY CREATESTAGE",(color->white),px0,py0,
     TITLE_GAME_LF1,TITLE_GAME_SF1,
     TITLE_GAME_TF1,TITLE_GAME_FF1);

  StepSelectAction(&tmpX,&Map->valueY[TITLE_VY_STATE_GAME]);
   
  if(Map->valueX[TITLE_VX_STATE_GAME]!=0){
    Map->valueX[TITLE_VX_STATE_GAME]=0;
  }
  
  if(Map->valueY[TITLE_VY_STATE_GAME]<0){
    Map->valueY[TITLE_VY_STATE_GAME]=TITLE_GAME_NUM-1;
  }
  else if(Map->valueY[TITLE_VY_STATE_GAME]>=TITLE_GAME_NUM){
    Map->valueY[TITLE_VY_STATE_GAME]=0;
  }

  enemyList->DrawSprite
    (EN_REV_BIRD,EN_WAY_B,2,
     WIDTH*(360)/MAP_XMAX,
     HEIGHT*(TITLE_GAME_PY1
	     +TITLE_GAME_MY1*Map->valueY[TITLE_VY_STATE_GAME])/MAP_YMAX);
  
  if(control->okValue==1){
    control->okValue=0;
    (this->*TITLE_GAME_SELECT[Map->valueY[TITLE_VY_STATE_GAME]])();
  }
  else if(control->cancelValue==1){
    control->cancelValue=0;
    Map->state=Map->state0;
  }
}

void (BirdTitle::*BirdTitle::TITLE_MENU_SELECT[TITLE_STATE_NUM])()={
  &BirdTitle::TopMenu,
  &BirdTitle::GameMenu
};

void BirdTitle::ViewMap(){
  int i;
  int enemyCount=0;
  int px0,py0;
  std::stringstream ss;
  std::string str;

  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);

  if(background){
    frame->draw_pixbuf
      (mGC,background,0,0,0,0,WIDTH,HEIGHT,
       Gdk::RGB_DITHER_NONE,0,0);
  }
  else{
    frame->draw_rectangle(backGC,true,0,0,WIDTH,HEIGHT);
  }
  /*
  i=0;

  while(i<bench){
    enemyList->Appear(MAX_WIDTH,rand()%HEIGHT,16,8,
		      rand()%6-14,2-rand()%5,0,0,2,10,
		      EN_STR_BIRD,EN_MOV_STR,
		      EN_TOUCH_BLOW,0,
		      EN_FORM_TAR_SMALL,0,0,0);
    i++;
  }
  */

  RegulateBird(bench);


  enemyCount=enemyList->Animate();
  if(plank){
    frame->draw_pixbuf
      (mGC,plank,0,0,WIDTH/5,HEIGHT/5,WIDTH*3/5,HEIGHT*3/5,
       Gdk::RGB_DITHER_NONE,0,0);
  }
  else{
  frame->draw_rectangle(frontGC,true,
			WIDTH/5,HEIGHT/5,WIDTH*3/5,HEIGHT*3/5);
  }

  px0=WIDTH;
  py0=0;
  ss<<"ENEMY : "<<enemyCount;
  str=ss.str();
  text->DrawString(str,color->white,px0,py0,
		   FONT_LINE_UPRIGHT,12,
		   FONT_SERIF,FONT_FACE_BOLD);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(330)/MAP_YMAX;
  text->DrawString("BIRD WATCH",color->white,px0,py0,
		   FONT_LINE_CENTER,35,
		   FONT_SERIF,FONT_FACE_REGULAR);

  (this->*TITLE_MENU_SELECT[Map->state])();

  mWindow->invalidate_rect(rect,false);

  GetCPUusage();

}
