#ifndef BIRD_TITLEMAP_H_
#define BIRD_TITLEMAP_H_

#include "basemap.h"
#include "bosspractice.h"
#include "namedialog.h"

#define TITLE_BIRD_RATE 1000

#define TITLE_STATE_TOP 0
#define TITLE_STATE_GAME 1
#define TITLE_STATE_NUM 2

#define TITLE_TOP_PX1 420
#define TITLE_TOP_PY1 450
#define TITLE_TOP_MX1 0
#define TITLE_TOP_MY1 60
#define TITLE_TOP_SX1 0
#define TITLE_TOP_SY1 0
#define TITLE_TOP_SF1 14
#define TITLE_TOP_LF1 FONT_LINE_LEFT
#define TITLE_TOP_TF1 FONT_SERIF
#define TITLE_TOP_FF1 FONT_FACE_BOLD

#define TITLE_TOP_GAME 0
#define TITLE_TOP_KEYCONFIG 1
#define TITLE_TOP_SCORE 2
#define TITLE_TOP_CREATE 3
#define TITLE_TOP_EXIT 4
#define TITLE_TOP_NUM 5

#define TITLE_GAME_PX1 380
#define TITLE_GAME_PY1 470
#define TITLE_GAME_MX1 0
#define TITLE_GAME_MY1 60
#define TITLE_GAME_SX1 0
#define TITLE_GAME_SY1 0
#define TITLE_GAME_SF1 14
#define TITLE_GAME_LF1 FONT_LINE_LEFT
#define TITLE_GAME_TF1 FONT_SERIF
#define TITLE_GAME_FF1 FONT_FACE_BOLD

#define TITLE_GAME_STREAM 0
#define TITLE_GAME_BOSS 1
#define TITLE_GAME_PLAYCREATE 2
#define TITLE_GAME_NUM 3

#define TITLE_VX_STATE_TOP 0
#define TITLE_VX_STATE_GAME 1

#define TITLE_VY_STATE_TOP 0
#define TITLE_VY_STATE_GAME 1

class BirdTitle : public BaseMap{
 private:
  int benchCount;
  int bench;
  int pUTime;
  int nUTime;
  int dUTime;
  int pSTime;
  int nSTime;
  int dSTime;
 public:
  Glib::RefPtr<Gdk::GC> backGC;
  Glib::RefPtr<Gdk::GC> frontGC;
  Glib::RefPtr<Gdk::Pixbuf> plank;
  Glib::RefPtr<Gdk::Pixbuf> background;
  BirdTitle();
  ~BirdTitle();
  void Create();

  void RegulateBird(int rate);

  int GetCPUusage();

  void GameSelect();
  void KeyConfigSelect();
  void ScoreSelect();
  void CreateSelect();
  void ExitSelect();
  static void(BirdTitle::*TITLE_TOP_SELECT[TITLE_TOP_NUM])();

  void TopMenu();

  void StreamGameSelect();
  void BossPracticeGameSelect();
  void PlayCreateGameSelect();
  static void(BirdTitle::*TITLE_GAME_SELECT[TITLE_GAME_NUM])();

  void GameMenu();

  static void(BirdTitle::*TITLE_MENU_SELECT[TITLE_STATE_NUM])();

  void ViewMap();
};

#endif
