#ifndef BIRD_ACTOR_LIST_H_
#define BIRD_ACTOR_LIST_H_

#include <gtkmm.h>
#include <iostream>

#define WIDTH 720
#define HEIGHT 480

#define MAX_WIDTH WIDTH+64
#define MIN_WIDTH -64

#define MAX_HEIGHT HEIGHT
#define MIN_HEIGHT 0

class BirdActor{
 public:
  int px;
  int py;
  int width;
  int height;
  int mx;
  int my;
  int tx;
  int ty;
  int fire;
  int style;
  int form;
  int move;
  int life;
  int tcount;
  int touch;
  int item;
  int drop;
  int direct;
  int dcount;
  int seq;
  int tmp;
  int score;
  BirdActor *target;
  BirdActor *next;
  BirdActor *prev;
};

void DistApprox(int *sx,int *sy,int tx,int ty,int force);

class ActorList{
 public:
  int listSize;
  BirdActor *first;
  BirdActor *end;
  ActorList();
  ~ActorList();
  int ContactRect(BirdActor *act1,BirdActor *act2);
  void Append(BirdActor *node);
  void Prepend(BirdActor *node);
  void Insert(BirdActor *node,BirdActor *target);
  void Reject(BirdActor *node);
  void ALLDelete();

  int TwoDimensionSpace(BirdActor *act,BirdActor *target);
};

#endif
