#include "basemap.h"

BaseMap::BaseMap(){
  scoreFile= new ScoreFile();
  player= new BirdPlayer();
  enemyList= new BirdEnemy();
  pfireList= new PlayerFire();
  efireList= new EnemyFire();
  itemList= new BirdItem();
  landList= new BirdLand();
}

BaseMap::~BaseMap(){
  delete scoreFile;
  delete player;
  delete enemyList;
  delete pfireList;
  delete efireList;
  delete itemList;
  delete landList;
}

void BaseMap::BaseCreate(Glib::RefPtr<Gdk::Window> mWindow0,
			 Glib::RefPtr<Gdk::Pixmap> frame0,
			 Glib::RefPtr<Gdk::GC> mGC0,
			 BirdMap *Map0,
			 BirdControl *control0,
			 BirdText *text0,
			 BirdColor *color0){

  mWindow=mWindow0;
  frame=frame0;
  mGC=mGC0;
  Map=Map0;
  control=control0;
  text=text0;
  color=color0;

  player->Create(frame,mGC,pfireList,landList,
		 &(control->selectValue),
		 &(control->okValue),&(control->cancelValue));
  landList->Create(frame,mWindow,Map,color,player);
  enemyList->Create(frame,mGC,Map,player,landList,
		    pfireList,efireList,itemList);
  pfireList->Create(frame,mGC,player,enemyList,landList,itemList);
  efireList->Create(frame,mGC,player,landList);
  itemList->Create(frame,mGC,Map,player);

}

std::string BaseMap::CallName(std::string name0){
  std::string name1;
  if(name0.size()){
    name1=name0;
  }
  else{
    name1="NO NAME";
  }
  return name1;
}

void BaseMap::StepSelectAction0(int *valueX,int *valueY){
  /*
    DUMMY
  */
}
void BaseMap::StepSelectAction1(int *valueX,int *valueY){
  control->selectValue-=control->selectValue&1;
  *valueX-=1;
}
void BaseMap::StepSelectAction2(int *valueX,int *valueY){
  control->selectValue-=control->selectValue&2;
  *valueY-=1;
}
void BaseMap::StepSelectAction3(int *valueX,int *valueY){
  control->selectValue-=control->selectValue&1;
  control->selectValue-=control->selectValue&2;
}
void BaseMap::StepSelectAction4(int *valueX,int *valueY){
  control->selectValue-=control->selectValue&4;
  *valueX+=1;
}
void BaseMap::StepSelectAction5(int *valueX,int *valueY){
  control->selectValue-=control->selectValue&1;
  control->selectValue-=control->selectValue&4;  
}
void BaseMap::StepSelectAction6(int *valueX,int *valueY){
  control->selectValue-=control->selectValue&2;  
  control->selectValue-=control->selectValue&4;  
}
void BaseMap::StepSelectAction7(int *valueX,int *valueY){
  control->selectValue-=control->selectValue&1;  
  control->selectValue-=control->selectValue&2;
  control->selectValue-=control->selectValue&4;
}
void BaseMap::StepSelectAction8(int *valueX,int *valueY){
  *valueY+=1;
  control->selectValue-=control->selectValue&8;
}
void BaseMap::StepSelectAction9(int *valueX,int *valueY){
  control->selectValue-=control->selectValue&1;
  control->selectValue-=control->selectValue&8;
}
void BaseMap::StepSelectAction10(int *valueX,int *valueY){
  control->selectValue-=control->selectValue&2;
  control->selectValue-=control->selectValue&8;
}
void BaseMap::StepSelectAction11(int *valueX,int *valueY){
  control->selectValue-=control->selectValue&1;
  control->selectValue-=control->selectValue&2;
  control->selectValue-=control->selectValue&8;
}
void BaseMap::StepSelectAction12(int *valueX,int *valueY){
  control->selectValue-=control->selectValue&4;
  control->selectValue-=control->selectValue&8;
}
void BaseMap::StepSelectAction13(int *valueX,int *valueY){
  control->selectValue-=control->selectValue&1;
  control->selectValue-=control->selectValue&4;
  control->selectValue-=control->selectValue&8;
}
void BaseMap::StepSelectAction14(int *valueX,int *valueY){
  control->selectValue-=control->selectValue&2;
  control->selectValue-=control->selectValue&4;
  control->selectValue-=control->selectValue&8;
}
void BaseMap::StepSelectAction15(int *valueX,int *valueY){
  control->selectValue-=control->selectValue&1;
  control->selectValue-=control->selectValue&2;
  control->selectValue-=control->selectValue&4;
  control->selectValue-=control->selectValue&8;
}
void (BaseMap::*BaseMap::STEP_SELECT_ACTION[16])
  (int *valueX,int *valueY)={
  &BaseMap::StepSelectAction0,
  &BaseMap::StepSelectAction1,
  &BaseMap::StepSelectAction2,
  &BaseMap::StepSelectAction3,
  &BaseMap::StepSelectAction4,
  &BaseMap::StepSelectAction5,
  &BaseMap::StepSelectAction6,
  &BaseMap::StepSelectAction7,
  &BaseMap::StepSelectAction8,
  &BaseMap::StepSelectAction9,
  &BaseMap::StepSelectAction10,
  &BaseMap::StepSelectAction11,
  &BaseMap::StepSelectAction12,
  &BaseMap::StepSelectAction13,
  &BaseMap::StepSelectAction14,
  &BaseMap::StepSelectAction15
};

void BaseMap::StepSelectAction
(int *valueX,int *valueY){
  (this->*STEP_SELECT_ACTION[control->selectValue])(valueX,valueY);
}


void BaseMap::VHMoveSelectAction0(int *valueX,int *valueY,int force){
  //DUMMY
}
void BaseMap::VHMoveSelectAction1(int *valueX,int *valueY,int force){
  *valueX-=force;
}
void BaseMap::VHMoveSelectAction2(int *valueX,int *valueY,int force){
  *valueY-=force;
}
void BaseMap::VHMoveSelectAction3(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&1;
  control->selectValue-=control->selectValue&2;
}
void BaseMap::VHMoveSelectAction4(int *valueX,int *valueY,int force){
  *valueX+=force;
}
void BaseMap::VHMoveSelectAction5(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&1;
  control->selectValue-=control->selectValue&4;  
}
void BaseMap::VHMoveSelectAction6(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&2;  
  control->selectValue-=control->selectValue&4;  
}
void BaseMap::VHMoveSelectAction7(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&1;  
  control->selectValue-=control->selectValue&2;
  control->selectValue-=control->selectValue&4;
}
void BaseMap::VHMoveSelectAction8(int *valueX,int *valueY,int force){
  *valueY+=force;
}
void BaseMap::VHMoveSelectAction9(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&1;
  control->selectValue-=control->selectValue&8;
}
void BaseMap::VHMoveSelectAction10(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&2;
  control->selectValue-=control->selectValue&8;
}
void BaseMap::VHMoveSelectAction11(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&1;
  control->selectValue-=control->selectValue&2;
  control->selectValue-=control->selectValue&8;
}
void BaseMap::VHMoveSelectAction12(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&4;
  control->selectValue-=control->selectValue&8;
}
void BaseMap::VHMoveSelectAction13(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&1;
  control->selectValue-=control->selectValue&4;
  control->selectValue-=control->selectValue&8;
}
void BaseMap::VHMoveSelectAction14(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&2;
  control->selectValue-=control->selectValue&4;
  control->selectValue-=control->selectValue&8;
}
void BaseMap::VHMoveSelectAction15(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&1;
  control->selectValue-=control->selectValue&2;
  control->selectValue-=control->selectValue&4;
  control->selectValue-=control->selectValue&8;
}
void (BaseMap::*BaseMap::VHMOVE_SELECT_ACTION[16])
  (int *valueX,int *valueY,int force)={
  &BaseMap::VHMoveSelectAction0,
  &BaseMap::VHMoveSelectAction1,
  &BaseMap::VHMoveSelectAction2,
  &BaseMap::VHMoveSelectAction3,
  &BaseMap::VHMoveSelectAction4,
  &BaseMap::VHMoveSelectAction5,
  &BaseMap::VHMoveSelectAction6,
  &BaseMap::VHMoveSelectAction7,
  &BaseMap::VHMoveSelectAction8,
  &BaseMap::VHMoveSelectAction9,
  &BaseMap::VHMoveSelectAction10,
  &BaseMap::VHMoveSelectAction11,
  &BaseMap::VHMoveSelectAction12,
  &BaseMap::VHMoveSelectAction13,
  &BaseMap::VHMoveSelectAction14,
  &BaseMap::VHMoveSelectAction15
};

void BaseMap::VHMoveSelectAction
(int selectValue,int *valueX,int *valueY,int force){
  (this->*VHMOVE_SELECT_ACTION[selectValue])(valueX,valueY,force);
}

void BaseMap::VariableSetValue(int *value,int force,int sign){
  if(Map->keyCount==0){
    *value+=1*sign;
  }
  else if((Map->keyCount>SELECTKEY_COUNT100)
	  &&(force>=SELECTKEY_VARIABLE100)){
    *value+=100*sign;
  }
  else if((Map->keyCount>SELECTKEY_COUNT10)
	  &&(force>=SELECTKEY_VARIABLE10)){
    *value+=10*sign;
  }
  else if((Map->keyCount>SELECTKEY_COUNT1)
	  &&(force>=SELECTKEY_VARIABLE1)){
    *value+=1*sign;
  }
}

void BaseMap::VariableSelectAction0(int *valueX,int *valueY,int force){
  Map->keyCount=0;
}
void BaseMap::VariableSelectAction1(int *valueX,int *valueY,int force){
  VariableSetValue(valueX,force,SELECTKEY_SIGN_MINUS);
  Map->keyCount++;

}
void BaseMap::VariableSelectAction2(int *valueX,int *valueY,int force){
  VariableSetValue(valueY,force,SELECTKEY_SIGN_MINUS);
  Map->keyCount++;
}
void BaseMap::VariableSelectAction3(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&1;
  control->selectValue-=control->selectValue&2;
}
void BaseMap::VariableSelectAction4(int *valueX,int *valueY,int force){
  VariableSetValue(valueX,force,SELECTKEY_SIGN_PLUS);
  Map->keyCount++;
}
void BaseMap::VariableSelectAction5(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&1;
  control->selectValue-=control->selectValue&4;  
}
void BaseMap::VariableSelectAction6(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&2;  
  control->selectValue-=control->selectValue&4;  
}
void BaseMap::VariableSelectAction7(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&1;  
  control->selectValue-=control->selectValue&2;
  control->selectValue-=control->selectValue&4;
}
void BaseMap::VariableSelectAction8(int *valueX,int *valueY,int force){
  VariableSetValue(valueY,force,SELECTKEY_SIGN_PLUS);
  Map->keyCount++;
}
void BaseMap::VariableSelectAction9(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&1;
  control->selectValue-=control->selectValue&8;
}
void BaseMap::VariableSelectAction10(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&2;
  control->selectValue-=control->selectValue&8;
}
void BaseMap::VariableSelectAction11(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&1;
  control->selectValue-=control->selectValue&2;
  control->selectValue-=control->selectValue&8;
}
void BaseMap::VariableSelectAction12(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&4;
  control->selectValue-=control->selectValue&8;
}
void BaseMap::VariableSelectAction13(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&1;
  control->selectValue-=control->selectValue&4;
  control->selectValue-=control->selectValue&8;
}
void BaseMap::VariableSelectAction14(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&2;
  control->selectValue-=control->selectValue&4;
  control->selectValue-=control->selectValue&8;
}
void BaseMap::VariableSelectAction15(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&1;
  control->selectValue-=control->selectValue&2;
  control->selectValue-=control->selectValue&4;
  control->selectValue-=control->selectValue&8;
}

void (BaseMap::*BaseMap::VARIABLE_SELECT_ACTION[16])
  (int *valueX,int *valueY,int force)={
  &BaseMap::VariableSelectAction0,
  &BaseMap::VariableSelectAction1,
  &BaseMap::VariableSelectAction2,
  &BaseMap::VariableSelectAction3,
  &BaseMap::VariableSelectAction4,
  &BaseMap::VariableSelectAction5,
  &BaseMap::VariableSelectAction6,
  &BaseMap::VariableSelectAction7,
  &BaseMap::VariableSelectAction8,
  &BaseMap::VariableSelectAction9,
  &BaseMap::VariableSelectAction10,
  &BaseMap::VariableSelectAction11,
  &BaseMap::VariableSelectAction12,
  &BaseMap::VariableSelectAction13,
  &BaseMap::VariableSelectAction14,
  &BaseMap::VariableSelectAction15
};

void BaseMap::VariableSelectAction
(int *valueX,int *valueY,int force){
  (this->*VARIABLE_SELECT_ACTION[control->selectValue])
    (valueX,valueY,force);
}
