#ifndef BIRD_BASE_MAP_H_
#define BIRD_BASE_MAP_H_

#include <gtkmm.h>
#include <iostream>
#include <sstream>
#include "scorefile.h"
#include "actlist.h"
#include "enemy.h"
#include "land.h"
#include "color.h"
#include "text.h"
#include "control.h"
#include "player.h"
#include "playerfire.h"
#include "enemyfire.h"
#include "item.h"
#include "map.h"

#define SELECTKEY_COUNT1 10
#define SELECTKEY_COUNT10 40
#define SELECTKEY_COUNT100 150

#define SELECTKEY_VARIABLE1 0
#define SELECTKEY_VARIABLE10 1
#define SELECTKEY_VARIABLE100 2
#define SELECTKEY_VARIABLE_NUM 3

#define SELECTKEY_SIGN_PLUS 1
#define SELECTKEY_SIGN_MINUS -1

class BaseMap{
 public:
  BirdMap *Map;
  BirdControl *control;
  BirdColor *color;
  BirdText *text;
  BirdPlayer *player;
  BirdLand *landList;
  BirdEnemy *enemyList;
  PlayerFire *pfireList;
  EnemyFire *efireList;
  BirdItem *itemList;
  ScoreFile *scoreFile;
  Glib::RefPtr<Gdk::Window> mWindow;
  Glib::RefPtr<Gdk::Pixmap> frame;
  Glib::RefPtr<Gdk::GC> mGC;
  BaseMap();
  ~BaseMap();
  void BaseCreate(Glib::RefPtr<Gdk::Window> mWindow0,
	      Glib::RefPtr<Gdk::Pixmap> frame0,
	      Glib::RefPtr<Gdk::GC> mGC0,
	      BirdMap *Map0,
	      BirdControl *control0,
	      BirdText *text0,
	      BirdColor *color0);

  std::string CallName(std::string name0);

  void StepSelectAction0(int *valueX,int *valueY);
  void StepSelectAction1(int *valueX,int *valueY);
  void StepSelectAction2(int *valueX,int *valueY);
  void StepSelectAction3(int *valueX,int *valueY);
  void StepSelectAction4(int *valueX,int *valueY);
  void StepSelectAction5(int *valueX,int *valueY);
  void StepSelectAction6(int *valueX,int *valueY);
  void StepSelectAction7(int *valueX,int *valueY);
  void StepSelectAction8(int *valueX,int *valueY);
  void StepSelectAction9(int *valueX,int *valueY);
  void StepSelectAction10(int *valueX,int *valueY);
  void StepSelectAction11(int *valueX,int *valueY);
  void StepSelectAction12(int *valueX,int *valueY);
  void StepSelectAction13(int *valueX,int *valueY);
  void StepSelectAction14(int *valueX,int *valueY);
  void StepSelectAction15(int *valueX,int *valueY);
  static void(BaseMap::*STEP_SELECT_ACTION[16])
    (int *valueX,int *valueY);

  void StepSelectAction(int *valueX,int *valueY);

  void VHMoveSelectAction0(int *valueX,int *valueY,int force);
  void VHMoveSelectAction1(int *valueX,int *valueY,int force);
  void VHMoveSelectAction2(int *valueX,int *valueY,int force);
  void VHMoveSelectAction3(int *valueX,int *valueY,int force);
  void VHMoveSelectAction4(int *valueX,int *valueY,int force);
  void VHMoveSelectAction5(int *valueX,int *valueY,int force);
  void VHMoveSelectAction6(int *valueX,int *valueY,int force);
  void VHMoveSelectAction7(int *valueX,int *valueY,int force);
  void VHMoveSelectAction8(int *valueX,int *valueY,int force);
  void VHMoveSelectAction9(int *valueX,int *valueY,int force);
  void VHMoveSelectAction10(int *valueX,int *valueY,int force);
  void VHMoveSelectAction11(int *valueX,int *valueY,int force);
  void VHMoveSelectAction12(int *valueX,int *valueY,int force);
  void VHMoveSelectAction13(int *valueX,int *valueY,int force);
  void VHMoveSelectAction14(int *valueX,int *valueY,int force);
  void VHMoveSelectAction15(int *valueX,int *valueY,int force);
  static void(BaseMap::*VHMOVE_SELECT_ACTION[16])
    (int *valueX,int *valueY,int force);

  void VHMoveSelectAction
    (int selectValue,int *valueX,int *valueY,int force);

  void VariableSetValue(int *value,int force,int sign);

  void VariableSelectAction0(int *valueX,int *valueY,int force);
  void VariableSelectAction1(int *valueX,int *valueY,int force);
  void VariableSelectAction2(int *valueX,int *valueY,int force);
  void VariableSelectAction3(int *valueX,int *valueY,int force);
  void VariableSelectAction4(int *valueX,int *valueY,int force);
  void VariableSelectAction5(int *valueX,int *valueY,int force);
  void VariableSelectAction6(int *valueX,int *valueY,int force);
  void VariableSelectAction7(int *valueX,int *valueY,int force);
  void VariableSelectAction8(int *valueX,int *valueY,int force);
  void VariableSelectAction9(int *valueX,int *valueY,int force);
  void VariableSelectAction10(int *valueX,int *valueY,int force);
  void VariableSelectAction11(int *valueX,int *valueY,int force);
  void VariableSelectAction12(int *valueX,int *valueY,int force);
  void VariableSelectAction13(int *valueX,int *valueY,int force);
  void VariableSelectAction14(int *valueX,int *valueY,int force);
  void VariableSelectAction15(int *valueX,int *valueY,int force);
  static void(BaseMap::*VARIABLE_SELECT_ACTION[16])
    (int *valueX,int *valueY,int force);

  void VariableSelectAction
    (int *valueX,int *valueY,int force);

};

#endif
