#include "basestage.h"
#include <sys/types.h>
#include <sys/stat.h>

BaseStage::BaseStage(){
  int i;
  i=0;
  while(i<STAGE_TIMELINE_MAX){
    timeLine[i]=0;
    i++;
  }
  timeLine[STAGE_TIMELINE_MAX]=999;

  crowdStyle[CROWD_TYPE_NO]=0;
  crowdStyle[CROWD_TYPE_STRBIRD]=EN_STR_BIRD;
  crowdStyle[CROWD_TYPE_TARBIRD]=EN_STR_BIRD;
  crowdStyle[CROWD_TYPE_REVBIRD]=EN_REV_BIRD;
  crowdStyle[CROWD_TYPE_HOMBIRD]=EN_HOM_BIRD;
  crowdStyle[CROWD_TYPE_SMALLBAT]=EN_SMALL_BAT;
  crowdStyle[CROWD_TYPE_BIGBAT]=EN_BIG_BAT;
  crowdStyle[CROWD_TYPE_SMALLSPHENICS]=EN_SMALL_SPHENICS;
  crowdStyle[CROWD_TYPE_WIDESPHENICS]=EN_WIDE_SPHENICS;
  crowdStyle[CROWD_TYPE_JUMPGALLUS]=EN_NORMAL_GALLUS;
  crowdStyle[CROWD_TYPE_RUNSTRUTHIO]=EN_NORMAL_STRUTHIO;
  crowdStyle[CROWD_TYPE_SMALLCROSSSTRIX]=EN_SMALL_CROSSSTRIX;
  crowdStyle[CROWD_TYPE_SMALLXREVSTRIX]=EN_SMALL_XREVSTRIX;
  crowdStyle[CROWD_TYPE_HOMEAGLE]=EN_NORMAL_EAGLE;
  crowdStyle[CROWD_TYPE_LINEHOMEAGLE]=EN_LINE_EAGLE;

  stageName="";
  initLife=10;
  initFire=PF_SMALL;
  initForm=PLAYER_FORM_NORMAL;

  crowdSeq[CROWD_TYPE_NO]=0;
  crowdSeq[CROWD_TYPE_STRBIRD]=1;
  crowdSeq[CROWD_TYPE_TARBIRD]=1;
  crowdSeq[CROWD_TYPE_REVBIRD]=1;
  crowdSeq[CROWD_TYPE_HOMBIRD]=1;
  crowdSeq[CROWD_TYPE_SMALLBAT]=1;
  crowdSeq[CROWD_TYPE_BIGBAT]=1;
  crowdSeq[CROWD_TYPE_SMALLSPHENICS]=0;
  crowdSeq[CROWD_TYPE_WIDESPHENICS]=0;
  crowdSeq[CROWD_TYPE_JUMPGALLUS]=0;
  crowdSeq[CROWD_TYPE_RUNSTRUTHIO]=0;
  crowdSeq[CROWD_TYPE_SMALLCROSSSTRIX]=0;
  crowdSeq[CROWD_TYPE_SMALLXREVSTRIX]=0;
  crowdSeq[CROWD_TYPE_HOMEAGLE]=0;
  crowdSeq[CROWD_TYPE_LINEHOMEAGLE]=0;

  endLine=0;
  bgPX=0;
  bgPY=0;
  bgMX=0;
  bgMY=0;
  bgPW=0;
  bgPH=0;
  bgInterX=0;
  bgInterY=0;
  bgStartX=0;
  bgStartY=0;
  bgMinX=0;
  bgMaxX=0;
  bgMinY=0;
  bgMaxY=0;
  bgMovW=0;
  bgMovH=0;
  bgBoss=0;
}

BaseStage::~BaseStage(){
}

void BaseStage::StageCreate(){
  backGC=Gdk::GC::create(mWindow);
  backGC->set_rgb_fg_color(*(color->sky));
  
  blackGC=Gdk::GC::create(mWindow);
  blackGC->set_rgb_fg_color(*(color->black));
  
  modeColor[PLAYER_MODE_NORMAL]=(color->white);
  modeColor[PLAYER_MODE_BOOST]=(color->yellow);
  modeColor[PLAYER_MODE_SPEED]=(color->green);
  modeColor[PLAYER_MODE_PASS]=(color->blue);
  
  fireColor[PF_SMALL]=(color->white);
  fireColor[PF_BIG]=(color->yellow);
  fireColor[PF_WIDE]=(color->green);
  fireColor[PF_LINE]=(color->red);
  
  formColor[PLAYER_FORM_NORMAL]=(color->white);
  formColor[PLAYER_FORM_CROSS]=(color->yellow);
  formColor[PLAYER_FORM_XREV]=(color->yellow);
  formColor[PLAYER_FORM_HOM]=(color->yellow);
  formColor[PLAYER_FORM_WAVE]=(color->yellow);
  formColor[PLAYER_FORM_DIVIDE]=(color->yellow);
  formColor[PLAYER_FORM_DROP]=(color->yellow);
  
  modeLimitGC[PLAYER_MODE_NORMAL]=Gdk::GC::create(mWindow);
  modeLimitGC[PLAYER_MODE_NORMAL]->
    set_rgb_fg_color(*(modeColor[PLAYER_MODE_NORMAL]));

  modeLimitGC[PLAYER_MODE_BOOST]=Gdk::GC::create(mWindow);
  modeLimitGC[PLAYER_MODE_BOOST]->
    set_rgb_fg_color(*(modeColor[PLAYER_MODE_BOOST]));

  modeLimitGC[PLAYER_MODE_SPEED]=Gdk::GC::create(mWindow);
  modeLimitGC[PLAYER_MODE_SPEED]->
    set_rgb_fg_color(*(modeColor[PLAYER_MODE_SPEED]));

  modeLimitGC[PLAYER_MODE_PASS]=Gdk::GC::create(mWindow);
  modeLimitGC[PLAYER_MODE_PASS]->
    set_rgb_fg_color(*(modeColor[PLAYER_MODE_PASS]));
}

int BaseStage::CalcStageID(){
  int value0;
  
  value0=bgMaxX+bgMaxY+endLine
    +initLife*STAGE_ID_LIFEPOW
    +initFire*STAGE_ID_FIREPOW
    +initForm*STAGE_ID_FORMPOW;
  
  return value0; 
}

std::string BaseStage::GetName(std::string name0){
  if(stageName.size()>0){
    
  }
  else{
    name0="NO NAME";
  }
  return name0;
}

void BaseStage::ModeLimitView(){
  int  modeGauge;
  int px0,py0;

  if(player->item!=PLAYER_MODE_NORMAL
     &&player->tcount>0){
    modeGauge=player->tcount*100/player->modeLimit[player->item];
    
    px0=WIDTH*1/12-8;
    py0=HEIGHT*19/20+5;

    text->DrawString
      ("LIMIT",(color->white),px0,py0,FONT_LINE_RIGHT,
       10,FONT_SERIF,FONT_FACE_BOLD);

    frame->draw_rectangle(blackGC,true,
			WIDTH*1/12-4,HEIGHT*19/20-4,
			107,17);
    frame->draw_rectangle(modeLimitGC[player->item],true,
			  WIDTH*1/12+100-modeGauge,HEIGHT*19/20,
			  modeGauge,10);
  }
}

void BaseStage::PlayerModeView(int px,int py,int line,
			       int size,int type,int face){
  std::stringstream ss;
  std::string str;

  ss<<player->modeName[player->item]<<" MODE";
  str=ss.str();
  text->DrawString(str,(modeColor[player->item]),
		   px,py,line,size,type,face);
  ss.str("");
  ss.clear(std::stringstream::goodbit);
}

void BaseStage::PlayerFireView(int px,int py,int line,
			       int size,int type,int face){
  std::stringstream ss;
  std::string str;

  ss<<pfireList->FireName(player->fire)<<" FIRE";
  str=ss.str();
  text->DrawString(str,(fireColor[player->fire]),
		   px,py,line,size,type,face);

  ss.str("");
  ss.clear(std::stringstream::goodbit);
}

void BaseStage::PlayerFormView(int px,int py,int line,
			       int size,int type,int face){
  std::stringstream ss;
  std::string str;

  ss<<player->FormName(player->form)<<" FORM";
  str=ss.str();
  text->DrawString(str,(formColor[player->form]),
		   px,py,line,size,type,face);
  ss.str("");
  ss.clear(std::stringstream::goodbit);


}

void BaseStage::GameMeasureView(int speedX,int speedY){
  std::stringstream ss;
  std::string str;
  int enemyCount,playerFireCount,enemyFireCount,landCount,itemCount;
  
  landCount=landList->Animate();
  enemyCount=enemyList->Animate();
  playerFireCount=pfireList->Animate();
  enemyFireCount=efireList->Animate();
  player->Animate();
  itemCount=itemList->Animate();

  ss<<"SEC : "<<Map->sec;
  str=ss.str();
  text->DrawUpLeft(str,*(color->white),0,0,12,FONT_SANS);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  ss<<"SPEED X : "<<Map->speedX;
  str=ss.str();
  text->DrawUpLeft(str,*(color->white),WIDTH*1/6,0,12,FONT_SANS);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  ss<<"SPEED Y : "<<Map->speedY;
  str=ss.str();
  text->DrawUpLeft(str,*(color->white),WIDTH*2/6,0,12,FONT_SANS);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  ss<<"ENEMY : "<<enemyCount;
  str=ss.str();
  text->DrawUpLeft(str,*(color->white),WIDTH*3/6,0,15,FONT_SANS);
  ss.str("");
  ss.clear(std::stringstream::goodbit);
  
  ModeLimitView();
  
}

void BaseStage::GameStatusView(int statusFlag){
  std::stringstream ss;
  std::string str;
  int px0,py0;
  int px1,py1;

  py1=HEIGHT*(STAGE_GAMESTATUS_PY1)/MAP_YMAX;
  px0=WIDTH*(STAGE_GAMESTATUS_PX1
	     +STAGE_GAMESTATUS_MX1*STAGE_GAMESTATUS_SEC)/MAP_XMAX;
  py0=py1;
  ss<<"SEC : "<<Map->sec/50<<"."<<(Map->sec/5)%10;
  str=ss.str();
  text->DrawString
    (str,(color->white),px0,py0,
     STAGE_GAMESTATUS_LF1,
     STAGE_GAMESTATUS_SF1,
     STAGE_GAMESTATUS_TF1,
     STAGE_GAMESTATUS_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);
  
  px0=WIDTH*(STAGE_GAMESTATUS_PX1
	     +STAGE_GAMESTATUS_MX1*STAGE_GAMESTATUS_SCORE)/MAP_XMAX;
  py0=py1;
  ss<<"SCORE : "<<player->score;
  str=ss.str();
  text->DrawString
    (str,(color->white),px0,py0,
     STAGE_GAMESTATUS_LF1,
     STAGE_GAMESTATUS_SF1,
     STAGE_GAMESTATUS_TF1,
     STAGE_GAMESTATUS_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  PlayerModeView
    (WIDTH*(STAGE_GAMESTATUS_PX1
	    +STAGE_GAMESTATUS_MX1*STAGE_GAMESTATUS_MODE)/MAP_XMAX,
     py1,
     STAGE_GAMESTATUS_LF1,
     STAGE_GAMESTATUS_SF1,
     STAGE_GAMESTATUS_TF1,
     STAGE_GAMESTATUS_FF1);

  PlayerFireView
    (WIDTH*(STAGE_GAMESTATUS_PX1
	    +STAGE_GAMESTATUS_MX1*STAGE_GAMESTATUS_FIRE)/MAP_XMAX,
     py1,
     STAGE_GAMESTATUS_LF1,
     STAGE_GAMESTATUS_SF1,
     STAGE_GAMESTATUS_TF1,
     STAGE_GAMESTATUS_FF1);

  PlayerFormView
    (WIDTH*(STAGE_GAMESTATUS_PX1
	    +STAGE_GAMESTATUS_MX1*STAGE_GAMESTATUS_FORM)/MAP_XMAX,
     py1,
     STAGE_GAMESTATUS_LF1,
     STAGE_GAMESTATUS_SF1,
     STAGE_GAMESTATUS_TF1,
     STAGE_GAMESTATUS_FF1);
  
  px0=WIDTH*(STAGE_GAMESTATUS_PX1
	     +STAGE_GAMESTATUS_MX1*STAGE_GAMESTATUS_DEAD)/MAP_XMAX;
  py0=py1;
  if(statusFlag==STAGE_STATUSVIEW_DEAD){
    ss<<"DEAD : "<<(player->life-STAGE_FLIPLIFE_MAX)*-1;
  }
  else if(statusFlag==STAGE_STATUSVIEW_LIFE){
    ss<<"LIFE : "<<player->life;
  }
  str=ss.str();
  text->DrawString
    (str,(color->white),px0,py0,
     STAGE_GAMESTATUS_LF1,
     STAGE_GAMESTATUS_SF1,
     STAGE_GAMESTATUS_TF1,
     STAGE_GAMESTATUS_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);
  
  ModeLimitView();
}

void BaseStage::PauseContinueSelect(int changeFlag,int value){
  Map->state=Map->state0;
}
void BaseStage::PauseSaveSelect(int changeFlag,int value){
  
}
void BaseStage::PauseExitSelect(int changeFlag,int value){
  if(changeFlag==STAGE_CHANGE_STATE){
    Map->state=value;
  }
  else if(changeFlag==STAGE_CHANGE_TYPE){
    Map->ChangeType(value);
  }

}
void (BaseStage::*BaseStage::
      STAGE_PAUSEMENU_SELECT[STAGE_PAUSEMENU_NUM])
  (int changeFlag,int value)={
	&BaseStage::PauseContinueSelect,
	&BaseStage::PauseSaveSelect,
	&BaseStage::PauseExitSelect
      };

void BaseStage::PauseMenuView(int *valueY0,int changeFlag,int value){
  int tmpX;
  int px0,py0;
  int px1,py1;
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);
  
  frame->draw_rectangle(blackGC,true,WIDTH/4,HEIGHT/4,WIDTH/2,HEIGHT/2);

  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(380)/MAP_YMAX;

  text->DrawString("PAUSE MENU",(color->white),px0,py0,
		   FONT_LINE_CENTER,20,
		   FONT_SERIF,FONT_FACE_BOLD);

  px1=WIDTH*(STAGE_PAUSEMENU_PX1)/MAP_XMAX;
  px0=px1;
  py0=HEIGHT*(STAGE_PAUSEMENU_PY1
	      +STAGE_PAUSEMENU_MY1*STAGE_PAUSEMENU_CONTINUE)/MAP_YMAX;
  text->DrawString("CONTINUE",(color->white),px0,py0,
		   STAGE_PAUSEMENU_LF1,STAGE_PAUSEMENU_SF1,
		   STAGE_PAUSEMENU_TF1,STAGE_PAUSEMENU_FF1);

  px0=px1;
  py0=HEIGHT*(STAGE_PAUSEMENU_PY1
	      +STAGE_PAUSEMENU_MY1*STAGE_PAUSEMENU_SAVE)/MAP_YMAX;
  text->DrawString("SAVE & EXIT",(color->white),px0,py0,
		   STAGE_PAUSEMENU_LF1,STAGE_PAUSEMENU_SF1,
		   STAGE_PAUSEMENU_TF1,STAGE_PAUSEMENU_FF1);

  px0=px1;
  py0=HEIGHT*(STAGE_PAUSEMENU_PY1
	      +STAGE_PAUSEMENU_MY1*STAGE_PAUSEMENU_EXIT)/MAP_YMAX;
  text->DrawString("EXIT",(color->white),px0,py0,
		   STAGE_PAUSEMENU_LF1,STAGE_PAUSEMENU_SF1,
		   STAGE_PAUSEMENU_TF1,STAGE_PAUSEMENU_FF1);

  StepSelectAction(&tmpX,valueY0);

  if(*(valueY0)<0){
    *(valueY0)=STAGE_PAUSEMENU_NUM-1;
  }
  else if(*(valueY0)>=STAGE_PAUSEMENU_NUM){
    *valueY0=0;
  }

  enemyList->DrawSprite
    (EN_REV_BIRD,EN_WAY_B,2,
     WIDTH*(400)/MAP_XMAX,
     HEIGHT*(STAGE_PAUSEMENU_PY1+STAGE_PAUSEMENU_MY1
	     *(*valueY0))/MAP_YMAX);

  mWindow->invalidate_rect(rect,false);

  if(control->okValue==1){
    control->okValue=0;
    (this->*STAGE_PAUSEMENU_SELECT[*(valueY0)])(changeFlag,value);
  }
  else if(control->cancelValue==1){
    control->cancelValue=0;
    Map->state=Map->state0;
  }
}

void BaseStage::NoCrowd(int minW,int maxW,int minH,int maxH){
  /*
  DUMMY
  */
}

void BaseStage::StrBird(int minW,int maxW,int minH,int maxH){
  int px,py;
  px=(minW+rand()%(maxW-minW))*WIDTH/WIDTH_RATE;
  py=(minH+rand()%(maxH-minH))*HEIGHT/HEIGHT_RATE;
  enemyList->Appear(px,py,8,8,
		    rand()%6-14,3-rand()%7,0,0,2,10,
		    EN_STR_BIRD,EN_MOV_STR,
		    EN_TOUCH_PAIN,0,
		    EN_FORM_NOFIRE,0,
		    EN_ITEMDROP_WEAPON,100);
}
void BaseStage::BackStrBird(int minW,int maxW,int minH,int maxH){
  int px,py;
  px=(minW+rand()%(maxW-minW))*WIDTH/WIDTH_RATE;
  py=(minH+rand()%(maxH-minH))*HEIGHT/HEIGHT_RATE;
  enemyList->Appear(px,py,8,8,
		    14-rand()%6,3-rand()%7,0,0,2,10,
		    EN_STR_BIRD,EN_MOV_STR,
		    EN_TOUCH_PAIN,0,
		    EN_FORM_NOFIRE,0,
		    EN_ITEMDROP_WEAPON,100);
}
void BaseStage::TarBird(int minW,int maxW,int minH,int maxH){
  int sx,sy,tx,ty,f;
  f=14-rand()%6;
  sx=(minW+rand()%(maxW-minW))*WIDTH/WIDTH_RATE;
  sy=(minH+rand()%(maxH-minH))*HEIGHT/HEIGHT_RATE;
  tx=sx;
  ty=sy;
  DistApprox(&sx,&sy,player->px,player->py,f);
  enemyList->Appear(tx,ty,8,8,
		    sx,sy,0,0,2,10,
		    EN_STR_BIRD,EN_MOV_STR,
		    EN_TOUCH_PAIN,0,
		    EN_FORM_NOFIRE,0,
		    EN_ITEMDROP_WEAPON,100);
}
void BaseStage::RevBird(int minW,int maxW,int minH,int maxH){
  int px,py;
  px=(minW+rand()%(maxW-minW))*WIDTH/WIDTH_RATE;
  py=(minH+rand()%(maxH-minH))*HEIGHT/HEIGHT_RATE;
  enemyList->Appear(px,py,8,8,
		    rand()%4-6,14-rand()%29,0,0,2,10,
		    EN_REV_BIRD,EN_MOV_REV,
		    EN_TOUCH_REV,50,
		    EN_FORM_NOFIRE,0,
		    EN_ITEMDROP_WEAPON,100);
}
void BaseStage::BackRevBird(int minW,int maxW,int minH,int maxH){
  int px,py;
  px=(minW+rand()%(maxW-minW))*WIDTH/WIDTH_RATE;
  py=(minH+rand()%(maxH-minH))*HEIGHT/HEIGHT_RATE;
  enemyList->Appear(px,py,8,8,
		    6-rand()%4,14-rand()%29,0,0,2,10,
		    EN_REV_BIRD,EN_MOV_REV,
		    EN_TOUCH_REV,50,
		    EN_FORM_NOFIRE,0,
		    EN_ITEMDROP_WEAPON,100);
}
void BaseStage::HomBird(int minW,int maxW,int minH,int maxH){
  int h_mx,px,py;
  h_mx=12-rand()%6;
  px=(minW+rand()%(maxW-minW))*WIDTH/WIDTH_RATE;
  py=(minH+rand()%(maxH-minH))*HEIGHT/HEIGHT_RATE;
  enemyList->Appear(px,py,8,8,
		    0,0,h_mx,0,2,10,
		    EN_HOM_BIRD,EN_MOV_HOM,
		    EN_TOUCH_CH_NOSTR,(WIDTH*2)/(3*h_mx),
		    EN_FORM_NOFIRE,0,
		    EN_ITEMDROP_WEAPON,100);
}

void BaseStage::SmallSphenics(int minW,int maxW,int minH,int maxH){
  int px,py;
  px=(minW+rand()%(maxW-minW))*WIDTH/WIDTH_RATE;
  py=(minH+rand()%(maxH-minH))*HEIGHT/WIDTH_RATE;
  enemyList->Appear(px,py,8,32,
		    0,0,0,1,6,30,
		    EN_SMALL_SPHENICS,EN_MOV_GROUND,
		    EN_TOUCH_THROUGH,0,
		    EN_FORM_TAR_SMALL,10,
		    EN_ITEMDROP_WEAPONBONUS,100);
}
void BaseStage::WideSphenics(int minW,int maxW,int minH,int maxH){
  int px,py;
  px=(minW+rand()%(maxW-minW))*WIDTH/WIDTH_RATE;
  py=(minH+rand()%(maxH-minH))*HEIGHT/WIDTH_RATE;
  enemyList->Appear(px,py,8,32,
		    0,0,0,1,6,30,
		    EN_WIDE_SPHENICS,EN_MOV_GROUND,
		    EN_TOUCH_THROUGH,0,
		    EN_FORM_TAR_WIDE,10,
		    EN_ITEMDROP_WEAPONBONUS,100);
}

void BaseStage::RunStruthio(int minW,int maxW,int minH,int maxH){
  int px,py;
  px=(minW+rand()%(maxW-minW))*WIDTH/WIDTH_RATE;
  py=(minH+rand()%(maxH-minH))*HEIGHT/WIDTH_RATE;
  enemyList->Appear(px,py,32,64,
		    rand()%6-14,0,8,2,64,600,
		    EN_NORMAL_STRUTHIO,EN_MOV_JUMP,
		    EN_TOUCH_BLOW,3,
		    EN_FORM_NOFIRE,0,
		    EN_ITEMDROP_BONUSLIFE,500);
}
void BaseStage::BackRunStruthio(int minW,int maxW,int minH,int maxH){
  int px,py;
  px=(minW+rand()%(maxW-minW))*WIDTH/WIDTH_RATE;
  py=(minH+rand()%(maxH-minH))*HEIGHT/WIDTH_RATE;
  enemyList->Appear(px,py,32,64,
		    14-rand()%6,0,8,2,64,600,
		    EN_NORMAL_STRUTHIO,EN_MOV_JUMP,
		    EN_TOUCH_BLOW,3,
		    EN_FORM_NOFIRE,0,
		    EN_ITEMDROP_BONUSLIFE,500);
}

void BaseStage::JumpGallus(int minW,int maxW,int minH,int maxH){
  int px,py;
  px=(minW+rand()%(maxW-minW))*WIDTH/WIDTH_RATE;
  py=(minH+rand()%(maxH-minH))*HEIGHT/WIDTH_RATE;
  enemyList->Appear(px,py,16,16,
		    (rand()%3)-6,0,24-rand()%12,1,4,40,
		    EN_NORMAL_GALLUS,EN_MOV_JUMP,
		    EN_TOUCH_JUMP,1,
		    EN_FORM_NOFIRE,0,
		    EN_ITEMDROP_WEAPON,100);
}
void BaseStage::BackJumpGallus(int minW,int maxW,int minH,int maxH){
  int px,py;
  px=(minW+rand()%(maxW-minW))*WIDTH/WIDTH_RATE;
  py=(minH+rand()%(maxH-minH))*HEIGHT/WIDTH_RATE;
  enemyList->Appear(px,py,16,16,
		    6-(rand()%3),0,24-rand()%12,1,4,40,
		    EN_NORMAL_GALLUS,EN_MOV_JUMP,
		    EN_TOUCH_JUMP,1,
		    EN_FORM_NOFIRE,0,
		    EN_ITEMDROP_WEAPON,100);
}

void BaseStage::SmallBat(int minW,int maxW,int minH,int maxH){
  int px,py;
  px=(minW+rand()%(maxW-minW))*WIDTH/WIDTH_RATE;
  py=(minH+rand()%(maxH-minH))*HEIGHT/WIDTH_RATE;
  enemyList->Appear(px,py,16,16,
		    (rand()%6)*-1,6-rand()%13,0,0,6,60,
		    EN_SMALL_BAT,EN_MOV_REV,
		    EN_TOUCH_REV,1,
		    EN_FORM_TAR_SMALL,10,
		    EN_ITEMDROP_WEAPONBONUS,100);
}
void BaseStage::BackSmallBat(int minW,int maxW,int minH,int maxH){
  int px,py;
  px=(minW+rand()%(maxW-minW))*WIDTH/WIDTH_RATE;
  py=(minH+rand()%(maxH-minH))*HEIGHT/WIDTH_RATE;
  enemyList->Appear(px,py,16,16,
		    (rand()%6),6-rand()%13,0,0,6,60,
		    EN_SMALL_BAT,EN_MOV_REV,
		    EN_TOUCH_REV,1,
		    EN_FORM_TAR_SMALL,10,
		    EN_ITEMDROP_WEAPONBONUS,100);
}
void BaseStage::BigBat(int minW,int maxW,int minH,int maxH){
  int px,py;
  px=(minW+rand()%(maxW-minW))*WIDTH/WIDTH_RATE;
  py=(minH+rand()%(maxH-minH))*HEIGHT/WIDTH_RATE;
  enemyList->Appear(px,py,16,16,
		    (rand()%6)*-1,6-rand()%13,0,0,6,60,
		    EN_BIG_BAT,EN_MOV_REV,
		    EN_TOUCH_REV,1,
		    EN_FORM_TAR_BIG,10,
		    EN_ITEMDROP_WEAPONBONUS,100);
}
void BaseStage::BackBigBat(int minW,int maxW,int minH,int maxH){
  int px,py;
  px=(minW+rand()%(maxW-minW))*WIDTH/WIDTH_RATE;
  py=(minH+rand()%(maxH-minH))*HEIGHT/WIDTH_RATE;
  enemyList->Appear(px,py,16,16,
		    (rand()%6),6-rand()%13,0,0,6,60,
		    EN_BIG_BAT,EN_MOV_REV,
		    EN_TOUCH_REV,1,
		    EN_FORM_TAR_BIG,10,
		    EN_ITEMDROP_WEAPONBONUS,100);
}

void BaseStage::SmallCrossStrix(int minW,int maxW,int minH,int maxH){
  int px,py;
  px=(minW+rand()%(maxW-minW))*WIDTH/WIDTH_RATE;
  py=(minH+rand()%(maxH-minH))*HEIGHT/WIDTH_RATE;
  enemyList->Appear(px,py,32,32,
		    (rand()%6)*-1,6-rand()%13,0,0,32,300,
		    EN_SMALL_CROSSSTRIX,EN_MOV_REV,
		    EN_TOUCH_BLOW,0,
		    EN_FORM_CROSS_SMALL,10,
		    EN_ITEMDROP_WEAPONBONUS,200);
}
void BaseStage::BackSmallCrossStrix(int minW,int maxW,int minH,int maxH){
  int px,py;
  px=(minW+rand()%(maxW-minW))*WIDTH/WIDTH_RATE;
  py=(minH+rand()%(maxH-minH))*HEIGHT/WIDTH_RATE;
  enemyList->Appear(px,py,32,32,
		    (rand()%6),6-rand()%13,0,0,32,300,
		    EN_SMALL_CROSSSTRIX,EN_MOV_REV,
		    EN_TOUCH_BLOW,0,
		    EN_FORM_CROSS_SMALL,10,
		    EN_ITEMDROP_WEAPONBONUS,200);
}
void BaseStage::SmallXRevStrix(int minW,int maxW,int minH,int maxH){
  int px,py;
  px=(minW+rand()%(maxW-minW))*WIDTH/WIDTH_RATE;
  py=(minH+rand()%(maxH-minH))*HEIGHT/WIDTH_RATE;
  enemyList->Appear(px,py,32,32,
		    (rand()%6)*-1,6-rand()%13,0,0,32,300,
		    EN_SMALL_XREVSTRIX,EN_MOV_REV,
		    EN_TOUCH_BLOW,0,
		    EN_FORM_XREV_SMALL,10,
		    EN_ITEMDROP_WEAPONBONUS,200);
}
void BaseStage::BackSmallXRevStrix(int minW,int maxW,int minH,int maxH){
  int px,py;
  px=(minW+rand()%(maxW-minW))*WIDTH/WIDTH_RATE;
  py=(minH+rand()%(maxH-minH))*HEIGHT/WIDTH_RATE;
  enemyList->Appear(px,py,32,32,
		    (rand()%6),6-rand()%13,0,0,32,300,
		    EN_SMALL_XREVSTRIX,EN_MOV_REV,
		    EN_TOUCH_BLOW,0,
		    EN_FORM_XREV_SMALL,10,
		    EN_ITEMDROP_WEAPONBONUS,200);
}

void BaseStage::HomEagle(int minW,int maxW,int minH,int maxH){
  int h_mx,px,py;
  h_mx=6-rand()%4;
  px=(minW+rand()%(maxW-minW))*WIDTH/WIDTH_RATE;
  py=(minH+rand()%(maxH-minH))*HEIGHT/WIDTH_RATE;
  enemyList->Appear(px,py,48,48,
		    0,0,h_mx,0,64,600,
		    EN_NORMAL_EAGLE,EN_MOV_HOM,
		    EN_TOUCH_BLOW,WIDTH/h_mx,
		    EN_FORM_NOFIRE,0,
		    EN_ITEMDROP_BONUSLIFE,100);
}
void BaseStage::LineHomEagle(int minW,int maxW,int minH,int maxH){
  int h_mx,px,py;
  h_mx=6-rand()%4;
  px=(minW+rand()%(maxW-minW))*WIDTH/WIDTH_RATE;
  py=(minH+rand()%(maxH-minH))*HEIGHT/WIDTH_RATE;
  enemyList->Appear(px,py,48,48,
		    0,0,h_mx,0,64,600,
		    EN_LINE_EAGLE,EN_MOV_HOM,
		    EN_TOUCH_BLOW,WIDTH/h_mx,
		    EN_FORM_TAR_LINE,10,
		    EN_ITEMDROP_BONUSLIFE,100);
}

void (BaseStage::*CROWD_SELECT_TYPE[CROWD_NUM])
  (int minW,int maxW,int minH,int maxH)={
  &BaseStage::NoCrowd,&BaseStage::NoCrowd,
  &BaseStage::StrBird,&BaseStage::BackStrBird,
  &BaseStage::TarBird,&BaseStage::TarBird,
  &BaseStage::RevBird,&BaseStage::BackRevBird,
  &BaseStage::HomBird,&BaseStage::HomBird,
  &BaseStage::SmallBat,&BaseStage::BackSmallBat,
  &BaseStage::BigBat,&BaseStage::BackBigBat,
  &BaseStage::SmallSphenics,&BaseStage::SmallSphenics,
  &BaseStage::WideSphenics,&BaseStage::WideSphenics,
  &BaseStage::JumpGallus,&BaseStage::BackJumpGallus,
  &BaseStage::RunStruthio,&BaseStage::BackRunStruthio,
  &BaseStage::SmallCrossStrix,&BaseStage::BackSmallCrossStrix,
  &BaseStage::SmallXRevStrix,&BaseStage::BackSmallXRevStrix,
  &BaseStage::HomEagle,&BaseStage::HomEagle,
  &BaseStage::LineHomEagle,&BaseStage::LineHomEagle,
};

void BaseStage::CrowdModal(int index){
  StageCrowd *crowd;
  crowd=&mCrowd[index];
  (this->*CROWD_SELECT_TYPE[crowd->type])
    (crowd->minW,crowd->maxW,crowd->minH,crowd->maxH);
}

void BaseStage::NoLand(StageLand *land,int modalIndex){
  
}
void BaseStage::LeftScrLand(StageLand *land,int modalIndex){
  int px,py,left,right,up,down,freq;
  int spX0,flag;
  
  flag=0;
  spX0=mModal[modalIndex].speedX;
  if(spX0!=0){
    freq=WIDTH*(land->freq)/MODAL_LAND_FREQ;
    freq=freq/abs(spX0);
    if(freq<=1){
      flag=1;
    }
    else{
      if((Map->sec)%freq==0){
	flag=1;
      }
    }
    if(flag){
      left=(land->minL+rand()%(land->maxL-land->minL))
	*WIDTH/MODAL_LAND_L;
      right=(land->minR+rand()%(land->maxR-land->minR))
	*WIDTH/MODAL_LAND_R;
      up=(land->minU+rand()%(land->maxU-land->minU))
	*HEIGHT/MODAL_LAND_U;
      down=(land->minD+rand()%(land->maxD-land->minD))
	*HEIGHT/MODAL_LAND_D;
      px=(land->minPX+rand()%(land->maxPX-land->minPX))
	*WIDTH/MODAL_LAND_PX;
      px+=left;
      py=(land->minPY+rand()%(land->maxPY-land->minPY))
	*HEIGHT/MODAL_LAND_PY;
      landList->Appear(px,py,left,up,right,down,land->color);
    }
  }
  else{
    
  }
}
void BaseStage::RightScrLand(StageLand *land,int modalIndex){
  int px,py,left,right,up,down,freq;
  int spX0,flag;
  flag=0;
  spX0=mModal[modalIndex].speedX;
  if(spX0!=0){
    freq=land->freq*WIDTH/MODAL_LAND_FREQ;
    freq=freq/abs(spX0);
    if(freq<=1){
      flag=1;
    }
    else{
      if((Map->sec)%freq==0){
	flag=1;
      }
    }
  }
  else{
    
  }
  
  if(flag){    
    left=(land->minL+rand()%(land->maxL-land->minL))*WIDTH/MODAL_LAND_L;
    right=(land->minR+rand()%(land->maxR-land->minR))*WIDTH/MODAL_LAND_R;
    up=(land->minU+rand()%(land->maxU-land->minU))*HEIGHT/MODAL_LAND_U;
    down=(land->minD+rand()%(land->maxD-land->minD))*HEIGHT/MODAL_LAND_D;
    px=(land->minPX+rand()%(land->maxPX-land->minPX))
      *WIDTH/MODAL_LAND_PX;
    px-=right;
    py=(land->minPY+rand()%(land->maxPY-land->minPY))
      *HEIGHT/MODAL_LAND_PY;
    landList->Appear(px,py,left,up,right,down,land->color);
  }
}
void BaseStage::UpScrLand(StageLand *land,int modalIndex){
  int px,py,left,right,up,down,freq;
  int spY0,flag;
  flag=0;
  spY0=mModal[modalIndex].speedY;
  if(spY0!=0){
    freq=land->freq*HEIGHT/MODAL_LAND_FREQ;
    freq=freq/abs(spY0);
    if(freq<=1){
      flag=1;
    }
    else{
      if((Map->sec)%freq==0){
	flag=1;
      }
    }
  }
  else{
    
  }
  
  if(flag){
    left=(land->minL+rand()%(land->maxL-land->minL))*WIDTH/MODAL_LAND_L;
    right=(land->minR+rand()%(land->maxR-land->minR))*WIDTH/MODAL_LAND_R;
    up=(land->minU+rand()%(land->maxU-land->minU))*HEIGHT/MODAL_LAND_U;
    down=(land->minD+rand()%(land->maxD-land->minD))*HEIGHT/MODAL_LAND_D;
    px=(land->minPX+rand()%(land->maxPX-land->minPX))
      *WIDTH/MODAL_LAND_PX;
    py=(land->minPY+rand()%(land->maxPY-land->minPY))
      *HEIGHT/MODAL_LAND_PY;
    py+=up;
    landList->Appear(px,py,left,up,right,down,land->color);
  }
}
void BaseStage::DownScrLand(StageLand *land,int modalIndex){
  int px,py,left,right,up,down,freq;
  int spY0,flag;
  flag=0;
  spY0=mModal[modalIndex].speedY;
  if(spY0!=0){
    freq=land->freq*HEIGHT/MODAL_LAND_FREQ;
    freq=freq/abs(spY0);
    if(freq<=1){
      flag=1;
    }
    else{
      if((Map->sec)%freq==0){
	flag=1;
      }
    }
  }
  else{
    
  }

  if(flag){
    left=(land->minL+rand()%(land->maxL-land->minL))*WIDTH/MODAL_LAND_L;
    right=(land->minR+rand()%(land->maxR-land->minR))*WIDTH/MODAL_LAND_R;
    up=(land->minU+rand()%(land->maxU-land->minU))*HEIGHT/MODAL_LAND_U;
    down=(land->minD+rand()%(land->maxD-land->minD))*HEIGHT/MODAL_LAND_D;
    px=(land->minPX+rand()%(land->maxPX-land->minPX))
      *WIDTH/MODAL_LAND_PX;
    py=(land->minPY+rand()%(land->maxPY-land->minPY))
      *HEIGHT/MODAL_LAND_PY;
    py-=down;
    landList->Appear(px,py,left,up,right,down,land->color);
  }
}

void (BaseStage::*LAND_SELECT_TYPE[MODAL_LAND_TYPE_NUM])
  (StageLand *land,int modalIndex)={
    &BaseStage::NoLand,
    &BaseStage::LeftScrLand,
    &BaseStage::RightScrLand,
    &BaseStage::UpScrLand,
    &BaseStage::DownScrLand
};

void BaseStage::LandModal(StageModal *modal,int modalIndex){
  int i,px,py,left,right,up,down,freq;
  StageLand *land;
  
  i=0;
  while(i<modal->nLand){
    land=&mLand[modal->indexLand[i]];
    (this->*LAND_SELECT_TYPE[land->type])(land,modalIndex);
    i++;
  }
  
}

void BaseStage::SelectModal(StageModal *modal,int modalIndex){
  int crowdIndex=0;
  
  if(rand()%MODAL_CROWD_FREQ<modal->crowdFreq){
    crowdIndex=modal->indexCrowd[rand()%MODAL_CROWD_MAX];
    CrowdModal(crowdIndex);
  }
  LandModal(modal,modalIndex);
}

void BaseStage::WaitMap(StageModal *modal,int modalIndex){
  if(landList->first==NULL){
    Map->ChangeType(modal->value);
  }
}

void BaseStage::WaitState(StageModal *modal,int modalIndex){
  // enemyList->ALLDelete();
  if(landList->first==NULL){
    Map->state0=Map->state;
    Map->state=modal->value;
  }
}

void BaseStage::ChangeMap(StageModal *modal,int modalIndex){
  landList->ALLDelete();
  enemyList->ALLDelete();
  Map->ChangeType(modal->value);
}

void BaseStage::ChangeState(StageModal *modal,int modalIndex){
  landList->ALLDelete();
  enemyList->ALLDelete();
  Map->state0=Map->state;
  Map->state=modal->value;
}

void (BaseStage::*MODAL_SELECT_TYPE[MODAL_TYPE_NUM])
  (StageModal *modal,int modalIndex)={
    &BaseStage::SelectModal,
    &BaseStage::WaitMap,
    &BaseStage::WaitState,
    &BaseStage::ChangeMap,
    &BaseStage::ChangeState
  };

void BaseStage::ModalTypeSelect(int nSec0){
  StageModal *modal=NULL;
  
  modal=&mModal[timeLine[nSec0]];
  
  if(modal!=NULL){
    Map->speedX=modal->speedX;
    Map->speedY=modal->speedY;
    Map->minW=modal->minW*WIDTH/WIDTH_RATE;
    Map->maxW=modal->maxW*WIDTH/WIDTH_RATE;
    Map->minH=modal->minH*HEIGHT/HEIGHT_RATE;
    Map->maxH=modal->maxH*HEIGHT/HEIGHT_RATE;
    
    bgPX-=modal->speedX;
    bgPY-=modal->speedY;
    bgPW=bgPX*bgMovW/STAGE_BG_MOV_POWX+bgInterX;
    bgPH=bgPY*bgMovH/STAGE_BG_MOV_POWY+bgInterY;

    (this->*MODAL_SELECT_TYPE[modal->type])(modal,timeLine[nSec0]);
  }
  
}

void BaseStage::SetChangeModal(int num0,int type0,int value0){
  mModal[num0].speedX=-1;
  mModal[num0].speedY=0;
  mModal[num0].minW=-500;
  mModal[num0].maxW=1500;
  mModal[num0].minH=-500;
  mModal[num0].maxH=1500;
  mModal[num0].type=type0;
  mModal[num0].value=value0;
  mModal[num0].nLand=0;
  mModal[num0].crowdFreq=0;
}

void BaseStage::SaveCrowd(std::string folder,std::string name){
  std::string str;
  std::ofstream FO;
  int i;
  
  str=folder+"/"+name+".crowd";

  FO.open(str.c_str(),
	  (std::ios::out|std::ios::binary)|std::ios::trunc);
  i=0;
  while(i<STAGE_CROWD_MAX){
    FO<<i<<"\t";
    FO<<mCrowd[i].type<<"\t";
    FO<<mCrowd[i].minW<<"\t";
    FO<<mCrowd[i].maxW<<"\t";
    FO<<mCrowd[i].minH<<"\t";
    FO<<mCrowd[i].maxH<<std::endl;
    i++;
  }
  FO.close();
}

void BaseStage::SaveLand(std::string folder,std::string name){
  std::string str;
  std::ofstream FO;
  int i;
  
  str=folder+"/"+name+".land";

  FO.open(str.c_str(),
	  (std::ios::out|std::ios::binary)|std::ios::trunc);
  i=0;
  while(i<STAGE_LAND_MAX){
    FO<<i<<"\t";
    FO<<mLand[i].type<<"\t";
    FO<<mLand[i].color<<"\t";
    FO<<mLand[i].freq<<"\t";
    FO<<mLand[i].minL<<"\t";
    FO<<mLand[i].maxL<<"\t";
    FO<<mLand[i].minR<<"\t";
    FO<<mLand[i].maxR<<"\t";
    FO<<mLand[i].minU<<"\t";
    FO<<mLand[i].maxU<<"\t";
    FO<<mLand[i].minD<<"\t";
    FO<<mLand[i].maxD<<"\t";
    FO<<mLand[i].minPX<<"\t";
    FO<<mLand[i].maxPX<<"\t";
    FO<<mLand[i].minPY<<"\t";
    FO<<mLand[i].maxPY<<std::endl;
    i++;
  }
  FO.close();
}

void BaseStage::SaveModal(std::string folder,std::string name){
  std::string str;
  std::ofstream FO;
  int i,j;
  
  str=folder+"/"+name+".modal";

  FO.open(str.c_str(),
	  (std::ios::out|std::ios::binary)|std::ios::trunc);
  i=0;
  j=0;
  while(i<STAGE_MODAL_MAX){
    FO<<i<<"\t";
    FO<<mModal[i].speedX<<"\t";
    FO<<mModal[i].speedY<<"\t";
    FO<<mModal[i].minW<<"\t";
    FO<<mModal[i].maxW<<"\t";
    FO<<mModal[i].minH<<"\t";
    FO<<mModal[i].maxH<<"\t";
    FO<<mModal[i].crowdFreq<<"\t";
    FO<<mModal[i].nLand<<"\t";
    j=0;
    while(j<MODAL_CROWD_MAX){
      FO<<mModal[i].indexCrowd[j]<<"\t";
      j++;
    }
    j=0;
    while(j<MODAL_LAND_MAX-1){
      FO<<mModal[i].indexLand[j]<<"\t";
      j++;
    }
    FO<<mModal[i].indexLand[j]<<std::endl;
    i++;
  }
  FO.close();
}

void BaseStage::SaveStage(std::string folder,std::string name){
  std::string str;
  std::ofstream FO;
  std::string name0;

  struct stat STATE;

  int i;
  
  str=folder+"/"+name+".stage";

  if(stageName.size()>0){
    name0=stageName;
  }
  else{
    name0=name;
  }

  FO.open(str.c_str(),
	  (std::ios::out|std::ios::binary)|std::ios::trunc);

  FO<<"STATE<"<<std::endl;
  FO<<name0<<"\t";
  FO<<initLife<<"\t";
  FO<<initFire<<"\t";
  FO<<initForm<<std::endl;
  FO<<">"<<std::endl;

  FO<<"BG<"<<std::endl;
  FO<<bgPath<<"\t";
  FO<<bgWidth<<"\t";
  FO<<bgHeight<<"\t";
  FO<<bgInterX<<"\t";
  FO<<bgInterY<<"\t";
  FO<<bgRotate<<"\t";
  FO<<bgFlip<<std::endl;
  FO<<">"<<std::endl;

  FO<<"TIMELINE<"<<std::endl;
  i=0;
  while(i<STAGE_TIMELINE_MAX){
    FO<<i<<"\t";
    FO<<timeLine[i]<<std::endl;
    i++;
  }
  FO<<">"<<std::endl;

  FO<<"FILE<"<<std::endl;

  if(stat(str.c_str(),&STATE)==-1){
    std::cout<<"CAN'T GET "<<str<<std::endl;
  }
  else{
    FO<<STATE.st_ino<<"\t";
    FO<<STATE.st_atime<<"\t";
    FO<<STATE.st_mtime<<"\t";
    FO<<STATE.st_ctime<<std::endl;
  }
  FO<<">"<<std::endl;
  FO.close();
}

int BaseStage::LoadCrowd(std::string folder,std::string name){
  std::string file;
  std::ifstream FI;
  char ch;
  char str[255];
  int LOAD[CREATE_SAVE_CROWD_NUM];
  char *s0;
  int tmp;
  int enterCount=0;
  int tabCount=0;
  int strCount=0;
  int errorFlag=0;

  s0=&str[0];

  file=folder+"/"+name+".crowd";

  FI.open(file.c_str(),(std::ios::in|std::ios::binary));
  if(!FI){
    std::cout<<"NOT FOUND"<<file<<std::endl;
    errorFlag=1;
  }
  else{
    while(FI.get(ch)){
      if(ch=='\n'){
	*(s0+strCount)='\0';
	tmp=atoi(s0);
	LOAD[tabCount]=tmp;
	tabCount++;
	if((tabCount==CREATE_SAVE_CROWD_NUM)&&(enterCount==LOAD[0])){
	  mCrowd[LOAD[0]].type=LOAD[1];
	  mCrowd[LOAD[0]].minW=LOAD[2];
	  mCrowd[LOAD[0]].maxW=LOAD[3];
	  mCrowd[LOAD[0]].minH=LOAD[4];
	  mCrowd[LOAD[0]].maxH=LOAD[5];
	}
	else{
	  std::cout<<"FALSE ["<<enterCount<<"]"<<std::endl;
	  errorFlag=2;
	}
	strCount=0;
	tabCount=0;
	enterCount++;
      }
      else if(ch=='\t'){
	*(s0+strCount)='\0';
	tmp=atoi(s0);
	LOAD[tabCount]=tmp;
	strCount=0;
	tabCount++;
      }
      else{
	*(s0+strCount)=ch;
	strCount++;
      }
    }

    FI.close();
    if(enterCount==STAGE_CROWD_MAX){
      std::cout<<"CROWD NUM:"<<enterCount<<"=="
	       <<STAGE_CROWD_MAX<<std::endl;
    }
    else{
      std::cout<<"CROWD NUM:"<<enterCount<<"!="
	       <<STAGE_CROWD_MAX<<std::endl;
      errorFlag=3;
    }
  }
  return errorFlag;
}

int BaseStage::LoadLand(std::string folder,std::string name){
  std::string file;
  std::ifstream FI;
  char ch;
  char str[255];
  int LOAD[CREATE_SAVE_LAND_NUM];
  char *s0;
  int tmp;
  int enterCount=0;
  int tabCount=0;
  int strCount=0;
  int errorFlag=0;

  s0=&str[0];

  file=folder+"/"+name+".land";

  FI.open(file.c_str(),(std::ios::in|std::ios::binary));
  if(!FI){
    std::cout<<"NOT FOUND"<<file<<std::endl;
    errorFlag=1;
  }
  else{
    while(FI.get(ch)){
      if(ch=='\n'){
	*(s0+strCount)='\0';
	tmp=atoi(s0);
	LOAD[tabCount]=tmp;
	tabCount++;
	if((tabCount==CREATE_SAVE_LAND_NUM)&&(enterCount==LOAD[0])){
	  mLand[LOAD[0]].type=LOAD[1];
	  mLand[LOAD[0]].color=LOAD[2];
	  mLand[LOAD[0]].freq=LOAD[3];
	  mLand[LOAD[0]].minL=LOAD[4];
	  mLand[LOAD[0]].maxL=LOAD[5];
	  mLand[LOAD[0]].minR=LOAD[6];
	  mLand[LOAD[0]].maxR=LOAD[7];
	  mLand[LOAD[0]].minU=LOAD[8];
	  mLand[LOAD[0]].maxU=LOAD[9];
	  mLand[LOAD[0]].minD=LOAD[10];
	  mLand[LOAD[0]].maxD=LOAD[11];
	  mLand[LOAD[0]].minPX=LOAD[12];
	  mLand[LOAD[0]].maxPX=LOAD[13];
	  mLand[LOAD[0]].minPY=LOAD[14];
	  mLand[LOAD[0]].maxPY=LOAD[15];
	}
	else{
	  std::cout<<"FALSE ["<<enterCount<<"]"<<std::endl;
	  errorFlag=2;
	}
	strCount=0;
	tabCount=0;
	enterCount++;
      }
      else if(ch=='\t'){
	*(s0+strCount)='\0';
	tmp=atoi(s0);
	LOAD[tabCount]=tmp;
	strCount=0;
	tabCount++;
      }
      else{
	*(s0+strCount)=ch;
	strCount++;
      }
    }

    FI.close();
    if(enterCount==STAGE_LAND_MAX){
      std::cout<<"LAND NUM:"<<enterCount<<"=="
	       <<STAGE_LAND_MAX<<std::endl;
    }
    else{
      std::cout<<"LAND NUM:"<<enterCount<<"!="
	       <<STAGE_LAND_MAX<<std::endl;
      errorFlag=3;
    }
  }
  return errorFlag;
}

int BaseStage::LoadModal(std::string folder,std::string name){
  std::string file;
  std::ifstream FI;
  char ch;
  char str[255];
  int LOAD[CREATE_SAVE_MODAL_NUM];
  char *s0;
  int tmp,i;
  int enterCount=0;
  int tabCount=0;
  int strCount=0;
  int errorFlag=0;

  s0=&str[0];

  file=folder+"/"+name+".modal";

  FI.open(file.c_str(),(std::ios::in|std::ios::binary));
  if(!FI){
    std::cout<<"NOT FOUND"<<file<<std::endl;
    errorFlag=1;
  }
  else{
    while(FI.get(ch)){
      if(ch=='\n'){
	*(s0+strCount)='\0';
	tmp=atoi(s0);
	LOAD[tabCount]=tmp;
	tabCount++;
	if((tabCount==CREATE_SAVE_MODAL_NUM)&&(enterCount==LOAD[0])){
	  mModal[LOAD[0]].speedX=LOAD[1];
	  mModal[LOAD[0]].speedY=LOAD[2];
	  mModal[LOAD[0]].minW=LOAD[3];
	  mModal[LOAD[0]].maxW=LOAD[4];
	  mModal[LOAD[0]].minH=LOAD[5];
	  mModal[LOAD[0]].maxH=LOAD[6];
	  mModal[LOAD[0]].crowdFreq=LOAD[7];
	  mModal[LOAD[0]].nLand=LOAD[8];
	  i=0;
	  while(i<MODAL_CROWD_MAX){
	    mModal[LOAD[0]].indexCrowd[i]=LOAD[9+i];
	    i++;
	  }
	  i=0;
	  while(i<MODAL_LAND_MAX){
	    mModal[LOAD[0]].indexLand[i]=LOAD[19+i];
	    i++;
	  }
	}
	else{
	  std::cout<<"FALSE ["<<enterCount<<"]"<<std::endl;
	  errorFlag=2;
	}
	strCount=0;
	tabCount=0;
	enterCount++;
      }
      else if(ch=='\t'){
	*(s0+strCount)='\0';
	tmp=atoi(s0);
	LOAD[tabCount]=tmp;
	strCount=0;
	tabCount++;
      }
      else{
	*(s0+strCount)=ch;
	strCount++;
      }
    }

    FI.close();
    if(enterCount==STAGE_MODAL_MAX){
      std::cout<<"MODAL NUM:"<<enterCount<<"=="
	       <<STAGE_MODAL_MAX<<std::endl;
    }
    else{
      std::cout<<"MODAL NUM:"<<enterCount<<"!="
	       <<STAGE_MODAL_MAX<<std::endl;
      errorFlag=3;
    }
  }
  return errorFlag;
}



int BaseStage::LoadStage(std::string folder,std::string name,
			 int *width0,int *height0,
			 int *rotate0,int *flip0){
  struct stat STATE;
  std::string file;
  std::ifstream FI;
  char ch;
  char str[255];
  std::string LOAD[10];
  char *s0;
  int tmp,i;
  int inode,ctime,atime,mtime;
  int enterCount=0;
  int tabCount=0;
  int strCount=0;
  int errorFlag=0;
  int dataFlag=0;
  int readFlag=0;
  wchar_t wc[255];
  
  s0=&str[0];
  
  file=folder+"/"+name+".stage";
  
  std::cout<<"LOAD FILE"<<file<<std::endl;
  
  FI.open(file.c_str(),(std::ios::in));
  if(!FI){
    std::cout<<"NOT FOUND"<<std::endl;
    errorFlag=1;
  }
  else{
    while(FI.get(ch)){
      if(ch=='<'){
	if(readFlag==0){
	  readFlag=1;
	  dataFlag++;
	}
	else{
	  std::cout<<"ERROR <:"<<enterCount-1<<std::endl;
	  errorFlag=2;
	}
	enterCount=0;
      }
      else if(ch=='>'){
	if(readFlag==1){
	  readFlag=0;
	  if(dataFlag==1){
	    std::cout<<"STATE NUM:"<<enterCount-1<<std::endl;
	  }
	  if(dataFlag==2){
	    std::cout<<"BG NUM:"<<enterCount-1<<std::endl;
	  }
	  else if(dataFlag==3){
	    if(STAGE_TIMELINE_MAX==enterCount-1){
	      std::cout<<"TIMELINE NUM:"<<enterCount-1<<"=="
		       <<STAGE_TIMELINE_MAX<<std::endl;
	    }
	    else{
	      std::cout<<"FILE NUM:"<<enterCount-1<<"!="
		       <<STAGE_TIMELINE_MAX<<std::endl;
	      errorFlag=3;
	    }
	  }
	  else if(dataFlag==4){
	    if(stat(file.c_str(),&STATE)==-1){
	      std::cout<<"CAN'T GET "<<file<<std::endl;
	      errorFlag=1;
	    }
	    else{
	      std::cout<<"INODE:"<<inode<<":"<<STATE.st_ino<<std::endl;
	      std::cout<<"ATIME:"<<atime<<":"<<STATE.st_atime<<std::endl;
	      std::cout<<"MTIME:"<<mtime<<":"<<STATE.st_mtime<<std::endl;
	      std::cout<<"CTIME:"<<ctime<<":"<<STATE.st_ctime<<std::endl;
	    }
	  }
	}
	else{
	  std::cout<<"ERROR >:"<<enterCount-1<<std::endl;
	  errorFlag=2;
	}
	enterCount=0;
      }
      else{
	if(readFlag==1){
	  if(ch=='\n'){
	    if(enterCount>0){
	      *(s0+strCount)='\0';
	      LOAD[tabCount]=s0;
	      tabCount++;
	      if(dataFlag==1){
		if(tabCount==CREATE_SAVE_STAGE_STATE_NUM){
		  stageName=LOAD[0];
		  initLife=atoi(LOAD[1].c_str());
		  initFire=atoi(LOAD[2].c_str());
		  initForm=atoi(LOAD[3].c_str());
		}
		else{
		  std::cout<<"FALSE STATE["
			   <<CREATE_SAVE_STAGE_STATE_NUM<<"]"
			   <<"TAB="<<tabCount<<std::endl;
		}
	      }
	      else if(dataFlag==2){
		if(tabCount==CREATE_SAVE_STAGE_BG_NUM){
		  bgPath=LOAD[0];
		  *(width0)=atoi(LOAD[1].c_str());
		  *(height0)=atoi(LOAD[2].c_str());
		  bgInterX=atoi(LOAD[3].c_str());
		  bgInterY=atoi(LOAD[4].c_str());
		  *(rotate0)=atoi(LOAD[5].c_str());
		  *(flip0)=atoi(LOAD[6].c_str());
		}
		else{
		  std::cout<<"FALSE BG["
			   <<CREATE_SAVE_STAGE_BG_NUM<<"]"
			   <<"TAB="<<tabCount<<std::endl;
		}
	      }
	      else if(dataFlag==3){
		tmp=atoi(LOAD[0].c_str());
		if((tabCount==CREATE_SAVE_STAGE_TIMELINE_NUM)&&
		   (tmp==enterCount-1)){
		  timeLine[tmp]=atoi(LOAD[1].c_str());
		}
		else{
		  std::cout<<"FALSE TIMELINE["<<enterCount-1<<"]"
			   <<"TAB="<<tabCount;
		  std::cout<<" LOAD="<<tmp<<std::endl;
		  errorFlag=2;
		}
	      }
	      else if(dataFlag==4){
		if(tabCount==CREATE_SAVE_STAGE_FILE_NUM){
		  inode=atoi(LOAD[0].c_str());
		  atime=atoi(LOAD[1].c_str());
		  mtime=atoi(LOAD[2].c_str());
		  ctime=atoi(LOAD[3].c_str());
		}
		else{
		  std::cout<<"FALSE FILE["<<enterCount-1<<"]"
			   <<"TAB="<<tabCount<<std::endl;
		  errorFlag=2;
		}
	      }
	    }
	    strCount=0;
	    tabCount=0;
	    enterCount++;
	  }
	  else if(ch=='\t'){
	    *(s0+strCount)='\0';
	    LOAD[tabCount]=s0;
	    strCount=0;
	    tabCount++;
	  }
	  else{
	    *(s0+strCount)=ch;
	    strCount++;
	  }
	}
      }
    }

    FI.close();

  }
  return errorFlag;
}

int BaseStage::LoadBackGround(std::string path){
  Glib::ustring ustr;
  std::ifstream FI;
  int flag=0;
  /*
  std::string path;
  path=folder+"/"+name;
  */
  
  std::cout<<"OPEN:"<<path<<std::endl;
  
  if(background){
    background.clear();
    std::cout<<"REMIND CLEAR"<<std::endl; 
  }
  tBuf.clear();
  
  FI.open(path.c_str());

  if(FI){
    FI.close();
    try{
      tBuf=Gdk::Pixbuf::create_from_file
      (Glib::locale_to_utf8(path));
    }
    catch(...){
      tBuf.clear();
      bgMovW=0;
      bgMovH=0;
      bgInterX=0;
      bgInterY=0;
      bgWidth=0;
      bgHeight=0;
      bgRotate=0;
      bgFlip=0;
      std::cout<<"CATCH CLEAR"<<std::endl;
      flag=1;
    }
  }
  else{
    std::cout<<"CAN'T OPEN :"<<path<<std::endl;
  }
  
  if(tBuf){
    if(tBuf->get_width()>=WIDTH){
      if(tBuf->get_height()>=HEIGHT){
	background=tBuf->copy();	
	std::cout<<"BACKGROUND OK"<<std::endl;
      }
      else{
	background=tBuf->scale_simple
	  (tBuf->get_width(),HEIGHT,Gdk::INTERP_NEAREST);
	std::cout<<"LENGTH CLEAR"<<std::endl;
      }
    }
    else{
      if(tBuf->get_height()>=HEIGHT){
	background=tBuf->scale_simple
	  (WIDTH,tBuf->get_height(),Gdk::INTERP_NEAREST);
      }
      else{
	background=tBuf->scale_simple(WIDTH,HEIGHT,Gdk::INTERP_NEAREST);
	std::cout<<"LENGTH CLEAR"<<std::endl;
      }
    }
    flag=0;
    bgWidth=background->get_width();
    bgHeight=background->get_height();
    bgRotate=0;
    bgFlip=0;
  }
  else{
    tBuf.clear();
    bgMovW=0;
    bgMovH=0;
    bgInterX=0;
    bgInterY=0;
    bgWidth=0;
    bgHeight=0;
    bgRotate=0;
    bgFlip=0;
    std::cout<<"CLEAR"<<std::endl;
    flag=1;
  }

  return flag;
}

void BaseStage::ScaleRotate0(Glib::RefPtr<Gdk::Pixbuf> pixBuf0){
  background=pixBuf0->copy();
  bgRotate=STAGE_BG_ROTATE0;
}
void BaseStage::ScaleRotate90(Glib::RefPtr<Gdk::Pixbuf> pixBuf0){
  int tmp;
  background=pixBuf0->rotate_simple(Gdk::PIXBUF_ROTATE_COUNTERCLOCKWISE);
 
  tmp=bgWidth;
  bgWidth=bgHeight;
  bgHeight=tmp;
  bgRotate=STAGE_BG_ROTATE90;
}
void BaseStage::ScaleRotate180(Glib::RefPtr<Gdk::Pixbuf> pixBuf0){
  background=pixBuf0->rotate_simple(Gdk::PIXBUF_ROTATE_UPSIDEDOWN);
  bgRotate=STAGE_BG_ROTATE180;
}
void BaseStage::ScaleRotate270(Glib::RefPtr<Gdk::Pixbuf> pixBuf0){
  int tmp;
  background=pixBuf0->rotate_simple(Gdk::PIXBUF_ROTATE_CLOCKWISE);

  tmp=bgWidth;
  bgWidth=bgHeight;
  bgHeight=tmp;
  bgRotate=STAGE_BG_ROTATE270;
}
void (BaseStage::*BaseStage::CREATE_STAGE_ROTATE_SELECT
      [STAGE_BG_ROTATE_NUM])(Glib::RefPtr<Gdk::Pixbuf> pixBuf0)={
  &BaseStage::ScaleRotate0,
  &BaseStage::ScaleRotate90,
  &BaseStage::ScaleRotate180,
  &BaseStage::ScaleRotate270
};

int BaseStage::RotateBackGround(Glib::RefPtr<Gdk::Pixbuf> pixBuf0,
				int rotate0){
  int flag=0;

  std::cout<<"BG ROTATE:"<<rotate0<<std::endl;
  (this->*CREATE_STAGE_ROTATE_SELECT[rotate0])(pixBuf0);

  return 0;
}

int BaseStage::FlipBackGround(Glib::RefPtr<Gdk::Pixbuf> pixBuf0,
				int flip0){
  int flag=0;
  std::cout<<"BG FLIP:"<<flip0<<std::endl;
  if(flip0==STAGE_BG_NOFLIP){
    background=pixBuf0->copy();
    bgFlip=STAGE_BG_NOFLIP;
  }
  else if(flip0==STAGE_BG_HFLIP){
    background=pixBuf0->flip(true);
    bgFlip=STAGE_BG_HFLIP;
  }
  else if(flip0==STAGE_BG_VFLIP){
    background=pixBuf0->flip(false);
    bgFlip=STAGE_BG_VFLIP;
  }

  return flag;
}

int BaseStage::ScaleBackGround(Glib::RefPtr<Gdk::Pixbuf> pixBuf0,
			       int width0,int height0){
  int flag=0;

  std::cout<<"BG WIDTH:"<<width0<<std::endl;
  std::cout<<"BG HEIGHT:"<<height0<<std::endl;

  /*
  if((bgWidth==width0)&&
     (bgHeight==height0)){
    background=pixBuf0->copy();
  }
  else{
  */
  background=pixBuf0->scale_simple
    (width0,height0,Gdk::INTERP_HYPER);
  
  bgWidth=width0;
  bgHeight=height0;

  return flag;
}

int BaseStage::FigureBackGround(int width0,int height0,
				int rotate0,int flip0){
  int flag=0;
  RotateBackGround(tBuf,rotate0);
  ScaleBackGround(background,width0,height0);
  FlipBackGround(background,flip0);

  return flag;
}

int BaseStage::CalcStageDistance(){
  int i,tX,tY;
  int flag=0;

  endLine=0;
  bgMinX=0;
  bgMaxX=0;
  bgMinY=0;
  bgMaxY=0;
  tX=0;
  tY=0;
  i=0;

  for(;;){
    if(mModal[timeLine[i]].type==MODAL_TYPE_CHMAP){
      flag=0;
      endLine=i;
      std::cout<<"CHMAP ENDLINE:"<<endLine<<std::endl;
      break;
    }
    else if(mModal[timeLine[i]].type==MODAL_TYPE_CHSTATE){
      flag=0;
      endLine=i;
      std::cout<<"CHSTATE ENDLINE:"<<endLine<<std::endl;
      break;
    }
    else{
      tX-=mModal[timeLine[i]].speedX;
      tY-=mModal[timeLine[i]].speedY;

      if(tX<bgMinX){
	bgMinX=tX;
      }
      if(tX>bgMaxX){
	bgMaxX=tX;
      }
      if(tY<bgMinY){
	bgMinY=tY;
      }
      if(tY>bgMaxY){
	bgMaxY=tY;
      }
    }
    
    i++;
    /*
    if(i>=STAGE_TIMELINE_MAX){
      flag=1;
      endLine=STAGE_TIMELINE_MAX;
      break;
    }
    */
  }
  if(flag==0){
    bgMaxX=bgMaxX-bgMinX;
    bgStartX=bgMinX*-1;
    bgMinX=0;

    bgMaxY=bgMaxY-bgMinY;
    bgStartY=bgMinY*-1;
    bgMinY=0;
  }
  else{
    bgMaxX=0;
    bgStartX=0;
    bgMinX=0;

    bgMaxY=0;
    bgStartY=0;
    bgMinY=0;
  }

  bgPX=bgStartX;
  bgPY=bgStartY;

  return flag;
}

int BaseStage::CalcStageDistancePoint(int point,int &pointX,int &pointY){
  int i;
  int flag;

  flag=0;
  i=0;
  while(i<point){
    if(i>endLine){
      pointX=0;
      pointY=0;
      flag=1;
      break;
    }
    pointX-=mModal[timeLine[i]].speedX;
    pointY-=mModal[timeLine[i]].speedY;
    i++;
  }

  return flag;
}

int BaseStage::CalcBackGroundMove(int maxW,int maxH){
  int movX,movY;
  int movW,movH;
  int flag=0;

  if(!background){
    bgMovW=0;
    bgMovH=0;
    flag=-1;
  }
  else{
    movX=bgMaxX;
    movY=bgMaxY;
    
    movW=bgWidth-WIDTH;
    movH=bgHeight-HEIGHT;
    
    if(movW<0||movH<0){
      bgMovW=0;
      bgMovH=0;
      flag=1;
    }
    else{
      flag=0;
      if(movX<=0){
	bgMovW=0;
      }
      else{
	if(movW<=0){
	  bgMovW=0;
	}
	else{
	  bgMovW=movW*STAGE_BG_MOV_POWX/movX;
	  if(bgMovW>maxW){
	    bgMovW=maxW;
	  }
	}
      }
      
      if(movY<=0){
	bgMovH=0;
      }
      else{
	if(movH<=0){
	  bgMovH=0;
	}
	else{
	  bgMovH=movH*STAGE_BG_MOV_POWY/movY;
	  if(bgMovH>maxH){
	    bgMovH=maxH;
	  }
	}
      }
    }
  }
  return flag;
}

void BaseStage::BackGroundIntervalX(){
  int tmp=0;
  tmp=(bgWidth-WIDTH)-bgMovW*bgMaxX/STAGE_BG_MOV_POWX;
  if(bgInterX>tmp){
    std::cout<<"INTERVAL X MAX "<<tmp<<" :"<<bgInterX<<std::endl;
    bgInterX=tmp;
  }
  else if(bgInterX<0){
    std::cout<<"INTERVAL X MIN 0 :"<<bgInterX<<std::endl;
    bgInterX=0;
  }
  else{
    std::cout<<"INTERVAL X OK"<<std::endl;
  }  
}

void BaseStage::BackGroundIntervalY(){
  int tmp;
  tmp=(bgHeight-HEIGHT)-bgMovH*bgMaxY/STAGE_BG_MOV_POWY;
  if(bgInterY>tmp){
    std::cout<<"INTERVAL Y MAX "<<tmp<<" :"<<bgInterY<<std::endl;
    bgInterY=tmp;
  }
  else if(bgInterY<0){
    std::cout<<"INTERVAL Y MIN 0:"<<bgInterY<<std::endl;
    bgInterY=0;
  }
  else{
   std::cout<<"INTERVAL Y OK"<<std::endl;
  }
}

int BaseStage::LoadBirdWatch(std::string folder,std::string name){
  int flag=0;
  int crowdFlag=0;
  int landFlag=0;
  int modalFlag=0;
  int stageFlag=0;
  int tWidth0,tHeight0,tRotate0,tFlip0;

  crowdFlag=LoadCrowd(folder,name);
  if(crowdFlag!=0){
    std::cout<<"ERROR LOAD CROWD"<<std::endl;
    flag=1;
  }
  else{
    std::cout<<"SUCCESS LOAD CROWD"<<std::endl;
  }

  landFlag=LoadLand(folder,name);
  if(landFlag!=0){
    std::cout<<"ERROR LOAD LAND"<<std::endl;
    flag=1;
  }
  else{
    std::cout<<"SUCCESS LOAD LAND"<<std::endl;
  }

  modalFlag=LoadModal(folder,name);
  if(modalFlag!=0){
    std::cout<<"ERROR LOAD MODAL"<<std::endl;
    flag=1;
  }
  else{
    std::cout<<"SUCCESS LOAD MODAL"<<std::endl;
  }

  stageFlag=LoadStage(folder,name,&tWidth0,&tHeight0,
		      &tRotate0,&tFlip0);
  if(stageFlag!=0){
    std::cout<<"ERROR LOAD STAGE"<<std::endl;
    flag=1;
  }
  else{
    std::cout<<"SUCCESS LOAD STAGE"<<std::endl;
  }

  if(flag==0){
    if(CalcStageDistance()!=0){
      std::cout<<"ERROR CALC STAGE"<<std::endl;
    }
    else{
      std::cout<<"SUCCESS CALC STAGE"<<std::endl;
    }

    if(LoadBackGround(bgPath)==0){
      std::cout<<"LOAD BACKGROUND"<<std::endl;
      FigureBackGround(tWidth0,tHeight0,tRotate0,tFlip0);
    }
    else{
      std::cout<<"ERROR BACKGROUND"<<std::endl;
      flag=2;
    }
  }

  CalcBackGroundMove(2000,2000);

  BackGroundIntervalX();

  BackGroundIntervalY();

  return flag;
}

int BaseStage::LoadBirdWatch(std::string folder,std::string name,
			     int waitModal,int endModal,
			     int changeFlag,int value){
  int flag=0;
  int crowdFlag=0;
  int landFlag=0;
  int modalFlag=0;
  int stageFlag=0;
  int tWidth0,tHeight0,tRotate0,tFlip0;

  crowdFlag=LoadCrowd(folder,name);
  if(crowdFlag!=0){
    std::cout<<"ERROR LOAD CROWD"<<std::endl;
    flag=1;
  }
  else{
    std::cout<<"SUCCESS LOAD CROWD"<<std::endl;
  }

  landFlag=LoadLand(folder,name);
  if(landFlag!=0){
    std::cout<<"ERROR LOAD LAND"<<std::endl;
    flag=1;
  }
  else{
    std::cout<<"SUCCESS LOAD LAND"<<std::endl;
  }

  modalFlag=LoadModal(folder,name);
  if(modalFlag!=0){
    std::cout<<"ERROR LOAD MODAL"<<std::endl;
    flag=1;
  }
  else{
    std::cout<<"SUCCESS LOAD MODAL"<<std::endl;
  }

  if(changeFlag==STAGE_CHANGE_STATE){
    SetChangeModal(waitModal,MODAL_TYPE_WSTATE,value);
    SetChangeModal(endModal,MODAL_TYPE_CHSTATE,value);
  }
  else if(changeFlag==STAGE_CHANGE_TYPE){
    SetChangeModal(waitModal,MODAL_TYPE_WMAP,value);
    SetChangeModal(endModal,MODAL_TYPE_CHMAP,value);
  }

  stageFlag=LoadStage(folder,name,&tWidth0,&tHeight0,
		      &tRotate0,&tFlip0);
  if(stageFlag!=0){
    std::cout<<"ERROR LOAD STAGE"<<std::endl;
    flag=1;
  }
  else{
    std::cout<<"SUCCESS LOAD STAGE"<<std::endl;
  }

  if(flag==0){
    if(CalcStageDistance()!=0){
      std::cout<<"ERROR CALC STAGE"<<std::endl;
    }
    else{
      std::cout<<"SUCCESS CALC STAGE"<<std::endl;
    }

    if(LoadBackGround(bgPath)==0){
      std::cout<<"LOAD BACKGROUND"<<std::endl;
      FigureBackGround(tWidth0,tHeight0,tRotate0,tFlip0);
    }
    else{
      std::cout<<"ERROR BACKGROUND"<<std::endl;
      flag=2;
    }
  }

  CalcBackGroundMove(2000,2000);

  BackGroundIntervalX();

  BackGroundIntervalY();

  return flag;
}

void BaseStage::RunBackGround(){
  if(background){
    frame->draw_pixbuf
      (mGC,background,bgPW,bgPH,0,0,WIDTH,HEIGHT,
       Gdk::RGB_DITHER_NONE,0,0);
  }
  else{
    frame->draw_rectangle(backGC,true,0,0,WIDTH,HEIGHT);
  }
}

void BaseStage::BGMoveEllipse(int spX,int spY,int powX,int powY){
  int cx,cy;
  int sx,sy;

  cx=(background->get_width()-WIDTH)/2;
  cy=(background->get_height()-HEIGHT)/2;
  
  sx=bgPW;
  sy=bgPH;
  DistApprox(&sx,&sy,cx,cy,10);

  bgMX-=sx;
  bgMY-=sy;
  
  if(abs(bgMX)<spX){
    Map->speedX=bgMX;
    bgPW-=Map->speedX*powX;
  }
  else{
    if(bgMX>=0){
      Map->speedX=spX;
    }
    else{
      Map->speedX=spX*-1;
    }
    bgPW-=Map->speedX*powX;
  }

  if(abs(bgMY)<spY){
    Map->speedY=bgMY;
    bgPH-=Map->speedY*powY;
  }
  else{
    if(bgMY>=0){
      Map->speedY=spY;
    }
    else{
      Map->speedY=spY*-1;
    }
    bgPH-=Map->speedY*powY;
  }

  if(bgPW<0){
    bgPW=0;
  }
  else if(bgPW>background->get_width()-WIDTH){
    bgPW=background->get_width()-WIDTH;
  }

  if(bgPH<0){
    bgPH=0;
  }
  else if(bgPH>background->get_height()-HEIGHT){
    bgPH=background->get_height()-HEIGHT;
  }
}

void BaseStage::BGMoveReverse(int spX,int spY){

  bgPX-=Map->speedX;
  bgPY-=Map->speedY;

  if(bgPX>bgMaxX){
    Map->speedX=spX;
    bgPX=bgMaxX;
  }
  else if(bgPX<0){
    Map->speedX=spX*-1;
    bgPX=0;
  }

  if(bgPY>bgMaxY){
    Map->speedY=spY;
    bgPY=bgMaxY;
  }
  else if(bgPY<0){
    Map->speedY=spY*-1;
    bgPY=0;
  }

  bgPW=bgPX*bgMovW/STAGE_BG_MOV_POWX;
  bgPH=bgPY*bgMovH/STAGE_BG_MOV_POWY;  
}

void BaseStage::BGMoveReverse(int spX,int spY,int LenX,int LenY){
  int powX,powY;
  int dW,dH;

  dW=bgWidth-WIDTH;
  dH=bgHeight-HEIGHT;

  bgPW-=Map->speedX*dW/LenX;
  bgPH-=Map->speedY*dH/LenY;
  
  if(bgPW<0){
    bgPW=0;
    Map->speedX=spX*-1;
  }
  else if(bgPW>dW){
    bgPW=dW;
    Map->speedX=spX;
  }
  
  if(bgPH<0){
    bgPH=0;
    Map->speedY=spY*-1;
  }
  else if(bgPH>dH){
    bgPH=dH;
    Map->speedY=spY;
  }
}

void BaseStage::BossBGMoveSet(int maxX,int maxY){
  bgMaxX=maxX;
  bgMaxY=maxY;

  CalcBackGroundMove(10000,10000);

  if(bgPW>0){
    bgPX=bgPW*STAGE_BG_MOV_POWX/bgMovW;
  }
  else{
    bgPX=0;
  }

  if(bgPH>0){
    bgPY=bgPH*STAGE_BG_MOV_POWY/bgMovH;
  }
  else{
    bgPY=0;
  }
}

void BaseStage::BossModal(int spX,int spY,int powX,int powY){

  bgPW-=Map->speedX*powX;
  bgPH-=Map->speedY*powY;

  if(bgPW<0){
    bgPW=0;
    Map->speedX=spX*-1;
  }
  else if(bgPW>background->get_width()-WIDTH){
    bgPW=background->get_width()-WIDTH;
    Map->speedX=spX;
  }

  if(bgPH<0){
    bgPH=0;
    Map->speedY=spY*-1;
  }
  else if(bgPH>background->get_height()-HEIGHT){
    bgPH=background->get_height()-HEIGHT;
    Map->speedY=spY;
  }
}
