#ifndef BIRD_BASE_STAGE_H_
#define BIRD_BASE_STAGE_H_

#include "basemap.h"
#include <fstream>

#define STAGE_CROWD_MAX 1000
#define STAGE_LAND_MAX 1000
#define STAGE_MODAL_MAX 1000
#define STAGE_TIMELINE_MAX 10000

#define WIDTH_RATE 1000
#define HEIGHT_RATE 1000

#define STAGE_ID_LIFEPOW 3
#define STAGE_ID_FIREPOW 4
#define STAGE_ID_FORMPOW 5

#define MODAL_CROWD_MAX 10
#define MODAL_CROWD_FREQ 1000

#define MODAL_LAND_MAX 10
#define MODAL_LAND_FREQ 1000
#define MODAL_LAND_U 1000
#define MODAL_LAND_D 1000
#define MODAL_LAND_L 1000
#define MODAL_LAND_R 1000
#define MODAL_LAND_PX 1000
#define MODAL_LAND_PY 1000

#define STAGE_CHANGE_STATE 0
#define STAGE_CHANGE_TYPE 1
#define STAGE_CHANGE_NUM 2

#define STAGE_FLIPLIFE_MAX 10000

#define STAGE_STATUSVIEW_DEAD 0
#define STAGE_STATUSVIEW_LIFE 1
#define STAGE_STATUSVIEW_NUM 2

#define STAGE_PAUSEMENU_PX1 425
#define STAGE_PAUSEMENU_PY1 480
#define STAGE_PAUSEMENU_MX1 0
#define STAGE_PAUSEMENU_MY1 60
#define STAGE_PAUSEMENU_SX1 0
#define STAGE_PAUSEMENU_SY1 0
#define STAGE_PAUSEMENU_SF1 12
#define STAGE_PAUSEMENU_LF1 FONT_LINE_LEFT
#define STAGE_PAUSEMENU_TF1 FONT_SERIF
#define STAGE_PAUSEMENU_FF1 FONT_FACE_BOLD

#define STAGE_PAUSEMENU_CONTINUE 0
#define STAGE_PAUSEMENU_SAVE 1
#define STAGE_PAUSEMENU_EXIT 2
#define STAGE_PAUSEMENU_NUM 3

#define STAGE_GAMESTATUS_PX1 70
#define STAGE_GAMESTATUS_PY1 0
#define STAGE_GAMESTATUS_MX1 170
#define STAGE_GAMESTATUS_MY1 0
#define STAGE_GAMESTATUS_SX1 0
#define STAGE_GAMESTATUS_SY1 0
#define STAGE_GAMESTATUS_SF1 10
#define STAGE_GAMESTATUS_LF1 FONT_LINE_UPCENTER
#define STAGE_GAMESTATUS_TF1 FONT_SERIF
#define STAGE_GAMESTATUS_FF1 FONT_FACE_BOLD

#define STAGE_GAMESTATUS_SEC 0
#define STAGE_GAMESTATUS_SCORE 1
#define STAGE_GAMESTATUS_FIRE 2
#define STAGE_GAMESTATUS_FORM 3
#define STAGE_GAMESTATUS_MODE 4
#define STAGE_GAMESTATUS_DEAD 5
#define STAGE_GAMESTATUS_NUM 6

#define CROWD_WAY_F 0
#define CROWD_WAY_B 1
#define CROWD_WAY_NUM 2

#define CROWD_TYPE_NO 0
#define CROWD_TYPE_STRBIRD 1
#define CROWD_TYPE_TARBIRD 2
#define CROWD_TYPE_REVBIRD 3
#define CROWD_TYPE_HOMBIRD 4
#define CROWD_TYPE_SMALLBAT 5
#define CROWD_TYPE_BIGBAT 6
#define CROWD_TYPE_SMALLSPHENICS 7
#define CROWD_TYPE_WIDESPHENICS 8
#define CROWD_TYPE_JUMPGALLUS 9
#define CROWD_TYPE_RUNSTRUTHIO 10
#define CROWD_TYPE_SMALLCROSSSTRIX 11
#define CROWD_TYPE_SMALLXREVSTRIX 12
#define CROWD_TYPE_HOMEAGLE 13
#define CROWD_TYPE_LINEHOMEAGLE 14
#define CROWD_TYPE_NUM 15
#define CROWD_NUM CROWD_WAY_NUM*CROWD_TYPE_NUM

#define MODAL_LAND_TYPE_NO 0
#define MODAL_LAND_TYPE_L 1
#define MODAL_LAND_TYPE_R 2
#define MODAL_LAND_TYPE_U 3
#define MODAL_LAND_TYPE_D 4
#define MODAL_LAND_TYPE_NUM 5

#define MODAL_TYPE_SEL 0
#define MODAL_TYPE_WMAP 1
#define MODAL_TYPE_WSTATE 2
#define MODAL_TYPE_CHMAP 3
#define MODAL_TYPE_CHSTATE 4
#define MODAL_TYPE_NUM 5

#define CREATE_SAVE_CROWD_NUM 6
#define CREATE_SAVE_LAND_NUM 16
#define CREATE_SAVE_MODAL_NUM 29

#define CREATE_SAVE_STAGE_DATA_NO 0
#define CREATE_SAVE_STAGE_DATA_NAME 1
#define CREATE_SAVE_STAGE_DATA_TIMELINE 2
#define CREATE_SAVE_STAGE_DATA_FILE 3
#define CREATE_SAVE_STAGE_DATA_NUM 4

#define CREATE_SAVE_STAGE_STATE_NUM 4
#define CREATE_SAVE_STAGE_BG_NUM 7
#define CREATE_SAVE_STAGE_TIMELINE_NUM 2
#define CREATE_SAVE_STAGE_FILE_NUM 4


#define STAGE_BG_MOV_MAXW 2000
#define STAGE_BG_MOV_MAXH 2000

#define STAGE_BG_MOV_POWX 1000
#define STAGE_BG_MOV_POWY 1000

#define STAGE_BG_ROTATE0 0
#define STAGE_BG_ROTATE90 1
#define STAGE_BG_ROTATE180 2
#define STAGE_BG_ROTATE270 3
#define STAGE_BG_ROTATE_NUM 4

#define STAGE_BG_NOFLIP 0
#define STAGE_BG_HFLIP 1
#define STAGE_BG_VFLIP 2
#define STAGE_BG_FLIP_NUM 3

class StageCrowd{
 public:
  int type;
  int minW;
  int maxW;
  int minH;
  int maxH;
  StageCrowd(){
    type=0;
    minW=1102;
    maxW=1103;
    minH=0;
    maxH=1000;
  }
};

class StageLand{
 public:
  int minPX;
  int maxPX;
  int minPY;
  int maxPY;
  int minL;
  int maxL;
  int minR;
  int maxR;
  int minU;
  int maxU;
  int minD;
  int maxD;
  int color;
  int type;
  int freq;
  StageLand(){
    minPX=1000;
    maxPX=1020;
    minPY=1000;
    maxPY=1020;
    minL=10;
    maxL=500;
    minR=10;
    maxR=500;
    minU=10;
    maxU=500;
    minD=10;
    maxD=500;
    type=0;
    color=0;
    freq=300;
  }
};

class StageModal{
 public:
  int speedX;
  int speedY;
  int minW;
  int maxW;
  int minH;
  int maxH;
  int nLand;
  int crowdFreq;
  int type;
  int value;
  int indexCrowd[MODAL_CROWD_MAX];
  int indexLand[MODAL_LAND_MAX];
  StageModal(){
    int i;
    speedX=-1;
    speedY=0;
    minW=-100;
    maxW=1100;
    minH=-100;
    maxH=1100;
    nLand=1;
    type=0;
    value=0;
    crowdFreq=100;
    i=0;
    while(i<MODAL_CROWD_MAX){
      indexCrowd[i]=0;
      i++;
    }
    i=0;
    while(i<MODAL_LAND_MAX){
      indexLand[i]=0;
      i++;
    }
  }
  void CrowdInit(){
    int i=0;
    while(i<MODAL_CROWD_MAX){
      indexCrowd[i]=0;
      i++;
    }
  }
  void LandInit(){
    int i=0;
    while(i<MODAL_LAND_MAX){
      indexLand[i]=0;
      i++;
    }
  }
};

class BaseStage : public BaseMap{
 public:
  Gdk::Color *(modeColor[PLAYER_MODE_NUM]);
  Gdk::Color *(fireColor[PF_TYPE_NUM]);
  Gdk::Color *(formColor[PLAYER_FORM_NUM]);
  Glib::RefPtr<Gdk::GC> backGC;
  Glib::RefPtr<Gdk::GC> blackGC;
  Glib::RefPtr<Gdk::GC> modeLimitGC[PLAYER_MODE_NUM];
  int timeLine[STAGE_TIMELINE_MAX+1];
  int crowdStyle[CROWD_TYPE_NUM];
  int crowdSeq[CROWD_TYPE_NUM];
  std::string stageName;
  int initLife;
  int initFire;
  int initForm;
  StageModal mModal[STAGE_MODAL_MAX];
  StageLand mLand[STAGE_LAND_MAX];
  StageCrowd mCrowd[STAGE_CROWD_MAX];
  std::string bgPath;
  int endLine;
  int bgPX;
  int bgPY;
  int bgPW;
  int bgPH;
  int bgMX;
  int bgMY;
  int bgCount;
  int bgInterX;
  int bgInterY;
  int bgStartX;
  int bgStartY;
  int bgMinX;
  int bgMaxX;
  int bgMinY;
  int bgMaxY;
  int bgMovW;
  int bgMovH;
  int bgWidth;
  int bgHeight;
  int bgRotate;
  int bgFlip;
  int bgBoss;
  Glib::RefPtr<Gdk::Pixbuf> background;
  Glib::RefPtr<Gdk::Pixbuf> tBuf;
  BaseStage();
  ~BaseStage();
  void StageCreate();

  int CalcStageID();
  std::string GetName(std::string name0);
  void ModeLimitView();
  void PlayerModeView(int px,int py,int line,int size,int type,int face);
  void PlayerFireView(int px,int py,int line,int size,int type,int face);
  void PlayerFormView(int px,int py,int line,int size,int type,int face);

  void GameMeasureView(int speedX,int speedY);
  void GameStatusView(int statusFlag);

  void PauseContinueSelect(int changeFlag,int value);
  void PauseSaveSelect(int changeFlag,int value);
  void PauseExitSelect(int changeFlag,int value);
  static void(BaseStage::*STAGE_PAUSEMENU_SELECT[STAGE_PAUSEMENU_NUM])
    (int changeFlag,int value);

  void PauseMenuView(int *valueY0,int changeFlag,int value);

  void NoCrowd(int minW,int maxW,int minH,int maxH);

  void StrBird(int minW,int maxW,int minH,int maxH);
  void BackStrBird(int minW,int maxW,int minH,int maxH);
  void TarBird(int minW,int maxW,int minH,int maxH);
  void RevBird(int minW,int maxW,int minH,int maxH);
  void BackRevBird(int minW,int maxW,int minH,int maxH);
  void HomBird(int minW,int maxW,int minH,int maxH);
  
  void SmallSphenics(int minW,int maxW,int minH,int maxH);
  void WideSphenics(int minW,int maxW,int minH,int maxH);

  void RunStruthio(int minW,int maxW,int minH,int maxH);
  void BackRunStruthio(int minW,int maxW,int minH,int maxH);

  void JumpGallus(int minW,int maxW,int minH,int maxH);
  void BackJumpGallus(int minW,int maxW,int minH,int maxH);

  void SmallBat(int minW,int maxW,int minH,int maxH);
  void BackSmallBat(int minW,int maxW,int minH,int maxH);
  void BigBat(int minW,int maxW,int minH,int maxH);
  void BackBigBat(int minW,int maxW,int minH,int maxH);

  void SmallCrossStrix(int minW,int maxW,int minH,int maxH);
  void BackSmallCrossStrix(int minW,int maxW,int minH,int maxH);
  void SmallXRevStrix(int minW,int maxW,int minH,int maxH);
  void BackSmallXRevStrix(int minW,int maxW,int minH,int maxH);

  void HomEagle(int minW,int maxW,int minH,int maxH);
  void LineHomEagle(int minW,int maxW,int minH,int maxH);

  void NoLand(StageLand *land,int modalIndex);
  void LeftScrLand(StageLand *land,int modalIndex);
  void RightScrLand(StageLand *land,int modalIndex);
  void UpScrLand(StageLand *land,int modalIndex);
  void DownScrLand(StageLand *land,int modalIndex);

  void SelectCrowd(int type);
  void CrowdModal(int index);
  void LandModal(StageModal *modal,int moddalIndex);

  void SelectModal(StageModal *modal,int moddalIndex);
  void ChangeMap(StageModal *modal,int moddalIndex);
  void ChangeState(StageModal *modal,int moddalIndex);
  void WaitMap(StageModal *modal,int moddalIndex);
  void WaitState(StageModal *modal,int moddalIndex);

  void ModalTypeSelect(int nSec0);

  void SetChangeModal(int num0,int type0,int value0);

  void SaveCrowd(std::string folder,std::string name);
  void SaveLand(std::string folder,std::string name);
  void SaveModal(std::string folder,std::string name);
  void SaveStage(std::string folder,std::string name);

  int LoadCrowd(std::string folder,std::string name);
  int LoadLand(std::string folder,std::string name);
  int LoadModal(std::string folder,std::string name);
  int LoadStage(std::string folder,std::string name,
		int *width0,int *height0,
		int *rotate0,int *flip0);

  int LoadBackGround(std::string path);

  void ScaleRotate0(Glib::RefPtr<Gdk::Pixbuf> pixBuf0);
  void ScaleRotate90(Glib::RefPtr<Gdk::Pixbuf> pixBuf0);
  void ScaleRotate180(Glib::RefPtr<Gdk::Pixbuf> pixBuf0);
  void ScaleRotate270(Glib::RefPtr<Gdk::Pixbuf> pixBuf0);

  static void(BaseStage::*CREATE_STAGE_ROTATE_SELECT
	      [STAGE_BG_ROTATE_NUM])(Glib::RefPtr<Gdk::Pixbuf> pixBuf0);

  int RotateBackGround(Glib::RefPtr<Gdk::Pixbuf> pixBuf0,int rotate0);
  int FlipBackGround(Glib::RefPtr<Gdk::Pixbuf> pixBuf0,int flip0);
  int ScaleBackGround(Glib::RefPtr<Gdk::Pixbuf> pixBuf0,
		      int width0,int height0);

  int FigureBackGround(int width0,int height0,int rotate0,int flip0);

  int CalcStageDistance();
  int CalcStageDistancePoint(int point,int &pointX,int &pointY);
  int CalcBackGroundMove(int maxW,int maxH);

  void BackGroundIntervalX();
  void BackGroundIntervalY();

  int LoadBirdWatch(std::string folder,std::string name);
  int LoadBirdWatch(std::string folder,std::string name,
		    int waitModal,int endModal,
		    int changeFlag,int value);

  void RunBackGround();

  void BGMoveReverse(int spX,int spY);
  void BGMoveReverse(int spX,int spY,int powX,int powY);
  void BGMoveEllipse(int spX,int spY,int LenX,int LenY);

  void BossBGMoveSet(int MaxX,int MaxY);

  void BossModal(int spX,int spY,int powX,int powY);

};

#endif
