#include "bossbase.h"

BossBase::BossBase(){
  int i;
  double a;

  a=M_PI/180;
  i=0;
  while(i<ANGLE_MAX){
    SIN[i]=(int)((double)(sin(a*i))*ANGLE_FLOAT);
    COS[i]=(int)((double)(cos(a*i))*ANGLE_FLOAT);
    /*
    std::cout<<i<<":"<<" SIN :"<<SIN[i]
	     <<" COS :"<<COS[i]<<std::endl;
    */
    i++;
  }

  bossMode=0;
  bossState=0;
  bossMove=0;
  bossAngle=0;
  bossAttack=0;
  bossAttackFreq=0;
  bossTarX=0;
  bossTarY=0;
  bossATarY=0;
  bossATarY=0;
  bossMoveCount=0;
  bossAngleCount=0;
  bossAttackCount=0;
  boss=NULL;
  
}

BossBase::~BossBase(){

}

void BossBase::BaseCreate(BaseStage *baseStage0,
		      Glib::RefPtr<Gdk::Window> mWindow0,
		      Glib::RefPtr<Gdk::Pixmap> frame0){
  
  baseStage=baseStage0;
  frame=frame0;
  mWindow=mWindow0;
  
  Map=baseStage->Map;

  text=baseStage->text;
  control=baseStage->control;
  color=baseStage->color;

  pfireList=baseStage->pfireList;
  efireList=baseStage->efireList;
  enemyList=baseStage->enemyList;
  landList=baseStage->landList; 
  player=baseStage->player;

  blueGC=Gdk::GC::create(mWindow0);
  blueGC->set_rgb_fg_color(*(color->blue));
  yellowGC=Gdk::GC::create(mWindow0);
  yellowGC->set_rgb_fg_color(*(color->yellow));
  redGC=Gdk::GC::create(mWindow0);
  redGC->set_rgb_fg_color(*(color->red));
  orangeGC=Gdk::GC::create(mWindow0);
  orangeGC->set_rgb_fg_color(*(color->orange));
  lifeColorGC=Gdk::GC::create(mWindow0);
  lifeColorGC->set_rgb_fg_color(*(color->red));
}

void BossBase::LifeView(int life,int maxLife){
  int lifeValue;
  int px0,py0;

  lifeValue=life*100/maxLife;
  px0=WIDTH*5/6-8;
  py0=HEIGHT*19/20+5;

  text->DrawString
    ("BOSS",(color->white),px0,py0,FONT_LINE_RIGHT,10,
     FONT_SERIF,FONT_FACE_BOLD);

  frame->draw_rectangle(baseStage->blackGC,true,
			WIDTH*5/6-4,HEIGHT*19/20-4,
			107,17);
  frame->draw_rectangle(lifeColorGC,true,
			WIDTH*5/6+100-lifeValue,HEIGHT*19/20,
			lifeValue,10);
}

int BossBase::ReachPoint(BirdActor *act,int tx,int ty){
  int flag=0;

  if((tx>act->px-act->width/2)&&(tx<act->px+act->width/2)){
    if((ty>act->py-act->height/2)&&(ty<act->py+act->height/2)){
      flag=1;
    }
  }

  return flag;
}

int BossBase::CompareFigR(int sx,int sy,BirdPoint p1,BirdPoint p2){
  int flag=0;
  int dx,dy,ay,cy;
  int tdy,tsy,ty1,ty2;

  dx=p2.x-p1.x;
  dy=p2.y-p1.y;

  if(dx==0){
    if(dy>0){
      flag=(sx<p1.x);
    }
    else{
      flag=(sx>p1.x);
    }
  }
  else if(dy==0){
    if(dx>0){
      flag=(sy>p1.y);
    }
    else{
      flag=(sy<p1.y);
    }
  }
  else{
    tdy=dy*MATH_FLOAT;
    tsy=sy*MATH_FLOAT;
    ty1=p1.y*MATH_FLOAT;
    ty2=p2.y*MATH_FLOAT;

    cy=(tdy/dx)*(sx-p1.x)+ty1;

    if(dx>0){
      flag=(tsy>cy);
    }
    else{
      flag=(tsy<cy);
    }
  }
  return flag;
}

int BossBase::FigureRange(int sx,int sy,BirdPoint *point,int n){
  int i;
  int flag=0;

  i=0;
  while(i<n){
    
    flag=CompareFigR(sx,sy,*(point+(i%n)),*(point+(i+1)%n));
    /*
    std::cout<<"["<<i<<"]: "
	     <<"("<<(point+(i%n))->x<<","<<(point+(i%n))->y<<")"
	     <<"("<<(point+((i+1)%n))->x<<","<<(point+((i+1)%n))->y
	     <<")"
	     <<std::endl;
    */
    if(!flag){
      return 0;
    }

    i++;
  }
  
  return flag;
}

void BossBase::TouchPlayer(){

  if(boss->px<player->px){
    player->px+=20;
  }
  else{
    player->px-=20;
  }

  if(boss->py<player->py){
    player->py+=20;
  }
  else{
    player->py-=20;
  }

  if(player->dcount>0){
    
  }
  else{
    player->dcount=PLAYER_T_DMG;
  }
}

