#ifndef BIRD_BOSS_CROWD_H_
#define BIRD_BOSS_CROWD_H_

#include <gtkmm.h>
#include "bossbase.h"

#define BOSS_CROWD_BIRD_FREQ 1000
#define BOSS_CROWD_ATTACK_THROW_FREQ 1000

#define BOSS_CROWD_MODE_VEASY 0
#define BOSS_CROWD_MODE_EASY 1
#define BOSS_CROWD_MODE_NORMAL 2
#define BOSS_CROWD_MODE_HARD 3
#define BOSS_CROWD_MODE_VHARD 4
#define BOSS_CROWD_MODE_NUM 5

#define BOSS_CROWD_STATE_START 0
#define BOSS_CROWD_STATE_ACTION 1
#define BOSS_CROWD_STATE_DEAD 2
#define BOSS_CROWD_STATE_NUM 3

/*
  VEASY
*/

#define BOSS_CROWD_VEASY_FORM_CHANGE 0
#define BOSS_CROWD_VEASY_FORM_FLOCK 1
#define BOSS_CROWD_VEASY_FORM_STRAIGHT 2
#define BOSS_CROWD_VEASY_FORM_NUM 3

#define BOSS_CROWD_VEASY_FIRE_CHANGE 0
#define BOSS_CROWD_VEASY_FIRE_NO 1
#define BOSS_CROWD_VEASY_FIRE_TARGET 2
#define BOSS_CROWD_VEASY_FIRE_NUM 3

#define BOSS_CROWD_VEASY_MOV_CHANGE 0
#define BOSS_CROWD_VEASY_MOV_STOP 1
#define BOSS_CROWD_VEASY_MOV_TARGET 2
#define BOSS_CROWD_VEASY_MOV_HOMING 3
#define BOSS_CROWD_VEASY_MOV_RAPID 4
#define BOSS_CROWD_VEASY_MOV_NUM 5

/*
  EASY
*/

#define BOSS_CROWD_EASY_FORM_CHANGE 0
#define BOSS_CROWD_EASY_FORM_FLOCK 1
#define BOSS_CROWD_EASY_FORM_STRAIGHT 2
#define BOSS_CROWD_EASY_FORM_NUM 3

#define BOSS_CROWD_EASY_FIRE_CHANGE 0
#define BOSS_CROWD_EASY_FIRE_NO 1
#define BOSS_CROWD_EASY_FIRE_TARGET 2
#define BOSS_CROWD_EASY_FIRE_NUM 3

#define BOSS_CROWD_EASY_MOV_CHANGE 0
#define BOSS_CROWD_EASY_MOV_STOP 1
#define BOSS_CROWD_EASY_MOV_TARGET 2
#define BOSS_CROWD_EASY_MOV_HOMING 3
#define BOSS_CROWD_EASY_MOV_RAPID 4
#define BOSS_CROWD_EASY_MOV_NUM 5

/*
  NORMAL
*/

#define BOSS_CROWD_NORMAL_FORM_CHANGE 0
#define BOSS_CROWD_NORMAL_FORM_FLOCK 1
#define BOSS_CROWD_NORMAL_FORM_STRAIGHT 2
#define BOSS_CROWD_NORMAL_FORM_NUM 4

#define BOSS_CROWD_NORMAL_FIRE_CHANGE 0
#define BOSS_CROWD_NORMAL_FIRE_NO 1
#define BOSS_CROWD_NORMAL_FIRE_TARGET 2
#define BOSS_CROWD_NORMAL_FIRE_CROSS 3
#define BOSS_CROWD_NORMAL_FIRE_XREV 4
#define BOSS_CROWD_NORMAL_FIRE_NUM 5

#define BOSS_CROWD_NORMAL_MOV_CHANGE 0
#define BOSS_CROWD_NORMAL_MOV_STOP 1
#define BOSS_CROWD_NORMAL_MOV_TARGET 2
#define BOSS_CROWD_NORMAL_MOV_HOMING 3
#define BOSS_CROWD_NORMAL_MOV_RAPID 4
#define BOSS_CROWD_NORMAL_MOV_NUM 5

/*
  HARD
*/

#define BOSS_CROWD_HARD_FORM_CHANGE 0
#define BOSS_CROWD_HARD_FORM_FLOCK 1
#define BOSS_CROWD_HARD_FORM_STRAIGHT 2
#define BOSS_CROWD_HARD_FORM_REVERSE 3
#define BOSS_CROWD_HARD_FORM_THROW 4
#define BOSS_CROWD_HARD_FORM_NUM 5

#define BOSS_CROWD_HARD_FIRE_CHANGE 0
#define BOSS_CROWD_HARD_FIRE_NO 1
#define BOSS_CROWD_HARD_FIRE_TARGET 2
#define BOSS_CROWD_HARD_FIRE_NUM 5

#define BOSS_CROWD_HARD_MOV_CHANGE 0
#define BOSS_CROWD_HARD_MOV_STOP 1
#define BOSS_CROWD_HARD_MOV_TARGET 2
#define BOSS_CROWD_HARD_MOV_HOMING 3
#define BOSS_CROWD_HARD_MOV_RAPID 4
#define BOSS_CROWD_HARD_MOV_NUM 5

/*
  VHARD
*/

#define BOSS_CROWD_VHARD_FORM_CHANGE 0
#define BOSS_CROWD_VHARD_FORM_FLOCK 1
#define BOSS_CROWD_VHARD_FORM_STRAIGHT 2
#define BOSS_CROWD_VHARD_FORM_REVERSE 3
#define BOSS_CROWD_VHARD_FORM_THROW 4
#define BOSS_CROWD_VHARD_FORM_NUM 5

#define BOSS_CROWD_VHARD_FIRE_CHANGE 0
#define BOSS_CROWD_VHARD_FIRE_NO 1
#define BOSS_CROWD_VHARD_FIRE_TARGET 2
#define BOSS_CROWD_VHARD_FIRE_CROSS 3
#define BOSS_CROWD_VHARD_FIRE_XREV 4
#define BOSS_CROWD_VHARD_FIRE_NUM 5

#define BOSS_CROWD_VHARD_MOV_CHANGE 0
#define BOSS_CROWD_VHARD_MOV_STOP 1
#define BOSS_CROWD_VHARD_MOV_TARGET 2
#define BOSS_CROWD_VHARD_MOV_HOMING 3
#define BOSS_CROWD_VHARD_MOV_RAPID 4
#define BOSS_CROWD_VHARD_MOV_NUM 5

class BossCrowd : public BossBase{
 public:
  int tIndex;
  int lifeList[BOSS_CROWD_MODE_NUM];
  int formChange[BOSS_CROWD_MODE_NUM];
  int fireChange[BOSS_CROWD_MODE_NUM];
  int moveChange[BOSS_CROWD_MODE_NUM];
  int formFlock[BOSS_CROWD_MODE_NUM];
  BossCrowd();
  ~BossCrowd();
  void Create();

  void AddBirdVEasy(int px0,int py0);
  void AddBirdEasy(int px0,int py0);
  void AddBirdNormal(int px0,int py0);
  void AddBirdHard(int px0,int py0);
  void AddBirdVHard(int px0,int py0);
  static void(BossCrowd::*BOSS_CROWD_ADDBIRD_SELECT[BOSS_CROWD_MODE_NUM])
    (int px0,int py0);

  BirdActor *NextThrow(BirdActor *target,int flag);

  void NoFire(int *enemyCount0);
  void TargetFire(int *enemyCount0);
  void CrossFire(int *enemyCount0);
  void XRevFire(int *enemyCount0);

  void FlockForm(int *enemyCount0);
  void StraightForm(int *enemyCount0);
  void ReverseForm(int *enemyCount0);
  void ThrowForm(int *enemyCount0);

  void StopMove(int *enemyCount0);
  void TargetMove(int *enemyCount0);
  void HomingMove(int *enemyCount0);
  void RapidMove(int *enemyCount0);
  
  int StartState(int bgBoss0,int mode0,int *enemyCount0);
  int ActionState(int bgBoss0,int mode0,int *enemyCount0);
  int DeadState(int bgBoss0,int mode0,int *enemyCount0);
  static int(BossCrowd::*BOSS_CROWD_STATE_SELECT[BOSS_CROWD_STATE_NUM])
    (int bgBoss0,int mode0,int *enemyCount0);

  int Act(int bgBoss0,int mode0,int *enemyCount0);

  int VEasyStart(int bgBoss0,int mode0,int *enemyCount0);
  int EasyStart(int bgBoss0,int mode0,int *enemyCount0);
  int NormalStart(int bgBoss0,int mode0,int *enemyCount0);
  int HardStart(int bgBoss0,int mode0,int *enemyCount0);
  int VHardStart(int bgBoss0,int mode0,int *enemyCount0);
  static int(BossCrowd::*BOSS_CROWD_START_SELECT[BOSS_CROWD_MODE_NUM])
    (int bgBoss0,int mode0,int *enemyCount0);

  void VEasyAction(int *enemyCount0);
  void EasyAction(int *enemyCount0);
  void NormalAction(int *enemyCount0);
  void HardAction(int *enemyCount0);
  void VHardAction(int *enemyCount0);
  static void(BossCrowd::*BOSS_CROWD_ACTION_SELECT[BOSS_CROWD_MODE_NUM])
    (int *enemyCount0);

  void VEasyFormChange(int *enemyCount0);
  static void(BossCrowd::*BOSS_CROWD_VEASY_FORM_SELECT
	      [BOSS_CROWD_VEASY_FORM_NUM])(int *enemyCount0);
  void VEasyFireChange(int *enemyCount0);
  static void(BossCrowd::*BOSS_CROWD_VEASY_FIRE_SELECT
	      [BOSS_CROWD_VEASY_FIRE_NUM])(int *enemyCount0);
  void VEasyMoveChange(int *enemyCount0);
  static void(BossCrowd::*BOSS_CROWD_VEASY_MOVE_SELECT
	      [BOSS_CROWD_VEASY_MOV_NUM])(int *enemyCount0);

  void EasyFormChange(int *enemyCount0);
  static void(BossCrowd::*BOSS_CROWD_EASY_FORM_SELECT
	      [BOSS_CROWD_EASY_FORM_NUM])(int *enemyCount0);
  void EasyFireChange(int *enemyCount0);
  static void(BossCrowd::*BOSS_CROWD_EASY_FIRE_SELECT
	      [BOSS_CROWD_EASY_FIRE_NUM])(int *enemyCount0);
  void EasyMoveChange(int *enemyCount0);
  static void(BossCrowd::*BOSS_CROWD_EASY_MOVE_SELECT
	      [BOSS_CROWD_EASY_MOV_NUM])(int *enemyCount0);

  void NormalFormChange(int *enemyCount0);
  static void(BossCrowd::*BOSS_CROWD_NORMAL_FORM_SELECT
	      [BOSS_CROWD_NORMAL_FORM_NUM])(int *enemyCount0);
  void NormalFireChange(int *enemyCount0);
  static void(BossCrowd::*BOSS_CROWD_NORMAL_FIRE_SELECT
	      [BOSS_CROWD_NORMAL_FIRE_NUM])(int *enemyCount0);
  void NormalMoveChange(int *enemyCount0);
  static void(BossCrowd::*BOSS_CROWD_NORMAL_MOVE_SELECT
	      [BOSS_CROWD_NORMAL_MOV_NUM])(int *enemyCount0);

  void HardFormChange(int *enemyCount0);
  static void(BossCrowd::*BOSS_CROWD_HARD_FORM_SELECT
	      [BOSS_CROWD_HARD_FORM_NUM])(int *enemyCount0);
  void HardFireChange(int *enemyCount0);
  static void(BossCrowd::*BOSS_CROWD_HARD_FIRE_SELECT
	      [BOSS_CROWD_HARD_FIRE_NUM])(int *enemyCount0);
  void HardMoveChange(int *enemyCount0);
  static void(BossCrowd::*BOSS_CROWD_HARD_MOVE_SELECT
	      [BOSS_CROWD_HARD_MOV_NUM])(int *enemyCount0);

  void VHardFormChange(int *enemyCount0);
  static void(BossCrowd::*BOSS_CROWD_VHARD_FORM_SELECT
	      [BOSS_CROWD_VHARD_FORM_NUM])(int *enemyCount0);
  void VHardFireChange(int *enemyCount0);
  static void(BossCrowd::*BOSS_CROWD_VHARD_FIRE_SELECT
	      [BOSS_CROWD_VHARD_FIRE_NUM])(int *enemyCount0);
  void VHardMoveChange(int *enemyCount0);
  static void(BossCrowd::*BOSS_CROWD_VHARD_MOVE_SELECT
	      [BOSS_CROWD_VHARD_MOV_NUM])(int *enemyCount0);
};

#endif
