#include "bosseagle.h"
#include "xpm/eagle.h"

BossEagle::BossEagle(){
  sprite[0].xpm=(char **)eagle_f1_xpm;
  sprite[1].xpm=(char **)eagle_b1_xpm;
  sprite[2].xpm=(char **)eagle_fE1_xpm;
  sprite[3].xpm=(char **)eagle_bE1_xpm;
  
  spriteBox= new SpriteBox(sprite,1,4);
  spriteBox->SetSprite(128,128);

  lifeList[BOSS_EAGLE_MODE_VEASY]=500;
  lifeList[BOSS_EAGLE_MODE_EASY]=750;
  lifeList[BOSS_EAGLE_MODE_NORMAL]=750;
  lifeList[BOSS_EAGLE_MODE_HARD]=1000;
  lifeList[BOSS_EAGLE_MODE_VHARD]=1000;

  attackChange[BOSS_EAGLE_MODE_VEASY]=BOSS_EAGLE_VEASY_ATTACK_CHANGE;
  attackChange[BOSS_EAGLE_MODE_EASY]=BOSS_EAGLE_EASY_ATTACK_CHANGE;
  attackChange[BOSS_EAGLE_MODE_NORMAL]
    =BOSS_EAGLE_NORMAL_ATTACK_CHANGE;
  attackChange[BOSS_EAGLE_MODE_HARD]=BOSS_EAGLE_HARD_ATTACK_CHANGE;
  attackChange[BOSS_EAGLE_MODE_VHARD]=BOSS_EAGLE_VHARD_ATTACK_CHANGE;

  moveChange[BOSS_EAGLE_MODE_VEASY]=BOSS_EAGLE_VEASY_MOV_CHANGE;
  moveChange[BOSS_EAGLE_MODE_EASY]=BOSS_EAGLE_EASY_MOV_CHANGE;
  moveChange[BOSS_EAGLE_MODE_NORMAL]
    =BOSS_EAGLE_NORMAL_MOV_CHANGE;
  moveChange[BOSS_EAGLE_MODE_HARD]=BOSS_EAGLE_HARD_MOV_CHANGE;
  moveChange[BOSS_EAGLE_MODE_VHARD]=BOSS_EAGLE_VHARD_MOV_CHANGE;
  
  moveAvoid[BOSS_EAGLE_MODE_VEASY]=BOSS_EAGLE_VEASY_MOV_AVOID;
  moveAvoid[BOSS_EAGLE_MODE_EASY]=BOSS_EAGLE_EASY_MOV_AVOID;
  moveAvoid[BOSS_EAGLE_MODE_NORMAL]
    =BOSS_EAGLE_NORMAL_MOV_AVOID;
  moveAvoid[BOSS_EAGLE_MODE_HARD]=BOSS_EAGLE_HARD_MOV_AVOID;
  moveAvoid[BOSS_EAGLE_MODE_VHARD]=BOSS_EAGLE_VHARD_MOV_AVOID; 
}

BossEagle::~BossEagle(){
  delete spriteBox;

  if(enemyList->first==boss){
    /*
    enemyList->Reject(boss);
    delete boss;
    */
  }
  else{
    if(boss){
      delete boss;
    }
  }
  boss=NULL;

}

void BossEagle::Create(){

}

int BossEagle::EnterScreen(BirdActor *act){
  int flag=0;
  if(act->px<WIDTH){
    if(act->px>0){
      if(act->py<HEIGHT){
	if(act->py>0){
	  flag=1;
	}
      }
    }
  }
  return flag;
}

void BossEagle::AcceBigFire(int mx0,int my0,int tx0,int ty0){
  BirdActor *act;

  act=efireList->Appear
    (boss->px,boss->py,16,16,mx0,my0,tx0,ty0,
     EF_HOM_BIG,EF_MOV_ACCE,
     EF_TOUCH_CH_NOSTR,EF_FORM_LR,-1);

  act->tmp=efireList->TwoDimensionSpace(act,player);
}

void BossEagle::AddStrBird(){
  if(Map->speedX<0){
    enemyList->Appear(-16,rand()%HEIGHT,16,8,
		      8+rand()%6,rand()%7-3,0,0,2,10,
		      EN_STR_BIRD,EN_MOV_STR,
		      EN_TOUCH_PAIN,0,
		      EN_FORM_TAR_SMALL,0,
		      EN_ITEMDROP_ALL,200);
  }
  else{
    enemyList->Appear(WIDTH+16,rand()%HEIGHT,16,8,
		      rand()%6-14,rand()%7-3,0,0,2,10,
		      EN_STR_BIRD,EN_MOV_STR,
		      EN_TOUCH_PAIN,0,
		      EN_FORM_TAR_SMALL,0,
		      EN_ITEMDROP_ALL,200);
  }
}
void BossEagle::AddRevBird(){
  if(Map->speedX<0){
    enemyList->Appear(WIDTH+16,rand()%HEIGHT,16,8,
		      rand()%4-6,14-rand()%29,0,0,2,10,
		      EN_REV_BIRD,EN_MOV_REV,
		      EN_TOUCH_REV,-1,
		      EN_FORM_TAR_SMALL,0,
		      EN_ITEMDROP_ALL,100);
  }
  else{
    enemyList->Appear(-16,rand()%HEIGHT,16,8,
		      6-rand()%4,14-rand()%29,0,0,2,10,
		      EN_REV_BIRD,EN_MOV_REV,
		      EN_TOUCH_REV,-1,
		      EN_FORM_TAR_SMALL,0,
		      EN_ITEMDROP_ALL,100);
  }
}
void BossEagle::AddAcceBird(){
  BirdActor *act;
  if(Map->speedX<0){
   act=enemyList->Appear(-16,rand()%HEIGHT,16,8,
		      (rand()%6),0,12+rand()%2,1,2,10,
		      EN_HOM_BIRD,EN_MOV_XYACCE,
		      EN_TOUCH_CH_NOSTR,-1,
		      EN_FORM_TAR_SMALL,0,
		      EN_ITEMDROP_ALL,100);
   act->target=player;
   act->tmp=enemyList->TwoDimensionSpace(act,player);
  }
  else{
    act=enemyList->Appear(WIDTH+16,rand()%HEIGHT,16,8,
		      (rand()%6)*-1,0,12+rand()%2,1,2,10,
		      EN_HOM_BIRD,EN_MOV_XYACCE,
		      EN_TOUCH_CH_NOSTR,-1,
		      EN_FORM_TAR_SMALL,0,
		      EN_ITEMDROP_ALL,100);
    act->target=player;
    act->tmp=enemyList->TwoDimensionSpace(act,player);
  }
}


void BossEagle::CallStrBird(){ 
  int max0,rest0;
  int i;

  max0=bossAttackFreq/BOSS_EAGLE_BIRD_FREQ;
  rest0=bossAttackFreq%BOSS_EAGLE_BIRD_FREQ;

  i=0;
  while(i<max0){
    AddStrBird();
    i++;
  }
  if((rand()%BOSS_EAGLE_BIRD_FREQ)<rest0){
    AddStrBird();
  }
  
  if(EnterScreen(boss)){
    bossAttack=attackChange[bossMode];
  }

  if(bossAttackCount>0){
    bossAttackCount--;
  }
  else{
    bossAttack=attackChange[bossMode];
  }
}
void BossEagle::CallRevBird(){ 
  int max0,rest0;
  int i;

  max0=bossAttackFreq/BOSS_EAGLE_BIRD_FREQ;
  rest0=bossAttackFreq%BOSS_EAGLE_BIRD_FREQ;

  i=0;
  while(i<max0){
    AddRevBird();
    i++;
  }
  if((rand()%BOSS_EAGLE_BIRD_FREQ)<rest0){
    AddRevBird();
  }
  
  if(EnterScreen(boss)){
    bossAttack=attackChange[bossMode];
  }

  if(bossAttackCount>0){
    bossAttackCount--;
  }
  else{
    bossAttack=attackChange[bossMode];
  }
}
void BossEagle::CallHomBird(){ 
  int max0,rest0;
  int i;

  max0=bossAttackFreq/BOSS_EAGLE_BIRD_FREQ;
  rest0=bossAttackFreq%BOSS_EAGLE_BIRD_FREQ;

  i=0;
  while(i<max0){
    AddAcceBird();
    i++;
  }
  if((rand()%BOSS_EAGLE_BIRD_FREQ)<rest0){
    AddAcceBird();
  }
  
  if(EnterScreen(boss)){
    bossAttack=attackChange[bossMode];
  }

  if(bossAttackCount>0){
    bossAttackCount--;
  }
  else{
    bossAttack=attackChange[bossMode];
  }
}
void BossEagle::CrossInFire(){
  if(bossCount>0){
    bossCount--;
  }
  else{
    if(EnterScreen(boss)){
      efireList->Appear
	(boss->px,boss->py,8,8,8,0,0,0,
	 EF_STR_SMALL,EF_MOV_STR,
	 EF_TOUCH_PAIN,EF_FORM_LR,0);
      efireList->Appear
	(boss->px,boss->py,8,8,-8,0,0,0,
	 EF_STR_SMALL,EF_MOV_STR,
	 EF_TOUCH_PAIN,EF_FORM_LR,0);
      efireList->Appear
	(boss->px,boss->py,8,8,0,8,0,0,
	 EF_STR_SMALL,EF_MOV_STR,
	 EF_TOUCH_PAIN,EF_FORM_UD,0);
      efireList->Appear
	(boss->px,boss->py,8,8,0,-8,0,0,
	 EF_STR_SMALL,EF_MOV_STR,
	 EF_TOUCH_PAIN,EF_FORM_UD,0);
      bossCount=bossAttackFreq;
    }
    else{
      if(bossMove==moveAvoid[bossMode]){
	bossAttack=attackChange[bossMode];
      }
    }
  }
  if(bossAttackCount>0){
    bossAttackCount--;
  }
  else{
    bossAttack=attackChange[bossMode];
  }
}
void BossEagle::XRevInFire(){
  if(bossCount>0){
    bossCount--;
  }
  else{
    if(EnterScreen(boss)){
      efireList->Appear(boss->px,boss->py,8,8,
			6,6,0,0,
			EF_REV_SMALL,EF_MOV_REV,
			EF_TOUCH_PAIN,EF_FORM_LR,4);
      efireList->Appear(boss->px,boss->py,8,8,
			-6,-6,0,0,
			EF_REV_SMALL,EF_MOV_REV,
			EF_TOUCH_PAIN,EF_FORM_LR,4);
      efireList->Appear(boss->px,boss->py,8,8,
			-6,6,0,0,
			EF_REV_SMALL,EF_MOV_REV,
			EF_TOUCH_PAIN,EF_FORM_LR,4);
      efireList->Appear(boss->px,boss->py,8,8,
			6,-6,0,0,
			EF_REV_SMALL,EF_MOV_REV,
			EF_TOUCH_PAIN,EF_FORM_LR,4);
      bossCount=bossAttackFreq;
    }
    else{
      if(bossMove==moveAvoid[bossMode]){
	bossAttack=attackChange[bossMode];
      }
    }
  }
  if(bossAttackCount>0){
    bossAttackCount--;
  }
  else{
    bossAttack=attackChange[bossMode];
  }
}
void BossEagle::ALLRevInFire(){
  BirdActor *act;
  if(bossCount>0){
    bossCount--;
  }
  else{
    if(EnterScreen(boss)){
      act=efireList->Appear
	(boss->px,boss->py,32,8,
	 -6,-6,0,0,
	 EF_REV_LINE,EF_MOV_ALLREV,
	 EF_TOUCH_BLOW,EF_FORM_LR,-1);
      act->tmp=EF_DIRECT_D;
      act=efireList->Appear
	(boss->px,boss->py,32,8,
	 6,-6,0,0,
	 EF_REV_LINE,EF_MOV_ALLREV,
	 EF_TOUCH_BLOW,EF_FORM_LR,-1);
      act->tmp=EF_DIRECT_D;
      act=efireList->Appear
	(boss->px,boss->py,32,8,
	 -6,6,0,0,
	 EF_REV_LINE,EF_MOV_ALLREV,
	 EF_TOUCH_BLOW,EF_FORM_LR,-1);
      act->tmp=EF_DIRECT_U;
      act=efireList->Appear
	(boss->px,boss->py,32,8,
	 6,6,0,0,
	 EF_REV_LINE,EF_MOV_ALLREV,
	 EF_TOUCH_BLOW,EF_FORM_LR,-1);
      act->tmp=EF_DIRECT_U;
      bossCount=bossAttackFreq;
    }
    else{
      if(bossMove==moveAvoid[bossMode]){
	bossAttack=attackChange[bossMode];
      }
    }
  }
  if(bossAttackCount>0){
    bossAttackCount--;
  }
  else{
    bossAttack=attackChange[bossMode];
  }
}
void BossEagle::AcceHomOutFire(){ 
  BirdActor *act;

  if(bossCount>0){
    bossCount--;
  }
  else{
    if(boss->direct==EN_WAY_F){
      act=efireList->Appear
	(boss->px,boss->py,16,16,
	 5-rand()%11,3-rand()%7,8,1,
	 EF_HOM_BIG,EF_MOV_ACCE,
	 EF_TOUCH_CH_NOSTR,EF_FORM_LR,-1);
      act->tmp=efireList->TwoDimensionSpace(act,player);
    }
    else if(boss->direct==EN_WAY_B){
      act=efireList->Appear
	(boss->px,boss->py,16,16,
	 5-rand()%11,3-rand()%7,8,1,
	 EF_HOM_BIG,EF_MOV_ACCE,
	 EF_TOUCH_CH_NOSTR,EF_FORM_LR,-1);
      act->tmp=efireList->TwoDimensionSpace(act,player);
    }

    bossCount=bossAttackFreq;
  }
 
  if(bossMove!=moveAvoid[bossMode]){
    bossAttack=attackChange[bossMode];
  }  
  
  if(bossAttackCount>0){
    bossAttackCount--;
  }
  else{
    bossAttack=attackChange[bossMode];
  }
}

void BossEagle::ReverseMove(){
  boss->px+=boss->mx;
  boss->py+=boss->my;

  if(boss->px<0){
    boss->px+=abs(boss->mx)*2+10;
    boss->mx=abs(boss->mx);
  }
  else if(boss->px>WIDTH){
    boss->mx=abs(boss->mx)*-1;
    boss->px+=abs(boss->mx)*-2-10;
  }
  if(boss->py<0){
    boss->my=abs(boss->my);
    boss->py+=abs(boss->my)*2+10;
  }
  else if(boss->py>HEIGHT){
    boss->my=abs(boss->my)*-1;
    boss->py+=abs(boss->my)*-2-10;
  }

  if(bossMoveCount>0){
    bossMoveCount--;
  }
  else{
    bossMove=moveChange[bossMode];
  }
}

void BossEagle::AcceHomingMove(){
  int sx,sy;
  sx=boss->px;
  sy=boss->py;
  
  DistApprox(&sx,&sy,player->px,player->py,boss->ty);
  
  boss->mx+=sx;
  boss->my+=sy;
  
  if(abs(boss->mx)>boss->tx){
    if(boss->mx>0){
      boss->mx=boss->tx;
    }
    else{
      boss->mx=boss->tx*-1;
    }
  }
  else{

  }

  if(abs(boss->my)>boss->tx){
    if(boss->my>0){
      boss->my=boss->tx;
    }
    else{
      boss->my=boss->tx*-1;
    }
  }
  else{

  }

  boss->px+=boss->mx;
  boss->py+=boss->my;

  if(bossMoveCount>0){
    bossMoveCount--;
  }
  else{
    bossMove=moveChange[bossMode];
  }
}

void BossEagle::AcceTargetMove(){
  int sx,sy;
  sx=boss->px;
  sy=boss->py;
  
  DistApprox(&sx,&sy,bossTarX,bossTarY,boss->ty);
  
  boss->mx+=sx;
  boss->my+=sy;
  
  if(abs(boss->mx)>boss->tx){
    if(boss->mx>0){
      boss->mx=boss->tx;
    }
    else{
      boss->mx=boss->tx*-1;
    }
  }
  else{

  }

  if(abs(boss->my)>boss->tx){
    if(boss->my>0){
      boss->my=boss->tx;
    }
    else{
      boss->my=boss->tx*-1;
    }
  }
  else{

  }

  boss->px+=boss->mx;
  boss->py+=boss->my;

  if(bossMoveCount>0){
    bossMoveCount--;
  }
  else{
    bossMove=moveChange[bossMode];
  }
}
void BossEagle::AvoidMove(){
  if(bossMoveCount>0){
    bossMoveCount--;
  }
  else{
    bossMove=moveChange[bossMode];
  }
}

void BossEagle::Draw(){
  BirdActor *node;
  BirdActor *tmp;

  node=pfireList->first;
  while(node){
    tmp=node->next;
    
    if(enemyList->ContactRect(boss,node)){
      pfireList->EnemyTouchSelect(node,boss,1);
      boss->dcount=5;
    }

    node=tmp;
  }

  if(boss->px>player->px){
    boss->direct=0;
  }
  else{
    boss->direct=1;
  }

  if(enemyList->ContactRect(boss,player)){
    TouchPlayer();
  }

  if(boss->dcount>0){
    boss->dcount--;
    spriteBox->DrawSprite
      (frame,baseStage->mGC,boss->px,boss->py,
       boss->seq+boss->direct*spriteBox->nSeq+(spriteBox->nLength/2));
  }
  else{
    spriteBox->DrawSprite
      (frame,baseStage->mGC,boss->px,boss->py,
       boss->seq+boss->direct*spriteBox->nSeq);
  }
}

int BossEagle::Act(int bgBoss0,int mode0){
  bgBoss0=(this->*BOSS_EAGLE_STATE_SELECT[bossState])(bgBoss0,mode0);
  return bgBoss0;
}

/*
  STATE
*/

int BossEagle::StartState(int bgBoss0,int mode0){
  if(!boss){
    bossMode=mode0;
    (this->*BOSS_EAGLE_START_SELECT[bossMode])();
  }
  bossState=BOSS_EAGLE_STATE_ACTION;
  return bgBoss0;
}
int BossEagle::ActionState(int bgBoss0,int mode0){

  (this->*BOSS_EAGLE_ACTION_SELECT[bossMode])();
  
  if(boss->life>0){
    Draw();
    LifeView(boss->life,lifeList[bossMode]);
  }
  else{
    baseStage->pfireList->ALLDelete();
    enemyList->efireList->ALLDelete();
    enemyList->Reject(boss);
    enemyList->ALLDelete();
    
    bgBoss0=BOSS_ACT_BGSTOP;
    bossState=BOSS_EAGLE_STATE_EXPLODE;
    bossExplodeCount=70;
    bossExplode=0;
  }
  return bgBoss0;
}
int BossEagle::ExplodeState(int bgBoss0,int mode0){
  bossExplodeCount+=-1;
  bossExplode+=bossExplodeCount/5;

  if(bossExplode>0){
    frame->draw_arc(redGC,true,
		    boss->px-bossExplode/2,
		    boss->py-bossExplode*3/2,
		    bossExplode,
		    bossExplode*3,
		    0,360*64);
    frame->draw_arc(orangeGC,true,
		    boss->px-bossExplode*3/2,
		    boss->py-bossExplode/2,
		    bossExplode*3,
		    bossExplode,
		    0,360*64);
  }
  else{
    bossCount=50;
    bossState=BOSS_EAGLE_STATE_DEAD;
    if(boss!=NULL){
      delete boss;
    }
    boss=NULL;
  }
  return bgBoss0;
}
int BossEagle::DeadState(int bgBoss0,int mode0){
  if(bossCount>0){
    bossCount--;
  }
  else{
    bossState=BOSS_EAGLE_STATE_START;
    bgBoss0=BOSS_ACT_END;
  }
  return bgBoss0;
}
int (BossEagle::*BossEagle::BOSS_EAGLE_STATE_SELECT
     [BOSS_EAGLE_STATE_NUM])(int bgBoss0,int mode0)={
       &BossEagle::StartState,
       &BossEagle::ActionState,
       &BossEagle::ExplodeState,
       &BossEagle::DeadState
     };

/*
  START
*/

void BossEagle::VEasyStart(){
  boss= new BirdActor();
  
  boss->px=WIDTH*3/2;
  boss->py=(rand()%1000)*HEIGHT/MAP_YMAX;
  boss->width=64;
  boss->height=64;
  boss->move=EN_MOV_BOSS;
  boss->touch=EN_TOUCH_THROUGH;
  boss->life=lifeList[bossMode];
  boss->mx=0;
  boss->my=0;
  boss->tx=20;
  boss->ty=2;
  boss->tmp=0;
  boss->form=0;
  boss->direct=1;
  boss->seq=0;
  boss->score=0;
  bossMove=BOSS_EAGLE_VEASY_MOV_ACCETAR;
  bossAttack=BOSS_EAGLE_VEASY_ATTACK_CHANGE;
  bossAngle=0;
  bossTarX=WIDTH*3/4;
  bossTarY=HEIGHT/2;
  bossATarY=0;
  bossATarY=0;
  bossMoveCount=50;
  bossAngleCount=0;
  bossAttackCount=0;

  enemyList->Prepend(boss);
}
void BossEagle::EasyStart(){
  boss= new BirdActor();
  
  boss->px=WIDTH*3/2;
  boss->py=(rand()%1000)*HEIGHT/MAP_YMAX;
  boss->width=64;
  boss->height=64;
  boss->move=EN_MOV_BOSS;
  boss->touch=EN_TOUCH_THROUGH;
  boss->life=lifeList[bossMode];
  boss->mx=0;
  boss->my=0;
  boss->tx=20;
  boss->ty=2;
  boss->tmp=0;
  boss->form=0;
  boss->direct=1;
  boss->seq=0;
  boss->score=0;
  bossMove=BOSS_EAGLE_EASY_MOV_ACCETAR;
  bossAttack=BOSS_EAGLE_EASY_ATTACK_CHANGE;
  bossAngle=0;
  bossTarX=WIDTH*3/4;
  bossTarY=HEIGHT/2;
  bossATarY=0;
  bossATarY=0;
  bossMoveCount=50;
  bossAngleCount=0;
  bossAttackCount=0;

  enemyList->Prepend(boss);
}
void BossEagle::NormalStart(){
  boss= new BirdActor();
  
  boss->px=WIDTH*3/2;
  boss->py=(rand()%1000)*HEIGHT/MAP_YMAX;
  boss->width=64;
  boss->height=64;
  boss->move=EN_MOV_BOSS;
  boss->touch=EN_TOUCH_THROUGH;
  boss->life=lifeList[bossMode];
  boss->mx=0;
  boss->my=0;
  boss->tx=20;
  boss->ty=2;
  boss->tmp=0;
  boss->form=0;
  boss->direct=1;
  boss->seq=0;
  boss->score=0;
  bossMove=BOSS_EAGLE_NORMAL_MOV_ACCETAR;
  bossAttack=BOSS_EAGLE_NORMAL_ATTACK_CHANGE;
  bossAngle=0;
  bossTarX=WIDTH*3/4;
  bossTarY=HEIGHT/2;
  bossATarY=0;
  bossATarY=0;
  bossMoveCount=50;
  bossAngleCount=0;
  bossAttackCount=0;

  enemyList->Prepend(boss);
}
void BossEagle::HardStart(){
  boss= new BirdActor();
  
  boss->px=WIDTH*3/2;
  boss->py=(rand()%1000)*HEIGHT/MAP_YMAX;
  boss->width=64;
  boss->height=64;
  boss->move=EN_MOV_BOSS;
  boss->touch=EN_TOUCH_THROUGH;
  boss->life=lifeList[bossMode];
  boss->mx=0;
  boss->my=0;
  boss->tx=20;
  boss->ty=2;
  boss->tmp=0;
  boss->form=0;
  boss->direct=1;
  boss->seq=0;
  boss->score=0;
  bossMove=BOSS_EAGLE_HARD_MOV_ACCETAR;
  bossAttack=BOSS_EAGLE_HARD_ATTACK_CHANGE;
  bossAngle=0;
  bossTarX=WIDTH*3/4;
  bossTarY=HEIGHT/2;
  bossATarY=0;
  bossATarY=0;
  bossMoveCount=50;
  bossAngleCount=0;
  bossAttackCount=0;

  enemyList->Prepend(boss);
}
void BossEagle::VHardStart(){
  boss= new BirdActor();
  
  boss->px=WIDTH*3/2;
  boss->py=(rand()%1000)*HEIGHT/MAP_YMAX;
  boss->width=64;
  boss->height=64;
  boss->move=EN_MOV_BOSS;
  boss->touch=EN_TOUCH_THROUGH;
  boss->life=lifeList[bossMode];
  boss->mx=0;
  boss->my=0;
  boss->tx=20;
  boss->ty=2;
  boss->tmp=0;
  boss->form=0;
  boss->direct=1;
  boss->seq=0;
  boss->score=0;
  bossMove=BOSS_EAGLE_VHARD_MOV_ACCETAR;
  bossAttack=BOSS_EAGLE_VHARD_ATTACK_CHANGE;
  bossAngle=0;
  bossTarX=WIDTH*3/4;
  bossTarY=HEIGHT/2;
  bossATarY=0;
  bossATarY=0;
  bossMoveCount=50;
  bossAngleCount=0;
  bossAttackCount=0;

  enemyList->Prepend(boss);
}
void (BossEagle::*BossEagle::
      BOSS_EAGLE_START_SELECT[BOSS_EAGLE_MODE_NUM])()={
	&BossEagle::VEasyStart,
	&BossEagle::EasyStart,
	&BossEagle::NormalStart,
	&BossEagle::HardStart,
	&BossEagle::VHardStart
      };

/*
  ACTION
*/

void BossEagle::VEasyAction(){
  (this->*BOSS_EAGLE_VEASY_ATTACK_SELECT[bossAttack])();

  (this->*BOSS_EAGLE_VEASY_MOVE_SELECT[bossMove])();
}
void BossEagle::EasyAction(){
  (this->*BOSS_EAGLE_EASY_ATTACK_SELECT[bossAttack])();

  (this->*BOSS_EAGLE_EASY_MOVE_SELECT[bossMove])();
}
void BossEagle::NormalAction(){
  (this->*BOSS_EAGLE_NORMAL_ATTACK_SELECT[bossAttack])();

  (this->*BOSS_EAGLE_NORMAL_MOVE_SELECT[bossMove])();
}
void BossEagle::HardAction(){
  (this->*BOSS_EAGLE_HARD_ATTACK_SELECT[bossAttack])();

  (this->*BOSS_EAGLE_HARD_MOVE_SELECT[bossMove])();
}
void BossEagle::VHardAction(){
  (this->*BOSS_EAGLE_VHARD_ATTACK_SELECT[bossAttack])();

  (this->*BOSS_EAGLE_VHARD_MOVE_SELECT[bossMove])();
}
void (BossEagle::*BossEagle::
      BOSS_EAGLE_ACTION_SELECT[BOSS_EAGLE_MODE_NUM])()={
	&BossEagle::VEasyAction,
	&BossEagle::EasyAction,
	&BossEagle::NormalAction,
	&BossEagle::HardAction,
	&BossEagle::VHardAction
      };

/*
  VEASY
*/

void BossEagle::VEasyAttackChange(){
  if(bossMove==moveAvoid[bossMode]){
    bossAttack=rand()%(BOSS_EAGLE_VEASY_ATTACK_NUM-1)+1;
  }
  else{
    bossAttack=0;
  }

  if(bossAttack==BOSS_EAGLE_VEASY_ATTACK_CALLSTRBIRD){
    bossAttackCount=rand()%(50)+50;
    bossAttackFreq=500;
  }
}
void (BossEagle::*BossEagle::BOSS_EAGLE_VEASY_ATTACK_SELECT
      [BOSS_EAGLE_VEASY_ATTACK_NUM])()={
	&BossEagle::VEasyAttackChange,
	&BossEagle::CallStrBird
      };

void BossEagle::VEasyMoveChange(){
  bossMove=rand()%(BOSS_EAGLE_VEASY_MOV_NUM-1)+1;

  if(bossMove==BOSS_EAGLE_VEASY_MOV_REVERSE){
    bossMoveCount=rand()%(100)+100;
    if(abs(boss->mx)<16){
      if(abs(boss->my)<16){
	if(boss->mx>0){
	  boss->mx=16;
	}
	else{
	  boss->mx=-16;
	}
      }
    }
  }
  else if(bossMove==BOSS_EAGLE_VEASY_MOV_ACCETAR){
    bossTarX=rand()%WIDTH;
    bossTarY=rand()%HEIGHT;
    boss->tx=rand()%20+16;
    boss->ty=rand()%2+2;
    bossMoveCount=rand()%(100)+100;
  }
  else if(bossMove==BOSS_EAGLE_VEASY_MOV_AVOID){
    if(boss->direct==EN_WAY_F){
      bossTarX=rand()%WIDTH-WIDTH*3/2;
      bossTarY=rand()%HEIGHT;

    }
    else if(boss->direct==EN_WAY_B){
      bossTarX=rand()%WIDTH+WIDTH*3/2;
      bossTarY=rand()%HEIGHT;
    }

    boss->tx=rand()%20+16;
    boss->ty=rand()%2+2;
    bossMoveCount=rand()%(100)+100;
  }
}
void (BossEagle::*BossEagle::BOSS_EAGLE_VEASY_MOVE_SELECT
      [BOSS_EAGLE_VEASY_MOV_NUM])()={
	&BossEagle::VEasyMoveChange,
	&BossEagle::ReverseMove,
	&BossEagle::AcceTargetMove,
	&BossEagle::AcceTargetMove
      };

/*
  EASY
*/

void BossEagle::EasyAttackChange(){
  if(bossMove==moveAvoid[bossMode]){
    bossAttack=rand()%(BOSS_EAGLE_EASY_ATTACK_NUM-1)+1;
  }
  else{
    bossAttack=rand()%(BOSS_EAGLE_EASY_ATTACK_XREVINFIRE)+1;
  }

  if(bossAttack==BOSS_EAGLE_EASY_ATTACK_CROSSINFIRE){
    bossAttackCount=rand()%(100)+100;
    bossAttackFreq=10;
  }
  else if(bossAttack==BOSS_EAGLE_EASY_ATTACK_XREVINFIRE){
    bossAttackCount=rand()%(100)+100;
    bossAttackFreq=10;
  }
  else if(bossAttack==BOSS_EAGLE_EASY_ATTACK_CALLSTRBIRD){
    bossAttackCount=rand()%(100)+100;
    bossAttackFreq=500;
  }
}
void (BossEagle::*BossEagle::BOSS_EAGLE_EASY_ATTACK_SELECT
      [BOSS_EAGLE_EASY_ATTACK_NUM])()={
	&BossEagle::EasyAttackChange,
	&BossEagle::CrossInFire,
	&BossEagle::XRevInFire,
	&BossEagle::CallStrBird
      };

void BossEagle::EasyMoveChange(){
  bossMove=rand()%(BOSS_EAGLE_EASY_MOV_NUM-1)+1;

  if(bossMove==BOSS_EAGLE_EASY_MOV_REVERSE){
    bossMoveCount=rand()%(50)+50;
    if(abs(boss->mx)<16){
      if(abs(boss->my)<16){
	if(boss->mx>0){
	  boss->mx=16;
	}
	else{
	  boss->mx=-16;
	}
      }
    }
  }
  else if(bossMove==BOSS_EAGLE_EASY_MOV_ACCETAR){
    bossTarX=rand()%WIDTH;
    bossTarY=rand()%HEIGHT;
    boss->tx=rand()%20+16;
    boss->ty=rand()%2+2;
    bossMoveCount=rand()%(100)+100;
  }
  else if(bossMove==BOSS_EAGLE_EASY_MOV_AVOID){
    if(boss->direct==EN_WAY_F){
      bossTarX=rand()%WIDTH-WIDTH*3/2;
      bossTarY=rand()%HEIGHT;

    }
    else if(boss->direct==EN_WAY_B){
      bossTarX=rand()%WIDTH+WIDTH*3/2;
      bossTarY=rand()%HEIGHT;
    }

    boss->tx=rand()%20+16;
    boss->ty=rand()%2+2;
    bossMoveCount=rand()%(100)+100;
  }
}
void (BossEagle::*BossEagle::BOSS_EAGLE_EASY_MOVE_SELECT
      [BOSS_EAGLE_EASY_MOV_NUM])()={
	&BossEagle::EasyMoveChange,
	&BossEagle::ReverseMove,
	&BossEagle::AcceTargetMove,
	&BossEagle::AcceTargetMove
      };

/*
  NORMAL
*/

void BossEagle::NormalAttackChange(){
  if(bossMove==moveAvoid[bossMode]){
    bossAttack=rand()%(BOSS_EAGLE_NORMAL_ATTACK_NUM-1)+1;
  }
  else{
    bossAttack=rand()%(BOSS_EAGLE_NORMAL_ATTACK_ALLREVINFIRE)+1;
  }

  if(bossAttack==BOSS_EAGLE_NORMAL_ATTACK_CROSSINFIRE){
    bossAttackCount=rand()%(100)+100;
    bossAttackFreq=10;
  }
  else if(bossAttack==BOSS_EAGLE_NORMAL_ATTACK_XREVINFIRE){
    bossAttackCount=rand()%(100)+100;
    bossAttackFreq=10;
  }
  else if(bossAttack==BOSS_EAGLE_NORMAL_ATTACK_ALLREVINFIRE){
    bossAttackCount=rand()%(100)+100;
    bossAttackFreq=50;
  }
  else if(bossAttack==BOSS_EAGLE_NORMAL_ATTACK_CALLSTRBIRD){
    bossAttackCount=rand()%(100)+100;
    bossAttackFreq=500;
  }
  else if(bossAttack==BOSS_EAGLE_NORMAL_ATTACK_CALLREVBIRD){
    bossAttackCount=rand()%(100)+100;
    bossAttackFreq=250;
  }
  else if(bossAttack==BOSS_EAGLE_NORMAL_ATTACK_ACCEHOMOUTFIRE){
    bossAttackCount=rand()%(100)+100;
    bossAttackFreq=10;
  }
}
void (BossEagle::*BossEagle::BOSS_EAGLE_NORMAL_ATTACK_SELECT
      [BOSS_EAGLE_NORMAL_ATTACK_NUM])()={
	&BossEagle::NormalAttackChange,
	&BossEagle::CrossInFire,
	&BossEagle::XRevInFire,
	&BossEagle::ALLRevInFire,
	&BossEagle::CallStrBird,
	&BossEagle::CallRevBird,
	&BossEagle::AcceHomOutFire
      };

void BossEagle::NormalMoveChange(){
  bossMove=rand()%(BOSS_EAGLE_NORMAL_MOV_NUM-1)+1;

  if(bossMove==BOSS_EAGLE_NORMAL_MOV_REVERSE){
    bossMoveCount=rand()%(50)+50;
    if(abs(boss->mx)<16){
      if(abs(boss->my)<16){
	if(boss->mx>0){
	  boss->mx=16;
	}
	else{
	  boss->mx=-16;
	}
      }
    }
  }
  else if(bossMove==BOSS_EAGLE_NORMAL_MOV_ACCETAR){
    bossTarX=rand()%WIDTH;
    bossTarY=rand()%HEIGHT;
    boss->tx=rand()%20+16;
    boss->ty=rand()%2+2;
    bossMoveCount=rand()%(100)+100;
  }
  else if(bossMove==BOSS_EAGLE_NORMAL_MOV_AVOID){
    if(boss->direct==EN_WAY_F){
      bossTarX=rand()%WIDTH-WIDTH*3/2;
      bossTarY=rand()%HEIGHT;

    }
    else if(boss->direct==EN_WAY_B){
      bossTarX=rand()%WIDTH+WIDTH*3/2;
      bossTarY=rand()%HEIGHT;
    }

    boss->tx=rand()%20+16;
    boss->ty=rand()%2+2;
    bossMoveCount=rand()%(100)+100;
  }
}
void (BossEagle::*BossEagle::BOSS_EAGLE_NORMAL_MOVE_SELECT
      [BOSS_EAGLE_NORMAL_MOV_NUM])()={
	&BossEagle::NormalMoveChange,
	&BossEagle::ReverseMove,
	&BossEagle::AcceTargetMove,
	&BossEagle::AcceTargetMove
      };

/*
  HARD
*/

void BossEagle::HardAttackChange(){
  if(bossMove==moveAvoid[bossMode]){
    bossAttack=rand()%(BOSS_EAGLE_HARD_ATTACK_NUM-1)+1;
  }
  else{
    bossAttack=rand()%(BOSS_EAGLE_HARD_ATTACK_XREVINFIRE)+1;
  }

  if(bossAttack==BOSS_EAGLE_HARD_ATTACK_CROSSINFIRE){
    bossAttackCount=rand()%(100)+100;
    bossAttackFreq=2;
  }
  else if(bossAttack==BOSS_EAGLE_HARD_ATTACK_XREVINFIRE){
    bossAttackCount=rand()%(100)+100;
    bossAttackFreq=2;
  }
  else if(bossAttack==BOSS_EAGLE_HARD_ATTACK_CALLSTRBIRD){
    bossAttackCount=rand()%(100)+100;
    bossAttackFreq=1000;
  }
}
void (BossEagle::*BossEagle::BOSS_EAGLE_HARD_ATTACK_SELECT
      [BOSS_EAGLE_HARD_ATTACK_NUM])()={
	&BossEagle::HardAttackChange,
	&BossEagle::CrossInFire,
	&BossEagle::XRevInFire,
	&BossEagle::CallStrBird
      };

void BossEagle::HardMoveChange(){
  bossMove=rand()%(BOSS_EAGLE_HARD_MOV_NUM-1)+1;

  if(bossMove==BOSS_EAGLE_HARD_MOV_REVERSE){
    bossMoveCount=rand()%(50)+50;
    if(abs(boss->mx)<16){
      if(abs(boss->my)<16){
	if(boss->mx>0){
	  boss->mx=16;
	}
	else{
	  boss->mx=-16;
	}
      }
    }
  }
  else if(bossMove==BOSS_EAGLE_HARD_MOV_ACCETAR){
    bossTarX=rand()%WIDTH;
    bossTarY=rand()%HEIGHT;
    boss->tx=rand()%20+16;
    boss->ty=rand()%2+2;
    bossMoveCount=rand()%(50)+50;
  }
  else if(bossMove==BOSS_EAGLE_HARD_MOV_ACCEHOM){
    boss->tx=rand()%8+16;
    boss->ty=rand()%2+2;
    bossMoveCount=rand()%(50)+50;
  }
  else if(bossMove==BOSS_EAGLE_HARD_MOV_AVOID){
    if(boss->direct==EN_WAY_F){
      bossTarX=rand()%WIDTH-WIDTH*3/2;
      bossTarY=rand()%HEIGHT;

    }
    else if(boss->direct==EN_WAY_B){
      bossTarX=rand()%WIDTH+WIDTH*3/2;
      bossTarY=rand()%HEIGHT;
    }

    boss->tx=rand()%20+16;
    boss->ty=rand()%2+2;
    bossMoveCount=rand()%(100)+100;
  }
}
void (BossEagle::*BossEagle::BOSS_EAGLE_HARD_MOVE_SELECT
      [BOSS_EAGLE_HARD_MOV_NUM])()={
	&BossEagle::HardMoveChange,
	&BossEagle::ReverseMove,
	&BossEagle::AcceTargetMove,
	&BossEagle::AcceHomingMove,
	&BossEagle::AcceTargetMove
      };

/*
  VHARD
*/

void BossEagle::VHardAttackChange(){
  if(bossMove==moveAvoid[bossMode]){
    bossAttack=rand()%(BOSS_EAGLE_VHARD_ATTACK_NUM-1)+1;
  }
  else{
    bossAttack=rand()%(BOSS_EAGLE_VHARD_ATTACK_ALLREVINFIRE)+1;
  }
  //  bossCount=0;

  if(bossAttack==BOSS_EAGLE_VHARD_ATTACK_CROSSINFIRE){
    bossAttackCount=rand()%(100)+100;
    bossAttackFreq=2;
  }
  else if(bossAttack==BOSS_EAGLE_VHARD_ATTACK_XREVINFIRE){
    bossAttackCount=rand()%(100)+100;
    bossAttackFreq=2;
  }
  else if(bossAttack==BOSS_EAGLE_VHARD_ATTACK_ALLREVINFIRE){
    bossAttackCount=rand()%(100)+100;
    bossAttackFreq=30;
  }
  else if(bossAttack==BOSS_EAGLE_VHARD_ATTACK_CALLSTRBIRD){
    bossAttackCount=rand()%(100)+100;
    bossAttackFreq=1000;
  }
  else if(bossAttack==BOSS_EAGLE_VHARD_ATTACK_CALLREVBIRD){
    bossAttackCount=rand()%(100)+100;
    bossAttackFreq=500;
  }
  else if(bossAttack==BOSS_EAGLE_VHARD_ATTACK_ACCEHOMOUTFIRE){
    bossAttackCount=rand()%(100)+100;
    bossAttackFreq=2;
  }
}
void (BossEagle::*BossEagle::BOSS_EAGLE_VHARD_ATTACK_SELECT
      [BOSS_EAGLE_VHARD_ATTACK_NUM])()={
	&BossEagle::VHardAttackChange,
	&BossEagle::CrossInFire,
	&BossEagle::XRevInFire,
	&BossEagle::ALLRevInFire,
	&BossEagle::CallStrBird,
	&BossEagle::CallRevBird,
	&BossEagle::AcceHomOutFire
      };

void BossEagle::VHardMoveChange(){
  bossMove=rand()%(BOSS_EAGLE_VHARD_MOV_NUM-1)+1;

  if(bossMove==BOSS_EAGLE_VHARD_MOV_REVERSE){
    bossMoveCount=rand()%(50)+50;
    if(abs(boss->mx)<16){
      if(abs(boss->my)<16){
	if(boss->mx>0){
	  boss->mx=16;
	}
	else{
	  boss->mx=-16;
	}
      }
    }
  }
  else if(bossMove==BOSS_EAGLE_VHARD_MOV_ACCETAR){
    bossTarX=rand()%WIDTH;
    bossTarY=rand()%HEIGHT;
    boss->tx=rand()%20+16;
    boss->ty=rand()%2+2;
    bossMoveCount=rand()%(50)+50;
  }
  else if(bossMove==BOSS_EAGLE_VHARD_MOV_ACCEHOM){
    boss->tx=rand()%8+16;
    boss->ty=rand()%2+2;
    bossMoveCount=rand()%(50)+50;
  }
  else if(bossMove==BOSS_EAGLE_VHARD_MOV_AVOID){
    if(boss->direct==EN_WAY_F){
      bossTarX=rand()%WIDTH-WIDTH*3/2;
      bossTarY=rand()%HEIGHT;

    }
    else if(boss->direct==EN_WAY_B){
      bossTarX=rand()%WIDTH+WIDTH*3/2;
      bossTarY=rand()%HEIGHT;
    }

    boss->tx=rand()%20+16;
    boss->ty=rand()%2+2;
    bossMoveCount=rand()%(100)+100;
  }
}
void (BossEagle::*BossEagle::BOSS_EAGLE_VHARD_MOVE_SELECT
      [BOSS_EAGLE_VHARD_MOV_NUM])()={
	&BossEagle::VHardMoveChange,
	&BossEagle::ReverseMove,
	&BossEagle::AcceTargetMove,
	&BossEagle::AcceHomingMove,
	&BossEagle::AcceTargetMove
      };
