#ifndef BIRD_BOSS_EAGLE_H_
#define BIRD_BOSS_EAGLE_H_

#include <gtkmm.h>
#include "bossbase.h"

#define BOSS_EAGLE_BIRD_FREQ 1000

#define BOSS_EAGLE_MODE_VEASY 0
#define BOSS_EAGLE_MODE_EASY 1
#define BOSS_EAGLE_MODE_NORMAL 2
#define BOSS_EAGLE_MODE_HARD 3
#define BOSS_EAGLE_MODE_VHARD 4
#define BOSS_EAGLE_MODE_NUM 5

#define BOSS_EAGLE_STATE_START 0
#define BOSS_EAGLE_STATE_ACTION 1
#define BOSS_EAGLE_STATE_EXPLODE 2
#define BOSS_EAGLE_STATE_DEAD 3
#define BOSS_EAGLE_STATE_NUM 4

/*
  VEASY
*/

#define BOSS_EAGLE_VEASY_ATTACK_CHANGE 0
#define BOSS_EAGLE_VEASY_ATTACK_CALLSTRBIRD 1
#define BOSS_EAGLE_VEASY_ATTACK_NUM 2

#define BOSS_EAGLE_VEASY_MOV_CHANGE 0
#define BOSS_EAGLE_VEASY_MOV_REVERSE 1
#define BOSS_EAGLE_VEASY_MOV_ACCETAR 2
#define BOSS_EAGLE_VEASY_MOV_AVOID 3
#define BOSS_EAGLE_VEASY_MOV_NUM 4

/*
  EASY
*/

#define BOSS_EAGLE_EASY_ATTACK_CHANGE 0
#define BOSS_EAGLE_EASY_ATTACK_CROSSINFIRE 1
#define BOSS_EAGLE_EASY_ATTACK_XREVINFIRE 2
#define BOSS_EAGLE_EASY_ATTACK_CALLSTRBIRD 3
#define BOSS_EAGLE_EASY_ATTACK_NUM 4

#define BOSS_EAGLE_EASY_MOV_CHANGE 0
#define BOSS_EAGLE_EASY_MOV_REVERSE 1
#define BOSS_EAGLE_EASY_MOV_ACCETAR 2
#define BOSS_EAGLE_EASY_MOV_AVOID 3
#define BOSS_EAGLE_EASY_MOV_NUM 4

/*
  NORMAL
*/

#define BOSS_EAGLE_NORMAL_ATTACK_CHANGE 0
#define BOSS_EAGLE_NORMAL_ATTACK_CROSSINFIRE 1
#define BOSS_EAGLE_NORMAL_ATTACK_XREVINFIRE 2
#define BOSS_EAGLE_NORMAL_ATTACK_ALLREVINFIRE 3
#define BOSS_EAGLE_NORMAL_ATTACK_CALLSTRBIRD 4
#define BOSS_EAGLE_NORMAL_ATTACK_CALLREVBIRD 5
#define BOSS_EAGLE_NORMAL_ATTACK_ACCEHOMOUTFIRE 6
#define BOSS_EAGLE_NORMAL_ATTACK_NUM 7

#define BOSS_EAGLE_NORMAL_MOV_CHANGE 0
#define BOSS_EAGLE_NORMAL_MOV_REVERSE 1
#define BOSS_EAGLE_NORMAL_MOV_ACCETAR 2
#define BOSS_EAGLE_NORMAL_MOV_AVOID 3
#define BOSS_EAGLE_NORMAL_MOV_NUM 4

/*
  HARD
*/

#define BOSS_EAGLE_HARD_ATTACK_CHANGE 0
#define BOSS_EAGLE_HARD_ATTACK_CROSSINFIRE 1
#define BOSS_EAGLE_HARD_ATTACK_XREVINFIRE 2
#define BOSS_EAGLE_HARD_ATTACK_CALLSTRBIRD 3
#define BOSS_EAGLE_HARD_ATTACK_NUM 4

#define BOSS_EAGLE_HARD_MOV_CHANGE 0
#define BOSS_EAGLE_HARD_MOV_REVERSE 1
#define BOSS_EAGLE_HARD_MOV_ACCETAR 2
#define BOSS_EAGLE_HARD_MOV_ACCEHOM 3
#define BOSS_EAGLE_HARD_MOV_AVOID 4
#define BOSS_EAGLE_HARD_MOV_NUM 5

/*
  VHARD
*/

#define BOSS_EAGLE_VHARD_ATTACK_CHANGE 0
#define BOSS_EAGLE_VHARD_ATTACK_CROSSINFIRE 1
#define BOSS_EAGLE_VHARD_ATTACK_XREVINFIRE 2
#define BOSS_EAGLE_VHARD_ATTACK_ALLREVINFIRE 3
#define BOSS_EAGLE_VHARD_ATTACK_CALLSTRBIRD 4
#define BOSS_EAGLE_VHARD_ATTACK_CALLREVBIRD 5
#define BOSS_EAGLE_VHARD_ATTACK_ACCEHOMOUTFIRE 6
#define BOSS_EAGLE_VHARD_ATTACK_NUM 7

#define BOSS_EAGLE_VHARD_MOV_CHANGE 0
#define BOSS_EAGLE_VHARD_MOV_REVERSE 1
#define BOSS_EAGLE_VHARD_MOV_ACCETAR 2
#define BOSS_EAGLE_VHARD_MOV_ACCEHOM 3
#define BOSS_EAGLE_VHARD_MOV_AVOID 4
#define BOSS_EAGLE_VHARD_MOV_NUM 5

class BossEagle : public BossBase {
 public:
  int lifeList[BOSS_EAGLE_MODE_NUM];
  int attackChange[BOSS_EAGLE_MODE_NUM];
  int moveChange[BOSS_EAGLE_MODE_NUM];
  int moveAvoid[BOSS_EAGLE_MODE_NUM];
  BirdSprite sprite[4];
  SpriteBox *spriteBox;
  Glib::RefPtr<Gdk::Pixbuf> pixBuf;
  Glib::RefPtr<Gdk::Pixbuf> tBuf;
  BossEagle();
  ~BossEagle();
  void Create();

  int EnterScreen(BirdActor *act);

  void AcceBigFire(int mx0,int my0,int tx0,int ty0);
  void AddStrBird();
  void AddRevBird();
  void AddAcceBird();

  void CallStrBird();
  void CallRevBird();
  void CallHomBird();
  void CrossInFire();
  void XRevInFire();
  void ALLRevInFire();
  void AcceHomOutFire();

  void ReverseMove();
  void AcceTargetMove();
  void AcceHomingMove();
  void AvoidMove();

  void Draw();
  int Act(int bgBoss0,int mode0);

  int StartState(int bgBoss0,int mode0);
  int ActionState(int bgBoss0,int mode0);
  int ExplodeState(int bgBoss0,int mode0);
  int DeadState(int bgBoss0,int mode0);
  static int(BossEagle::*BOSS_EAGLE_STATE_SELECT[BOSS_EAGLE_STATE_NUM])
    (int bgBoss0,int mode0);

  void VEasyStart();
  void EasyStart();
  void NormalStart();
  void HardStart();
  void VHardStart();
  static void
    (BossEagle::*BOSS_EAGLE_START_SELECT[BOSS_EAGLE_MODE_NUM])();

  void VEasyAction();
  void EasyAction();
  void NormalAction();
  void HardAction();
  void VHardAction();
  static void
    (BossEagle::*BOSS_EAGLE_ACTION_SELECT[BOSS_EAGLE_MODE_NUM])();

  void VEasyAttackChange();
  static void(BossEagle::*BOSS_EAGLE_VEASY_ATTACK_SELECT
	      [BOSS_EAGLE_VEASY_ATTACK_NUM])();
  void VEasyMoveChange();
  static void(BossEagle::*BOSS_EAGLE_VEASY_MOVE_SELECT
	      [BOSS_EAGLE_VEASY_MOV_NUM])();

  void EasyAttackChange();
  static void(BossEagle::*BOSS_EAGLE_EASY_ATTACK_SELECT
	      [BOSS_EAGLE_EASY_ATTACK_NUM])();
  void EasyMoveChange();
  static void(BossEagle::*BOSS_EAGLE_EASY_MOVE_SELECT
	      [BOSS_EAGLE_EASY_MOV_NUM])();

  void NormalAttackChange();
  static void(BossEagle::*BOSS_EAGLE_NORMAL_ATTACK_SELECT
	      [BOSS_EAGLE_NORMAL_ATTACK_NUM])();
  void NormalMoveChange();
  static void(BossEagle::*BOSS_EAGLE_NORMAL_MOVE_SELECT
	      [BOSS_EAGLE_NORMAL_MOV_NUM])();

  void HardAttackChange();
  static void(BossEagle::*BOSS_EAGLE_HARD_ATTACK_SELECT
	      [BOSS_EAGLE_HARD_ATTACK_NUM])();
  void HardMoveChange();
  static void(BossEagle::*BOSS_EAGLE_HARD_MOVE_SELECT
	      [BOSS_EAGLE_HARD_MOV_NUM])();

  void VHardAttackChange();
  static void(BossEagle::*BOSS_EAGLE_VHARD_ATTACK_SELECT
	      [BOSS_EAGLE_VHARD_ATTACK_NUM])();
  void VHardMoveChange();
  static void(BossEagle::*BOSS_EAGLE_VHARD_MOVE_SELECT
	      [BOSS_EAGLE_VHARD_MOV_NUM])();
};

#endif
