#include "bosssilkhat.h"

BossSilkHat::BossSilkHat(){
  hatPoints.push_back(Gdk::Point(0,0));
  hatPoints.push_back(Gdk::Point(0,0));
  hatPoints.push_back(Gdk::Point(0,0));
  hatPoints.push_back(Gdk::Point(0,0));
  hatPoints.push_back(Gdk::Point(0,0));

  edgePoints.push_back(Gdk::Point(0,0));
  edgePoints.push_back(Gdk::Point(0,0));
  edgePoints.push_back(Gdk::Point(0,0));
  edgePoints.push_back(Gdk::Point(0,0));

  passPoints.push_back(Gdk::Point(0,0));
  passPoints.push_back(Gdk::Point(0,0));
  passPoints.push_back(Gdk::Point(0,0));
  passPoints.push_back(Gdk::Point(0,0));

  damagePoints.push_back(Gdk::Point(0,0));
  damagePoints.push_back(Gdk::Point(0,0));
  damagePoints.push_back(Gdk::Point(0,0));
  damagePoints.push_back(Gdk::Point(0,0));

  bossMode=0;
  bossState=BOSS_SILKHAT_STATE_START;
  bossMove=0;
  bossAngle=0;
  bossAttack=0;
  bossTarX=0;
  bossTarY=0;
  bossATarX=0;
  bossATarY=0;
  bossMoveCount=0;
  bossAngleCount=0;
  bossAttackCount=0;
  boss=NULL;

  lifeList[BOSS_SILKHAT_MODE_VEASY]=50;
  lifeList[BOSS_SILKHAT_MODE_EASY]=100;
  lifeList[BOSS_SILKHAT_MODE_NORMAL]=100;
  lifeList[BOSS_SILKHAT_MODE_HARD]=200;
  lifeList[BOSS_SILKHAT_MODE_VHARD]=200;

  attackChange[BOSS_SILKHAT_MODE_VEASY]=BOSS_SILKHAT_VEASY_ATTACK_CHANGE;
  attackChange[BOSS_SILKHAT_MODE_EASY]=BOSS_SILKHAT_EASY_ATTACK_CHANGE;
  attackChange[BOSS_SILKHAT_MODE_NORMAL]
    =BOSS_SILKHAT_NORMAL_ATTACK_CHANGE;
  attackChange[BOSS_SILKHAT_MODE_HARD]=BOSS_SILKHAT_HARD_ATTACK_CHANGE;
  attackChange[BOSS_SILKHAT_MODE_VHARD]=BOSS_SILKHAT_VHARD_ATTACK_CHANGE;

  angleChange[BOSS_SILKHAT_MODE_VEASY]=BOSS_SILKHAT_VEASY_ANGLE_CHANGE;
  angleChange[BOSS_SILKHAT_MODE_EASY]=BOSS_SILKHAT_EASY_ANGLE_CHANGE;
  angleChange[BOSS_SILKHAT_MODE_NORMAL]
    =BOSS_SILKHAT_NORMAL_ANGLE_CHANGE;
  angleChange[BOSS_SILKHAT_MODE_HARD]=BOSS_SILKHAT_HARD_ANGLE_CHANGE;
  angleChange[BOSS_SILKHAT_MODE_VHARD]=BOSS_SILKHAT_VHARD_ANGLE_CHANGE;

  moveChange[BOSS_SILKHAT_MODE_VEASY]=BOSS_SILKHAT_VEASY_MOV_CHANGE;
  moveChange[BOSS_SILKHAT_MODE_EASY]=BOSS_SILKHAT_EASY_MOV_CHANGE;
  moveChange[BOSS_SILKHAT_MODE_NORMAL]
    =BOSS_SILKHAT_NORMAL_MOV_CHANGE;
  moveChange[BOSS_SILKHAT_MODE_HARD]=BOSS_SILKHAT_HARD_MOV_CHANGE;
  moveChange[BOSS_SILKHAT_MODE_VHARD]=BOSS_SILKHAT_VHARD_MOV_CHANGE;

  moveStraight[BOSS_SILKHAT_MODE_VEASY]=BOSS_SILKHAT_VEASY_MOV_STRAIGHT;
  moveStraight[BOSS_SILKHAT_MODE_EASY]=BOSS_SILKHAT_EASY_MOV_STRAIGHT;
  moveStraight[BOSS_SILKHAT_MODE_NORMAL]
    =BOSS_SILKHAT_NORMAL_MOV_STRAIGHT;
  moveStraight[BOSS_SILKHAT_MODE_HARD]=BOSS_SILKHAT_HARD_MOV_STRAIGHT;
  moveStraight[BOSS_SILKHAT_MODE_VHARD]=BOSS_SILKHAT_VHARD_MOV_STRAIGHT;
}

BossSilkHat::~BossSilkHat(){
  
  if(enemyList->first==boss){
    /*
    enemyList->Reject(boss);
    delete boss;
    */
  }
  else{
    if(boss){
      delete boss;
    }
  }
  boss=NULL;
}

void BossSilkHat::Create(){
  darkBlueGC=Gdk::GC::create(mWindow);
  darkBlueGC->set_rgb_fg_color(*(color->darkblue));
}

void BossSilkHat::CallStrBird(){
  int tmpX,tmpY,tmpD;

  tmpD=10;
  tmpX=-1*SIN[(boss->direct)%360]*tmpD/ANGLE_FLOAT-Map->speedX;
  tmpY=COS[(boss->direct)%360]*tmpD/ANGLE_FLOAT-Map->speedY;

  enemyList->Appear(boss->px,boss->py,8,8,
		    tmpX+4-rand()%9,tmpY+4-rand()%9,0,0,2,10,
		    EN_STR_BIRD,EN_MOV_STR,
		    EN_TOUCH_BLOW,0,
		    EN_FORM_TAR_SMALL,0,
		    EN_ITEMDROP_ALL,100);
}

void BossSilkHat::CallRevBird(){
  int tmpX,tmpY,tmpD;

  tmpD=10;
  tmpX=-1*SIN[(boss->direct)%360]*tmpD/ANGLE_FLOAT-Map->speedX;
  tmpY=COS[(boss->direct)%360]*tmpD/ANGLE_FLOAT-Map->speedY;

  enemyList->Appear(boss->px,boss->py,8,8,
		    tmpX+4-rand()%9,tmpY+4-rand()%9,0,0,2,10,
		    EN_REV_BIRD,EN_MOV_REV,
		    EN_TOUCH_REV,0,
		    EN_FORM_TAR_SMALL,0,
		    EN_ITEMDROP_ALL,100);
}

void BossSilkHat::CallHomBird(){
  int tmpX,tmpY,tmpD;
  BirdActor *act;

  tmpD=10;
  tmpX=-1*SIN[(boss->direct)%360]*tmpD/ANGLE_FLOAT-Map->speedX;
  tmpY=COS[(boss->direct)%360]*tmpD/ANGLE_FLOAT-Map->speedY;

  act=enemyList->Appear(boss->px,boss->py,8,8,
			tmpX+4-rand()%9,tmpY+4-rand()%9,
			14,1,2,10,
			EN_HOM_BIRD,EN_MOV_XYACCE,
			EN_TOUCH_CH_NOSTR,-1,
			EN_FORM_TAR_SMALL,0,
			EN_ITEMDROP_ALL,100);
  if(boss->px<player->px){
    if(boss->py<player->py){
      act->tmp=1;
    }
    else{
      act->tmp=3;
    }
  }
  else{
    if(boss->py<player->py){
      act->tmp=2;
    }
    else{
      act->tmp=4;
    }
  }
  act->target=player;
}

/*
  ATTACK
*/

void BossSilkHat::StrBirdAttackFreq(){
  int i;
  int max0;
  int rest0;
  max0=bossAttackFreq/BOSS_SILKHAT_ATTACK_FREQ_MAX;
  rest0=bossAttackFreq%BOSS_SILKHAT_ATTACK_FREQ_MAX;

  i=0;
  while(i<max0){
    CallStrBird();
    i++;
  }
  if(rand()%BOSS_SILKHAT_ATTACK_FREQ_MAX<rest0){
    CallStrBird();
  }
  
  if(bossAttackCount>0){
    bossAttackCount--;
  }
  else{
    bossAttack=attackChange[bossMode];
  }
}

void BossSilkHat::RevBirdAttackFreq(){
  int i;
  int max0;
  int rest0;
  max0=bossAttackFreq/BOSS_SILKHAT_ATTACK_FREQ_MAX;
  rest0=bossAttackFreq%BOSS_SILKHAT_ATTACK_FREQ_MAX;

  i=0;
  while(i<max0){
    CallRevBird();
    i++;
  }
  if(rand()%BOSS_SILKHAT_ATTACK_FREQ_MAX<rest0){
    CallRevBird();
  }
  
  if(bossAttackCount>0){
    bossAttackCount--;
  }
  else{
    bossAttack=attackChange[bossMode];
  }
}

void BossSilkHat::HomBirdAttackFreq(){
  int i;
  int max0;
  int rest0;
  max0=bossAttackFreq/BOSS_SILKHAT_ATTACK_FREQ_MAX;
  rest0=bossAttackFreq%BOSS_SILKHAT_ATTACK_FREQ_MAX;

  i=0;
  while(i<max0){
    CallHomBird();
    i++;
  }
  if(rand()%BOSS_SILKHAT_ATTACK_FREQ_MAX<rest0){
    CallHomBird();
  }
  
  if(bossAttackCount>0){
    bossAttackCount--;
  }
  else{
    bossAttack=attackChange[bossMode];
  }
}

/*
  ANGLE
*/

void BossSilkHat::SilkHatAngleStop(){
  if((boss->px>0&&boss->px<WIDTH)
     &&(boss->py>0&&boss->py<HEIGHT)){
    if(bossAngleCount>0){
      bossAngleCount--;
    }
    else{
      bossAngle=angleChange[bossMode];
    }
  }
  else{
    if(bossMove==moveStraight[bossMode]){
      bossAngle=angleChange[bossMode];
    }
  }
}
void BossSilkHat::SilkHatAngleTarget(){
  int sx,sy;
  int tx,ty;
  int in;

  sx=SIN[boss->direct%360]*32/ANGLE_FLOAT;
  sy=COS[boss->direct%360]*32/ANGLE_FLOAT;

  tx=bossATarX-boss->px;
  ty=boss->py-bossATarY;

  in=tx*sy-sx*ty;

  if(in>0){
    boss->direct-=boss->my;
  }
  else if(in<0){
    boss->direct+=boss->my;
  }

  if(bossAngleCount>0){
    bossAngleCount--;
  }
  else{
    bossAngle=angleChange[bossMode];
  }
}
void BossSilkHat::SilkHatAngleHoming(){
  int sx,sy;
  int tx,ty;
  int in;
  
  sx=SIN[boss->direct%360]*32/ANGLE_FLOAT;
  sy=COS[boss->direct%360]*32/ANGLE_FLOAT;

  tx=player->px-boss->px;
  ty=boss->py-player->py;

  in=tx*sy-sx*ty;

  if(in>0){
    boss->direct-=boss->my;
  }
  else if(in<0){
    boss->direct+=boss->my;    
  }

  if(bossAngleCount>0){
    bossAngleCount--;
  }
  else{
    bossAngle=angleChange[bossMode];
  }
}
void BossSilkHat::SilkHatAngleRotate(){
  boss->direct+=boss->my;

  if(bossAngleCount>0){
    bossAngleCount--;
  }
  else{
    bossAngle=angleChange[bossMode];
  }
}
void BossSilkHat::SilkHatAngleAvoid(){
  int sx,sy;
  int tx,ty;
  int in;
  
  sx=SIN[boss->direct%360]*32/ANGLE_FLOAT;
  sy=COS[boss->direct%360]*32/ANGLE_FLOAT;

  tx=player->px-boss->px;
  ty=boss->py-player->py;

  in=tx*sy-sx*ty;

  if(in>0){
    boss->direct+=boss->my;
  }
  else if(in<0){
    boss->direct-=boss->my;    
  }

  if((boss->px>0&&boss->px<WIDTH)
     &&(boss->py>0&&boss->py<HEIGHT)){
    if(bossAngleCount>0){
      bossAngleCount--;
    }
    else{
      bossAngle=angleChange[bossMode];
    }
  }
  else{
    bossAngle=angleChange[bossMode];
  }
}

/*
  MOVE
*/

void BossSilkHat::SilkHatMoveStop(){
  if(bossMoveCount>0){
    bossMoveCount--;
  }
  else{
    bossMove=moveChange[bossMode];
  } 
}
void BossSilkHat::SilkHatMoveStraight(){
  int tmpX,tmpY;
    
  tmpX=-1*SIN[(boss->direct)%360]*boss->mx/ANGLE_FLOAT;
  tmpY=COS[(boss->direct)%360]*boss->mx/ANGLE_FLOAT;
  
  boss->px+=tmpX;
  boss->py+=tmpY;
    
  if(bossMoveCount>0){
    bossMoveCount--;
  }
  else{
    bossMove=moveChange[bossMode];
  }
}
void BossSilkHat::SilkHatMoveTarget(){
  int sx,sy;
  sx=boss->px;
  sy=boss->py;

  DistApprox(&sx,&sy,bossTarX,bossTarY,boss->mx);

  boss->px+=sx;
  boss->py+=sy;

  if(ReachPoint(boss,bossTarX,bossTarY)==1){
    bossMove=moveChange[bossMode];
  }
}
void BossSilkHat::SilkHatMoveHoming(){
  int sx,sy;
  sx=boss->px;
  sy=boss->py;
  
  DistApprox(&sx,&sy,player->px,player->py,boss->mx);
  
  boss->px+=sx;
  boss->py+=sy;
  
  if(bossMoveCount>0){
    bossMoveCount--;
  }
  else{
    bossMove=moveChange[bossMode];
  }
}
void BossSilkHat::SilkHatMoveAvoid(){
  int sx,sy;
  sx=player->px;
  sy=player->py;
  
  DistApprox(&sx,&sy,boss->px,boss->py,boss->mx);
  
  boss->px+=sx;
  boss->py+=sy;
  
  if((boss->px>0&&boss->px<WIDTH)
     &&(boss->py>0&&boss->py<HEIGHT)){
    if(bossMoveCount>0){
      bossMoveCount--;
    }
    else{
      bossMove=moveChange[bossMode];
    }
  }
  else{
    bossMove=moveChange[bossMode];
  }
}

void BossSilkHat::Draw(){
  int px0,py0,tLife1,tLife2,hFlag0;
  std::stringstream ss;
  BirdPoint hat[4];
  BirdPoint edge[3];
  BirdPoint pass[3];
  BirdPoint damage[3];

  int r;
  r=100;

  hat[0].x=boss->px+SIN[(315+boss->direct)%360]*r/ANGLE_FLOAT;
  hat[0].y=boss->py-COS[(315+boss->direct)%360]*r/ANGLE_FLOAT;
  hat[1].x=boss->px+SIN[(45+boss->direct)%360]*r/ANGLE_FLOAT;
  hat[1].y=boss->py-COS[(45+boss->direct)%360]*r/ANGLE_FLOAT;
  hat[2].x=boss->px+SIN[(135+boss->direct)%360]*r/ANGLE_FLOAT;
  hat[2].y=boss->py-COS[(135+boss->direct)%360]*r/ANGLE_FLOAT;
  hat[3].x=boss->px+SIN[(225+boss->direct)%360]*r/ANGLE_FLOAT;
  hat[3].y=boss->py-COS[(225+boss->direct)%360]*r/ANGLE_FLOAT; 
 
  edge[0].x=boss->px+SIN[(180+boss->direct)%360]*1/3*r/ANGLE_FLOAT;
  edge[0].y=boss->py-COS[(180+boss->direct)%360]*1/3*r/ANGLE_FLOAT;
  edge[1].x=boss->px+SIN[(120+boss->direct)%360]*3/2*r/ANGLE_FLOAT;
  edge[1].y=boss->py-COS[(120+boss->direct)%360]*3/2*r/ANGLE_FLOAT;
  edge[2].x=boss->px+SIN[(240+boss->direct)%360]*3/2*r/ANGLE_FLOAT;
  edge[2].y=boss->py-COS[(240+boss->direct)%360]*3/2*r/ANGLE_FLOAT;

  pass[0].x=boss->px+SIN[(0+boss->direct)%360]*1/2*r/ANGLE_FLOAT;
  pass[0].y=boss->py-COS[(0+boss->direct)%360]*1/2*r/ANGLE_FLOAT;
  pass[1].x=boss->px+SIN[(140+boss->direct)%360]*1/1*r/ANGLE_FLOAT;
  pass[1].y=boss->py-COS[(140+boss->direct)%360]*1/1*r/ANGLE_FLOAT;
  pass[2].x=boss->px+SIN[(220+boss->direct)%360]*1/1*r/ANGLE_FLOAT;
  pass[2].y=boss->py-COS[(220+boss->direct)%360]*1/1*r/ANGLE_FLOAT;

  damage[0].x=boss->px+SIN[(0+boss->direct)%360]*1/2*r/ANGLE_FLOAT;
  damage[0].y=boss->py-COS[(0+boss->direct)%360]*1/2*r/ANGLE_FLOAT;
  damage[1].x=boss->px+SIN[(120+boss->direct)%360]*1/2*r/ANGLE_FLOAT;
  damage[1].y=boss->py-COS[(120+boss->direct)%360]*1/2*r/ANGLE_FLOAT;
  damage[2].x=boss->px+SIN[(240+boss->direct)%360]*1/2*r/ANGLE_FLOAT;
  damage[2].y=boss->py-COS[(240+boss->direct)%360]*1/2*r/ANGLE_FLOAT;

  BirdActor *node;
  BirdActor *tmp;

  node=pfireList->first;
  while(node){
    tmp=node->next;
    
    if(FigureRange(node->px,node->py,&damage[0],3)){
      /*
      boss->life-=node->life;
      node->life=0;
      */
      pfireList->EnemyTouchSelect(node,boss,1);
      boss->dcount=5;
    }
    else if(FigureRange(node->px,node->py,&pass[0],3)){
      
    }
    else{
      hFlag0=0;
      if(FigureRange(node->px,node->py,&hat[0],4)){
	hFlag0=1;
      }
      else if(FigureRange(node->px,node->py,&edge[0],3)){
	hFlag0=1;
      }

      if(hFlag0){
	tLife1=boss->life;
	tLife2=node->life;
	pfireList->EnemyTouchSelect(node,boss,1);

	boss->life=tLife1;
	boss->dcount=0;
	node->life=tLife2;
	node->dcount=0;

	if(boss->px>node->px){
	  node->mx=abs(node->mx)*-1;
	}
	else{
	  node->mx=abs(node->mx);
	}

	if(boss->py>node->py){
	  node->my=abs(node->my)*-1;
	}
	else{
	  node->my=abs(node->my);
	}
	
	if(abs(node->mx)<4&&abs(node->my)<4){
	  node->life=0;
	  node->dcount=0;
	}
	else{
	  node->move=PF_MOV_NOSTR;
	}
      }
    }
    node=tmp;
  }

  if(FigureRange(player->px,player->py,&hat[0],4)){
    /*
    std::cout<<"HIT HAT:("<<player->px<<","<<player->py<<")"<<std::endl;
    */
    TouchPlayer();
  }
  else if(FigureRange(player->px,player->py,&edge[0],3)){
    /*
    std::cout<<"HIT EDGE:("<<player->px<<","<<player->py<<")"<<std::endl;
    */
    TouchPlayer();
  }

  hatPoints[0].set_x(hat[0].x);
  hatPoints[0].set_y(hat[0].y);
  hatPoints[1].set_x(hat[1].x);
  hatPoints[1].set_y(hat[1].y);
  hatPoints[2].set_x(hat[2].x);
  hatPoints[2].set_y(hat[2].y);
  hatPoints[3].set_x(hat[3].x);
  hatPoints[3].set_y(hat[3].y);
  hatPoints[4].set_x(hat[0].x);
  hatPoints[4].set_y(hat[0].y);
  
  edgePoints[0].set_x(edge[0].x);
  edgePoints[0].set_y(edge[0].y);
  edgePoints[1].set_x(edge[1].x);
  edgePoints[1].set_y(edge[1].y);
  edgePoints[2].set_x(edge[2].x);
  edgePoints[2].set_y(edge[2].y);
  edgePoints[3].set_x(edge[0].x);
  edgePoints[3].set_y(edge[0].y);

  if(boss->dcount>0){
    boss->dcount--;

    frame->draw_polygon(redGC,true,hatPoints);

    frame->draw_polygon(redGC,true,edgePoints);
  }
  else{
    frame->draw_polygon(darkBlueGC,true,hatPoints);

    frame->draw_polygon(darkBlueGC,true,edgePoints);
  } 
  /*
  passPoints[0].set_x(pass[0].x);
  passPoints[0].set_y(pass[0].y);
  passPoints[1].set_x(pass[1].x);
  passPoints[1].set_y(pass[1].y);
  passPoints[2].set_x(pass[2].x);
  passPoints[2].set_y(pass[2].y);
  passPoints[3].set_x(pass[0].x);
  passPoints[3].set_y(pass[0].y);

  frame->draw_polygon(yellowGC,true,passPoints);

  damagePoints[0].set_x(damage[0].x);
  damagePoints[0].set_y(damage[0].y);
  damagePoints[1].set_x(damage[1].x);
  damagePoints[1].set_y(damage[1].y);
  damagePoints[2].set_x(damage[2].x);
  damagePoints[2].set_y(damage[2].y);
  damagePoints[3].set_x(damage[0].x);
  damagePoints[3].set_y(damage[0].y);

  frame->draw_polygon(redGC,true,damagePoints);
  */
  /*
  px0=WIDTH*(0)/MAP_XMAX;
  py0=HEIGHT*(1000)/MAP_YMAX;
  ss<<"freq:"<<bossAttackFreq/10<<"%"
    <<" (count:"<<bossAttackCount*2<<"0msec)";
  text->DrawString
    (ss.str(),(color->white),px0,py0,FONT_LINE_DOWNLEFT,20,
     FONT_SERIF,FONT_FACE_BOLD);
  ss.str("");
  ss.clear(std::stringstream::goodbit);
  */
}

int BossSilkHat::StartState(int bgBoss0,int mode0){
  if(!boss){
    bossMode=mode0;
    (this->*BOSS_SILKHAT_START_SELECT[bossMode])();
  }

  bossState=BOSS_SILKHAT_STATE_ACT;
  return bgBoss0;
}
int BossSilkHat::ActState(int bgBoss0,int mode0){

  (this->*BOSS_SILKHAT_ACT_SELECT[bossMode])();
  
  if(boss->life>0){
    Draw();
    LifeView(boss->life,lifeList[bossMode]);
  }
  else{
    baseStage->pfireList->ALLDelete();
    (baseStage->player)->target=NULL;
    enemyList->Reject(boss);
    enemyList->ALLDelete();
    
    bossState=BOSS_SILKHAT_STATE_EXPLODE;
    bossExplodeCount=70;
    bossExplode=0;
    bgBoss0=BOSS_ACT_BGSTOP;
  }
  return bgBoss0;
}
int BossSilkHat::ExplodeState(int bgBoss0,int mode0){
  bossExplodeCount+=-1;
  bossExplode+=bossExplodeCount/5;
  if(bossExplode>0){
    frame->draw_arc(redGC,true,
		    boss->px-bossExplode/2,
		    boss->py-bossExplode*3/2,
		    bossExplode,
		    bossExplode*3,
		    0,360*64);
    frame->draw_arc(orangeGC,true,
		    boss->px-bossExplode*3/2,
		    boss->py-bossExplode/2,
		    bossExplode*3,
		    bossExplode,
		    0,360*64);
  }
  else{
    bossCount=50;
    bossState=BOSS_SILKHAT_STATE_DEAD;
    if(boss!=NULL){
      delete boss;
    }
    boss=NULL;
  }
  return bgBoss0;
}
int BossSilkHat::DeadState(int bgBoss0,int mode0){
  if(bossCount>0){
    bossCount--;
  }
  else{
    bossState=BOSS_SILKHAT_STATE_START;
    bgBoss0=BOSS_ACT_END;
  }
  return bgBoss0;
}
int (BossSilkHat::*BossSilkHat::BOSS_SILKHAT_STATE_SELECT
     [BOSS_SILKHAT_STATE_NUM])(int bgBoss0,int mode0)={
       &BossSilkHat::StartState,
       &BossSilkHat::ActState,
       &BossSilkHat::ExplodeState,
       &BossSilkHat::DeadState
     };

int BossSilkHat::Act(int bgBoss0,int mode0){
  bgBoss0=(this->*BOSS_SILKHAT_STATE_SELECT[bossState])
    (bgBoss0,mode0);

  return bgBoss0;
}

/*
  START
*/

void BossSilkHat::VEasyStart(){
  boss= new BirdActor();

  boss->px=WIDTH*5/4;
  boss->py=HEIGHT*1/2;
  boss->width=10;
  boss->height=10;
  boss->move=EN_MOV_BOSS;
  boss->touch=EN_TOUCH_THROUGH;
  boss->life=lifeList[bossMode];
  boss->direct=0;
  boss->mx=4;
  boss->my=1;
  bossMove=BOSS_SILKHAT_VEASY_MOV_TARGET;
  bossAngle=BOSS_SILKHAT_VEASY_ANGLE_STOP;
  bossAttack=BOSS_SILKHAT_VEASY_ATTACK_STRBIRD;
  bossAttackFreq=0;
  bossTarX=WIDTH*3/4;
  bossTarY=HEIGHT/2;
  bossATarY=0;
  bossATarY=0;
  bossMoveCount=0;
  bossAngleCount=60;
  bossAttackCount=60;
  enemyList->Prepend(boss);
}
void BossSilkHat::EasyStart(){
  boss= new BirdActor();

  boss->px=WIDTH*5/4;
  boss->py=HEIGHT*1/2;
  boss->width=10;
  boss->height=10;
  boss->move=EN_MOV_BOSS;
  boss->touch=EN_TOUCH_THROUGH;
  boss->life=lifeList[bossMode];
  boss->direct=0;
  boss->mx=4;
  boss->my=1;
  bossMove=BOSS_SILKHAT_EASY_MOV_TARGET;
  bossAngle=BOSS_SILKHAT_EASY_ANGLE_STOP;
  bossAttack=BOSS_SILKHAT_EASY_ATTACK_STRBIRD;
  bossAttackFreq=0;
  bossTarX=WIDTH*3/4;
  bossTarY=HEIGHT/2;
  bossATarY=0;
  bossATarY=0;
  bossMoveCount=0;
  bossAngleCount=60;
  bossAttackCount=60;
  enemyList->Prepend(boss);
}
void BossSilkHat::NormalStart(){
  boss= new BirdActor();

  boss->px=WIDTH*5/4;
  boss->py=HEIGHT*1/2;
  boss->width=10;
  boss->height=10;
  boss->move=EN_MOV_BOSS;
  boss->touch=EN_TOUCH_THROUGH;
  boss->life=lifeList[bossMode];
  boss->direct=0;
  boss->mx=4;
  boss->my=1;
  bossMove=BOSS_SILKHAT_NORMAL_MOV_TARGET;
  bossAngle=BOSS_SILKHAT_NORMAL_ANGLE_STOP;
  bossAttack=BOSS_SILKHAT_NORMAL_ATTACK_STRBIRD;
  bossAttackFreq=0;
  bossTarX=WIDTH*3/4;
  bossTarY=HEIGHT/2;
  bossATarY=0;
  bossATarY=0;
  bossMoveCount=0;
  bossAngleCount=60;
  bossAttackCount=60;
  enemyList->Prepend(boss);
}
void BossSilkHat::HardStart(){
  boss= new BirdActor();

  boss->px=WIDTH*5/4;
  boss->py=HEIGHT*1/2;
  boss->width=10;
  boss->height=10;
  boss->move=EN_MOV_BOSS;
  boss->touch=EN_TOUCH_THROUGH;
  boss->life=lifeList[bossMode];
  boss->direct=0;
  boss->mx=4;
  boss->my=1;
  bossMove=BOSS_SILKHAT_HARD_MOV_TARGET;
  bossAngle=BOSS_SILKHAT_HARD_ANGLE_STOP;
  bossAttack=BOSS_SILKHAT_HARD_ATTACK_STRBIRD;
  bossAttackFreq=0;
  bossTarX=WIDTH*3/4;
  bossTarY=HEIGHT/2;
  bossATarY=0;
  bossATarY=0;
  bossMoveCount=0;
  bossAngleCount=60;
  bossAttackCount=60;
  enemyList->Prepend(boss);
}
void BossSilkHat::VHardStart(){
  boss= new BirdActor();
  
  boss->px=WIDTH*5/4;
  boss->py=HEIGHT*1/2;
  boss->width=10;
  boss->height=10;
  boss->move=EN_MOV_BOSS;
  boss->touch=EN_TOUCH_THROUGH;
  boss->life=lifeList[bossMode];
  boss->direct=0;
  boss->mx=4;
  boss->my=1;
  bossMove=BOSS_SILKHAT_VHARD_MOV_TARGET;
  bossAngle=BOSS_SILKHAT_VHARD_ANGLE_STOP;
  bossAttack=BOSS_SILKHAT_VHARD_ATTACK_STRBIRD;
  bossAttackFreq=0;
  bossTarX=WIDTH*3/4;
  bossTarY=HEIGHT/2;
  bossATarY=0;
  bossATarY=0;
  bossMoveCount=0;
  bossAngleCount=60;
  bossAttackCount=60;
  enemyList->Prepend(boss);
}
void (BossSilkHat::*BossSilkHat::
      BOSS_SILKHAT_START_SELECT[BOSS_SILKHAT_MODE_NUM])()={
	&BossSilkHat::VEasyStart,
	&BossSilkHat::EasyStart,
	&BossSilkHat::NormalStart,
	&BossSilkHat::HardStart,
	&BossSilkHat::VHardStart
      };

/*
  ACTION
*/

void BossSilkHat::VEasyAct(){
  (this->*BOSS_SILKHAT_VEASY_ATTACK_SELECT[bossAttack])();
  
  (this->*BOSS_SILKHAT_VEASY_ANGLE_SELECT[bossAngle])();
  
  if(boss->direct>360){
    boss->direct=boss->direct%360;
  }
  else if(boss->direct<0){
    boss->direct=boss->direct+360;
  }

  (this->*BOSS_SILKHAT_VEASY_MOV_SELECT[bossMove])();
}
void BossSilkHat::EasyAct(){
  (this->*BOSS_SILKHAT_EASY_ATTACK_SELECT[bossAttack])();
  
  (this->*BOSS_SILKHAT_EASY_ANGLE_SELECT[bossAngle])();
  
  if(boss->direct>360){
    boss->direct=boss->direct%360;
  }
  else if(boss->direct<0){
    boss->direct=boss->direct+360;
  }

  (this->*BOSS_SILKHAT_EASY_MOV_SELECT[bossMove])();
}
void BossSilkHat::NormalAct(){
  (this->*BOSS_SILKHAT_NORMAL_ATTACK_SELECT[bossAttack])();
  
  (this->*BOSS_SILKHAT_NORMAL_ANGLE_SELECT[bossAngle])();
  
  if(boss->direct>360){
    boss->direct=boss->direct%360;
  }
  else if(boss->direct<0){
    boss->direct=boss->direct+360;
  }

  (this->*BOSS_SILKHAT_NORMAL_MOV_SELECT[bossMove])();
}
void BossSilkHat::HardAct(){
  (this->*BOSS_SILKHAT_HARD_ATTACK_SELECT[bossAttack])();
  
  (this->*BOSS_SILKHAT_HARD_ANGLE_SELECT[bossAngle])();
  
  if(boss->direct>360){
    boss->direct=boss->direct%360;
  }
  else if(boss->direct<0){
    boss->direct=boss->direct+360;
  }

  (this->*BOSS_SILKHAT_HARD_MOV_SELECT[bossMove])();
}
void BossSilkHat::VHardAct(){
  (this->*BOSS_SILKHAT_VHARD_ATTACK_SELECT[bossAttack])();
  
  (this->*BOSS_SILKHAT_VHARD_ANGLE_SELECT[bossAngle])();
  
  if(boss->direct>360){
    boss->direct=boss->direct%360;
  }
  else if(boss->direct<0){
    boss->direct=boss->direct+360;
  }

  (this->*BOSS_SILKHAT_VHARD_MOV_SELECT[bossMove])();
}
void (BossSilkHat::*BossSilkHat::
      BOSS_SILKHAT_ACT_SELECT[BOSS_SILKHAT_MODE_NUM])()={
	&BossSilkHat::VEasyAct,
	&BossSilkHat::EasyAct,
	&BossSilkHat::NormalAct,
	&BossSilkHat::HardAct,
	&BossSilkHat::VHardAct
      };

/*
  VEASY
*/

void BossSilkHat::VEasyAttackChange(){
  bossAttack=rand()%(BOSS_SILKHAT_VEASY_ATTACK_NUM-1)+1;
  
  if(bossAttack==BOSS_SILKHAT_VEASY_ATTACK_STRBIRD){
    bossAttackFreq=rand()%(1000);
    bossAttackCount=(100-(100*abs(500-bossAttackFreq)/500))*3/2+50;
  }
}
void (BossSilkHat::*BossSilkHat::
      BOSS_SILKHAT_VEASY_ATTACK_SELECT
      [BOSS_SILKHAT_VEASY_ATTACK_NUM])()={
	&BossSilkHat::VEasyAttackChange,
	&BossSilkHat::StrBirdAttackFreq
      };

void BossSilkHat::VEasyAngleChange(){
  bossAngle=rand()%(BOSS_SILKHAT_VEASY_ANGLE_NUM-1)+1;

  if(bossAngle==BOSS_SILKHAT_VEASY_ANGLE_STOP){
    bossAngleCount=rand()%(50)+50;
  }
  else if(bossAngle==BOSS_SILKHAT_VEASY_ANGLE_TARGET){
    bossATarX=rand()%WIDTH;
    bossATarY=rand()%HEIGHT;
    boss->my=rand()%2+2;
    bossAngleCount=(rand()%100+100)/boss->my;
  }
  else if(bossAngle==BOSS_SILKHAT_VEASY_ANGLE_HOMING){
    boss->my=rand()%2+2;
    bossAngleCount=(rand()%100+100)/boss->my;
  }
  else if(bossAngle==BOSS_SILKHAT_VEASY_ANGLE_ROTATE){
    if(rand()%2==0){
      boss->my=30-rand()%20;
    }
    else{
      boss->my=rand()%20-30;
    }
    bossAngleCount=(500)/abs(boss->my);
  }
}
void (BossSilkHat::*BossSilkHat::
      BOSS_SILKHAT_VEASY_ANGLE_SELECT[BOSS_SILKHAT_VEASY_ANGLE_NUM])()={
	&BossSilkHat::VEasyAngleChange,
	&BossSilkHat::SilkHatAngleStop,
	&BossSilkHat::SilkHatAngleTarget,
	&BossSilkHat::SilkHatAngleHoming,
	&BossSilkHat::SilkHatAngleRotate
      };

void BossSilkHat::VEasyMoveChange(){
  bossMove=rand()%(BOSS_SILKHAT_VEASY_MOV_NUM-1)+1;
  boss->mx=rand()%2+2;

  if(bossMove==BOSS_SILKHAT_VEASY_MOV_STOP){
    bossMoveCount=rand()%(50)+50;
  }
  else if(bossMove==BOSS_SILKHAT_VEASY_MOV_STRAIGHT){
    bossMoveCount=(rand()%150+150)/boss->mx;
  }
  else if(bossMove==BOSS_SILKHAT_VEASY_MOV_TARGET){
    bossTarX=rand()%WIDTH;
    bossTarY=rand()%HEIGHT;
  }
  else if(bossMove==BOSS_SILKHAT_VEASY_MOV_HOMING){
    bossMoveCount=(rand()%100+100)/boss->mx;
  }
  else if(bossMove==BOSS_SILKHAT_VEASY_MOV_AVOID){
    bossMoveCount=(rand()%100+100)/boss->mx;
  }
}
void (BossSilkHat::*BossSilkHat::
      BOSS_SILKHAT_VEASY_MOV_SELECT[BOSS_SILKHAT_VEASY_MOV_NUM])()={
	&BossSilkHat::VEasyMoveChange,
	&BossSilkHat::SilkHatMoveStop,
	&BossSilkHat::SilkHatMoveStraight,
	&BossSilkHat::SilkHatMoveTarget,
	&BossSilkHat::SilkHatMoveHoming,
	&BossSilkHat::SilkHatMoveAvoid
      };

/*
  EASY
*/

void BossSilkHat::EasyAttackChange(){
  bossAttack=rand()%(BOSS_SILKHAT_EASY_ATTACK_NUM-1)+1;
  
  if(bossAttack==BOSS_SILKHAT_EASY_ATTACK_STRBIRD){
    bossAttackFreq=rand()%(2000);
    bossAttackCount=(100-(100*abs(1000-bossAttackFreq)/1000))+25;
  }
}
void (BossSilkHat::*BossSilkHat::
      BOSS_SILKHAT_EASY_ATTACK_SELECT
      [BOSS_SILKHAT_EASY_ATTACK_NUM])()={
	&BossSilkHat::EasyAttackChange,
	&BossSilkHat::StrBirdAttackFreq
      };

void BossSilkHat::EasyAngleChange(){
  bossAngle=rand()%(BOSS_SILKHAT_EASY_ANGLE_NUM-1)+1;

  if(bossAngle==BOSS_SILKHAT_EASY_ANGLE_STOP){
    bossAngleCount=rand()%(50)+50;
  }
  else if(bossAngle==BOSS_SILKHAT_EASY_ANGLE_TARGET){
    bossATarX=rand()%WIDTH;
    bossATarY=rand()%HEIGHT;
    boss->my=rand()%2+2;
    bossAngleCount=(rand()%100+100)/boss->my;
  }
  else if(bossAngle==BOSS_SILKHAT_EASY_ANGLE_HOMING){
    boss->my=rand()%2+2;
    bossAngleCount=(rand()%100+100)/boss->my;
  }
  else if(bossAngle==BOSS_SILKHAT_EASY_ANGLE_ROTATE){
    if(rand()%2==0){
      boss->my=30-rand()%20;
    }
    else{
      boss->my=rand()%20-30;
    }
    bossAngleCount=(500)/abs(boss->my);
  }
}
void (BossSilkHat::*BossSilkHat::
      BOSS_SILKHAT_EASY_ANGLE_SELECT[BOSS_SILKHAT_EASY_ANGLE_NUM])()={
	&BossSilkHat::EasyAngleChange,
	&BossSilkHat::SilkHatAngleStop,
	&BossSilkHat::SilkHatAngleTarget,
	&BossSilkHat::SilkHatAngleHoming,
	&BossSilkHat::SilkHatAngleRotate
      };

void BossSilkHat::EasyMoveChange(){
  bossMove=rand()%(BOSS_SILKHAT_EASY_MOV_NUM-1)+1;
  boss->mx=rand()%2+2;

  if(bossMove==BOSS_SILKHAT_EASY_MOV_STOP){
    bossMoveCount=rand()%(50)+50;
  }
  else if(bossMove==BOSS_SILKHAT_EASY_MOV_STRAIGHT){
    bossMoveCount=(rand()%150+150)/boss->mx;
  }
  else if(bossMove==BOSS_SILKHAT_EASY_MOV_TARGET){
    bossTarX=rand()%WIDTH;
    bossTarY=rand()%HEIGHT;
  }
  else if(bossMove==BOSS_SILKHAT_EASY_MOV_HOMING){
    bossMoveCount=(rand()%100+100)/boss->mx;
  }
  else if(bossMove==BOSS_SILKHAT_EASY_MOV_AVOID){
    bossMoveCount=(rand()%100+100)/boss->mx;
  }
}
void (BossSilkHat::*BossSilkHat::
      BOSS_SILKHAT_EASY_MOV_SELECT[BOSS_SILKHAT_EASY_MOV_NUM])()={
	&BossSilkHat::EasyMoveChange,
	&BossSilkHat::SilkHatMoveStop,
	&BossSilkHat::SilkHatMoveStraight,
	&BossSilkHat::SilkHatMoveTarget,
	&BossSilkHat::SilkHatMoveHoming,
	&BossSilkHat::SilkHatMoveAvoid
      };

/*
  NORMAL
*/

void BossSilkHat::NormalAttackChange(){
  bossAttack=rand()%(BOSS_SILKHAT_NORMAL_ATTACK_NUM-1)+1;
  
  if(bossAttack==BOSS_SILKHAT_NORMAL_ATTACK_STRBIRD){
    bossAttackFreq=rand()%(2000);
    bossAttackCount=(100-(100*abs(1000-bossAttackFreq)/1000))+20;
  }
  else if(bossAttack==BOSS_SILKHAT_NORMAL_ATTACK_REVBIRD){
    bossAttackFreq=rand()%(1000);
    bossAttackCount=(100-(100*abs(500-bossAttackFreq)/500))/2+10;
  }
  else if(bossAttack==BOSS_SILKHAT_NORMAL_ATTACK_HOMBIRD){
    bossAttackFreq=rand()%(1000);
    bossAttackCount=(100-(100*abs(500-bossAttackFreq)/500))/2+10;
  }
}
void (BossSilkHat::*BossSilkHat::
      BOSS_SILKHAT_NORMAL_ATTACK_SELECT
      [BOSS_SILKHAT_NORMAL_ATTACK_NUM])()={
	&BossSilkHat::NormalAttackChange,
	&BossSilkHat::StrBirdAttackFreq,
	&BossSilkHat::RevBirdAttackFreq,
	&BossSilkHat::HomBirdAttackFreq
      };

void BossSilkHat::NormalAngleChange(){
  bossAngle=rand()%(BOSS_SILKHAT_NORMAL_ANGLE_NUM-1)+1;

  if(bossAngle==BOSS_SILKHAT_NORMAL_ANGLE_STOP){
    bossAngleCount=rand()%(50)+50;
  }
  else if(bossAngle==BOSS_SILKHAT_NORMAL_ANGLE_HOMING){
    boss->my=rand()%2+2;
    bossAngleCount=(rand()%100+100)/boss->my;
  }
  else if(bossAngle==BOSS_SILKHAT_NORMAL_ANGLE_ROTATE){
    if(rand()%2==0){
      boss->my=30-rand()%20;
    }
    else{
      boss->my=rand()%20-30;
    }
    bossAngleCount=(500)/abs(boss->my);
  }
  else if(bossAngle==BOSS_SILKHAT_NORMAL_ANGLE_AVOID){
    boss->my=rand()%2+2;
    bossAngleCount=(rand()%100+100)/boss->my;
  }
}
void (BossSilkHat::*BossSilkHat::
      BOSS_SILKHAT_NORMAL_ANGLE_SELECT
      [BOSS_SILKHAT_NORMAL_ANGLE_NUM])()={
	&BossSilkHat::NormalAngleChange,
	&BossSilkHat::SilkHatAngleStop,
	&BossSilkHat::SilkHatAngleHoming,
	&BossSilkHat::SilkHatAngleRotate,
	&BossSilkHat::SilkHatAngleAvoid
      };

void BossSilkHat::NormalMoveChange(){
  bossMove=rand()%(BOSS_SILKHAT_NORMAL_MOV_NUM-1)+1;
  boss->mx=rand()%2+2;

  if(bossMove==BOSS_SILKHAT_NORMAL_MOV_STOP){
    bossMoveCount=rand()%(50)+50;
  }
  else if(bossMove==BOSS_SILKHAT_NORMAL_MOV_STRAIGHT){
    bossMoveCount=(rand()%150+150)/boss->mx;
  }
  else if(bossMove==BOSS_SILKHAT_NORMAL_MOV_TARGET){
    bossTarX=rand()%WIDTH;
    bossTarY=rand()%HEIGHT;
  }
  else if(bossMove==BOSS_SILKHAT_NORMAL_MOV_HOMING){
    bossMoveCount=(rand()%100+100)/boss->mx;
  }
  else if(bossMove==BOSS_SILKHAT_NORMAL_MOV_AVOID){
    bossMoveCount=(rand()%100+100)/boss->mx;
  }
}
void (BossSilkHat::*BossSilkHat::
      BOSS_SILKHAT_NORMAL_MOV_SELECT[BOSS_SILKHAT_NORMAL_MOV_NUM])()={
	&BossSilkHat::NormalMoveChange,
	&BossSilkHat::SilkHatMoveStop,
	&BossSilkHat::SilkHatMoveStraight,
	&BossSilkHat::SilkHatMoveTarget,
	&BossSilkHat::SilkHatMoveHoming,
	&BossSilkHat::SilkHatMoveAvoid
      };

/*
  HARD
*/

void BossSilkHat::HardAttackChange(){
  bossAttack=rand()%(BOSS_SILKHAT_HARD_ATTACK_NUM-1)+1;
  
  if(bossAttack==BOSS_SILKHAT_HARD_ATTACK_STRBIRD){
    bossAttackFreq=rand()%(4000);
    bossAttackCount=(100-(100*abs(2000-bossAttackFreq)/2000))+25;
  }
}
void (BossSilkHat::*BossSilkHat::
      BOSS_SILKHAT_HARD_ATTACK_SELECT
      [BOSS_SILKHAT_HARD_ATTACK_NUM])()={
	&BossSilkHat::HardAttackChange,
	&BossSilkHat::StrBirdAttackFreq
      };

void BossSilkHat::HardAngleChange(){
  bossAngle=rand()%(BOSS_SILKHAT_HARD_ANGLE_NUM-1)+1;

  if(bossAngle==BOSS_SILKHAT_HARD_ANGLE_STOP){
    bossAngleCount=rand()%(25)+25;
  }
  else if(bossAngle==BOSS_SILKHAT_HARD_ANGLE_TARGET){
    bossATarX=rand()%WIDTH;
    bossATarY=rand()%HEIGHT;
    boss->my=rand()%3+3;
    bossAngleCount=(rand()%100+100)/boss->my;
  }
  else if(bossAngle==BOSS_SILKHAT_HARD_ANGLE_HOMING){
    boss->my=rand()%3+3;
    bossAngleCount=(rand()%100+100)/boss->my;
  }
  else if(bossAngle==BOSS_SILKHAT_HARD_ANGLE_ROTATE){
    if(rand()%2==0){
      boss->my=30-rand()%20;
    }
    else{
      boss->my=rand()%20-30;
    }
    bossAngleCount=(rand()%500+500)/abs(boss->my);
  }
}
void (BossSilkHat::*BossSilkHat::
      BOSS_SILKHAT_HARD_ANGLE_SELECT[BOSS_SILKHAT_HARD_ANGLE_NUM])()={
	&BossSilkHat::HardAngleChange,
	&BossSilkHat::SilkHatAngleStop,
	&BossSilkHat::SilkHatAngleTarget,
	&BossSilkHat::SilkHatAngleHoming,
	&BossSilkHat::SilkHatAngleRotate
      };

void BossSilkHat::HardMoveChange(){
  bossMove=rand()%(BOSS_SILKHAT_HARD_MOV_NUM-1)+1;
  boss->mx=rand()%3+3;

  if(bossMove==BOSS_SILKHAT_HARD_MOV_STOP){
    bossMoveCount=rand()%(25)+25;
  }
  else if(bossMove==BOSS_SILKHAT_HARD_MOV_STRAIGHT){
    bossMoveCount=(rand()%150+150)/boss->mx;
  }
  else if(bossMove==BOSS_SILKHAT_HARD_MOV_TARGET){
    bossTarX=rand()%WIDTH;
    bossTarY=rand()%HEIGHT;
  }
  else if(bossMove==BOSS_SILKHAT_HARD_MOV_HOMING){
    bossMoveCount=(rand()%100+100)/boss->mx;
  }
  else if(bossMove==BOSS_SILKHAT_HARD_MOV_AVOID){
    bossMoveCount=(rand()%100+100)/boss->mx;
  }
}
void (BossSilkHat::*BossSilkHat::
      BOSS_SILKHAT_HARD_MOV_SELECT[BOSS_SILKHAT_HARD_MOV_NUM])()={
	&BossSilkHat::HardMoveChange,
	&BossSilkHat::SilkHatMoveStop,
	&BossSilkHat::SilkHatMoveStraight,
	&BossSilkHat::SilkHatMoveTarget,
	&BossSilkHat::SilkHatMoveHoming,
	&BossSilkHat::SilkHatMoveAvoid
      };

/*
  VHARD
*/

void BossSilkHat::VHardAttackChange(){
  bossAttack=rand()%(BOSS_SILKHAT_VHARD_ATTACK_NUM-1)+1;

  if(bossAttack==BOSS_SILKHAT_VHARD_ATTACK_STRBIRD){
    bossAttackFreq=rand()%(4000);
    bossAttackCount=(100-(100*abs(2000-bossAttackFreq)/2000))+20;
  }
  else if(bossAttack==BOSS_SILKHAT_VHARD_ATTACK_REVBIRD){
    bossAttackFreq=rand()%(2000);
    bossAttackCount=(100-(100*abs(1000-bossAttackFreq)/1000))/2+10;
  }
  else if(bossAttack==BOSS_SILKHAT_VHARD_ATTACK_HOMBIRD){
    bossAttackFreq=rand()%(2000);
    bossAttackCount=(100-(100*abs(1000-bossAttackFreq)/1000))/2+10;
  }
}
void (BossSilkHat::*BossSilkHat::
      BOSS_SILKHAT_VHARD_ATTACK_SELECT
      [BOSS_SILKHAT_VHARD_ATTACK_NUM])()={
	&BossSilkHat::VHardAttackChange,
	&BossSilkHat::StrBirdAttackFreq,
	&BossSilkHat::RevBirdAttackFreq,
	&BossSilkHat::HomBirdAttackFreq
      };

void BossSilkHat::VHardAngleChange(){
  bossAngle=rand()%(BOSS_SILKHAT_VHARD_ANGLE_NUM-1)+1;

  if(bossAngle==BOSS_SILKHAT_VHARD_ANGLE_STOP){
    bossAngleCount=rand()%25+(25);
  }
  else if(bossAngle==BOSS_SILKHAT_VHARD_ANGLE_HOMING){
    boss->my=rand()%3+3;
    bossAngleCount=(rand()%100+100)/boss->my;
  }
  else if(bossAngle==BOSS_SILKHAT_VHARD_ANGLE_ROTATE){
    if(rand()%2==0){
      boss->my=30-rand()%20;
    }
    else{
      boss->my=rand()%20-30;
    }
    bossAngleCount=(rand()%500+500)/abs(boss->my);
  }
  else if(bossAngle==BOSS_SILKHAT_VHARD_ANGLE_AVOID){
    boss->my=rand()%3+3;
    bossAngleCount=(rand()%100+100)/boss->my;
  }
}
void (BossSilkHat::*BossSilkHat::
      BOSS_SILKHAT_VHARD_ANGLE_SELECT[BOSS_SILKHAT_VHARD_ANGLE_NUM])()={
	&BossSilkHat::VHardAngleChange,
	&BossSilkHat::SilkHatAngleStop,
	&BossSilkHat::SilkHatAngleHoming,
	&BossSilkHat::SilkHatAngleRotate,
	&BossSilkHat::SilkHatAngleAvoid
      };

void BossSilkHat::VHardMoveChange(){
  bossMove=rand()%(BOSS_SILKHAT_VHARD_MOV_NUM-1)+1;
  boss->mx=rand()%3+3;

  if(bossMove==BOSS_SILKHAT_VHARD_MOV_STOP){
    bossMoveCount=rand()%25+25;
  }
  else if(bossMove==BOSS_SILKHAT_VHARD_MOV_STRAIGHT){
    bossMoveCount=(rand()%150+150)/boss->mx;
  }
  else if(bossMove==BOSS_SILKHAT_VHARD_MOV_TARGET){
    bossTarX=rand()%WIDTH;
    bossTarY=rand()%HEIGHT;
  }
  else if(bossMove==BOSS_SILKHAT_VHARD_MOV_HOMING){
    bossMoveCount=(rand()%100+100)/boss->mx;
  }
  else if(bossMove==BOSS_SILKHAT_VHARD_MOV_AVOID){
    bossMoveCount=(rand()%100+100)/boss->mx;
  }
}
void (BossSilkHat::*BossSilkHat::
      BOSS_SILKHAT_VHARD_MOV_SELECT[BOSS_SILKHAT_VHARD_MOV_NUM])()={
	&BossSilkHat::VHardMoveChange,
	&BossSilkHat::SilkHatMoveStop,
	&BossSilkHat::SilkHatMoveStraight,
	&BossSilkHat::SilkHatMoveTarget,
	&BossSilkHat::SilkHatMoveHoming,
	&BossSilkHat::SilkHatMoveAvoid
      };
