#ifndef BIRD_USER_CONTROL_H_
#define BIRD_USER_CONTROL_H_

#include <gtkmm.h>
#include <iostream>

#define CONTROL_KEYFLAG_NO 0
#define CONTROL_KEYFLAG_RECEIVE 1
#define CONTROL_KEYFLAG_NUM 2

class BirdControl{
 private:
  int keyFlag;
  int keyValue;
  guint okKey1;
  guint okKey2;
  guint cancelKey;
  guint upKey;
  guint downKey;
  guint leftKey;
  guint rightKey;
 public:
  int okKeyValue;
  int cancelKeyValue;
  int upKeyValue;
  int downKeyValue;
  int leftKeyValue;
  int rightKeyValue;
  int selectValue;
  int okValue;
  int cancelValue;
  BirdControl();
  ~BirdControl();
  void Create(Gtk::Window *window0);
  std::string GetKeyName(guint value0);

  guint GetOkKey();
  guint GetCancelKey();
  guint GetLeftKey();
  guint GetRightKey();
  guint GetUpKey();
  guint GetDownKey();

  void SetOkKey(guint key0);
  void SetCancelKey(guint key0);
  void SetLeftKey(guint key0);
  void SetRightKey(guint key0);
  void SetUpKey(guint key0);
  void SetDownKey(guint key0);

  void ChangeKeyFlag(int flag0);
  int GetKeyValue(int &value);

  void GameKeyPress(GdkEventKey *event);
  void ReceiveKeyPress(GdkEventKey *event);

  void GameKeyRelease(GdkEventKey *event);
 protected:
  bool KeyPressEvent(GdkEventKey *event);
  bool KeyReleaseEvent(GdkEventKey *event);
};

#endif
