#ifndef BIRD_CREATE_BASE_H_
#define BIRD_CREATE_BASE_H_

#include <gtkmm.h>
#include <fstream>
#include "basestage.h"

#define CREATE_GC_BLACK 0
#define CREATE_GC_GRAY 1
#define CREATE_GC_SKY 2
#define CREATE_GC_RED 3
#define CREATE_GC_YELLOW 4
#define CREATE_GC_WHITE 5
#define CREATE_GC_NUM 6

#define CREATE_STATE_TOP 0
#define CREATE_STATE_CROWD 1
#define CREATE_STATE_CRST 2
#define CREATE_STATE_LAND 3
#define CREATE_STATE_LANDST 4
#define CREATE_STATE_MODAL 5
#define CREATE_STATE_MODALST 6
#define CREATE_STATE_CROWDINDEX 7
#define CREATE_STATE_LANDINDEX 8
#define CREATE_STATE_TIMELINE 9
#define CREATE_STATE_MODALINDEX 10
#define CREATE_STATE_PLAY 11
#define CREATE_STATE_PAUSE 12
#define CREATE_STATE_BACKGROUND 13
#define CREATE_STATE_GAMESTART 14
#define CREATE_STATE_GAMEEND 15
#define CREATE_STATE_EXIT 16
#define CREATE_STATE_STATUS 17
#define CREATE_STATE_NUM 18

#define CREATE_VX_STATE_TOP 0
#define CREATE_VX_STATE_CROWD 1
#define CREATE_VX_CRST_TYPE 2
#define CREATE_VX_CRST_WAY 3
#define CREATE_VX_CRST_MINW 4
#define CREATE_VX_CRST_MAXW 5
#define CREATE_VX_CRST_MINH 6
#define CREATE_VX_CRST_MAXH 7
#define CREATE_VX_STATE_LAND 8
#define CREATE_VX_LANDST_TYPE 9
#define CREATE_VX_LANDST_COLOR 10
#define CREATE_VX_LANDST_FREQ 11
#define CREATE_VX_LANDST_MINL 12
#define CREATE_VX_LANDST_MAXL 13
#define CREATE_VX_LANDST_MINR 14
#define CREATE_VX_LANDST_MAXR 15
#define CREATE_VX_LANDST_MINU 16
#define CREATE_VX_LANDST_MAXU 17
#define CREATE_VX_LANDST_MIND 18
#define CREATE_VX_LANDST_MAXD 19
#define CREATE_VX_LANDST_MINPX 20
#define CREATE_VX_LANDST_MAXPX 21
#define CREATE_VX_LANDST_MINPY 22
#define CREATE_VX_LANDST_MAXPY 23
#define CREATE_VX_STATE_MODAL 24
#define CREATE_VX_MODALST_SPEEDX 25
#define CREATE_VX_MODALST_SPEEDY 26
#define CREATE_VX_MODALST_MINW 27
#define CREATE_VX_MODALST_MAXW 28
#define CREATE_VX_MODALST_MINH 29
#define CREATE_VX_MODALST_MAXH 30
#define CREATE_VX_MODALST_CRFREQ 31
#define CREATE_VX_MODALST_NLAND 32
#define CREATE_VX_MODALST_INDEXLAND 33
#define CREATE_VX_MODALST_INDEXCR 34
#define CREATE_VX_MODALST_ALLCROWD 35
#define CREATE_VX_STATE_CROWDINDEX 36
#define CREATE_VX_STATE_CROWDINDEXPOS 37
#define CREATE_VX_STATE_LANDINDEX 38
#define CREATE_VX_STATE_LANDINDEXPOS 39
#define CREATE_VX_TIMELINE_SHIFT 40
#define CREATE_VX_TIMELINE_LINE 41
#define CREATE_VX_TIMELINE_MENU 42
#define CREATE_VX_TIMELINE_LINEPOS 43
#define CREATE_VX_STATE_MODALINDEX 44
#define CREATE_VX_STATE_MODALINDEXPOS 45
#define CREATE_VX_CROWD_SHIFTTYPE 46
#define CREATE_VX_LAND_SHIFTTYPE 47
#define CREATE_VX_MODAL_SHIFTTYPE 48
#define CREATE_VX_STATE_PAUSE 49
#define CREATE_VX_STATE_BACKGROUND 50
#define CREATE_VX_BACKGROUND_SHIFT 51
#define CREATE_VX_BGSIZE_WIDTH 52
#define CREATE_VX_BGSIZE_HEIGHT 53
#define CREATE_VX_BGSIZE_ROTATE 54
#define CREATE_VX_BGSIZE_FLIP 55
#define CREATE_VX_BGINTERVAL_XINTERVAL 56
#define CREATE_VX_BGINTERVAL_YINTERVAL 57
#define CREATE_VX_GAMESTART_POINT 58
#define CREATE_VX_STATE_EXIT 59
#define CREATE_VX_STATUS_NAME 60
#define CREATE_VX_STATUS_LIFE 61
#define CREATE_VX_STATUS_FIRE 62
#define CREATE_VX_STATUS_FORM 63

#define CREATE_VY_TOP_LPLACE 0
#define CREATE_VY_TOP_RPLACE 1
#define CREATE_VY_CROWD_LPLACE 2
#define CREATE_VY_CROWD_RPLACE 3
#define CREATE_VY_CROWD_LPOS 4
#define CREATE_VY_CROWD_COPY 5
#define CREATE_VY_STATE_CRST 6
#define CREATE_VY_LAND_LPLACE 7
#define CREATE_VY_LAND_RPLACE 8
#define CREATE_VY_STATE_LANDST 9
#define CREATE_VY_MODAL_LPLACE 10
#define CREATE_VY_MODAL_RPLACE 11
#define CREATE_VY_STATE_MODALST 12
#define CREATE_VY_STATE_CROWDINDEX 13
#define CREATE_VY_STATE_LANDINDEX 14
#define CREATE_VY_STATE_TIMELINE 15
#define CREATE_VY_TIMELINE_SHIFTTYPE 16
#define CREATE_VY_STATE_MODALINDEX 17
#define CREATE_VY_LAND_COPY 18
#define CREATE_VY_MODAL_COPY 19
#define CREATE_VY_PAUSE_MENU 20
#define CREATE_VY_BACKGROUND_STRUCT 21
#define CREATE_VY_BACKGROUND_MENU 22
#define CREATE_VY_SHIFT_BGSIZE 23
#define CREATE_VY_SHIFT_BGINTERVAL 24
#define CREATE_VY_STATE_STATUS 25

#define CREATE_TOP_NPLACE 2
#define CREATE_CROWD_NPLACE 2
#define CREATE_CRST_NUM 6
#define CREATE_LAND_NPLACE 2
#define CREATE_LANDST_NUM 15
#define CREATE_MODAL_NPLACE 2
#define CREATE_MODALST_NUM 11

#define CREATE_MODAL_WAITMAP 998
#define CREATE_MODAL_CHANGEMAP 999

class CreateBase{
 public:
  Glib::RefPtr<Gdk::Pixbuf> mIcon;
  std::vector<Gdk::Point> points;
  Glib::RefPtr<Gdk::Pixbuf> wood;
  Glib::RefPtr<Gdk::Pixbuf> rock;
  BaseStage *baseStage;
  BirdMap *Map;
  BirdColor *color;
  BirdText *text;
  BirdControl *control;
  BirdEnemy *enemyList;
  BirdLand *landList;
  BirdSprite endSprite;
  BirdSprite waitSprite;
  Glib::RefPtr<Gdk::Pixmap> frame;
  Glib::RefPtr<Gdk::Window> mWindow;
  Glib::RefPtr<Gdk::GC> brownGC;
  Glib::RefPtr<Gdk::GC> grayGC;
  Glib::RefPtr<Gdk::GC> yellowGC;
  Glib::RefPtr<Gdk::GC> skyGC;
  Glib::RefPtr<Gdk::GC> blackGC;
  Glib::RefPtr<Gdk::GC> whiteGC;
  Glib::RefPtr<Gdk::GC> GCList[CREATE_GC_NUM];
  CreateBase();
  ~CreateBase();
  void SetStage(BaseStage *baseStage0,
		Glib::RefPtr<Gdk::Window> mWindow0,
		Glib::RefPtr<Gdk::Pixmap> frame0);

  Gdk::Color ColorSelect
    (int *A,int *A0,int An,Gdk::Color *colorA,
     int *B,int *B0,int Bn,Gdk::Color *colorB,
     Gdk::Color *color0);
  Gdk::Color *ColorSelect0
    (int *A,int *A0,int An,Gdk::Color *colorA,
     int *B,int *B0,int Bn,Gdk::Color *colorB,
     Gdk::Color *color0);

  Glib::RefPtr<Gdk::GC> CursorGC
    (int *A,int *A0,int An,int colorA,
     int *B,int *B0,int Bn,int colorB,
     int color0);
  void RunWoodBG(int px0,int py0,int width0,int height0);
  void RunRockBG(int px0,int py0,int width0,int height0);
    
  void NoCrowd(int px,int py,int way);
  void StrBird(int px,int py,int way);
  void TarBird(int px,int py,int way);
  void RevBird(int px,int py,int way);
  void HomBird(int px,int py,int way);
  void SmallBat(int px,int py,int way);
  void BigBat(int px,int py,int way);
  void SmallSphenics(int px,int py,int way);
  void WideSphenics(int px,int py,int way);
  void JumpGallus(int px,int py,int way);
  void RunStruthio(int px,int py,int way);
  void SmallCrossStrix(int px,int py,int way);
  void SmallXRevStrix(int px,int py,int way);
  void HomEagle(int px,int py,int way);
  void LineHomEagle(int px,int py,int way);

  void DrawCrowd(int px,int py,int type,int way);
  void ScaleCrowd(int px,int py,int type,int way,int width,int height);

  void DrawNoLand(int px,int py,int width,int height,int color);
  void DrawLandLeft(int px,int py,int width,int height,int color);
  void DrawLandRight(int px,int py,int width,int height,int color);
  void DrawLandUp(int px,int py,int width,int height,int color);
  void DrawLandDown(int px,int py,int width,int height,int color);

  static void(CreateBase::*CREATE_DRAW_LAND_VIEW[MODAL_LAND_TYPE_NUM])
    (int px,int py,int width,int height,int color);

  void DrawLandView(int type,int color,
		    int px,int py,int width,int height);

  void DrawModalView(StageModal *modal,
		     int px,int py,int width,int height);
  void CrowdIndexMap(int minW,int maxW,int minH,int maxH);
  void LandIndexMap(int minW,int maxW,int minH,int maxH);
  void ModalIndexMap(int minW,int maxW,int minH,int maxH);

};

#endif
