#include"createcrowd.h"

CreateCrowd::CreateCrowd(){
  crowdWay[CROWD_WAY_F]="forward";
  crowdWay[CROWD_WAY_B]="back";
}

CreateCrowd::~CreateCrowd(){

}

void CreateCrowd::Create(BaseStage *baseStage0){

}

void CreateCrowd::CrowdTimeLineSelect(){
  Map->state0=Map->state;
  Map->state=CREATE_STATE_TIMELINE;
}
void CreateCrowd::CrowdModalSelect(){
  Map->state0=Map->state;
  Map->state=CREATE_STATE_MODAL;
}
void CreateCrowd::CrowdLandSelect(){
  Map->state0=Map->state;
  Map->state=CREATE_STATE_LAND;
}
void CreateCrowd::CrowdTopSelect(){
  Map->state0=Map->state;
  Map->state=CREATE_STATE_TOP;
}
void CreateCrowd::CrowdCopySelect(){
  Map->valueX[CREATE_VX_CROWD_SHIFTTYPE]=CREATE_CROWD_SHIFT_COPY;
  Map->valueX[CREATE_VX_STATE_CROWD]=CREATE_VY_CROWD_LPLACE;
}
void CreateCrowd::CrowdLoadSelect(){
  Glib::ustring path,path0;
  Glib::ustring file;
  Glib::ustring name;
  Glib::ustring folder;
  int position;
  int crowdFlag;
  int landFlag;
  int modalFlag;
  int stageFlag;

  Gtk::FileChooserDialog diag
    ("LOAD CROWD",Gtk::FILE_CHOOSER_ACTION_OPEN);
  diag.add_button(Gtk::Stock::OPEN, Gtk::RESPONSE_OK);
  diag.add_button(Gtk::Stock::CANCEL, Gtk::RESPONSE_CANCEL);
  
  diag.set_icon(mIcon);

  Gtk::FileFilter filt;
  filt.set_name("crowd");
  filt.add_pattern("*.crowd");
  diag.add_filter(filt);

  path0=diag.get_current_folder();

  path=path0+"/stage";

  if(diag.set_current_folder(path)){
    std::cout<<"FIND FOLDER:"<<path<<std::endl;
  }
  else{
    std::cout<<"FALSE FOLDER:"<<diag.get_current_folder()<<std::endl;
  }

  switch( diag.run() ){

  case Gtk::RESPONSE_OK:
    file=diag.get_filename();
    folder=diag.get_current_folder();
    name=file;
    name.erase(name.find(folder,0),folder.size()+1);
    name.erase(name.find(".crowd",0),6);

    if(folder.find(path0,0)!=std::string::npos){
      folder.erase(folder.find(path0,0),path0.size()+1);
    }

    std::cout<<"FILE:"<<file<<std::endl;
    std::cout<<"FOLDER:"<<folder<<std::endl;
    std::cout<<"NAME:"<<name<<std::endl;

    crowdFlag=baseStage->LoadCrowd
      (Glib::locale_from_utf8(folder),Glib::locale_from_utf8(name));
    if(crowdFlag!=0){
      std::cout<<"ERROR LOAD CROWD"<<std::endl;
    }
    break;
    
  case Gtk::RESPONSE_CANCEL:
    break;
  }
 
  diag.show();
  diag.resize(200,100);  
}
void (CreateCrowd::*CREATE_CROWD_RIGHT_SELECT[CREATE_CROWD_RNUM])()={
  &CreateCrowd::CrowdTimeLineSelect,
  &CreateCrowd::CrowdModalSelect,
  &CreateCrowd::CrowdLandSelect,
  &CreateCrowd::CrowdTopSelect,
  &CreateCrowd::CrowdCopySelect,
  &CreateCrowd::CrowdLoadSelect
};

void CreateCrowd::CrowdLeftSelect(){
  int type,way;
  StageCrowd *crowd;
  crowd=&(baseStage->mCrowd[Map->valueY[CREATE_VY_CROWD_LPLACE]]);
  
  Map->state=CREATE_STATE_CRST;
  Map->valueY[CREATE_VY_STATE_CRST]=CREATE_VX_CRST_TYPE;

  if(crowd->type==0){
    type=0;
    way=0;
  }
  else{
    type=crowd->type/CROWD_WAY_NUM;
    way=crowd->type%CROWD_WAY_NUM;
  }
  Map->valueX[CREATE_VX_CRST_TYPE]=type;
  Map->valueX[CREATE_VX_CRST_WAY]=way;
  Map->valueX[CREATE_VX_CRST_MINW]=(crowd->minW);
  Map->valueX[CREATE_VX_CRST_MAXW]=(crowd->maxW);
  Map->valueX[CREATE_VX_CRST_MINH]=(crowd->minH);
  Map->valueX[CREATE_VX_CRST_MAXH]=(crowd->maxH);
}
void CreateCrowd::CrowdRightSelect(){
  (this->*CREATE_CROWD_RIGHT_SELECT
   [Map->valueY[Map->valueX[CREATE_VX_STATE_CROWD]]])();
}

void (CreateCrowd::*CREATE_CROWD_PLACE_SELECT[CREATE_CROWD_NPLACE])()={
  &CreateCrowd::CrowdLeftSelect,
  &CreateCrowd::CrowdRightSelect
};

void CreateCrowd::CrowdStruct(int num,int col){
  int px0,py0,sx0,sy0;
  int px1,py1,px2,py2;
  std::stringstream ss;
  std::string str;  
  StageCrowd *crowd;
  Gdk::Color *color0;

  int cursorA[10];
  int cursorA0[10];
  int cursorB[10];
  int cursorB0[10];

  crowd=&(baseStage->mCrowd[num]);

  cursorA[0]=Map->valueY[CREATE_VY_CROWD_COPY];
  cursorA0[0]=num;
  cursorA[1]=Map->valueX[CREATE_VX_CROWD_SHIFTTYPE];
  cursorA0[1]=CREATE_CROWD_SHIFT_COPY;

  cursorB[0]=Map->valueY[CREATE_VY_CROWD_LPLACE];
  cursorB0[0]=num;
  cursorB[1]=Map->valueX[CREATE_VX_STATE_CROWD];
  cursorB0[1]=CREATE_VY_CROWD_LPLACE;

  px0=WIDTH*(CREATE_CROWD_PX1-CREATE_CROWD_SX1)/MAP_XMAX;
  py0=HEIGHT*(CREATE_CROWD_PY1-CREATE_CROWD_SY1
	      +CREATE_CROWD_MY1*col)/MAP_YMAX;
  sx0=WIDTH*(CREATE_CROWD_SX1*2)/MAP_XMAX;
  sy0=HEIGHT*(CREATE_CROWD_SY1*2)/MAP_YMAX;

  frame->draw_rectangle
    (CursorGC(cursorA,cursorA0,2,CREATE_GC_YELLOW,
	      cursorB,cursorB0,2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_CROWD_DW2,py0+CREATE_CROWD_DH2,
	    sx0-CREATE_CROWD_DW2*2,sy0-CREATE_CROWD_DH2*2);
  
  px0=WIDTH*(CREATE_CROWD_PX1-CREATE_CROWD_SX1)/MAP_XMAX;
  py0=HEIGHT*(CREATE_CROWD_PY1+CREATE_CROWD_MY1*col)/MAP_YMAX;
  ss<<num<<":";
  str=ss.str(); 
  text->DrawString
    (str,
     ColorSelect0(&cursorA[0],&cursorA0[0],0,color->red,
		 &cursorB[0],&cursorB0[0],2,color->yellow,
		 color->white),
     px0,py0,FONT_LINE_RIGHT,17,FONT_SERIF,FONT_FACE_BOLD);
  ss.str("");
  ss.clear(std::stringstream::goodbit);
  
  int type,way;
  if(crowd->type<=0){
    type=0;
    way=0;
  }
  else{
    type=crowd->type/CROWD_WAY_NUM;
    way=crowd->type%CROWD_WAY_NUM;
  }

  cursorB[1]=Map->valueY[CREATE_VY_STATE_CRST];
  cursorB0[1]=CREATE_VX_CRST_TYPE;
  cursorB[2]=Map->state;
  cursorB0[2]=CREATE_STATE_CRST;

  px1=WIDTH*(CREATE_CRST_PX1
	     +CREATE_CRST_MY1*CREATE_CROWDST_ROW_NAME)/MAP_XMAX;
  px2=WIDTH*(CREATE_CRST_PX1
	     +CREATE_CRST_MX1*CREATE_CROWDST_ROW_VALUE)/MAP_XMAX;

  py1=HEIGHT*(CREATE_CRST_PY1+CREATE_CRST_MY1*CREATE_CROWDST_TYPE
	      +CREATE_CROWD_MY1*col)/MAP_YMAX;
  px0=px1;
  py0=py1;
  color0=ColorSelect0(&cursorA[0],&cursorA0[0],0,color->red,
		     &cursorB[0],&cursorB0[0],3,color->yellow,
		     color->white);
  text->DrawString
    ("TYPE",color0,px0,py0,
     CREATE_CRST_LF1,CREATE_CRST_SF1,
     CREATE_CRST_TF1,CREATE_CRST_FF1);
  px0=px2;
  py0=py1;
  ss<<":"<<type;
  str=ss.str(); 
  text->DrawString
    (str,color0,px0,py0,
     CREATE_CRST_LF1,CREATE_CRST_SF1,
     CREATE_CRST_TF1,CREATE_CRST_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  cursorB0[1]=CREATE_VX_CRST_WAY;
  py1=HEIGHT*(CREATE_CRST_PY1+CREATE_CRST_MY1*CREATE_CROWDST_WAY
	      +CREATE_CROWD_MY1*col)/MAP_YMAX;
  px0=px1;
  py0=py1;
  color0=ColorSelect0(&cursorA[0],&cursorA0[0],0,color->red,
		     &cursorB[0],&cursorB0[0],3,color->yellow,
		     color->white);
  text->DrawString
    ("WAY",color0,px0,py0,
     CREATE_CRST_LF1,CREATE_CRST_SF1,
     CREATE_CRST_TF1,CREATE_CRST_FF1);
  px0=px2;
  py0=py1;
  ss<<": "<<crowdWay[way];
  str=ss.str(); 
  text->DrawString
    (str,color0,px0,py0,
     CREATE_CRST_LF1,CREATE_CRST_SF1,
     CREATE_CRST_TF1,CREATE_CRST_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  cursorB0[1]=CREATE_VX_CRST_MINW;
  py1=HEIGHT*(CREATE_CRST_PY1+CREATE_CRST_MY1*CREATE_CROWDST_MINPX
	      +CREATE_CROWD_MY1*col)/MAP_YMAX;
  px0=px1;
  py0=py1;
  color0=ColorSelect0(&cursorA[0],&cursorA0[0],0,color->red,
		     &cursorB[0],&cursorB0[0],3,color->yellow,
		     color->white);
  text->DrawString
    ("Min PX",color0,px0,py0,
     CREATE_CRST_LF1,CREATE_CRST_SF1,
     CREATE_CRST_TF1,CREATE_CRST_FF1);
  px0=px2;
  py0=py1;
  ss<<":"<<crowd->minW/10<<"."<<abs(crowd->minW%10)<<"%";
  str=ss.str(); 
  text->DrawString
    (str,ColorSelect0(&cursorA[0],&cursorA0[0],0,color->red,
		     &cursorB[0],&cursorB0[0],3,color->yellow,
		     color->white),px0,py0,
     CREATE_CRST_LF1,CREATE_CRST_SF1,
     CREATE_CRST_TF1,CREATE_CRST_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  cursorB0[1]=CREATE_VX_CRST_MAXW;
  py1=HEIGHT*(CREATE_CRST_PY1+CREATE_CRST_MY1*CREATE_CROWDST_MAXPX
	      +CREATE_CROWD_MY1*col)/MAP_YMAX;
  px0=px1;
  py0=py1;
  color0=ColorSelect0(&cursorA[0],&cursorA0[0],0,color->red,
		     &cursorB[0],&cursorB0[0],3,color->yellow,
		     color->white);
  text->DrawString
    ("Max PX",color0,px0,py0,
     CREATE_CRST_LF1,CREATE_CRST_SF1,
     CREATE_CRST_TF1,CREATE_CRST_FF1);
  px0=px2;
  py0=py1;
  ss<<":"<<crowd->maxW/10<<"."<<abs(crowd->maxW%10)<<"%";
  str=ss.str(); 
  text->DrawString
    (str,color0,px0,py0,
     CREATE_CRST_LF1,CREATE_CRST_SF1,
     CREATE_CRST_TF1,CREATE_CRST_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);
  
  cursorB0[1]=CREATE_VX_CRST_MINH;
  py1=HEIGHT*(CREATE_CRST_PY1+CREATE_CRST_MY1*CREATE_CROWDST_MINPY
	      +CREATE_CROWD_MY1*col)/MAP_YMAX;
  px0=px1;
  py0=py1;
  color0=ColorSelect0(&cursorA[0],&cursorA0[0],0,color->red,
		     &cursorB[0],&cursorB0[0],3,color->yellow,
		     color->white);
  text->DrawString
    ("Min PY",color0,px0,py0,
     CREATE_CRST_LF1,CREATE_CRST_SF1,
     CREATE_CRST_TF1,CREATE_CRST_FF1);
  px0=px2;
  py0=py1;
  ss<<":"<<crowd->minH/10<<"."<<abs(crowd->minH%10)<<"%";
  str=ss.str(); 
  text->DrawString
    (str,color0,px0,py0,
     CREATE_CRST_LF1,CREATE_CRST_SF1,
     CREATE_CRST_TF1,CREATE_CRST_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  cursorB0[1]=CREATE_VX_CRST_MAXH;
  py1=HEIGHT*(CREATE_CRST_PY1+CREATE_CRST_MY1*CREATE_CROWDST_MAXPY
	      +CREATE_CROWD_MY1*col)/MAP_YMAX;
  px0=px1;
  py0=py1;
  color0=ColorSelect0(&cursorA[0],&cursorA0[0],0,color->red,
		     &cursorB[0],&cursorB0[0],3,color->yellow,
		     color->white);
  text->DrawString
    ("Max PY",color0,px0,py0,
     CREATE_CRST_LF1,CREATE_CRST_SF1,
     CREATE_CRST_TF1,CREATE_CRST_FF1);
  px0=px2;
  py0=py1;
  ss<<":"<<crowd->maxH/10<<"."<<abs(crowd->maxH%10)<<"%";
  str=ss.str(); 
  text->DrawString
    (str,color0,px0,py0,
     CREATE_CRST_LF1,CREATE_CRST_SF1,
     CREATE_CRST_TF1,CREATE_CRST_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  frame->draw_rectangle
    (blackGC,true,
     WIDTH*(500)/MAP_XMAX,
     HEIGHT*(300+CREATE_CROWD_MY1*col)/MAP_YMAX,
     WIDTH*(100)/MAP_XMAX,
     HEIGHT*(100)/MAP_YMAX);

  frame->draw_rectangle
    (yellowGC,false,
     WIDTH*(400+(crowd->minW+1000)/10)/MAP_XMAX,
     HEIGHT*(200+(crowd->minH+1000)/10
	     +CREATE_CROWD_MY1*col)/MAP_YMAX,
     WIDTH*((crowd->maxW-crowd->minW)/10)/MAP_XMAX,
     HEIGHT*((crowd->maxH-crowd->minH)/10)/MAP_YMAX);
  
  DrawCrowd
    (WIDTH*(595)/MAP_XMAX,
     HEIGHT*(155+CREATE_CROWD_MY1*col)/MAP_YMAX,
     type,way);
}

void CreateCrowd::ShiftCrowdSelect(){
  baseStage->VariableSelectAction
    (&Map->valueX[CREATE_VX_STATE_CROWD],
     &Map->valueY[Map->valueX[CREATE_VX_STATE_CROWD]],
     SELECTKEY_VARIABLE100);

  if(Map->valueX[CREATE_VX_STATE_CROWD]<CREATE_VY_CROWD_LPLACE){
    Map->valueX[CREATE_VX_STATE_CROWD]=CREATE_VY_CROWD_RPLACE;
  }
  else if(Map->valueX[CREATE_VX_STATE_CROWD]>CREATE_VY_CROWD_RPLACE){
    Map->valueX[CREATE_VX_STATE_CROWD]=CREATE_VY_CROWD_LPLACE;
  }

  if(Map->valueX[CREATE_VX_STATE_CROWD]==CREATE_VY_CROWD_LPLACE){
    if(Map->valueY[CREATE_VY_CROWD_LPLACE]<1){
      Map->valueY[CREATE_VY_CROWD_LPLACE]=STAGE_CROWD_MAX-1;
      Map->keyCount=1;
    }
    else if(Map->valueY[CREATE_VY_CROWD_LPLACE]>=STAGE_CROWD_MAX){
      Map->valueY[CREATE_VY_CROWD_LPLACE]=1;
      Map->keyCount=1;
    }
  }
  else if(Map->valueX[CREATE_VX_STATE_CROWD]==CREATE_VY_CROWD_RPLACE){
    if(Map->valueY[CREATE_VY_CROWD_RPLACE]<0){
      Map->valueY[CREATE_VY_CROWD_RPLACE]=CREATE_CROWD_RNUM-1;
    }
    else if(Map->valueY[CREATE_VY_CROWD_RPLACE]>=CREATE_CROWD_RNUM){
      Map->valueY[CREATE_VY_CROWD_RPLACE]=0;
    }      
  }
  
  if(control->okValue){
    control->okValue=0;
   (this->*CREATE_CROWD_PLACE_SELECT
     [Map->valueX[CREATE_VX_STATE_CROWD]-CREATE_VY_CROWD_LPLACE])();    
  }
  else if(control->cancelValue){
    control->cancelValue=0;
    Map->state=Map->state0;
  }

  if(Map->state==Map->state0){
    Map->state0=CREATE_STATE_TOP;
  }
}

void CreateCrowd::ShiftCrowdCopy(){
  int px0,py0;
  std::stringstream ss;
  std::string str;
  StageCrowd *crowd1;
  StageCrowd *crowd2;

  px0=WIDTH*(1000)/MAP_XMAX;
  py0=HEIGHT*(1000)/MAP_YMAX;

  if(Map->valueY[CREATE_VY_CROWD_COPY]!=0){
    ss<<"COPY : "<<Map->valueY[CREATE_VY_CROWD_COPY];
    str=ss.str();
    text->DrawString
      (str,(color->white),px0,py0,
       FONT_LINE_DOWNRIGHT,15,
       FONT_SERIF,FONT_FACE_BOLD);
    ss.str("");
    ss.clear(std::stringstream::goodbit);
  }

  baseStage->VariableSelectAction
    (&Map->valueX[CREATE_VX_STATE_CROWD],
     &Map->valueY[CREATE_VY_CROWD_LPLACE],
     SELECTKEY_VARIABLE100);

  if(Map->valueX[CREATE_VX_STATE_CROWD]!=CREATE_VY_CROWD_LPLACE){
    Map->valueX[CREATE_VX_STATE_CROWD]=CREATE_VY_CROWD_LPLACE;
  }

  if(Map->valueX[CREATE_VX_STATE_CROWD]==CREATE_VY_CROWD_LPLACE){
    if(Map->valueY[CREATE_VY_CROWD_LPLACE]<1){
      Map->valueY[CREATE_VY_CROWD_LPLACE]=STAGE_CROWD_MAX-1;
      Map->keyCount=1;
    }
    else if(Map->valueY[CREATE_VY_CROWD_LPLACE]>=STAGE_CROWD_MAX){
      Map->valueY[CREATE_VY_CROWD_LPLACE]=1;
      Map->keyCount=1;
    }
  }
  
  if(control->okValue){
    control->okValue=0;
    if(Map->valueY[CREATE_VY_CROWD_COPY]==0){
      Map->valueY[CREATE_VY_CROWD_COPY]
	=Map->valueY[CREATE_VY_CROWD_LPLACE];
    }
    else{
      crowd1=&(baseStage->mCrowd[Map->valueY[CREATE_VY_CROWD_LPLACE]]);
      crowd2=&(baseStage->mCrowd[Map->valueY[CREATE_VY_CROWD_COPY]]);
      crowd1->type=crowd2->type;
      crowd1->minW=crowd2->minW;
      crowd1->maxW=crowd2->maxW;
      crowd1->minH=crowd2->minH;
      crowd1->maxH=crowd2->maxH;
      Map->valueX[CREATE_VX_CROWD_SHIFTTYPE]=CREATE_CROWD_SHIFT_EDIT;
      Map->valueY[CREATE_VY_CROWD_COPY]=0;
    }
  }
  else if(control->cancelValue){
    control->cancelValue=0;
    Map->valueX[CREATE_VX_CROWD_SHIFTTYPE]=CREATE_CROWD_SHIFT_EDIT;
    Map->valueY[CREATE_VY_CROWD_COPY]=0;
  }

}

void CreateCrowd::CrowdStructTypeRange(StageCrowd *crowd){
  int tmp;
  if(Map->valueX[CREATE_VX_CRST_TYPE]<0){
    Map->valueX[CREATE_VX_CRST_TYPE]=CROWD_TYPE_NUM-1;
  }
  else if(Map->valueX[CREATE_VX_CRST_TYPE]>=CROWD_TYPE_NUM){
    Map->valueX[CREATE_VX_CRST_TYPE]=0;
  }
  tmp=Map->valueX[CREATE_VX_CRST_TYPE]*CROWD_WAY_NUM
    +Map->valueX[CREATE_VX_CRST_WAY];
  crowd->type=tmp;
}
void CreateCrowd::CrowdStructWayRange(StageCrowd *crowd){
  int tmp;
  if(Map->valueX[CREATE_VX_CRST_WAY]<0){
    Map->valueX[CREATE_VX_CRST_WAY]=CROWD_WAY_NUM-1;
  }
  else if(Map->valueX[CREATE_VX_CRST_WAY]>=CROWD_WAY_NUM){
    Map->valueX[CREATE_VX_CRST_WAY]=0;
  }
  tmp=Map->valueX[CREATE_VX_CRST_TYPE]*CROWD_WAY_NUM
    +Map->valueX[CREATE_VX_CRST_WAY];
  crowd->type=tmp;
}
void CreateCrowd::CrowdStructMinWRange(StageCrowd *crowd){
  if(Map->valueX[CREATE_VX_CRST_MINW]<-1000){
    Map->valueX[CREATE_VX_CRST_MINW]=-1000;
  }
  else if(Map->valueX[CREATE_VX_CRST_MINW]>=
	  Map->valueX[CREATE_VX_CRST_MAXW]){
    Map->valueX[CREATE_VX_CRST_MINW]
      =Map->valueX[CREATE_VX_CRST_MAXW]-1;
  }
  crowd->minW=Map->valueX[CREATE_VX_CRST_MINW];
}
void CreateCrowd::CrowdStructMaxWRange(StageCrowd *crowd){
  if(Map->valueX[CREATE_VX_CRST_MAXW]<=
     Map->valueX[CREATE_VX_CRST_MINW]){
    Map->valueX[CREATE_VX_CRST_MAXW]
      =Map->valueX[CREATE_VX_CRST_MINW]+1;
  }
  else if(Map->valueX[CREATE_VX_CRST_MAXW]>2000){
    Map->valueX[CREATE_VX_CRST_MAXW]=2000;
  }
  crowd->maxW=Map->valueX[CREATE_VX_CRST_MAXW];
}
void CreateCrowd::CrowdStructMinHRange(StageCrowd *crowd){
  if(Map->valueX[CREATE_VX_CRST_MINH]<-1000){
    Map->valueX[CREATE_VX_CRST_MINH]=-1000;
  }
  else if(Map->valueX[CREATE_VX_CRST_MINH]>=
	  Map->valueX[CREATE_VX_CRST_MAXH]){
    Map->valueX[CREATE_VX_CRST_MINH]
      =Map->valueX[CREATE_VX_CRST_MAXH]-1;
  }
  crowd->minH=Map->valueX[CREATE_VX_CRST_MINH];
}
void CreateCrowd::CrowdStructMaxHRange(StageCrowd *crowd){
  if(Map->valueX[CREATE_VX_CRST_MAXH]<=
     Map->valueX[CREATE_VX_CRST_MINH]){
    Map->valueX[CREATE_VX_CRST_MAXH]
      =Map->valueX[CREATE_VX_CRST_MINH]+1;
  }
  else if(Map->valueX[CREATE_VX_CRST_MAXH]>2000){
    Map->valueX[CREATE_VX_CRST_MAXH]=2000;
  }
  crowd->maxH=Map->valueX[CREATE_VX_CRST_MAXH];
}

void (CreateCrowd::*CREATE_CRST_RANGE[CREATE_CRST_NUM])
  (StageCrowd *crowd)={
    &CreateCrowd::CrowdStructTypeRange,
    &CreateCrowd::CrowdStructWayRange,
    &CreateCrowd::CrowdStructMinWRange,
    &CreateCrowd::CrowdStructMaxWRange,
    &CreateCrowd::CrowdStructMinHRange,
    &CreateCrowd::CrowdStructMaxHRange
  };

void CreateCrowd::ShiftCrowdStruct(){
  int px,py;
  int tmp;

  baseStage->VariableSelectAction
    (&Map->valueX[Map->valueY[CREATE_VY_STATE_CRST]],
     &Map->valueY[CREATE_VY_STATE_CRST],
     SELECTKEY_VARIABLE10);

  if(Map->valueY[CREATE_VY_STATE_CRST]<CREATE_VX_CRST_TYPE){
    Map->valueY[CREATE_VY_STATE_CRST]=CREATE_VX_CRST_MAXH;
  }
  else if(Map->valueY[CREATE_VY_STATE_CRST]>CREATE_VX_CRST_MAXH){
    Map->valueY[CREATE_VY_STATE_CRST]=CREATE_VX_CRST_TYPE;
  }

  (this->*CREATE_CRST_RANGE
   [Map->valueY[CREATE_VY_STATE_CRST]-CREATE_VX_CRST_TYPE])
    (&(baseStage->mCrowd[Map->valueY[CREATE_VY_CROWD_LPLACE]]));

  tmp=Map->valueY[CREATE_VY_CROWD_LPLACE]
    -Map->valueY[CREATE_VY_CROWD_LPOS];
  
  px=WIDTH*(115)/MAP_XMAX;
  py=HEIGHT*
    (CREATE_CRST_PY1+CREATE_CRST_MY1
     *(Map->valueY[CREATE_VY_STATE_CRST]-CREATE_VX_CRST_TYPE)
     +CREATE_CROWD_MY1*tmp)/MAP_YMAX;

  enemyList->DrawSprite(EN_HOM_BIRD,EN_WAY_B,1,px,py);
  
  if(control->okValue){
    control->okValue=0;
    Map->state=CREATE_STATE_CROWD;
  }
  else if(control->cancelValue){
    control->cancelValue=0;
    
    Map->state=CREATE_STATE_CROWD;
  }
}

void CreateCrowd::CrowdMenu(){
  int px0,py0,sx0,sy0;
  int px1,py1;
  int i;
  std::stringstream ss;
  std::string str;  
  int cursorA[10];
  int cursorA0[10];
  int cursorB[10];
  int cursorB0[10];

  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);

  RunWoodBG(0,0,WIDTH,HEIGHT);

  cursorA[0]=CREATE_CROWD_TLINE;
  cursorA0[0]=CREATE_CROWD_COPY;
  cursorA[1]=Map->valueX[CREATE_VX_CROWD_SHIFTTYPE];
  cursorA0[1]=CREATE_CROWD_SHIFT_COPY;

  cursorB[0]=Map->valueY[CREATE_VY_CROWD_RPLACE];
  cursorB0[0]=CREATE_CROWD_TLINE;
  cursorB[1]=Map->valueX[CREATE_VX_STATE_CROWD];
  cursorB0[1]=CREATE_VY_CROWD_RPLACE;

  px0=WIDTH*(CREATE_CROWD_PX2-CREATE_CROWD_SX2)/MAP_XMAX;
  py0=HEIGHT*(CREATE_CROWD_PY2-CREATE_CROWD_SY2
	      +CREATE_CROWD_MY2*CREATE_CROWD_TLINE)/MAP_YMAX;
  sx0=WIDTH*(CREATE_CROWD_SX2*2)/MAP_XMAX;
  sy0=HEIGHT*(CREATE_CROWD_SY2*2)/MAP_YMAX;

  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],2,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_CROWD_DW2,py0+CREATE_CROWD_DH2,
	    sx0-CREATE_CROWD_DW2*2,sy0-CREATE_CROWD_DH2*2);

  cursorA[0]=CREATE_CROWD_MODAL;
  cursorB0[0]=CREATE_CROWD_MODAL;
  py0=HEIGHT*(CREATE_CROWD_PY2-CREATE_CROWD_SY2
	      +CREATE_CROWD_MY2*CREATE_CROWD_MODAL)/MAP_YMAX;

  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],2,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_CROWD_DW2,py0+CREATE_CROWD_DH2,
	    sx0-CREATE_CROWD_DW2*2,sy0-CREATE_CROWD_DH2*2);

  cursorA[0]=CREATE_CROWD_LAND;
  cursorB0[0]=CREATE_CROWD_LAND;
  py0=HEIGHT*(CREATE_CROWD_PY2-CREATE_CROWD_SY2
	      +CREATE_CROWD_MY2*CREATE_CROWD_LAND)/MAP_YMAX;

  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],2,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_CROWD_DW2,py0+CREATE_CROWD_DH2,
	    sx0-CREATE_CROWD_DW2*2,sy0-CREATE_CROWD_DH2*2);

  cursorA[0]=CREATE_CROWD_TOP;
  cursorB0[0]=CREATE_CROWD_TOP;
  py0=HEIGHT*(CREATE_CROWD_PY2-CREATE_CROWD_SY2
	      +CREATE_CROWD_MY2*CREATE_CROWD_TOP)/MAP_YMAX;

  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],2,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_CROWD_DW2,py0+CREATE_CROWD_DH2,
	    sx0-CREATE_CROWD_DW2*2,sy0-CREATE_CROWD_DH2*2);

  cursorA[0]=CREATE_CROWD_COPY;
  cursorB0[0]=CREATE_CROWD_COPY;
  py0=HEIGHT*(CREATE_CROWD_PY2-CREATE_CROWD_SY2
	      +CREATE_CROWD_MY2*CREATE_CROWD_COPY)/MAP_YMAX;

  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],2,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_CROWD_DW2,py0+CREATE_CROWD_DH2,
	    sx0-CREATE_CROWD_DW2*2,sy0-CREATE_CROWD_DH2*2);

  cursorA[0]=CREATE_CROWD_LOAD;
  cursorB0[0]=CREATE_CROWD_LOAD;
  py0=HEIGHT*(CREATE_CROWD_PY2-CREATE_CROWD_SY2
	      +CREATE_CROWD_MY2*CREATE_CROWD_LOAD)/MAP_YMAX;

  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],2,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_CROWD_DW2,py0+CREATE_CROWD_DH2,
	    sx0-CREATE_CROWD_DW2*2,sy0-CREATE_CROWD_DH2*2);

  px1=WIDTH*(CREATE_CROWD_PX2)/MAP_XMAX;
  px0=px1;
  py0=HEIGHT*(CREATE_CROWD_PY2
	      +CREATE_CROWD_MY2*CREATE_CROWD_TLINE)/MAP_YMAX;
  text->DrawString
    ("TIMELINE",(color->black),px0,py0,
     CREATE_CROWD_LF2,CREATE_CROWD_SF2,
     CREATE_CROWD_TF2,CREATE_CROWD_FF2);

  px0=px1;
  py0=HEIGHT*(CREATE_CROWD_PY2
	      +CREATE_CROWD_MY2*CREATE_CROWD_MODAL)/MAP_YMAX;
  text->DrawString
    ("MODAL",(color->black),px0,py0,
     CREATE_CROWD_LF2,CREATE_CROWD_SF2,
     CREATE_CROWD_TF2,CREATE_CROWD_FF2);

  px0=px1;
  py0=HEIGHT*(CREATE_CROWD_PY2
	      +CREATE_CROWD_MY2*CREATE_CROWD_LAND)/MAP_YMAX;
  text->DrawString
    ("LAND",(color->black),px0,py0,
     CREATE_CROWD_LF2,CREATE_CROWD_SF2,
     CREATE_CROWD_TF2,CREATE_CROWD_FF2);

  px0=px1;
  py0=HEIGHT*(CREATE_CROWD_PY2
	      +CREATE_CROWD_MY2*CREATE_CROWD_TOP)/MAP_YMAX;
  text->DrawString
    ("TOP",(color->black),px0,py0,
     CREATE_CROWD_LF2,CREATE_CROWD_SF2,
     CREATE_CROWD_TF2,CREATE_CROWD_FF2);

  px0=px1;
  py0=HEIGHT*(CREATE_CROWD_PY2
	      +CREATE_CROWD_MY2*CREATE_CROWD_COPY)/MAP_YMAX;
  text->DrawString
    ("COPY",(color->black),px0,py0,
     CREATE_CROWD_LF2,CREATE_CROWD_SF2,
     CREATE_CROWD_TF2,CREATE_CROWD_FF2);

  px0=px1;
  py0=HEIGHT*(CREATE_CROWD_PY2
	      +CREATE_CROWD_MY2*CREATE_CROWD_LOAD)/MAP_YMAX;
  text->DrawString
    ("LOAD",(color->black),px0,py0,
     CREATE_CROWD_LF2,CREATE_CROWD_SF2,
     CREATE_CROWD_TF2,CREATE_CROWD_FF2);


  px0=WIDTH*(CREATE_CROWD_PX2)/MAP_XMAX;
  py0=HEIGHT*(950)/MAP_YMAX;
  text->DrawString
    ("CROWD",(color->white),px0,py0,
     FONT_LINE_DOWNCENTER,25,
     FONT_SERIF,FONT_FACE_ITALIC);


  if(Map->valueY[CREATE_VY_CROWD_LPOS]>
     Map->valueY[CREATE_VY_CROWD_LPLACE]){
    Map->valueY[CREATE_VY_CROWD_LPOS]
      =Map->valueY[CREATE_VY_CROWD_LPLACE];
  }
  else if(Map->valueY[CREATE_VY_CROWD_LPOS]+1<
	  Map->valueY[CREATE_VY_CROWD_LPLACE]){
    Map->valueY[CREATE_VY_CROWD_LPOS]=
      Map->valueY[CREATE_VY_CROWD_LPLACE]-1;
  }

  CrowdStruct(Map->valueY[CREATE_VY_CROWD_LPOS],0);
  CrowdStruct(Map->valueY[CREATE_VY_CROWD_LPOS]+1,1);
  
  if(Map->state==CREATE_STATE_CROWD){
    if(Map->valueX[CREATE_VX_CROWD_SHIFTTYPE]==
       CREATE_CROWD_SHIFT_EDIT){
      ShiftCrowdSelect();
    }
    else if(Map->valueX[CREATE_VX_CROWD_SHIFTTYPE]==
	    CREATE_CROWD_SHIFT_COPY){
      ShiftCrowdCopy();
    }

  }
  else if(Map->state==CREATE_STATE_CRST){
    ShiftCrowdStruct();
  }

  mWindow->invalidate_rect(rect,false);
}

