#ifndef BIRD_CREATE_CROWD_H_
#define BIRD_CREATE_CROWD_H_

#include <gtkmm.h>
#include "basestage.h"
#include "createbase.h"

#define CREATE_CROWD_PX1 400
#define CREATE_CROWD_PY1 260
#define CREATE_CROWD_MX1 150
#define CREATE_CROWD_MY1 480
#define CREATE_CROWD_SX1 325
#define CREATE_CROWD_SY1 210
#define CREATE_CROWD_SF1 15
#define CREATE_CROWD_LF1 FONT_LINE_LEFT
#define CREATE_CROWD_TF1 FONT_SERIF
#define CREATE_CROWD_FF1 FONT_FACE_BOLD

#define CREATE_CROWD_DW1 5
#define CREATE_CROWD_DH1 5

#define CREATE_CROWD_PX2 850
#define CREATE_CROWD_PY2 100
#define CREATE_CROWD_MX2 150
#define CREATE_CROWD_MY2 120
#define CREATE_CROWD_SX2 100
#define CREATE_CROWD_SY2 50
#define CREATE_CROWD_SF2 15
#define CREATE_CROWD_LF2 FONT_LINE_CENTER
#define CREATE_CROWD_TF2 FONT_SERIF
#define CREATE_CROWD_FF2 FONT_FACE_BOLD

#define CREATE_CROWD_DW2 5
#define CREATE_CROWD_DH2 5

#define CREATE_CROWD_TLINE 0
#define CREATE_CROWD_MODAL 1
#define CREATE_CROWD_LAND 2
#define CREATE_CROWD_TOP 3
#define CREATE_CROWD_COPY 4
#define CREATE_CROWD_LOAD 5
#define CREATE_CROWD_RNUM 6

#define CREATE_CRST_PX1 135
#define CREATE_CRST_PY1 110
#define CREATE_CRST_MX1 130
#define CREATE_CRST_MY1 60
#define CREATE_CRST_SX1 325
#define CREATE_CRST_SY1 210
#define CREATE_CRST_SF1 15
#define CREATE_CRST_LF1 FONT_LINE_LEFT
#define CREATE_CRST_TF1 FONT_SERIF
#define CREATE_CRST_FF1 FONT_FACE_BOLD

#define CREATE_CRST_PX2 260
#define CREATE_CRST_PY2 110
#define CREATE_CRST_MX2 0
#define CREATE_CRST_MY2 60
#define CREATE_CRST_SX2 325
#define CREATE_CRST_SY2 210
#define CREATE_CRST_SF2 15
#define CREATE_CRST_LF2 FONT_LINE_LEFT
#define CREATE_CRST_TF2 FONT_SERIF
#define CREATE_CRST_FF2 FONT_FACE_BOLD

#define CREATE_CROWDST_ROW_NAME 0
#define CREATE_CROWDST_ROW_VALUE 1
#define CREATE_CROWDST_ROW_NUM 2

#define CREATE_CROWDST_TYPE 0
#define CREATE_CROWDST_WAY 1
#define CREATE_CROWDST_MINPX 2
#define CREATE_CROWDST_MAXPX 3
#define CREATE_CROWDST_MINPY 4
#define CREATE_CROWDST_MAXPY 5
#define CREATE_CROWDST_NUM 6

#define CREATE_CROWD_SHIFT_EDIT 0
#define CREATE_CROWD_SHIFT_COPY 1
#define CREATE_CROWD_SHIFT_NUM 2

class CreateCrowd : public CreateBase{
  public:
  std::string crowdWay[CROWD_WAY_NUM];
  CreateCrowd();
  ~CreateCrowd();
  void Create(BaseStage *baseStage0);

  void CrowdTimeLineSelect();
  void CrowdModalSelect();
  void CrowdLandSelect();
  void CrowdTopSelect();
  void CrowdCopySelect();
  void CrowdLoadSelect();

  void CrowdLeftSelect();
  void CrowdRightSelect();

  void CrowdStruct(int num,int col);

  void CrowdStructTypeRange(StageCrowd *crowd);
  void CrowdStructWayRange(StageCrowd *crowd);
  void CrowdStructMinWRange(StageCrowd *crowd);
  void CrowdStructMaxWRange(StageCrowd *crowd);
  void CrowdStructMinHRange(StageCrowd *crowd);
  void CrowdStructMaxHRange(StageCrowd *crowd);

  void ShiftCrowdSelect();
  void ShiftCrowdCopy();
  void ShiftCrowdStruct();

  void CrowdMenu();
};


#endif
