#include"createland.h"

CreateLand::CreateLand(){
  landType[MODAL_LAND_TYPE_NO]="NO";
  landType[MODAL_LAND_TYPE_L]="LeftScroll";
  landType[MODAL_LAND_TYPE_R]="RightScroll";
  landType[MODAL_LAND_TYPE_U]="UpScroll";
  landType[MODAL_LAND_TYPE_D]="DownScroll";

  landColor[LAND_COLOR_MOUNTAIN]="Brown";
  landColor[LAND_COLOR_FOREST]="Green";
  landColor[LAND_COLOR_ROCK]="Gray";
  landColor[LAND_COLOR_ICE]="Cobalt";
}

CreateLand::~CreateLand(){

}

void CreateLand::Create(){

}

void CreateLand::LandTimeLineSelect(){
  Map->state0=Map->state;
  Map->state=CREATE_STATE_TIMELINE;
}
void CreateLand::LandModalSelect(){
  Map->state0=Map->state;
  Map->state=CREATE_STATE_MODAL;
}
void CreateLand::LandCrowdSelect(){
  Map->state0=Map->state;
  Map->state=CREATE_STATE_CROWD;
}
void CreateLand::LandTopSelect(){
  Map->state0=Map->state;
  Map->state=CREATE_STATE_TOP;
}
void CreateLand::LandCopySelect(){
  Map->valueX[CREATE_VX_LAND_SHIFTTYPE]=CREATE_LAND_SHIFT_COPY;
  Map->valueX[CREATE_VX_STATE_LAND]=CREATE_VY_LAND_LPLACE;
}
void CreateLand::LandLoadSelect(){
  Glib::ustring path,path0;
  Glib::ustring file;
  Glib::ustring name;
  Glib::ustring folder;
  int position;
  int crowdFlag;
  int landFlag;
  int modalFlag;
  int stageFlag;

  Gtk::FileChooserDialog diag
    ("LOAD LAND",Gtk::FILE_CHOOSER_ACTION_OPEN);
  diag.add_button(Gtk::Stock::OPEN, Gtk::RESPONSE_OK);
  diag.add_button(Gtk::Stock::CANCEL, Gtk::RESPONSE_CANCEL);
  diag.set_icon(mIcon);

  Gtk::FileFilter filt;
  filt.set_name("land");
  filt.add_pattern("*.land");
  diag.add_filter( filt );

  path0=diag.get_current_folder();

  path=path0+"/stage";

  if(diag.set_current_folder(path)){
    std::cout<<"FIND FOLDER:"<<path<<std::endl;
  }
  else{
    std::cout<<"FALSE FOLDER:"<<diag.get_current_folder()<<std::endl;
  }

  switch( diag.run() ){

  case Gtk::RESPONSE_OK:
    file=diag.get_filename();
    folder=diag.get_current_folder();
    name=file;
    name.erase(name.find(folder,0),folder.size()+1);
    name.erase(name.find(".land",0),5);

    if(folder.find(path0,0)!=std::string::npos){
      folder.erase(folder.find(path0,0),path0.size()+1);
    }

    std::cout<<"FILE:"<<file<<std::endl;
    std::cout<<"FOLDER:"<<folder<<std::endl;
    std::cout<<"NAME:"<<name<<std::endl;

    landFlag=baseStage->LoadLand
      (Glib::locale_from_utf8(folder),Glib::locale_from_utf8(name));
    if(landFlag!=0){
      std::cout<<"ERROR LOAD LAND"<<std::endl;
    }
    break;
    
  case Gtk::RESPONSE_CANCEL:
    break;
  }
 
  diag.show();
  diag.resize(200,100);  
}
void (CreateLand::*CREATE_LAND_RIGHT_SELECT[CREATE_LAND_RNUM])()={
  &CreateLand::LandTimeLineSelect,
  &CreateLand::LandModalSelect,
  &CreateLand::LandCrowdSelect,
  &CreateLand::LandTopSelect,
  &CreateLand::LandCopySelect,
  &CreateLand::LandLoadSelect
};

void CreateLand::LandLeftSelect(){
  StageLand *land;

  land=&(baseStage->mLand[Map->valueY[CREATE_VY_LAND_LPLACE]]);

  Map->state=CREATE_STATE_LANDST;
  Map->valueY[CREATE_VY_STATE_LANDST]=CREATE_VX_LANDST_TYPE;
  
  Map->valueX[CREATE_VX_LANDST_TYPE]=land->type;
  Map->valueX[CREATE_VX_LANDST_COLOR]=land->color;
  Map->valueX[CREATE_VX_LANDST_FREQ]=land->freq;
  Map->valueX[CREATE_VX_LANDST_MINL]=land->minL;
  Map->valueX[CREATE_VX_LANDST_MAXL]=land->maxL;
  Map->valueX[CREATE_VX_LANDST_MINR]=land->minR;
  Map->valueX[CREATE_VX_LANDST_MAXR]=land->maxR;
  Map->valueX[CREATE_VX_LANDST_MINU]=land->minU;
  Map->valueX[CREATE_VX_LANDST_MAXU]=land->maxU;
  Map->valueX[CREATE_VX_LANDST_MIND]=land->minD;
  Map->valueX[CREATE_VX_LANDST_MAXD]=land->maxD;
  Map->valueX[CREATE_VX_LANDST_MINPX]=land->minPX;
  Map->valueX[CREATE_VX_LANDST_MAXPX]=land->maxPX;
  Map->valueX[CREATE_VX_LANDST_MINPY]=land->minPY;
  Map->valueX[CREATE_VX_LANDST_MAXPY]=land->maxPY;
}
void CreateLand::LandRightSelect(){
  (this->*CREATE_LAND_RIGHT_SELECT
   [Map->valueY[Map->valueX[CREATE_VX_STATE_LAND]]])();
}

void (CreateLand::*CREATE_LAND_PLACE_SELECT[CREATE_LAND_NPLACE])()={
  &CreateLand::LandLeftSelect,
  &CreateLand::LandRightSelect
};

void CreateLand::ShiftLandSelect(){
  baseStage->VariableSelectAction
    (&Map->valueX[CREATE_VX_STATE_LAND],
     &Map->valueY[Map->valueX[CREATE_VX_STATE_LAND]],
     SELECTKEY_VARIABLE100);
  
  if(Map->valueX[CREATE_VX_STATE_LAND]<CREATE_VY_LAND_LPLACE){
    Map->valueX[CREATE_VX_STATE_LAND]=CREATE_VY_LAND_RPLACE;
  }
  else if(Map->valueX[CREATE_VX_STATE_LAND]>CREATE_VY_LAND_RPLACE){
    Map->valueX[CREATE_VX_STATE_LAND]=CREATE_VY_LAND_LPLACE;
  }

  if(Map->valueX[CREATE_VX_STATE_LAND]==CREATE_VY_LAND_LPLACE){
    if(Map->valueY[CREATE_VY_LAND_LPLACE]<1){
      Map->valueY[CREATE_VY_LAND_LPLACE]=STAGE_LAND_MAX-1;
      Map->keyCount=1;
    }
    else if(Map->valueY[CREATE_VY_LAND_LPLACE]>=STAGE_LAND_MAX){
      Map->valueY[CREATE_VY_LAND_LPLACE]=1;
      Map->keyCount=1;
    }
  }
  else if(Map->valueX[CREATE_VX_STATE_LAND]==CREATE_VY_LAND_RPLACE){
    if(Map->valueY[CREATE_VY_LAND_RPLACE]<0){
      Map->valueY[CREATE_VY_LAND_RPLACE]=CREATE_LAND_RNUM-1;
    }
    else if(Map->valueY[CREATE_VY_LAND_RPLACE]>=CREATE_LAND_RNUM){
      Map->valueY[CREATE_VY_LAND_RPLACE]=0;
    }
  }

  if(control->okValue){
    control->okValue=0;
    (this->*CREATE_LAND_PLACE_SELECT
     [Map->valueX[CREATE_VX_STATE_LAND]-CREATE_VY_LAND_LPLACE])();
  }
  else if(control->cancelValue){
    control->cancelValue=0;
    Map->state=Map->state0;
  }

  if(Map->state==Map->state0){
    Map->state0=CREATE_STATE_TOP;
  }

}

void CreateLand::ShiftLandCopy(){
  int px0,py0;
  std::stringstream ss;
  std::string str;
  StageLand *land1;
  StageLand *land2;

  if(Map->valueY[CREATE_VY_LAND_COPY]!=0){
    px0=WIDTH*(1000)/MAP_XMAX;
    py0=HEIGHT*(1000)/MAP_YMAX;
    ss<<"COPY : "<<Map->valueY[CREATE_VY_LAND_COPY];
    str=ss.str();
    text->DrawString
      (str,color->white,px0,py0,
       FONT_LINE_DOWNRIGHT,15,
       FONT_SERIF,FONT_FACE_BOLD);
    ss.str("");
    ss.clear(std::stringstream::goodbit);
  }

  baseStage->VariableSelectAction
    (&Map->valueX[CREATE_VX_STATE_LAND],
     &Map->valueY[CREATE_VY_LAND_LPLACE],
     SELECTKEY_VARIABLE100);
  
  if(Map->valueX[CREATE_VX_STATE_LAND]!=CREATE_VY_LAND_LPLACE){
    Map->valueX[CREATE_VX_STATE_LAND]=CREATE_VY_LAND_LPLACE;
  }

  if(Map->valueX[CREATE_VX_STATE_LAND]==CREATE_VY_LAND_LPLACE){
    if(Map->valueY[CREATE_VY_LAND_LPLACE]<1){
      Map->valueY[CREATE_VY_LAND_LPLACE]=STAGE_LAND_MAX-1;
      Map->keyCount=1;
    }
    else if(Map->valueY[CREATE_VY_LAND_LPLACE]>=STAGE_LAND_MAX){
      Map->valueY[CREATE_VY_LAND_LPLACE]=1;
      Map->keyCount=1;
    }
  }

  if(control->okValue){
    control->okValue=0;
    if(Map->valueY[CREATE_VY_LAND_COPY]==0){
      Map->valueY[CREATE_VY_LAND_COPY]
	=Map->valueY[CREATE_VY_LAND_LPLACE];
    }
    else{
      land1=&(baseStage->mLand[Map->valueY[CREATE_VY_LAND_LPLACE]]);
      land2=&(baseStage->mLand[Map->valueY[CREATE_VY_LAND_COPY]]);
      land1->type=land2->type;
      land1->color=land2->color;
      land1->freq=land2->freq;
      land1->minL=land2->minL;
      land1->maxL=land2->maxL;
      land1->minR=land2->minR;
      land1->maxR=land2->maxR;
      land1->minU=land2->minU;
      land1->maxU=land2->maxU;
      land1->minD=land2->minD;
      land1->maxD=land2->maxD;
      land1->minPX=land2->minPX;
      land1->maxPX=land2->maxPX;
      land1->minPY=land2->minPY;
      land1->maxPY=land2->maxPY;
      Map->valueX[CREATE_VX_LAND_SHIFTTYPE]=CREATE_LAND_SHIFT_EDIT;
      Map->valueY[CREATE_VY_LAND_COPY]=0;
    }
  }
  else if(control->cancelValue){
    control->cancelValue=0;
    Map->valueX[CREATE_VX_LAND_SHIFTTYPE]=CREATE_LAND_SHIFT_EDIT;
    Map->valueY[CREATE_VY_LAND_COPY]=0;
  }
}

void CreateLand::LandStructTypeRange(StageLand *land){
  if(Map->valueX[CREATE_VX_LANDST_TYPE]<0){
    Map->valueX[CREATE_VX_LANDST_TYPE]=MODAL_LAND_TYPE_NUM-1;
  }
  else if(Map->valueX[CREATE_VX_LANDST_TYPE]>=MODAL_LAND_TYPE_NUM){
    Map->valueX[CREATE_VX_LANDST_TYPE]=0;
  }
  land->type=Map->valueX[CREATE_VX_LANDST_TYPE];
}
void CreateLand::LandStructColorRange(StageLand *land){
  if(Map->valueX[CREATE_VX_LANDST_COLOR]<0){
    Map->valueX[CREATE_VX_LANDST_COLOR]=LAND_COLOR_NUM-1;
  }
  else if(Map->valueX[CREATE_VX_LANDST_COLOR]>=LAND_COLOR_NUM){
    Map->valueX[CREATE_VX_LANDST_COLOR]=0;
  }
  land->color=Map->valueX[CREATE_VX_LANDST_COLOR];
}
void CreateLand::LandStructFrequenceRange(StageLand *land){
  if(Map->valueX[CREATE_VX_LANDST_FREQ]<0){
    Map->valueX[CREATE_VX_LANDST_FREQ]=0;
  }
  else if(Map->valueX[CREATE_VX_LANDST_FREQ]>1000){
    Map->valueX[CREATE_VX_LANDST_FREQ]=1000;
  }
  land->freq=Map->valueX[CREATE_VX_LANDST_FREQ];
}
void CreateLand::LandStructMinLRange(StageLand *land){
  if(Map->valueX[CREATE_VX_LANDST_MINL]<1){
    Map->valueX[CREATE_VX_LANDST_MINL]=1;
  }
  else if(Map->valueX[CREATE_VX_LANDST_MINL]>=
	  Map->valueX[CREATE_VX_LANDST_MAXL]){
    Map->valueX[CREATE_VX_LANDST_MINL]
      =Map->valueX[CREATE_VX_LANDST_MAXL]-1;
  }
  land->minL=Map->valueX[CREATE_VX_LANDST_MINL];
}
void CreateLand::LandStructMaxLRange(StageLand *land){
  if(Map->valueX[CREATE_VX_LANDST_MAXL]
     <=Map->valueX[CREATE_VX_LANDST_MINL]){
    Map->valueX[CREATE_VX_LANDST_MAXL]
      =Map->valueX[CREATE_VX_LANDST_MINL]+1;
  }
  else if(Map->valueX[CREATE_VX_LANDST_MAXL]>2000){
    Map->valueX[CREATE_VX_LANDST_MAXL]=2000;
  }
  land->maxL=Map->valueX[CREATE_VX_LANDST_MAXL];
}
void CreateLand::LandStructMinRRange(StageLand *land){
  if(Map->valueX[CREATE_VX_LANDST_MINR]<1){
    Map->valueX[CREATE_VX_LANDST_MINR]=1;
  }
  else if(Map->valueX[CREATE_VX_LANDST_MINR]>=
	  Map->valueX[CREATE_VX_LANDST_MAXR]){
    Map->valueX[CREATE_VX_LANDST_MINR]
      =Map->valueX[CREATE_VX_LANDST_MAXR]-1;
  }
  land->minR=Map->valueX[CREATE_VX_LANDST_MINR];
}
void CreateLand::LandStructMaxRRange(StageLand *land){
  if(Map->valueX[CREATE_VX_LANDST_MAXR]<=
     Map->valueX[CREATE_VX_LANDST_MINR]){
    Map->valueX[CREATE_VX_LANDST_MAXR]
      =Map->valueX[CREATE_VX_LANDST_MINR]+1;
  }
  else if(Map->valueX[CREATE_VX_LANDST_MAXR]>2000){
    Map->valueX[CREATE_VX_LANDST_MAXR]=2000;
  }
  land->maxR=Map->valueX[CREATE_VX_LANDST_MAXR];
}
void CreateLand::LandStructMinURange(StageLand *land){
  if(Map->valueX[CREATE_VX_LANDST_MINU]<1){
    Map->valueX[CREATE_VX_LANDST_MINU]=1;
  }
  else if(Map->valueX[CREATE_VX_LANDST_MINU]>=
	  Map->valueX[CREATE_VX_LANDST_MAXU]){
    Map->valueX[CREATE_VX_LANDST_MINU]
      =Map->valueX[CREATE_VX_LANDST_MAXU]-1;
  }
  land->minU=Map->valueX[CREATE_VX_LANDST_MINU];
}
void CreateLand::LandStructMaxURange(StageLand *land){
  if(Map->valueX[CREATE_VX_LANDST_MAXU]<=
     Map->valueX[CREATE_VX_LANDST_MINU]){
    Map->valueX[CREATE_VX_LANDST_MAXU]
      =Map->valueX[CREATE_VX_LANDST_MINU]+1;
  }
  else if(Map->valueX[CREATE_VX_LANDST_MAXU]>2000){
    Map->valueX[CREATE_VX_LANDST_MAXU]=2000;
  }
  land->maxU=Map->valueX[CREATE_VX_LANDST_MAXU];
}
void CreateLand::LandStructMinDRange(StageLand *land){
  if(Map->valueX[CREATE_VX_LANDST_MIND]<1){
    Map->valueX[CREATE_VX_LANDST_MIND]=1;
  }
  else if(Map->valueX[CREATE_VX_LANDST_MIND]>=
	  Map->valueX[CREATE_VX_LANDST_MAXD]){
    Map->valueX[CREATE_VX_LANDST_MIND]
    =Map->valueX[CREATE_VX_LANDST_MAXD]-1;
  }
  land->minD=Map->valueX[CREATE_VX_LANDST_MIND];
}
void CreateLand::LandStructMaxDRange(StageLand *land){
  if(Map->valueX[CREATE_VX_LANDST_MAXD]<=
     Map->valueX[CREATE_VX_LANDST_MIND]){
    Map->valueX[CREATE_VX_LANDST_MAXD]
      =Map->valueX[CREATE_VX_LANDST_MIND]+1;
  }
  else if(Map->valueX[CREATE_VX_LANDST_MAXD]>2000){
    Map->valueX[CREATE_VX_LANDST_MAXD]=2000;
  }
  land->maxD=Map->valueX[CREATE_VX_LANDST_MAXD];
}
void CreateLand::LandStructMinPXRange(StageLand *land){
  if(Map->valueX[CREATE_VX_LANDST_MINPX]<-1000){
    Map->valueX[CREATE_VX_LANDST_MINPX]=-1000;
  }
  else if(Map->valueX[CREATE_VX_LANDST_MINPX]
	  >=Map->valueX[CREATE_VX_LANDST_MAXPX]){
    Map->valueX[CREATE_VX_LANDST_MINPX]
      =Map->valueX[CREATE_VX_LANDST_MAXPX]-1;
  }
  land->minPX=Map->valueX[CREATE_VX_LANDST_MINPX];
}
void CreateLand::LandStructMaxPXRange(StageLand *land){
  if(Map->valueX[CREATE_VX_LANDST_MAXPX]<=
     Map->valueX[CREATE_VX_LANDST_MINPX]){
    Map->valueX[CREATE_VX_LANDST_MAXPX]
      =Map->valueX[CREATE_VX_LANDST_MINPX]+1;
  }
  else if(Map->valueX[CREATE_VX_LANDST_MAXPX]>2000){
    Map->valueX[CREATE_VX_LANDST_MAXPX]=2000;
  }
  land->maxPX=Map->valueX[CREATE_VX_LANDST_MAXPX];
}
void CreateLand::LandStructMinPYRange(StageLand *land){
  if(Map->valueX[CREATE_VX_LANDST_MINPY]<-1000){
    Map->valueX[CREATE_VX_LANDST_MINPY]=-1000;
  }
  else if(Map->valueX[CREATE_VX_LANDST_MINPY]>=
	  Map->valueX[CREATE_VX_LANDST_MAXPY]){
    Map->valueX[CREATE_VX_LANDST_MINPY]
      =Map->valueX[CREATE_VX_LANDST_MAXPY]-1;
  }
  land->minPY=Map->valueX[CREATE_VX_LANDST_MINPY];
}
void CreateLand::LandStructMaxPYRange(StageLand *land){
  if(Map->valueX[CREATE_VX_LANDST_MAXPY]<=
     Map->valueX[CREATE_VX_LANDST_MINPY]){
    Map->valueX[CREATE_VX_LANDST_MAXPY]
      =Map->valueX[CREATE_VX_LANDST_MINPY]+1;
  }
  else if(Map->valueX[CREATE_VX_LANDST_MAXPY]>2000){
    Map->valueX[CREATE_VX_LANDST_MAXPY]=2000;
  }
  land->maxPY=Map->valueX[CREATE_VX_LANDST_MAXPY];
}

void (CreateLand::*CREATE_LANDST_RANGE[CREATE_LANDST_NUM])
  (StageLand *land)={
    &CreateLand::LandStructTypeRange,
    &CreateLand::LandStructColorRange,
    &CreateLand::LandStructFrequenceRange,
    &CreateLand::LandStructMinLRange,
    &CreateLand::LandStructMaxLRange,
    &CreateLand::LandStructMinRRange,
    &CreateLand::LandStructMaxRRange,
    &CreateLand::LandStructMinURange,
    &CreateLand::LandStructMaxURange,
    &CreateLand::LandStructMinDRange,
    &CreateLand::LandStructMaxDRange,
    &CreateLand::LandStructMinPXRange,
    &CreateLand::LandStructMaxPXRange,
    &CreateLand::LandStructMinPYRange,
    &CreateLand::LandStructMaxPYRange
};

void CreateLand::ShiftLandStruct(){
  int px,py;

  baseStage->VariableSelectAction
    (&Map->valueX[Map->valueY[CREATE_VY_STATE_LANDST]],
     &Map->valueY[CREATE_VY_STATE_LANDST],
     SELECTKEY_VARIABLE10);

  if(Map->valueY[CREATE_VY_STATE_LANDST]<CREATE_VX_LANDST_TYPE){
    Map->valueY[CREATE_VY_STATE_LANDST]=CREATE_VX_LANDST_MAXPY;
  }
  else if(Map->valueY[CREATE_VY_STATE_LANDST]>CREATE_VX_LANDST_MAXPY){
    Map->valueY[CREATE_VY_STATE_LANDST]=CREATE_VX_LANDST_TYPE;
  }

  (this->*CREATE_LANDST_RANGE
   [Map->valueY[CREATE_VY_STATE_LANDST]-CREATE_VX_LANDST_TYPE])
    (&(baseStage->mLand[Map->valueY[CREATE_VY_LAND_LPLACE]]));

  px=WIDTH*(115)/MAP_XMAX;
  py=HEIGHT*
    (CREATE_LANDST_PY1+CREATE_LANDST_MY1
     *(Map->valueY[CREATE_VY_STATE_LANDST]-CREATE_VX_LANDST_TYPE))
    /MAP_YMAX;

  enemyList->DrawSprite(EN_HOM_BIRD,EN_WAY_B,1,px,py);

  if(control->okValue){
    control->okValue=0;
    Map->state=CREATE_STATE_LAND;
  }
  else if(control->cancelValue){
    control->cancelValue=0;
    Map->state=CREATE_STATE_LAND;
  }
}

void CreateLand::LandStructText(int px1,int py1,int px2,int py2,
				Gdk::Color *color0,
				std::string name,std::string value){
  int px0,py0;

  px0=px1;
  py0=py1;
  text->DrawString
    (name,color0,px0,py0,
     CREATE_LANDST_LF1,CREATE_LANDST_SF1,
     CREATE_LANDST_TF1,CREATE_LANDST_FF1);
  px0=px2;
  py0=py1;
  text->DrawString
    (value,color0,px0,py0,
     CREATE_LANDST_LF1,CREATE_LANDST_SF1,
     CREATE_LANDST_TF1,CREATE_LANDST_FF1);
}

void CreateLand::LandMenu(){
  int px0,py0,sx0,sy0;
  int px1,py1,px2,py2;
  StageLand *land;
  std::stringstream ss;
  std::string str;
  Gdk::Color *color0;
  int cursorA[10];
  int cursorA0[10];
  int cursorB[10];
  int cursorB0[10];

  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);
    
  RunWoodBG(0,0,WIDTH,HEIGHT);

  cursorA[0]=CREATE_LAND_TLINE;
  cursorA0[0]=CREATE_LAND_COPY;
  cursorA[1]=Map->valueX[CREATE_VX_LAND_SHIFTTYPE];
  cursorA0[1]=CREATE_LAND_SHIFT_COPY;

  cursorB[0]=Map->valueY[CREATE_VY_LAND_RPLACE];
  cursorB0[0]=CREATE_LAND_TLINE;
  cursorB[1]=Map->valueX[CREATE_VX_STATE_LAND];
  cursorB0[1]=CREATE_VY_LAND_RPLACE;

  px0=WIDTH*(CREATE_LAND_PX2-CREATE_LAND_SX2)/MAP_XMAX;
  py0=HEIGHT*(CREATE_LAND_PY2-CREATE_LAND_SY2
	      +CREATE_LAND_MY2*CREATE_LAND_TLINE)/MAP_YMAX;
  sx0=WIDTH*(CREATE_LAND_SX2*2)/MAP_XMAX;
  sy0=HEIGHT*(CREATE_LAND_SY2*2)/MAP_YMAX;

  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],2,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_LAND_DW2,py0+CREATE_LAND_DH2,
	    sx0-CREATE_LAND_DW2*2,sy0-CREATE_LAND_DH2*2);

  cursorA[0]=CREATE_LAND_MODAL;
  cursorB0[0]=CREATE_LAND_MODAL;
  py0=HEIGHT*(CREATE_LAND_PY2-CREATE_LAND_SY2
	      +CREATE_LAND_MY2*CREATE_LAND_MODAL)/MAP_YMAX;
  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],2,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),	
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_LAND_DW2,py0+CREATE_LAND_DH2,
	    sx0-CREATE_LAND_DW2*2,sy0-CREATE_LAND_DH2*2);
     
  cursorA[0]=CREATE_LAND_CROWD;
  cursorB0[0]=CREATE_LAND_CROWD;
  py0=HEIGHT*(CREATE_LAND_PY2-CREATE_LAND_SY2
	      +CREATE_LAND_MY2*CREATE_LAND_CROWD)/MAP_YMAX;
  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],2,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),	
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_LAND_DW2,py0+CREATE_LAND_DH2,
	    sx0-CREATE_LAND_DW2*2,sy0-CREATE_LAND_DH2*2);

  cursorA[0]=CREATE_LAND_TOP;
  cursorB0[0]=CREATE_LAND_TOP;
  py0=HEIGHT*(CREATE_LAND_PY2-CREATE_LAND_SY2
	      +CREATE_LAND_MY2*CREATE_LAND_TOP)/MAP_YMAX;
  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],2,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),	
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_LAND_DW2,py0+CREATE_LAND_DH2,
	    sx0-CREATE_LAND_DW2*2,sy0-CREATE_LAND_DH2*2);

  cursorA[0]=CREATE_LAND_COPY;
  cursorB0[0]=CREATE_LAND_COPY;
  py0=HEIGHT*(CREATE_LAND_PY2-CREATE_LAND_SY2
	      +CREATE_LAND_MY2*CREATE_LAND_COPY)/MAP_YMAX;
  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],2,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),	
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_LAND_DW2,py0+CREATE_LAND_DH2,
	    sx0-CREATE_LAND_DW2*2,sy0-CREATE_LAND_DH2*2);

  cursorA[0]=CREATE_LAND_LOAD;
  cursorB0[0]=CREATE_LAND_LOAD;
  py0=HEIGHT*(CREATE_LAND_PY2-CREATE_LAND_SY2
	      +CREATE_LAND_MY2*CREATE_LAND_LOAD)/MAP_YMAX;
  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],2,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),	
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_LAND_DW2,py0+CREATE_LAND_DH2,
	    sx0-CREATE_LAND_DW2*2,sy0-CREATE_LAND_DH2*2);
  
  px1=WIDTH*(CREATE_LAND_PX2)/MAP_XMAX;
  px0=px1;
  py0=HEIGHT*(CREATE_LAND_PY2
	      +CREATE_LAND_MY2*CREATE_LAND_TLINE)/MAP_YMAX;
  text->DrawString
    ("TIMELINE",(color->black),px0,py0,
     CREATE_LAND_LF2,CREATE_LAND_SF2,
     CREATE_LAND_TF2,CREATE_LAND_FF2);
  
  px0=px1;
  py0=HEIGHT*(CREATE_LAND_PY2
	      +CREATE_LAND_MY2*CREATE_LAND_MODAL)/MAP_YMAX;
  text->DrawString
    ("MODAL",(color->black),px0,py0,
     CREATE_LAND_LF2,CREATE_LAND_SF2,
     CREATE_LAND_TF2,CREATE_LAND_FF2);

  px0=px1;
  py0=HEIGHT*(CREATE_LAND_PY2
	      +CREATE_LAND_MY2*CREATE_LAND_CROWD)/MAP_YMAX;
  text->DrawString
    ("CROWD",(color->black),px0,py0,
     CREATE_LAND_LF2,CREATE_LAND_SF2,
     CREATE_LAND_TF2,CREATE_LAND_FF2);

  px0=px1;
  py0=HEIGHT*(CREATE_LAND_PY2
	      +CREATE_LAND_MY2*CREATE_LAND_TOP)/MAP_YMAX;
  text->DrawString
    ("TOP",(color->black),px0,py0,
     CREATE_LAND_LF2,CREATE_LAND_SF2,
     CREATE_LAND_TF2,CREATE_LAND_FF2);

  px0=px1;
  py0=HEIGHT*(CREATE_LAND_PY2
	      +CREATE_LAND_MY2*CREATE_LAND_COPY)/MAP_YMAX;
  text->DrawString
    ("COPY",(color->black),px0,py0,
     CREATE_LAND_LF2,CREATE_LAND_SF2,
     CREATE_LAND_TF2,CREATE_LAND_FF2);

  px0=px1;
  py0=HEIGHT*(CREATE_LAND_PY2
	      +CREATE_LAND_MY2*CREATE_LAND_LOAD)/MAP_YMAX;
  text->DrawString
    ("LOAD",(color->black),px0,py0,
     CREATE_LAND_LF2,CREATE_LAND_SF2,
     CREATE_LAND_TF2,CREATE_LAND_FF2);

  px0=WIDTH*(CREATE_LAND_PX2)/MAP_XMAX;
  py0=HEIGHT*(950)/MAP_YMAX;
  text->DrawString
    ("LAND",(color->white),px0,py0,
     FONT_LINE_DOWNCENTER,25,
     FONT_SERIF,FONT_FACE_ITALIC);

  cursorA[0]=Map->valueY[CREATE_VY_LAND_COPY];
  cursorA0[0]=Map->valueY[CREATE_VY_LAND_LPLACE];
  cursorA[1]=Map->valueX[CREATE_VX_LAND_SHIFTTYPE];
  cursorA0[1]=CREATE_LAND_SHIFT_COPY;

  cursorB[0]=Map->valueX[CREATE_VX_STATE_LAND];
  cursorB0[0]=CREATE_VY_LAND_LPLACE;

  px0=WIDTH*(CREATE_LAND_PX1-CREATE_LAND_SX1)/MAP_XMAX;
  py0=HEIGHT*(CREATE_LAND_PY1-CREATE_LAND_SY1
	      +CREATE_LAND_MY1*0)/MAP_YMAX;
  sx0=WIDTH*(CREATE_LAND_SX1*2)/MAP_XMAX;
  sy0=HEIGHT*(CREATE_LAND_SY1*2)/MAP_YMAX;

  frame->draw_rectangle
    (CursorGC(cursorA,cursorA0,2,CREATE_GC_YELLOW,
	      cursorB,cursorB0,1,CREATE_GC_SKY,
	      CREATE_GC_BLACK),	
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_LAND_DW1,py0+CREATE_LAND_DH1,
	    sx0-CREATE_LAND_DW1*2,sy0-CREATE_LAND_DH1*2);
    
  land=&(baseStage->mLand[Map->valueY[CREATE_VY_LAND_LPLACE]]);
  
  points[0].set_x(WIDTH*(500-land->maxL*1/10)/MAP_XMAX);
  points[0].set_y(HEIGHT*(300)/MAP_YMAX);
  points[1].set_x(WIDTH*(500)/MAP_XMAX);
  points[1].set_y(HEIGHT*(300-land->maxU*1/10)/MAP_YMAX);
  points[2].set_x(WIDTH*(500+land->maxR*1/10)/MAP_XMAX);
  points[2].set_y(HEIGHT*(300)/MAP_YMAX);
  points[3].set_x(WIDTH*(500)/MAP_XMAX);
  points[3].set_y(HEIGHT*(300+land->maxD*1/10)/MAP_YMAX);
  points[4].set_x(WIDTH*(500-land->maxL*1/10)/MAP_XMAX);
  points[4].set_y(HEIGHT*(300)/MAP_YMAX);
  
  frame->draw_polygon
    (landList->gcList[land->color],true,points);


  if(land->type==1){
    enemyList->DrawSprite
      (EN_STR_BIRD,1,4,
       WIDTH*(500-land->maxL*1/10)/MAP_XMAX,
       HEIGHT*(300)/MAP_YMAX);
  }
  else if(land->type==2){

    enemyList->DrawSprite
      (EN_STR_BIRD,0,11,
       WIDTH*(500+land->maxR*1/10)/MAP_XMAX,
       HEIGHT*(300)/MAP_YMAX);
  }
  else if(land->type==3){
    enemyList->DrawSprite
      (EN_STR_BIRD,0,11,
       WIDTH*(500)/MAP_XMAX,
       HEIGHT*(300-land->maxU*1/10)/MAP_YMAX);
  }
  else if(land->type==4){
    enemyList->DrawSprite
      (EN_STR_BIRD,1,4,
       WIDTH*(500)/MAP_XMAX,
       HEIGHT*(300+land->maxD*1/10)/MAP_YMAX);
  }

  
  frame->draw_line
    (yellowGC,
     WIDTH*(500-land->minL*1/10)/MAP_XMAX,
     HEIGHT*(300)/MAP_YMAX,
     WIDTH*(500-land->maxL*1/10)/MAP_XMAX,
     HEIGHT*(300)/MAP_YMAX);
  frame->draw_line
    (yellowGC,
     WIDTH*(500+land->minR*1/10)/MAP_XMAX,
     HEIGHT*(300)/MAP_YMAX,
     WIDTH*(500+land->maxR*1/10)/MAP_XMAX,
     HEIGHT*(300)/MAP_YMAX);
  frame->draw_line
    (yellowGC,
     WIDTH*(500)/MAP_XMAX,
     HEIGHT*(300-land->minU*1/10)/MAP_YMAX,
     WIDTH*(500)/MAP_XMAX,
     HEIGHT*(300-land->maxU*1/10)/MAP_YMAX);
  frame->draw_line
    (yellowGC,
     WIDTH*(500)/MAP_XMAX,
     HEIGHT*(300+land->minD*1/10)/MAP_YMAX,
     WIDTH*(500)/MAP_XMAX,
     HEIGHT*(300+land->maxD*1/10)/MAP_YMAX);

  frame->draw_rectangle
    (blackGC,true,
     WIDTH*(480)/MAP_XMAX,
     HEIGHT*(700)/MAP_YMAX,
     WIDTH*(100)/MAP_XMAX,
     HEIGHT*(100)/MAP_YMAX);

  frame->draw_rectangle
    (yellowGC,false,
     WIDTH*(380+(land->minPX+1000)/10)/MAP_XMAX,
     HEIGHT*(600+(land->minPY+1000)/10)/MAP_YMAX,
     WIDTH*((land->maxPX-land->minPX)/10)/MAP_XMAX,
     HEIGHT*((land->maxPY-land->minPY)/10)/MAP_YMAX);
 

  px0=WIDTH*(CREATE_LAND_PX1-CREATE_LAND_SX1)/MAP_XMAX;
  py0=HEIGHT*(CREATE_LAND_PY1+CREATE_LAND_MY1*0)/MAP_YMAX;
  ss<<Map->valueY[CREATE_VY_LAND_LPLACE]<<":";
  str=ss.str(); 
  text->DrawString
    (str,(color->white),px0,py0,
     CREATE_LAND_LF1,CREATE_LAND_SF1,
     CREATE_LAND_TF1,CREATE_LAND_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  cursorB[0]=Map->valueY[CREATE_VY_STATE_LANDST];
  cursorB0[0]=CREATE_VX_LANDST_TYPE;
  cursorB[1]=Map->state;
  cursorB0[1]=CREATE_STATE_LANDST;
  
  px1=WIDTH*(CREATE_LANDST_PX1)/MAP_XMAX;
  px2=WIDTH*(CREATE_LANDST_PX2)/MAP_XMAX;
  py1=HEIGHT*(CREATE_LANDST_PY1
	      +CREATE_LANDST_MY1*CREATE_LANDST_TYPE)/MAP_YMAX;
  color0=ColorSelect0(cursorA,cursorA0,0,color->red,
		     cursorB,cursorB0,2,color->yellow,
		     color->white);
  ss<<": "<<landType[land->type];
  str=ss.str(); 
  LandStructText(px1,py1,px2,0,color0,"TYPE",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  cursorB0[0]=CREATE_VX_LANDST_COLOR;
  py1=HEIGHT*(CREATE_LANDST_PY1
	      +CREATE_LANDST_MY1*CREATE_LANDST_COLOR)/MAP_YMAX;
  color0=ColorSelect0(cursorA,cursorA0,0,color->red,
		     cursorB,cursorB0,2,color->yellow,
		     color->white);
  ss<<": "<<landColor[land->color];
  str=ss.str(); 
  LandStructText(px1,py1,px2,0,color0,"COLOR",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  cursorB0[0]=CREATE_VX_LANDST_FREQ;
  py1=HEIGHT*(CREATE_LANDST_PY1
	      +CREATE_LANDST_MY1*CREATE_LANDST_FREQ)/MAP_YMAX;
  color0=ColorSelect0(cursorA,cursorA0,0,color->red,
		     cursorB,cursorB0,2,color->yellow,
		     color->white);
  ss<<": "<<land->freq/10<<"."<<abs(land->freq%10)<<"%";
  str=ss.str(); 
  LandStructText(px1,py1,px2,0,color0,"FREQ",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  cursorB0[0]=CREATE_VX_LANDST_MINL;
  py1=HEIGHT*(CREATE_LANDST_PY1
	      +CREATE_LANDST_MY1*CREATE_LANDST_MINL)/MAP_YMAX;
  color0=ColorSelect0(cursorA,cursorA0,0,color->red,
		     cursorB,cursorB0,2,color->yellow,
		     color->white);
  ss<<": "<<land->minL/10<<"."<<abs(land->minL%10)<<"%";
  str=ss.str(); 
  LandStructText(px1,py1,px2,0,color0,"Min L",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  cursorB0[0]=CREATE_VX_LANDST_MAXL;
  py1=HEIGHT*(CREATE_LANDST_PY1
	      +CREATE_LANDST_MY1*CREATE_LANDST_MAXL)/MAP_YMAX;
  color0=ColorSelect0(cursorA,cursorA0,0,color->red,
		     cursorB,cursorB0,2,color->yellow,
		     color->white);
  ss<<": "<<land->maxL/10<<"."<<abs(land->maxL%10)<<"%";
  str=ss.str(); 
  LandStructText(px1,py1,px2,0,color0,"Max L",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);
  
  cursorB0[0]=CREATE_VX_LANDST_MINR;
  py1=HEIGHT*(CREATE_LANDST_PY1
	      +CREATE_LANDST_MY1*CREATE_LANDST_MINR)/MAP_YMAX;
  color0=ColorSelect0(cursorA,cursorA0,0,color->red,
		     cursorB,cursorB0,2,color->yellow,
		     color->white);
  ss<<": "<<land->minR/10<<"."<<abs(land->minR%10)<<"%";
  str=ss.str(); 
  LandStructText(px1,py1,px2,0,color0,"Min R",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  cursorB0[0]=CREATE_VX_LANDST_MAXR;
  py1=HEIGHT*(CREATE_LANDST_PY1
	      +CREATE_LANDST_MY1*CREATE_LANDST_MAXR)/MAP_YMAX;
  color0=ColorSelect0(cursorA,cursorA0,0,color->red,
		     cursorB,cursorB0,2,color->yellow,
		     color->white);
  ss<<": "<<land->maxR/10<<"."<<abs(land->maxR%10)<<"%";
  str=ss.str(); 
  LandStructText(px1,py1,px2,0,color0,"Max R",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  cursorB0[0]=CREATE_VX_LANDST_MINU;
  py1=HEIGHT*(CREATE_LANDST_PY1
	      +CREATE_LANDST_MY1*CREATE_LANDST_MINU)/MAP_YMAX;
  color0=ColorSelect0(cursorA,cursorA0,0,color->red,
		     cursorB,cursorB0,2,color->yellow,
		     color->white);
  ss<<": "<<land->minU/10<<"."<<abs(land->minU%10)<<"%";
  str=ss.str(); 
  LandStructText(px1,py1,px2,0,color0,"Min U",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  cursorB0[0]=CREATE_VX_LANDST_MAXU;
  py1=HEIGHT*(CREATE_LANDST_PY1
	      +CREATE_LANDST_MY1*CREATE_LANDST_MAXU)/MAP_YMAX;
  color0=ColorSelect0(cursorA,cursorA0,0,color->red,
		     cursorB,cursorB0,2,color->yellow,
		     color->white);
  ss<<": "<<land->maxU/10<<"."<<abs(land->maxU%10)<<"%";
  str=ss.str(); 
  LandStructText(px1,py1,px2,0,color0,"Max U",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  cursorB0[0]=CREATE_VX_LANDST_MIND;
  py1=HEIGHT*(CREATE_LANDST_PY1
	      +CREATE_LANDST_MY1*CREATE_LANDST_MIND)/MAP_YMAX;
  color0=ColorSelect0(cursorA,cursorA0,0,color->red,
		     cursorB,cursorB0,2,color->yellow,
		     color->white);
  ss<<": "<<land->minD/10<<"."<<abs(land->minD%10)<<"%";
  str=ss.str(); 
  LandStructText(px1,py1,px2,0,color0,"Min D",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  cursorB0[0]=CREATE_VX_LANDST_MAXD;
  py1=HEIGHT*(CREATE_LANDST_PY1
	      +CREATE_LANDST_MY1*CREATE_LANDST_MAXD)/MAP_YMAX;
  color0=ColorSelect0(cursorA,cursorA0,0,color->red,
		     cursorB,cursorB0,2,color->yellow,
		     color->white);
  ss<<": "<<land->maxD/10<<"."<<abs(land->maxD%10)<<"%";
  str=ss.str(); 
  LandStructText(px1,py1,px2,0,color0,"Max D",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  cursorB0[0]=CREATE_VX_LANDST_MINPX;
  py1=HEIGHT*(CREATE_LANDST_PY1
	      +CREATE_LANDST_MY1*CREATE_LANDST_MINPX)/MAP_YMAX;
  color0=ColorSelect0(cursorA,cursorA0,0,color->red,
		     cursorB,cursorB0,2,color->yellow,
		     color->white);
  ss<<": "<<land->minPX/10<<"."<<abs(land->minPX%10)<<"%";
  str=ss.str(); 
  LandStructText(px1,py1,px2,0,color0,"Min PX",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  cursorB0[0]=CREATE_VX_LANDST_MAXPX;
  py1=HEIGHT*(CREATE_LANDST_PY1
	      +CREATE_LANDST_MY1*CREATE_LANDST_MAXPX)/MAP_YMAX;
  color0=ColorSelect0(cursorA,cursorA0,0,color->red,
		     cursorB,cursorB0,2,color->yellow,
		     color->white);
  ss<<": "<<land->maxPX/10<<"."<<abs(land->maxPX%10)<<"%";
  str=ss.str(); 
  LandStructText(px1,py1,px2,0,color0,"Max PX",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  cursorB0[0]=CREATE_VX_LANDST_MINPY;
  py1=HEIGHT*(CREATE_LANDST_PY1
	      +CREATE_LANDST_MY1*CREATE_LANDST_MINPY)/MAP_YMAX;
  color0=ColorSelect0(cursorA,cursorA0,0,color->red,
		     cursorB,cursorB0,2,color->yellow,
		     color->white);
  ss<<": "<<land->minPY/10<<"."<<abs(land->minPY%10)<<"%";
  str=ss.str(); 
  LandStructText(px1,py1,px2,0,color0,"Min PY",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  cursorB0[0]=CREATE_VX_LANDST_MAXPY;
  py1=HEIGHT*(CREATE_LANDST_PY1
	      +CREATE_LANDST_MY1*CREATE_LANDST_MAXPY)/MAP_YMAX;
  color0=ColorSelect0(cursorA,cursorA0,0,color->red,
		     cursorB,cursorB0,2,color->yellow,
		     color->white);
  ss<<": "<<land->maxPY/10<<"."<<abs(land->maxPY%10)<<"%";
  str=ss.str(); 
  LandStructText(px1,py1,px2,0,color0,"Max PY",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);
  
  if(Map->state==CREATE_STATE_LAND){
    if(Map->valueX[CREATE_VX_LAND_SHIFTTYPE]==CREATE_LAND_SHIFT_EDIT){
      ShiftLandSelect();
    }
    else if(Map->valueX[CREATE_VX_LAND_SHIFTTYPE]==
	    CREATE_LAND_SHIFT_COPY){
      ShiftLandCopy();
    }
    
  }
  else if(Map->state==CREATE_STATE_LANDST){
    ShiftLandStruct();
  }
  
  mWindow->invalidate_rect(rect,false);
}
