#ifndef BIRD_CREATE_STAGE_H_
#define BIRD_CREATE_STAGE_H_

#include "basestage.h"
#include "createtop.h"
#include "createcrowd.h"
#include "createland.h"
#include "createmodal.h"
#include "createtime.h"
#include "createbackground.h"
#include "namedialog.h"

#define CREATE_EXIT_PX1 400
#define CREATE_EXIT_PY1 600
#define CREATE_EXIT_MX1 150
#define CREATE_EXIT_MY1 0
#define CREATE_EXIT_SX1 0
#define CREATE_EXIT_SY1 0
#define CREATE_EXIT_SF1 15
#define CREATE_EXIT_LF1 FONT_LINE_LEFT
#define CREATE_EXIT_TF1 FONT_SERIF
#define CREATE_EXIT_FF1 FONT_FACE_BOLD

#define CREATE_EXIT_YES 0
#define CREATE_EXIT_NO 1
#define CREATE_EXIT_NUM 2

#define CREATE_STATUS_PX1 420
#define CREATE_STATUS_PY1 450
#define CREATE_STATUS_MX1 0
#define CREATE_STATUS_MY1 60
#define CREATE_STATUS_SX1 0
#define CREATE_STATUS_SY1 0
#define CREATE_STATUS_SF1 12
#define CREATE_STATUS_LF1 FONT_LINE_LEFT
#define CREATE_STATUS_TF1 FONT_SERIF
#define CREATE_STATUS_FF1 FONT_FACE_BOLD

#define CREATE_STATUS_PX2 500
#define CREATE_STATUS_PY2 CREATE_STATUS_PY1
#define CREATE_STATUS_MX2 0
#define CREATE_STATUS_MY2 CREATE_STATUS_MY1
#define CREATE_STATUS_SX2 0
#define CREATE_STATUS_SY2 0
#define CREATE_STATUS_SF2 CREATE_STATUS_SF1
#define CREATE_STATUS_LF2 CREATE_STATUS_LF1
#define CREATE_STATUS_TF2 CREATE_STATUS_TF1
#define CREATE_STATUS_FF2 CREATE_STATUS_FF1

#define CREATE_STATUS_NAME 0
#define CREATE_STATUS_LIFE 1
#define CREATE_STATUS_FIRE 2
#define CREATE_STATUS_FORM 3
#define CREATE_STATUS_NUM 4

class CreateStage : public BaseStage{
 public:
  CreateTop *createTop;
  CreateCrowd *createCrowd;
  CreateLand *createLand;
  CreateModal *createModal;
  CreateTimeLine *createTimeLine;
  CreateBackGround *createBackGround;

  CreateStage();
  ~CreateStage();  
  void Create();

  void TopView();
  void CrowdView();
  void LandView();
  void ModalView();
  void TimeLineView();
  void BackGroundView();
  void GameView();
  void PauseView();
  void GameStartSlide();
  void GameEndSlide();

  void ExitYesSelect(int *mov0,int changeFlag,int value);
  void ExitNoSelect(int *mov0,int changeFlag,int value);
  static void(CreateStage::*CREATE_EXIT_SELECT[CREATE_EXIT_NUM])
    (int *mov0,int changeFlag,int value);
  void ExitSlide();
  void StatusView();
  static void(CreateStage::*CREATE_MENU_SELECT[CREATE_STATE_NUM])();


  void ViewMap();

  void SetModal();
  

};

#endif
