#ifndef BIRD_CREATE_TIMELINE_H_
#define BIRD_CREATE_TIMELINE_H_

#include <gtkmm.h>
#include "basestage.h"
#include "createbase.h"

#define CREATE_TIMELINE_PX1 120
#define CREATE_TIMELINE_PY1 300
#define CREATE_TIMELINE_MX1 160
#define CREATE_TIMELINE_MY1 100
#define CREATE_TIMELINE_SX1 70
#define CREATE_TIMELINE_SY1 50
#define CREATE_TIMELINE_SF1 14
#define CREATE_TIMELINE_LF1 FONT_LINE_CENTER
#define CREATE_TIMELINE_TF1 FONT_SERIF
#define CREATE_TIMELINE_FF1 FONT_FACE_BOLD

#define CREATE_TIMELINE_DW1 5
#define CREATE_TIMELINE_DH1 5

#define CREATE_TIMELINE_PX2 100
#define CREATE_TIMELINE_PY2 600
#define CREATE_TIMELINE_MX2 200
#define CREATE_TIMELINE_MY2 220
#define CREATE_TIMELINE_SX2 80
#define CREATE_TIMELINE_SY2 80
#define CREATE_TIMELINE_SF2 10
#define CREATE_TIMELINE_LF2 FONT_LINE_RIGHT
#define CREATE_TIMELINE_TF2 FONT_SERIF
#define CREATE_TIMELINE_FF2 FONT_FACE_BOLD

#define CREATE_TIMELINE_DW2 0
#define CREATE_TIMELINE_DH2 10

#define CREATE_TIMELINE_PX3 120
#define CREATE_TIMELINE_PY3 900
#define CREATE_TIMELINE_MX3 160
#define CREATE_TIMELINE_MY3 100
#define CREATE_TIMELINE_SX3 70
#define CREATE_TIMELINE_SY3 50
#define CREATE_TIMELINE_SF3 14
#define CREATE_TIMELINE_LF3 FONT_LINE_CENTER
#define CREATE_TIMELINE_TF3 FONT_SERIF
#define CREATE_TIMELINE_FF3 FONT_FACE_BOLD

#define CREATE_TIMELINE_DW3 5
#define CREATE_TIMELINE_DH3 5

#define CREATE_TIMELINE_MODAL 0
#define CREATE_TIMELINE_LAND 1
#define CREATE_TIMELINE_CROWD 2
#define CREATE_TIMELINE_TOP 3
#define CREATE_TIMELINE_COPY 4
#define CREATE_TIMELINE_MENU_NUM 5

#define CREATE_TIMELINE_DETAIL 0
#define CREATE_TIMELINE_ROUGH 1
#define CREATE_TIMELINE_SHIFT_NUM 2

#define CREATE_TIMELINE_PLACE_NUM 3
#define CREATE_TIMELINE_LINE_NUM 5

#define CREATE_TIMELINE_LINETYPE_20MS 0
#define CREATE_TIMELINE_LINETYPE_100MS 1
#define CREATE_TIMELINE_LINETYPE_1S 2
#define CREATE_TIMELINE_LINETYPE_10S 3
#define CREATE_TIMELINE_LINETYPE_NUM 4

#define CREATE_TIMELINE_COPY_NO 0
#define CREATE_TIMELINE_COPY_START 1
#define CREATE_TIMELINE_COPY_END 2
#define CREATE_TIMELINE_COPY_EXE 3
#define CREATE_TIMELINE_COPY_NUM 4

class CreateTimeLine : public CreateBase{
  public:
  int copyFlag;
  int copyStart;
  int copyEnd;
  int copyNum;
  int copyLine[STAGE_TIMELINE_MAX];
  int shiftPow[CREATE_TIMELINE_LINETYPE_NUM];
  int shiftMAX[CREATE_TIMELINE_LINETYPE_NUM];
  CreateTimeLine();
  ~CreateTimeLine();
  void Create();

  void ModalMenuSelect();
  void LandMenuSelect();
  void CrowdMenuSelect();
  void TopMenuSelect();
  void TopCopySelect();
  static void(CreateTimeLine::*CREATE_TIMELINE_MENU_SELECT
	      [CREATE_TIMELINE_MENU_NUM])();

  void MenuSelect();
  void LineSelect();
  void ShiftSelect();
  static void(CreateTimeLine::*CREATE_TIMELINE_PLACE_SELECT
	      [CREATE_TIMELINE_PLACE_NUM])();

  void CopyLineSelect();
  static void(CreateTimeLine::*CREATE_TIMELINE_COPYPLACE_SELECT
	      [CREATE_TIMELINE_PLACE_NUM])();

  void ShiftCopyLineSelect();
  void ShiftTimeLineSelect();

  void Line20mModalSelect();
  void Line100mModalSelect();
  void Line1SecModalSelect();
  void Line10SecModalSelect();

  void ShiftModalIndex();

  void ModalView(int num,int index,int scale);

  void SecValueView(std::string str,int index0);
  void SecNameView(std::string str,int index0);
  void StateNameView(int num,int index, int pow,int space,int length);

  void Line20mSec();
  void Line100mSec();
  void Line1Sec();
  void Line10Sec();
  
  void Menu();
};


#endif
