#include "draw.h"

DrawArea::DrawArea(Gtk::Window *window0){
  selectView= new SelectView(window0,this);
  timerFlag=0;
}

DrawArea::~DrawArea(){
  mTimer.disconnect();
  delete selectView;
}

bool DrawArea::on_configure_event(GdkEventConfigure *event){
  std::cout<<"CONFIGURE"<<std::endl;
 
  if(timerFlag==0){
    mWindow=get_window();

    mGC=Gdk::GC::create(mWindow);
    frame=Gdk::Pixmap::create(mWindow,WIDTH,HEIGHT,-1);

    selectView->Create(mWindow,frame,mGC);

    mTimer=Glib::signal_timeout().connect
      (sigc::mem_fun(*this,&DrawArea::TimeProcess),20);
    timerFlag=1;
  }



  return true;
}

bool DrawArea::on_expose_event(GdkEventExpose *event){
    mWindow->draw_drawable(mGC,frame,0,0,0,0,WIDTH,HEIGHT);
  return true;
}

bool DrawArea::TimeProcess(){
    selectView->SelectMap();
  return true;
}

void DrawArea::Create(){

}
