#include "enemy.h"
#include "xpm/bird.h"
#include "xpm/sphenics.h"
#include "xpm/struthio.h"
#include "xpm/gallus.h"
#include "xpm/bat.h"
#include "xpm/eagle.h"
#include "xpm/strix.h"

BirdEnemy::BirdEnemy(){
  CreateNormalBird();
  CreateReverseBird();
  CreateHomingBird();
  CreateSmallSphenics();
  CreateWideSphenics();
  CreateNormalStruthio();
  CreateNormalGallus();
  CreateSmallBat();
  CreateBigBat();
  CreateNormalEagle();
  CreateLineEagle();
  CreateSmallCrossStrix();
  CreateSmallXRevStrix();
  CreateCrow();
}

BirdEnemy::~BirdEnemy(){
  delete enemyBox[EN_STR_BIRD];
  delete enemyBox[EN_REV_BIRD];
  delete enemyBox[EN_HOM_BIRD];
  delete enemyBox[EN_SMALL_SPHENICS];
  delete enemyBox[EN_WIDE_SPHENICS];
  delete enemyBox[EN_NORMAL_STRUTHIO];
  delete enemyBox[EN_NORMAL_GALLUS];
  delete enemyBox[EN_SMALL_BAT];
  delete enemyBox[EN_BIG_BAT];
  delete enemyBox[EN_NORMAL_EAGLE];
  delete enemyBox[EN_LINE_EAGLE];
  delete enemyBox[EN_SMALL_CROSSSTRIX];
  delete enemyBox[EN_CROW];
}

void BirdEnemy::Create(Glib::RefPtr<Gdk::Pixmap> frame0,
		       Glib::RefPtr<Gdk::GC> mGC0,
		       BirdMap *Map0,
		       BirdPlayer *player0,
		       BirdLand *landList0,
		       PlayerFire *pfireList0,
		       EnemyFire *efireList0,
		       BirdItem *itemList0){
  Map=Map0;
  player=player0;
  landList=landList0;
  pfireList=pfireList0;
  efireList=efireList0;
  itemList=itemList0;
  frame=frame0;
  mGC=mGC0;
}

void BirdEnemy::DrawSprite(int style,int direct,int seq,int px,int py){
  SpriteBox *spriteBox;

  spriteBox=enemyBox[style];
  
  spriteBox->DrawSprite(frame,mGC,px,py,seq+direct*spriteBox->nSeq);
}
void BirdEnemy::DrawScale
(int style,int direct,int seq,int px,int py,int width,int height){
  SpriteBox *spriteBox;

  spriteBox=enemyBox[style];
  
  spriteBox->DrawScale
    (frame,mGC,px,py,seq+direct*spriteBox->nSeq,width,height);
}

int BirdEnemy::ContactPlayerFire(BirdActor *act){
  BirdActor *node;
  BirdActor *tmp;
  int enemyFlag,flag0=0;
  int lifeFlag=1;

  node=pfireList->first;
  while(node){
    tmp=node->next;
    
    if(node->life>0){
      enemyFlag=ContactRect(node,act);

      flag0=pfireList->EnemyTouchSelect(node,act,enemyFlag);
      if(flag0==PF_TOUCH_FLAG_FIRE){
	lifeFlag=1;
	break;
      }
      else if(flag0==PF_TOUCH_FLAG_ENEMY){
	lifeFlag=0;
	player->score+=act->score;
	if(rand()%1000<act->drop){
	  ItemDropSelect(act);
	}
      }
    }
    node=tmp;
  }
  return lifeFlag;
}

int BirdEnemy::ContactLand(BirdActor *act,int *tX,int *tY){
  BirdRhoum *node;
  BirdRhoum *tmp;
  int aX=0,aY=0;
  int flag0=0;
  
  node=landList->first;
  while(node){
    tmp=node->next;
    /*
    flag0=landList->ContactPoint(node,act->px,act->py);
    */
    flag0=landList->ContactActor(node,act,&aX,&aY);
    
    if(flag0>0){
      *tX=aX;
      *tY=aY;
      break;
    }
    
    node=tmp;
  }
  return flag0;
}

BirdActor *BirdEnemy::Appear
(int px,int py,int width,int height,
 int mx,int my,int tx,int ty, int life,int score,
 int style,int move,int touch,int tcount,
 int form,int fire,int item,int drop){

  BirdActor *act;
  act= new BirdActor();
  act->px=px;
  act->py=py;
  act->width=width;
  act->height=height;
  act->mx=mx;
  act->my=my;
  act->tx=tx;
  act->ty=ty;
  act->life=life;  
  act->style=style;
  act->move=move;
  act->touch=touch;
  act->tcount=tcount;
  act->score=score;
  act->item=item;
  act->drop=drop;
  act->form=form;
  act->fire=fire;
  act->dcount=0;
  act->direct=0;
  act->seq=0;

  act->next=NULL;
  act->prev=NULL;
  act->target=NULL;

  Append(act);

  return act;
}

int BirdEnemy::Animate(){
  BirdActor *node;
  BirdActor *tmp;
  BirdSprite *sprite0;
  SpriteBox *spriteBox0;
  int i;
  int landFlag=0;
  int playerFlag=0;
  int scrFlag=0;

  if(player->target!=NULL){
    if((player->target)->life>0){
      
    }
    else{
      player->target=NULL;
    }
  }

  i=0;
  node=first;
  while(node){
    tmp=node->next;
    spriteBox0=enemyBox[node->style];
  
    if(node->move==EN_MOV_BOSS){
      node=tmp;
      continue;
    }
      

    if(node->life>0){

      if(ContactPlayerFire(node)){
	(this->*ENEMY_MOVE[node->move])(node,Map->speedX,Map->speedY);

	playerFlag=ContactRect(player,node);
      
	(this->*ENEMY_TOUCH[node->touch])(node,playerFlag);
      
	if((rand()%EN_FORM_FREQ)<node->fire){
	  (this->*ENEMY_FIRE_FORM[node->form])(node);
	}
      }    
    }
    
    if(node->dcount<=0){
      if(node->life<=0){
	Reject(node);
	delete node;
	node=NULL;
      }
      else{
	node->seq++;
	if(node->seq>=spriteBox0->nSeq){
	  node->seq=0;
	}
	spriteBox0->DrawSprite
	  (frame,mGC,node->px,node->py,
	   node->seq+node->direct*spriteBox0->nSeq);
      }
    }
    else{
      node->dcount--;
      if(node->life<=0){
	
      }
      else{
	node->seq++;
	if(node->seq>=spriteBox0->nSeq){
	  node->seq=0;
	}
      }
      spriteBox0->DrawSprite
	(frame,mGC,node->px,node->py,
	 node->seq+node->direct*spriteBox0->nSeq
	 +(spriteBox0->nLength/2));
    }
    node=tmp;
    i++;
  }
  return i;
}



void BirdEnemy::StraightMove(BirdActor *act,int speedX,int speedY){
  int landFlag;

  if(act->life>0){
    act->px+=act->mx+speedX;
    act->py+=act->my+speedY;
    
    if(act->mx>0){
      act->direct=1;
    }
    else{
      act->direct=0;
    }
  }

  if(act->px<Map->minW){
    act->dcount=1;
    act->life=0;
  }
  else if(act->px>Map->maxW){
    act->dcount=1;
    act->life=0;
  }
  
  if(act->py<Map->minH){
    act->dcount=1;
    act->life=0;
  }
  else if(act->py>Map->maxH){
    act->dcount=1;
    act->life=0;
  }
}

void BirdEnemy::NoStrMove(BirdActor *act,int speedX,int speedY){
  int landFlag;
  int tX=0,tY=0;

  if(act->life>0){
    act->px+=act->mx+speedX;
    act->py+=act->my+speedY;
    
    if(act->mx>0){
      act->direct=1;
    }
    else if(act->mx<0){
      act->direct=0;
    }
    else{
      if(act->px>player->px){
	act->direct=0;
      }
      else{
	act->direct=1;
      }
    }
  }

  if(act->px<Map->minW){
    act->dcount=1;
    act->life=0;
  }
  else if(act->px>Map->maxW){
    act->dcount=1;
    act->life=0;
  }
  
  if(act->py<Map->minH){
    act->dcount=1;
    act->life=0;
  }
  else if(act->py>Map->maxH){
    act->dcount=1;
    act->life=0;
  }

  landFlag=ContactLand(act,&tX,&tY);

  if(landFlag){
    act->dcount=ENEMY_T_DEAD;
    act->life=0;
  }
}

void BirdEnemy::ReverseMove(BirdActor *act,int speedX,int speedY){
  int landFlag;
  int tX=0,tY=0;

  if(act->life>0){
    act->px+=act->mx+speedX;
    act->py+=act->my+speedY;
    
    if(act->mx>0){
      act->direct=1;
    }
    else{
      act->direct=0;
    }
  }

  if(act->px<Map->minW){
    act->dcount=1;
    act->life=0;
  }
  else if(act->px>Map->maxW){
    act->dcount=1;
    act->life=0;
  }
  
  if(act->py<0){
    act->py=0;
    act->my=abs(act->my);
  }
  else if(act->py>HEIGHT){
    act->py=HEIGHT;
    act->my=abs(act->my)*-1;
  }

  landFlag=ContactLand(act,&tX,&tY);

  if(landFlag==1){
    if(act->px>(WIDTH+act->width/2)||act->px<(act->width/2*-1)){
      act->py=tY+act->height/2;
      act->my=abs(act->my);
    }
    else{
      if(abs(act->my*2)>abs(tY-act->py)){
	act->py=tY;
	act->my=abs(act->my); 
      }
      else{
	//	act->px+=act->width/2;
	act->py+=act->height/2;
	act->mx=abs(act->mx);
	act->my=abs(act->my); 
      }
    }
  }
  else if(landFlag==2){
    if(act->px>(WIDTH+act->width/2)||act->px<(act->width/2*-1)){
      act->py=tY+act->height/2;
      act->my=abs(act->my); 
    }
    else{
      if(abs(act->my*2)>abs(tY-act->py)){
	act->py=tY;
	act->my=abs(act->my); 
      }
      else{
	//	act->px-=act->width/2;
	act->py+=act->height/2;
	act->mx=abs(act->mx)*-1;
	act->my=abs(act->my); 
      } 
    }
  }
  else if(landFlag==3){
    if(act->px>(WIDTH+act->width/2)||act->px<(act->width/2*-1)){
      act->py=tY-act->height/2;
      act->my=abs(act->my)*-1;
    }
    else{
      if(abs(act->my*2)>abs(tY-act->py)){
	act->py=tY;
	act->my=abs(act->my)*-1;
      }
      else{
	//	act->px+=act->width/2;
	act->py-=act->height/2;
	act->mx=abs(act->mx);
	act->my=abs(act->my)*-1;
      }
    }
  }
  else if(landFlag==4){
    if(act->px>(WIDTH+act->width/2)||act->px<(act->width/2*-1)){
      act->py=tY-act->height/2;
      act->my=abs(act->my)*-1;
    }
    else{
      if(abs(act->my*2)>abs(tY-act->py)){
	act->py=tY;
	act->my=abs(act->my)*-1;
      }
      else{
	//	act->px-=act->width/2;
	act->py-=act->height/2;
	act->mx=abs(act->mx)*-1;
	act->my=abs(act->my)*-1;
      }
    }
  }
}
void BirdEnemy::HomingMove(BirdActor *act,int speedX,int speedY){
  int sx,sy;
  int landFlag;
  int tX=0,tY=0;

  if(act->life>0){
    sx=act->px;
    sy=act->py;
    DistApprox(&sx,&sy,player->px,player->py,act->tx);

    act->mx=sx;
    act->my=sy;
    act->px+=act->mx+speedX;
    act->py+=act->my+speedY;
    
    if(sx>0){
      act->direct=1;
    }
    else{
      act->direct=0;
    }

    if(act->tcount>0){
      act->tcount--;
    }
    else{
      act->move=EN_MOV_NOSTR;
      if((abs(act->mx)<act->tx)
	 &&(abs(act->my)<act->ty)){
	if(act->mx>0){
	  act->mx=act->tx;
	}
	else{
	  act->mx=act->tx*-1;
	}
      }
    }   
  }

  if(act->px<Map->minW){
    act->dcount=1;
    act->life=0;
  }
  else if(act->px>Map->maxW){
    act->dcount=1;
    act->life=0;
  }
  
  if(act->py<Map->minH){
    act->dcount=1;
    act->life=0;
  }
  else if(act->py>Map->maxH){
    act->dcount=1;
    act->life=0;
  }

  landFlag=ContactLand(act,&tX,&tY);

  if(landFlag){
    if(act->px>(WIDTH+act->width/2)||act->px<(act->width/2*-1)){
      if(landFlag>2){
	act->py=tY-act->height;
      }
      else{
	act->py=tY+act->height;
      }
    }
    else{
      act->dcount=ENEMY_T_DEAD;
      act->life=0;
    }
  }
}  
void BirdEnemy::HomingStopMove(BirdActor *act,int speedX,int speedY){
  int sx,sy;
  int landFlag;
  int tX=0,tY=0;

  if(act->life>0){
    sx=act->px;
    sy=act->py;
    DistApprox(&sx,&sy,player->px,player->py,act->tx);

    act->mx=sx;
    act->my=sy;
    act->px+=act->mx+speedX;
    act->py+=act->my+speedY;
    
    if(sx>0){
      act->direct=1;
    }
    else{
      act->direct=0;
    }

    if(act->tcount>0){
      act->tcount--;
    }
    else{
      act->move=EN_MOV_NOSTR;
      act->mx=0;
      act->my=0;
    }   
  }

  if(act->px<Map->minW){
    act->dcount=1;
    act->life=0;
  }
  else if(act->px>Map->maxW){
    act->dcount=1;
    act->life=0;
  }
  
  if(act->py<Map->minH){
    act->dcount=1;
    act->life=0;
  }
  else if(act->py>Map->maxH){
    act->dcount=1;
    act->life=0;
  }

  landFlag=ContactLand(act,&tX,&tY);

  if(landFlag){
    if(act->px>(WIDTH+act->width/2)||act->px<(act->width/2*-1)){
      if(landFlag>2){
	act->py=tY-act->height/2;
      }
      else{
	act->py=tY+act->height/2;
      }
    }
    else{
      act->dcount=ENEMY_T_DEAD;
      act->life=0;
    }
  }
}  
void BirdEnemy::GroundMove(BirdActor *act,int speedX,int speedY){
  int landFlag=0;
  int tX=0,tY=0;

  if(act->life>0){
    
    act->my+=act->ty;

    act->px+=act->mx+speedX;
    act->py+=act->my+speedY;
    
    landFlag=ContactLand(act,&tX,&tY);
    if(landFlag==3||landFlag==4){
      act->my=0;
      act->px=tX;
      act->py=tY-1;
    }
    else{
    
    }
  
    if(act->mx>0){
      act->direct=1;
    }
    else if(act->mx<0){
      act->direct=0;
    }
    else{
      if(player->px<act->px){
	act->direct=0;
      }
      else{
	act->direct=1;
      }
    }
  }

  if(act->px<Map->minW){
    act->dcount=1;
    act->life=0;
  }
  else if(act->px>Map->maxW){
    act->dcount=1;
    act->life=0;
  }
  
  if(act->py>Map->maxH){
    act->dcount=1;
    act->life=0;
  }

}
void BirdEnemy::JumpMove(BirdActor *act,int speedX,int speedY){
  int landFlag=0;
  int tX=0,tY=0;

  if(act->life>0){
    
    act->px+=act->mx+speedX;
    act->py+=act->my+speedY;

    landFlag=ContactLand(act,&tX,&tY);
    if(landFlag==3||landFlag==4){
      act->my=act->tx*-1;
      if((act->px<WIDTH+act->width/2)&&(act->px>((act->width/2)*-1))){
	if((act->height/2)>abs(tY-act->py)){
	  act->py=tY-2;
	}
      }
      else{
	act->py=tY-2;
      }
    }
    else if(landFlag==1||landFlag==2){
      if(act->my>0){
	act->my=act->my*2;
      }
      else{
	act->my=abs(act->my)+1;
      }
      act->py=tY+(act->height/2);
      
    }
    else{
      act->my+=act->ty;
    }
    
    if(act->mx>0){
      act->direct=1;
    }
    else{
      act->direct=0;
    }

  }

  if(act->px<Map->minW){
    act->dcount=1;
    act->life=0;
  }
  else if(act->px>Map->maxW){
    act->dcount=1;
    act->life=0;
  }
  
  if(act->py>Map->maxH){
    act->dcount=1;
    act->life=0;
  }



}
void BirdEnemy::BossMove(BirdActor *act,int speedX,int speedY){
  /*
    BOSS MOV
  */
}

void BirdEnemy::XYAccelerateMove(BirdActor *act,int speedX,int speedY){
  int sx,sy;
  int ttx;
  if(act->life>0){
    if(act->target!=NULL&&(act->target)->life>0){
      sx=act->px;
      sy=act->py;
      DistApprox
	(&sx,&sy,(act->target)->px,(act->target)->py,act->ty);
      act->mx+=sx;
      act->my+=sy;
      
      if(abs(act->mx)>act->tx){
	if(act->mx>0){
	  act->mx=act->tx;
	}
	else{
	  act->mx=act->tx*-1;
	}
      }
      else{
	
      }

      if(abs(act->my)>act->tx){
	if(act->my>0){
	  act->my=act->tx;
	}
	else{
	  act->my=act->tx*-1;
	}
      }
      else{

      }

      ttx=act->tx;
      if(act->tmp==1){
	if((act->px>(act->target)->px)
	   &&(act->py>(act->target)->py)){
	  act->move=EF_MOV_NOSTR;
	  if((abs(act->mx)<ttx)
	     &&(abs(act->my)<ttx)){
	    if(act->mx>0){
	      act->mx=ttx;
	    }
	    else{
	      act->mx=ttx*-1;
	    }
	  }
	}
      }
      else if(act->tmp==2){
	if((act->px<(act->target)->px)
	   &&(act->py>(act->target)->py)){
	  act->move=EF_MOV_NOSTR;
	  if((abs(act->mx)<ttx)
	     &&(abs(act->my)<ttx)){
	    if(act->mx>0){
	      act->mx=ttx;
	    }
	    else{
	      act->mx=ttx*-1;
	    }
	  }
	}
      }
      else if(act->tmp==3){
	if((act->px>(act->target)->px)
	   &&(act->py<(act->target)->py)){
	  act->move=EF_MOV_NOSTR;
	  if((abs(act->mx)<ttx)
	     &&(abs(act->my)<ttx)){
	    if(act->mx>0){
	      act->mx=ttx;
	    }
	    else{
	      act->mx=ttx*-1;
	    }
	  }
	}
      }
      else if(act->tmp==4){
	if((act->px<(act->target)->px)
	   &&(act->py<(act->target)->py)){
	  act->move=EF_MOV_NOSTR;
	  if((abs(act->mx)<ttx)
	     &&(abs(act->my)<ttx)){
	    if(act->mx>0){
	      act->mx=ttx;
	    }
	    else{
	      act->mx=ttx*-1;
	    }
	  }	
	}
      } 
    }
    else{      
      act->target=NULL;
      act->move=EN_MOV_STR;
    }
    
    if(act->tcount>0){
      act->tcount--;
    }
    else if(act->tcount==0){
      act->target=NULL;
      act->move=EN_MOV_STR;
      if((abs(act->mx)<act->tx)
	 &&(abs(act->my)<act->tx)){
	if(act->mx>0){
	  act->mx=act->tx;
	}
	else{
	  act->mx=act->tx*-1;
	}
      }
    }

    act->px+=act->mx+speedX;
    act->py+=act->my+speedY;
    
    if(act->mx<0){
      act->direct=EN_WAY_F;
    }
    else{
      act->direct=EN_WAY_B;
    }
  }
}

void BirdEnemy::OrderMove(BirdActor *act,int speedX,int speedY){
  int tmp;
  if(act->life>0){
    if(act->target!=NULL&&(act->target)->life>0){
      (this->*ENEMY_MOVE[(act->target)->tmp])(act,speedX,speedY);
    }
    else{   
      act->target=NULL;
      act->move=EN_MOV_STR;
    }
  }
}

void BirdEnemy::ALLStrMove(BirdActor *act,int speedX,int speedY){
  if(act->life>0){
    act->px+=act->mx+speedX;
    act->py+=act->my+speedY;
    
    if(act->mx>0){
      act->direct=1;
    }
    else if(act->mx<0){
      act->direct=0;
    }
    else{
      if(act->px>player->px){
	act->direct=0;
      }
      else{
	act->direct=1;
      }
    }
  }

}

void BirdEnemy::ALLRevMove(BirdActor *act,int speedX,int speedY){
  int landFlag;
  int tX=0,tY=0;

  if(act->life>0){
    act->px+=act->mx+speedX;
    act->py+=act->my+speedY;
    
    if(act->mx>0){
      act->direct=1;
    }
    else{
      act->direct=0;
    }
  }

  if(act->px<0){
    act->px=0;
    act->mx=abs(act->mx);
  }
  else if(act->px>WIDTH){
    act->px=WIDTH;
    act->mx=abs(act->mx)*-1;
  }
  
  if(act->py<0){
    act->py=0;
    act->my=abs(act->my);
  }
  else if(act->py>HEIGHT){
    act->py=HEIGHT;
    act->my=abs(act->my)*-1;
  }

  landFlag=ContactLand(act,&tX,&tY);

  if(landFlag==1){
    if(act->px>(WIDTH+act->width/2)||act->px<(act->width/2*-1)){
      act->py=tY+act->height/2;
      act->my=abs(act->my); 
    }
    else{
      if(abs(act->my*2)>abs(tY-act->py)){
	act->py=tY;
	act->my=abs(act->my); 
      }
      else{
	act->px+=act->width/2;
	act->py+=act->height/2;
	act->mx*=-1;
	act->my=abs(act->my); 
      }
    }
  }
  else if(landFlag==2){
    if(act->px>(WIDTH+act->width/2)||act->px<(act->width/2*-1)){
      act->py=tY+act->height/2;
      act->my=abs(act->my); 
    }
    else{
      if(abs(act->my*2)>abs(tY-act->py)){
	act->py=tY;
	act->my=abs(act->my); 
      }
      else{
	act->px-=act->width/2;
	act->py+=act->height/2;
	act->mx*=-1;
	act->my=abs(act->my); 
      } 
    }
  }
  else if(landFlag==3){
    if(act->px>(WIDTH+act->width/2)||act->px<(act->width/2*-1)){
      act->py=tY-act->height/2;
      act->my=abs(act->my)*-1;
    }
    else{
      if(abs(act->my*2)>abs(tY-act->py)){
	act->py=tY;
	act->my=abs(act->my)*-1;
      }
      else{
	act->px+=act->width/2;
	act->py-=act->height/2;
	act->mx*=-1;
	act->my=abs(act->my)*-1;
      }
    }
  }
  else if(landFlag==4){
    if(act->px>(WIDTH+act->width/2)||act->px<(act->width/2*-1)){
      act->py=tY-act->height/2;
      act->my=abs(act->my)*-1;
    }
    else{
      if(abs(act->my*2)>abs(tY-act->py)){
	act->py=tY;
	act->my=abs(act->my)*-1;
      }
      else{
	act->px-=act->width/2;
	act->py-=act->height/2;
	act->mx*=-1;
	act->my=abs(act->my)*-1;
      }
    }
  }
}

void (BirdEnemy::*BirdEnemy::ENEMY_MOVE[EN_MOV_NUM])
  (BirdActor *act,int speedX,int speedY)={
  &BirdEnemy::StraightMove,
  &BirdEnemy::ReverseMove,
  &BirdEnemy::HomingMove,
  &BirdEnemy::NoStrMove,
  &BirdEnemy::GroundMove,
  &BirdEnemy::JumpMove,
  &BirdEnemy::HomingStopMove,
  &BirdEnemy::BossMove,
  &BirdEnemy::XYAccelerateMove,
  &BirdEnemy::OrderMove,
  &BirdEnemy::ALLStrMove,
  &BirdEnemy::ALLRevMove
};


void BirdEnemy::ThroughTouch(BirdActor *act,int playerFlag){
  //DUMMY
}

void BirdEnemy::PainTouch(BirdActor *act,int playerFlag){
  if(playerFlag>0){
    
    if(player->dcount>0){
      
    }
    else{
      player->dcount=PLAYER_T_DMG;
    }
  }
}
void BirdEnemy::ReverseTouch(BirdActor *act,int playerFlag){

  if(playerFlag>0){
    act->my*=-1;
    if(player->dcount>0){
      
    }
    else{
      player->dcount=PLAYER_T_DMG;   

    }
   
  }
}
void BirdEnemy::ChangeNoStrTouch(BirdActor *act,int playerFlag){
  if(playerFlag>0){
    act->move=EN_MOV_NOSTR;
    if((abs(act->mx)<act->tx)
	&&(abs(act->my)<act->tx)){
      if(act->mx>0){
	act->mx=act->tx;
      }
      else{
	act->mx=act->tx*-1;
      }
    }
    if(player->dcount>0){
      
    }
    else{
      player->dcount=PLAYER_T_DMG;   
    }
   
  }
}
void BirdEnemy::BlowTouch(BirdActor *act,int playerFlag){
  if(playerFlag>0){

    if(player->px>act->px){
      player->px+=act->width/2;
    }
    else{
      player->px-=act->width/2;
    }
    if(player->py>act->py){
      player->py+=act->height/2;
    }
    else{
      player->py-=act->height/2;
    }
    
    if(player->dcount>0){
      
    }
    else{
      player->dcount=PLAYER_T_DMG;   
    }
  }
}
void BirdEnemy::JumpTouch(BirdActor *act,int playerFlag){
  if(playerFlag>0){
    act->my=act->tx/(-2);
    if(player->dcount>0){
      
    }
    else{
      player->dcount=PLAYER_T_DMG;
    }
  }
}
void (BirdEnemy::*BirdEnemy::ENEMY_TOUCH[EN_TOUCH_NUM])
  (BirdActor *act,int playerFlag)={
  &BirdEnemy::PainTouch,
  &BirdEnemy::ReverseTouch,
  &BirdEnemy::ChangeNoStrTouch,
  &BirdEnemy::BlowTouch,
  &BirdEnemy::JumpTouch,
  &BirdEnemy::ThroughTouch
};

void BirdEnemy::NoFireForm(BirdActor *act){

}
void BirdEnemy::SmallStrFireForm(BirdActor *act){
  if(act->direct>0){
    efireList->Appear(act->px,act->py,8,8,
		      8,0,0,0,
		      EF_STR_SMALL,EF_MOV_STR,
		      EF_TOUCH_PAIN,EF_FORM_LR,1);
  }
  else{
    efireList->Appear(act->px,act->py,8,8,
		      -8,0,0,0,
		      EF_STR_SMALL,EF_MOV_STR,
		      EF_TOUCH_PAIN,EF_FORM_LR,1);
  }
}
void BirdEnemy::BigStrFireForm(BirdActor *act){
  if(act->direct>0){
    efireList->Appear(act->px,act->py,16,16,
		      8,0,0,0,
		      EF_STR_BIG,EF_MOV_STR,
		      EF_TOUCH_PAIN,EF_FORM_LR,1);
  }
  else{
    efireList->Appear(act->px,act->py,16,16,
		      -8,0,0,0,
		      EF_STR_BIG,EF_MOV_STR,
		      EF_TOUCH_PAIN,EF_FORM_LR,1);
  }
}
void BirdEnemy::WideStrFireForm(BirdActor *act){
  if(act->direct>0){
    efireList->Appear(act->px,act->py,8,32,
		      8,0,0,0,
		      EF_STR_WIDE,EF_MOV_STR,
		      EF_TOUCH_PAIN,EF_FORM_LR,1);
  }
  else{
    efireList->Appear(act->px,act->py,8,32,
		      -8,0,0,0,
		      EF_STR_WIDE,EF_MOV_STR,
		      EF_TOUCH_PAIN,EF_FORM_LR,1);
  }
}
void BirdEnemy::LineStrFireForm(BirdActor *act){
  if(act->direct>0){
    efireList->Appear(act->px,act->py,32,8,
		      8,0,0,0,
		      EF_STR_LINE,EF_MOV_STR,
		      EF_TOUCH_PAIN,EF_FORM_LR,1);
  }
  else{
    efireList->Appear(act->px,act->py,32,8,
		      -8,0,0,0,
		      EF_STR_LINE,EF_MOV_STR,
		      EF_TOUCH_PAIN,EF_FORM_LR,1);
  }
}
void BirdEnemy::SmallTargetFireForm(BirdActor *act){
  int sx,sy;
  sx=act->px;
  sy=act->py;
  DistApprox(&sx,&sy,player->px,player->py,6);
  efireList->Appear(act->px,act->py,8,8,
		    sx,sy,0,0,
		    EF_STR_SMALL,EF_MOV_STR,
		    EF_TOUCH_PAIN,EF_FORM_LR,0);
}
void BirdEnemy::BigTargetFireForm(BirdActor *act){
  int sx,sy;
  sx=act->px;
  sy=act->py;
  DistApprox(&sx,&sy,player->px,player->py,6);
  efireList->Appear(act->px,act->py,16,16,
		    sx,sy,0,0,
		    EF_STR_BIG,EF_MOV_STR,
		    EF_TOUCH_PAIN,EF_FORM_LR,0);
}
void BirdEnemy::WideTargetFireForm(BirdActor *act){
  int sx,sy;
  sx=act->px;
  sy=act->py;
  DistApprox(&sx,&sy,player->px,player->py,6);
  efireList->Appear(act->px,act->py,8,32,
		    sx,sy,0,0,
		    EF_STR_WIDE,EF_MOV_STR,
		    EF_TOUCH_PAIN,EF_FORM_LR,0);
}
void BirdEnemy::LineTargetFireForm(BirdActor *act){
  int sx,sy;
  sx=act->px;
  sy=act->py;
  DistApprox(&sx,&sy,player->px,player->py,6);
  efireList->Appear(act->px,act->py,32,8,
		    sx,sy,0,0,
		    EF_STR_LINE,EF_MOV_STR,
		    EF_TOUCH_PAIN,EF_FORM_LR,0);
}

void BirdEnemy::SmallHomingFireForm(BirdActor *act){
  efireList->Appear(act->px,act->py,8,8,
		    6,0,6,0,
		    EF_HOM_SMALL,EF_MOV_HOM,
		    EF_TOUCH_CH_NOSTR,EF_FORM_LR,WIDTH/80);
}
void BirdEnemy::BigHomingFireForm(BirdActor *act){
  efireList->Appear(act->px,act->py,16,16,
		    6,0,6,0,
		    EF_HOM_BIG,EF_MOV_HOM,
		    EF_TOUCH_CH_NOSTR,EF_FORM_LR,WIDTH/60);
}
void BirdEnemy::WideHomingFireForm(BirdActor *act){
  efireList->Appear(act->px,act->py,8,32,
		    6,0,6,0,
		    EF_HOM_WIDE,EF_MOV_HOM,
		    EF_TOUCH_CH_NOSTR,EF_FORM_LR,WIDTH/80);
}
void BirdEnemy::LineHomingFireForm(BirdActor *act){
  efireList->Appear(act->px,act->py,32,8,
		    6,0,6,0,
		    EF_HOM_LINE,EF_MOV_HOM,
		    EF_TOUCH_CH_NOSTR,EF_FORM_LR,WIDTH/40);
}

void BirdEnemy::SmallCrossFireForm(BirdActor *act){
  efireList->Appear(act->px,act->py,8,8,
		    8,0,0,0,
		    EF_STR_SMALL,EF_MOV_STR,
		    EF_TOUCH_PAIN,EF_FORM_LR,0);
  efireList->Appear(act->px,act->py,8,8,
		    -8,0,0,0,
		    EF_STR_SMALL,EF_MOV_STR,
		    EF_TOUCH_PAIN,EF_FORM_LR,0);
  efireList->Appear(act->px,act->py,8,8,
		    0,8,0,0,
		    EF_STR_SMALL,EF_MOV_STR,
		    EF_TOUCH_PAIN,EF_FORM_UD,0);
  efireList->Appear(act->px,act->py,8,8,
		    0,-8,0,0,
		    EF_STR_SMALL,EF_MOV_STR,
		    EF_TOUCH_PAIN,EF_FORM_UD,0);
}

void BirdEnemy::SmallXRevFireForm(BirdActor *act){
  efireList->Appear(act->px,act->py,8,8,
		    6,6,0,0,
		    EF_REV_SMALL,EF_MOV_REV,
		    EF_TOUCH_PAIN,EF_FORM_LR,4);
  efireList->Appear(act->px,act->py,8,8,
		    -6,-6,0,0,
		    EF_REV_SMALL,EF_MOV_REV,
		    EF_TOUCH_PAIN,EF_FORM_LR,4);
  efireList->Appear(act->px,act->py,8,8,
		    -6,6,0,0,
		    EF_REV_SMALL,EF_MOV_REV,
		    EF_TOUCH_PAIN,EF_FORM_LR,4);
  efireList->Appear(act->px,act->py,8,8,
		    6,-6,0,0,
		    EF_REV_SMALL,EF_MOV_REV,
		    EF_TOUCH_PAIN,EF_FORM_LR,4);
}
void BirdEnemy::OrderFireForm(BirdActor *act){
  if(act->target!=NULL&&(act->target)->life>0){
    if(rand()%EN_FORM_FREQ<(act->target)->fire){
      (this->*ENEMY_FIRE_FORM[(act->target)->form])(act);
    }
  }
  else{
    act->target=NULL;
  }
}
void (BirdEnemy::*BirdEnemy::ENEMY_FIRE_FORM[EN_FORM_NUM])
  (BirdActor *act)={
  &BirdEnemy::NoFireForm,
  &BirdEnemy::SmallStrFireForm,
  &BirdEnemy::BigStrFireForm,
  &BirdEnemy::WideStrFireForm,
  &BirdEnemy::LineStrFireForm,
  &BirdEnemy::SmallTargetFireForm,
  &BirdEnemy::BigTargetFireForm,
  &BirdEnemy::WideTargetFireForm,
  &BirdEnemy::LineTargetFireForm,
  &BirdEnemy::SmallHomingFireForm,
  &BirdEnemy::BigHomingFireForm,
  &BirdEnemy::WideHomingFireForm,
  &BirdEnemy::LineHomingFireForm,
  &BirdEnemy::SmallCrossFireForm,
  &BirdEnemy::SmallXRevFireForm,
  &BirdEnemy::OrderFireForm
};

void BirdEnemy::WeaponItemDrop(BirdActor *act){
  int random,fireitem,formitem;
  random=rand()%1000;
  fireitem=random%(ITEM_FIRE_NUM)+ITEM_BIG;
  formitem=random%(ITEM_FORM_NUM)+ITEM_CROSS;
  if(random<500){
    itemList->Appear(act->px,act->py,16,16,fireitem,fireitem,0);
  }
  else{
    itemList->Appear(act->px,act->py,16,16,formitem,formitem,0);
  }
}
void BirdEnemy::ALLItemDrop(BirdActor *act){
  int random,fireitem,formitem,modeitem;
  random=rand()%1000;
  fireitem=random%(ITEM_FIRE_NUM)+ITEM_BIG;
  formitem=random%(ITEM_FORM_NUM)+ITEM_CROSS;
  modeitem=random%(ITEM_MODE_NUM)+ITEM_BOOST;
  if(random<450){
    itemList->Appear(act->px,act->py,16,16,fireitem,fireitem,0);
  }
  else if(random<900){
    itemList->Appear(act->px,act->py,16,16,formitem,formitem,0);
  }
  else if(random<910){
    itemList->Appear(act->px,act->py,16,16,ITEM_HEART,ITEM_HEART,0);
  }
  else{
    itemList->Appear(act->px,act->py,16,16,modeitem,modeitem,0);
  }
}
void BirdEnemy::WeaponBonusItemDrop(BirdActor *act){
  int random,fireitem,formitem,modeitem;
  random=rand()%1000;
  fireitem=random%(ITEM_FIRE_NUM)+ITEM_BIG;
  formitem=random%(ITEM_FORM_NUM)+ITEM_CROSS;
  modeitem=random%(ITEM_MODE_NUM)+ITEM_BOOST;
  
  if(random<300){
    itemList->Appear(act->px,act->py,16,16,fireitem,fireitem,0);
  }
  else if(random<600){
    itemList->Appear(act->px,act->py,16,16,formitem,formitem,0);
  }
  else{
    itemList->Appear(act->px,act->py,16,16,modeitem,modeitem,0);
  }
}
void BirdEnemy::BonusLifeItemDrop(BirdActor *act){
  int random,modeitem;
  random=rand()%1000;
  modeitem=random%(ITEM_MODE_NUM)+ITEM_BOOST;
  
  if(random<500){
    itemList->Appear(act->px,act->py,16,16,modeitem,modeitem,0);
  }
  else{
    itemList->Appear(act->px,act->py,16,16,ITEM_HEART,ITEM_HEART,0);
  }
}
void (BirdEnemy::*BirdEnemy::ENEMY_ITEMDROP_SELECT[EN_ITEMDROP_NUM])
  (BirdActor *act)={
    &BirdEnemy::WeaponItemDrop,
    &BirdEnemy::ALLItemDrop,
    &BirdEnemy::WeaponBonusItemDrop,
    &BirdEnemy::BonusLifeItemDrop,
  };

void BirdEnemy::ItemDropSelect(BirdActor *act){
  (this->*ENEMY_ITEMDROP_SELECT[act->item])(act);
}

void BirdEnemy::CreateNormalBird(){
  bird[0].xpm=(char **)bird_f1_xpm;
  bird[1].xpm=(char **)bird_f2_xpm;
  bird[2].xpm=(char **)bird_f2_xpm;
  bird[3].xpm=(char **)bird_b1_xpm;
  bird[4].xpm=(char **)bird_b2_xpm;
  bird[5].xpm=(char **)bird_b2_xpm;
  bird[6].xpm=(char **)bird_fE1_xpm;
  bird[7].xpm=(char **)bird_fE2_xpm;
  bird[8].xpm=(char **)bird_fE2_xpm;
  bird[9].xpm=(char **)bird_bE1_xpm;
  bird[10].xpm=(char **)bird_bE2_xpm;
  bird[11].xpm=(char **)bird_bE2_xpm;
  
  enemyBox[EN_STR_BIRD]= new SpriteBox(bird,3,12); 
  enemyBox[EN_STR_BIRD]->SetSprite();
}

void BirdEnemy::CreateReverseBird(){
  revbird[0].xpm=(char **)revbird_f1_xpm;
  revbird[1].xpm=(char **)revbird_f2_xpm;
  revbird[2].xpm=(char **)revbird_f2_xpm;
  revbird[3].xpm=(char **)revbird_b1_xpm;
  revbird[4].xpm=(char **)revbird_b2_xpm;
  revbird[5].xpm=(char **)revbird_b2_xpm;
  revbird[6].xpm=(char **)bird_fE1_xpm;
  revbird[7].xpm=(char **)bird_fE2_xpm;
  revbird[8].xpm=(char **)bird_fE2_xpm;
  revbird[9].xpm=(char **)bird_bE1_xpm;
  revbird[10].xpm=(char **)bird_bE2_xpm;
  revbird[11].xpm=(char **)bird_bE2_xpm;
  
  enemyBox[EN_REV_BIRD]= new SpriteBox(revbird,3,12); 
  enemyBox[EN_REV_BIRD]->SetSprite();
}

void BirdEnemy::CreateHomingBird(){
  hombird[0].xpm=(char **)hombird_f1_xpm;
  hombird[1].xpm=(char **)hombird_f2_xpm;
  hombird[2].xpm=(char **)hombird_f2_xpm;
  hombird[3].xpm=(char **)hombird_b1_xpm;
  hombird[4].xpm=(char **)hombird_b2_xpm;
  hombird[5].xpm=(char **)hombird_b2_xpm;
  hombird[6].xpm=(char **)bird_fE1_xpm;
  hombird[7].xpm=(char **)bird_fE2_xpm;
  hombird[8].xpm=(char **)bird_fE2_xpm;
  hombird[9].xpm=(char **)bird_bE1_xpm;
  hombird[10].xpm=(char **)bird_bE2_xpm;
  hombird[11].xpm=(char **)bird_bE2_xpm;
  
  enemyBox[EN_HOM_BIRD]= new SpriteBox(hombird,3,12); 
  enemyBox[EN_HOM_BIRD]->SetSprite();
}

void BirdEnemy::CreateSmallSphenics(){
  smallspenics[0].xpm=(char **)sphenics_f1_xpm;
  smallspenics[1].xpm=(char **)sphenics_b1_xpm;
  smallspenics[2].xpm=(char **)sphenics_fE1_xpm;
  smallspenics[3].xpm=(char **)sphenics_bE1_xpm;
 
  enemyBox[EN_SMALL_SPHENICS]= new SpriteBox(smallspenics,1,4); 
  enemyBox[EN_SMALL_SPHENICS]->SetSprite();
}
void BirdEnemy::CreateWideSphenics(){
  widespenics[0].xpm=(char **)widesphenics_f1_xpm;
  widespenics[1].xpm=(char **)widesphenics_b1_xpm;
  widespenics[2].xpm=(char **)sphenics_fE1_xpm;
  widespenics[3].xpm=(char **)sphenics_bE1_xpm;
 
  enemyBox[EN_WIDE_SPHENICS]= new SpriteBox(widespenics,1,4); 
  enemyBox[EN_WIDE_SPHENICS]->SetSprite();
}

void BirdEnemy::CreateNormalStruthio(){
  struthio[0].xpm=(char **)struthio_f1_xpm;
  struthio[1].xpm=(char **)struthio_f2_xpm;
  struthio[2].xpm=(char **)struthio_b1_xpm;
  struthio[3].xpm=(char **)struthio_b2_xpm;
  struthio[4].xpm=(char **)struthio_fE1_xpm;
  struthio[5].xpm=(char **)struthio_fE2_xpm;
  struthio[6].xpm=(char **)struthio_bE1_xpm;
  struthio[7].xpm=(char **)struthio_bE2_xpm;
  
  enemyBox[EN_NORMAL_STRUTHIO]= new SpriteBox(struthio,2,8);
  enemyBox[EN_NORMAL_STRUTHIO]->SetSprite();
}

void BirdEnemy::CreateNormalGallus(){
  gallus[0].xpm=(char **)gallus_f1_xpm;
  gallus[1].xpm=(char **)gallus_b1_xpm;
  gallus[2].xpm=(char **)gallus_fE1_xpm;
  gallus[3].xpm=(char **)gallus_bE1_xpm;
  
  enemyBox[EN_NORMAL_GALLUS]= new SpriteBox(gallus,1,4);
  enemyBox[EN_NORMAL_GALLUS]->SetSprite();
}

void BirdEnemy::CreateSmallBat(){
  smallbat[0].xpm=(char **)bat_fb1_xpm;
  smallbat[1].xpm=(char **)bat_fb2_xpm;
  smallbat[2].xpm=(char **)bat_fb1_xpm;
  smallbat[3].xpm=(char **)bat_fb2_xpm;
  smallbat[4].xpm=(char **)bat_fbE1_xpm;
  smallbat[5].xpm=(char **)bat_fbE2_xpm;
  smallbat[6].xpm=(char **)bat_fbE1_xpm;
  smallbat[7].xpm=(char **)bat_fbE2_xpm;
  
  enemyBox[EN_SMALL_BAT]= new SpriteBox(smallbat,2,8);
  enemyBox[EN_SMALL_BAT]->SetSprite();
}
void BirdEnemy::CreateBigBat(){
  bigbat[0].xpm=(char **)bigbat_fb1_xpm;
  bigbat[1].xpm=(char **)bigbat_fb2_xpm;
  bigbat[2].xpm=(char **)bigbat_fb1_xpm;
  bigbat[3].xpm=(char **)bigbat_fb2_xpm;
  bigbat[4].xpm=(char **)bat_fbE1_xpm;
  bigbat[5].xpm=(char **)bat_fbE2_xpm;
  bigbat[6].xpm=(char **)bat_fbE1_xpm;
  bigbat[7].xpm=(char **)bat_fbE2_xpm;
  
  enemyBox[EN_BIG_BAT]= new SpriteBox(bigbat,2,8);
  enemyBox[EN_BIG_BAT]->SetSprite();
}

void BirdEnemy::CreateNormalEagle(){
  normaleagle[0].xpm=(char **)eagle_f1_xpm;
  normaleagle[1].xpm=(char **)eagle_b1_xpm;
  normaleagle[2].xpm=(char **)eagle_fE1_xpm;
  normaleagle[3].xpm=(char **)eagle_bE1_xpm;
  
  enemyBox[EN_NORMAL_EAGLE]= new SpriteBox(normaleagle,1,4);
  enemyBox[EN_NORMAL_EAGLE]->SetSprite();
}

void BirdEnemy::CreateLineEagle(){
  lineeagle[0].xpm=(char **)lineeagle_f1_xpm;
  lineeagle[1].xpm=(char **)lineeagle_b1_xpm;
  lineeagle[2].xpm=(char **)eagle_fE1_xpm;
  lineeagle[3].xpm=(char **)eagle_bE1_xpm;
  
  enemyBox[EN_LINE_EAGLE]= new SpriteBox(lineeagle,1,4);
  enemyBox[EN_LINE_EAGLE]->SetSprite();
}

void BirdEnemy::CreateSmallCrossStrix(){
  smallcrossstrix[0].xpm=(char **)crossstrix_fb1_xpm;
  smallcrossstrix[1].xpm=(char **)crossstrix_fb2_xpm;
  smallcrossstrix[2].xpm=(char **)crossstrix_fb1_xpm;
  smallcrossstrix[3].xpm=(char **)crossstrix_fb2_xpm;
  smallcrossstrix[4].xpm=(char **)strix_fbE1_xpm;
  smallcrossstrix[5].xpm=(char **)strix_fbE2_xpm;
  smallcrossstrix[6].xpm=(char **)strix_fbE1_xpm;
  smallcrossstrix[7].xpm=(char **)strix_fbE2_xpm;
  
  enemyBox[EN_SMALL_CROSSSTRIX]= new SpriteBox(smallcrossstrix,2,8);
  enemyBox[EN_SMALL_CROSSSTRIX]->SetSprite();
}

void BirdEnemy::CreateSmallXRevStrix(){
  smallxrevstrix[0].xpm=(char **)xrevstrix_fb1_xpm;
  smallxrevstrix[1].xpm=(char **)xrevstrix_fb2_xpm;
  smallxrevstrix[2].xpm=(char **)xrevstrix_fb1_xpm;
  smallxrevstrix[3].xpm=(char **)xrevstrix_fb2_xpm;
  smallxrevstrix[4].xpm=(char **)strix_fbE1_xpm;
  smallxrevstrix[5].xpm=(char **)strix_fbE2_xpm;
  smallxrevstrix[6].xpm=(char **)strix_fbE1_xpm;
  smallxrevstrix[7].xpm=(char **)strix_fbE2_xpm;
  
  enemyBox[EN_SMALL_XREVSTRIX]= new SpriteBox(smallxrevstrix,2,8);
  enemyBox[EN_SMALL_XREVSTRIX]->SetSprite();
}

void BirdEnemy::CreateCrow(){
  crow[0].xpm=(char **)crow_f1_xpm;
  crow[1].xpm=(char **)crow_f2_xpm;
  crow[2].xpm=(char **)crow_b1_xpm;
  crow[3].xpm=(char **)crow_b2_xpm;
  crow[4].xpm=(char **)bird_fE1_xpm;
  crow[5].xpm=(char **)bird_fE2_xpm;
  crow[6].xpm=(char **)bird_bE1_xpm;
  crow[7].xpm=(char **)bird_bE2_xpm;
  
  enemyBox[EN_CROW]= new SpriteBox(crow,2,8);
  enemyBox[EN_CROW]->SetSprite();
}
