#include "land.h"

BirdLand::BirdLand(){
  points.push_back(Gdk::Point(0,0));
  points.push_back(Gdk::Point(0,0));
  points.push_back(Gdk::Point(0,0));
  points.push_back(Gdk::Point(0,0));
  points.push_back(Gdk::Point(0,0));
}

BirdLand::~BirdLand(){
}

void BirdLand::Create(Glib::RefPtr<Gdk::Pixmap> frame0,
		      Glib::RefPtr<Gdk::Window> mWindow0,
		      BirdMap *Map0,
		      BirdColor *color0,
		      BirdPlayer *player0){
  Map=Map0;
  color=color0;
  player=player0;
  frame=frame0;

  gcList[LAND_COLOR_MOUNTAIN]=Gdk::GC::create(mWindow0);
  gcList[LAND_COLOR_MOUNTAIN]->set_rgb_fg_color(*(color->mountain));
  gcList[LAND_COLOR_FOREST]=Gdk::GC::create(mWindow0);
  gcList[LAND_COLOR_FOREST]->set_rgb_fg_color(*(color->forest));
  gcList[LAND_COLOR_ROCK]=Gdk::GC::create(mWindow0);
  gcList[LAND_COLOR_ROCK]->set_rgb_fg_color(*(color->darkgray));
  gcList[LAND_COLOR_ICE]=Gdk::GC::create(mWindow0);
  gcList[LAND_COLOR_ICE]->set_rgb_fg_color(*(color->cobalt));
}

int BirdLand::FirstCoordinate(BirdRhoum *rhoum,int *px,int *py){
  int dx,dy,ay,sy,tx,ty;
  int flag0=0;
  dx=rhoum->right;
  dy=(rhoum->down)<<8;
  dy=-1*dy;
  sy=(*py)<<8;
  tx=rhoum->px+rhoum->right;
  ty=(rhoum->py)<<8;
  
  if(dx==0){
    /*
    std::cout<<"FIRST COORDINATE DX=0"<<std::endl;
    */
  }
  else if(dy==0){
    /*
    std::cout<<"FIRST COORDINATE DY=0"<<std::endl;
    */
  }
  else{
    ay=(dy/dx)*(*px-tx)+ty;
    if(ay>sy){
      flag0=1;
      *py=ay>>8;
    }
  }
  return flag0;
}
int BirdLand::SecondCoordinate(BirdRhoum *rhoum,int *px,int *py){
  int dx,dy,ay,sy,tx,ty;
  int flag0=0;
  dx=rhoum->left;
  dy=(rhoum->down)<<8;
  sy=(*py)<<8;
  tx=rhoum->px-rhoum->left;
  ty=(rhoum->py)<<8;
  
  if(dx==0){
    /*
    std::cout<<"SECOND COORDINATE DX=0"<<std::endl;
    */
  }
  else if(dy==0){
    /*
    std::cout<<"SECOND COORDINATE DY=0"<<std::endl;
    */
  }
  else{
    ay=(dy/dx)*(*px-tx)+ty;
    if(ay>sy){
      flag0=2;
      *py=ay>>8;
    }
  }

  return flag0;
}
int BirdLand::ThirdCoordinate(BirdRhoum *rhoum,int *px,int *py){
  int dx,dy,ay,sy,tx,ty;
  int flag0=0;
  dx=rhoum->right;
  dy=(rhoum->up)<<8;
  sy=(*py)<<8;
  tx=rhoum->px+rhoum->right;
  ty=(rhoum->py)<<8;
  
  if(dx==0){
    /*
    std::cout<<"THIRD COORDINATE DX=0"<<std::endl;
    */
  }
  else if(dy==0){
    /*
    std::cout<<"THIRD COORDINATE DY=0"<<std::endl;
    */
  }
  else{
    ay=(dy/dx)*(*px-tx)+ty;
    if(ay<sy){
      flag0=3;
      *py=ay>>8;
    }
  }

  return flag0;
}
int BirdLand::FourthCoordinate(BirdRhoum *rhoum,int *px,int *py){
  int dx,dy,ay,sy,tx,ty;
  int flag0=0;
  dx=rhoum->left;
  dy=(rhoum->up)<<8;
  dy=-1*dy;
  sy=(*py)<<8;
  tx=rhoum->px-rhoum->left;
  ty=(rhoum->py)<<8;
  
  if(dx==0){
    /*
    std::cout<<"FOURTH COORDINATE DX=0"<<std::endl;
    */
  }
  else if(dy==0){
    /*
    std::cout<<"FOURTH COORDINATE DY=0"<<std::endl;
    */
  }
  else{
    ay=(dy/dx)*(*px-tx)+ty;
    if(ay<sy){
      flag0=4;
      *py=ay>>8;
    }
  }

  return flag0;
}

int (BirdLand::*CONTACT_POINT[4])(BirdRhoum *rhoum,int *px,int *py)={
  &BirdLand::FourthCoordinate,
  &BirdLand::ThirdCoordinate,
  &BirdLand::SecondCoordinate,
  &BirdLand::FirstCoordinate
};

int BirdLand::ContactPoint(BirdRhoum *rhoum,int *px,int *py){
  int flag0=0;

  flag0=(flag0+(rhoum->py<*py))<<1;
  flag0=(flag0+(rhoum->px<*px));
  
  return (this->*CONTACT_POINT[flag0])(rhoum,px,py);
}

int (BirdLand::*CONTACT_ACT[4])(BirdRhoum *rhoum,BirdActor *act,
				int *tX,int *tY)={
  &BirdLand::ActFourthCoordinate,
  &BirdLand::ActThirdCoordinate,
  &BirdLand::ActSecondCoordinate,
  &BirdLand::ActFirstCoordinate
};

int BirdLand::ActFirstCoordinate(BirdRhoum *rhoum,BirdActor *act,
				 int *tX,int *tY){
  int flag;
  int actX,actY;

  flag=0;
  actX=act->px-(act->width/2);
  actY=act->py-(act->height/2);

  if(rhoum->px<actX){
    if(actX>(rhoum->px+rhoum->right)){
      flag=0;
    }
    else{
      flag=FirstCoordinate(rhoum,&actX,&actY);
      *tX=actX+(act->width/2);
      *tY=actY+(act->width/2);  
    }
    /*
    if(rhoum->py<actY){
      flag=FirstCoordinate(rhoum,&actX,&actY);
      *tX=actX+(act->width/2);
      *tY=actY+(act->width/2);   
    }
    else{
      if(actX>(rhoum->px+rhoum->right)){
	flag=0;
      }
      else{
	flag=1;
	*tX=act->px;
	*tY=rhoum->py+act->height/2;
      }
    }
      */
    
  }
  else{
    if(actY>(rhoum->py+rhoum->down)){
      flag=0;
    }
    else{
      flag=1;
      *tX=act->px;
      *tY=rhoum->py+rhoum->down+act->height/2;
    }
  }
  return flag;
}

int BirdLand::ActSecondCoordinate(BirdRhoum *rhoum,BirdActor *act,
				  int *tX,int *tY){
  int actX,actY;
  int flag;

  flag=0;
  actX=act->px+(act->width/2);
  actY=act->py-(act->height/2);

  if(rhoum->px>actX){
    if(actX<(rhoum->px-rhoum->left)){
      flag=0;
    }
    else{
      flag=SecondCoordinate(rhoum,&actX,&actY);
      *tX=actX-(act->width/2);
      *tY=actY+(act->height/2);
    }
    /*
    if(rhoum->py<actY){
  
      flag=SecondCoordinate(rhoum,&actX,&actY);
      *tX=actX-(act->width/2);
      *tY=actY+(act->height/2);
    }
    else{
      if(actX<(rhoum->px-rhoum->left)){
	flag=0;
      }
      else{
	flag=2;
	*tX=act->px;
	*tY=rhoum->py+act->height/2;
      }
    }
      */
    
  }
  else{
    if(actY>(rhoum->py+rhoum->down)){
      flag=0;
    }
    else{
      flag=2;
      *tX=act->px;
      *tY=rhoum->py+rhoum->down+act->height/2;
    }
  }
  return flag;
}

int BirdLand::ActThirdCoordinate(BirdRhoum *rhoum,BirdActor *act,
				 int *tX,int *tY){
  int actX,actY;
  int flag;

  flag=0;
  actX=act->px-(act->width/2);
  actY=act->py+(act->height/2);
  
  if(rhoum->px<actX){
    if(actX>(rhoum->px+rhoum->right)){
      flag=0;
    }
    else{
      flag=ThirdCoordinate(rhoum,&actX,&actY);
      *tX=actX+(act->width/2);
      *tY=actY-(act->height/2);
    }
    /*
    if(rhoum->py>actY){
    
    flag=ThirdCoordinate(rhoum,&actX,&actY);
      *tX=actX+(act->width/2);
      *tY=actY-(act->height/2);
      
    }
    else{
      if(actX>(rhoum->px+rhoum->right)){
	flag=0;
      }
      else{
	flag=3;
	*tX=act->px;
	*tY=rhoum->py-act->height/2;
      }
    }
      */
  }
  else{
    if(actY<(rhoum->py-rhoum->up)){
      flag=0;
    }
    else{
      flag=3;
      *tX=act->px;
      *tY=rhoum->py-rhoum->up-act->height/2;
    }
  }
  
  
  return flag;
}

int BirdLand::ActFourthCoordinate(BirdRhoum *rhoum,BirdActor *act,
				  int *tX,int *tY){
  int actX,actY;
  int flag;

  flag=0;
  actX=act->px+(act->width/2);
  actY=act->py+(act->height/2);
      
  if(rhoum->px>actX){
    if(actX<(rhoum->px-rhoum->left)){
      flag=0;
    }
    else{
      flag=FourthCoordinate(rhoum,&actX,&actY);
      *tX=actX-(act->width/2);
      *tY=actY-(act->height/2);
    }
    /*
    if(rhoum->py>actY){
      flag=FourthCoordinate(rhoum,&actX,&actY);
      *tX=actX-(act->width/2);
      *tY=actY-(act->height/2);  
    }
    else{
      if(actX<(rhoum->px-rhoum->left)){
	flag=0;
      }
      else{
	flag=4;
	*tX=act->px;
	*tY=rhoum->py-act->height/2;
      }
    }
    */
  }
  else{
    if(actY<(rhoum->py-rhoum->up)){
      flag=0;
    }
    else{
      flag=4;
      *tX=act->px;
      *tY=rhoum->py-rhoum->up-act->height/2;
    }
  }
      
  return flag;
}

int BirdLand::ContactActor(BirdRhoum *rhoum,BirdActor *act,
			   int *tX,int *tY){
  int flag0;
  flag0=0;

  flag0=(flag0+(rhoum->py<act->py))<<1;
  flag0=(flag0+(rhoum->px<act->px));
  
  return (this->*CONTACT_ACT[flag0])(rhoum,act,tX,tY);
}

void BirdLand::Appear(BirdRhoum *rhoum){
  Append(rhoum);
}

void BirdLand::Appear(int px,int py,
		      int left,int up,int right,int down,int color){
  BirdRhoum *rhoum;

  rhoum= new BirdRhoum();
  
  rhoum->px=px;
  rhoum->py=py;
  rhoum->up=up;
  rhoum->left=left;
  rhoum->right=right;
  rhoum->down=down;
  rhoum->color=color;
  rhoum->type=0;

  Append(rhoum);
}

int BirdLand::Animate(){
  BirdRhoum *node;
  BirdRhoum *tmp;
  //   Glib::RefPtr<Gdk::GC> gc;
  int i;
  int sX,eX,sY,eY;
  int pX,pY;
  int playerFlag=0;
  
  i=0;
  node=first;
  while(node){
    tmp=node->next;
    
    node->px+=Map->speedX;
    node->py+=Map->speedY;
    
    sX=node->px-node->left;
    eX=node->px+node->right;
    sY=node->py-node->up;
    eY=node->py+node->down;
    
    points[0].set_x(sX);
    points[0].set_y(node->py);
    points[1].set_x(node->px);
    points[1].set_y(sY);
    points[2].set_x(eX);
    points[2].set_y(node->py);
    points[3].set_x(node->px);
    points[3].set_y(eY);
    points[4].set_x(sX);
    points[4].set_y(node->py);

    if((eX>Map->minW)&&(sX<Map->maxW)){
      frame->draw_polygon
	(gcList[node->color],true,points);
    }
    else{
      Reject(node);
      delete node;
    }
    node=tmp;
    i++;
  }
  return i;
}
