#include"mainsdl.h"


MainSDL::MainSDL(){
  okKeyValue=0;
  cancelKeyValue=0;
  leftKeyValue=0;
  rightKeyValue=0;
  upKeyValue=0;
  downKeyValue=0;
  jsNum=-1;
  jsFlag=0;
  jsValue=-1;
  mainJS=NULL;
  if(SDL_Init(SDL_INIT_VIDEO|SDL_INIT_JOYSTICK)<0){
    std::cout<<"SDL_DON'T USE:"<<SDL_GetError()<<std::endl;
    initFlag=0;
  }
  else{
    std::cout<<"ACTIVATE SDL"<<std::endl;
    initFlag=1;
  }
  
  SetJoyStick(0);
}

MainSDL::~MainSDL(){
  std::cout<<"SDL QUIT..."<<std::endl;
  if(mainJS){
    SDL_JoystickClose(mainJS);
  }

  if(initFlag==1){
    SDL_Quit();
  }
}

void MainSDL::Create(int *okValue0,int *cancelValue0,int *selectValue0){
  okValue=okValue0;
  cancelValue=cancelValue0;
  selectValue=selectValue0;
}

int MainSDL::GetJSNum(){
  return SDL_NumJoysticks();
}

std::string MainSDL::GetJSName(int index0){
  std::string name;
  if(index0<SDL_NumJoysticks()){
    name=SDL_JoystickName(index0);
  }
  else{
    name="NO JOYSTICK";
  }

  return name;
}

int MainSDL::SetJoyStick(int index0){
  SDL_JoystickUpdate();
  if(mainJS!=NULL&&jsNum>=0){
    SDL_JoystickClose(mainJS);
    std::cout<<"JOYSTICK["<<jsNum<<"] CLOSE"<<"\t"<<std::endl;
    jsNum=-1;
    mainJS=NULL;
  }

  mainJS=SDL_JoystickOpen(index0);
  if(mainJS){
    std::cout<<"JOYSTICK["<<index0<<"] OPENED"<<"\t"<<std::endl;
    jsNum=index0;
    axisXKey=0;
    axisYKey=1;
    okKey=0;
    cancelKey=1;
  }
  else{
    std::cout<<"JOYSTICK["<<index0<<"] CAN'T OPEN"<<"\t"<<std::endl;
    jsNum=-1;
    return -1;
  }
  
  return 0;
}

int MainSDL::GetMainJSData(JSData *data0){
  int flag0=0;
  if(mainJS){
    data0->index=SDL_JoystickIndex(mainJS);
    data0->name=SDL_JoystickName(data0->index);
    data0->nAxis=SDL_JoystickNumAxes(mainJS);
    data0->nButton=SDL_JoystickNumButtons(mainJS);
    flag0=0;
  }
  else{
    flag0=-1;
  }

  return flag0;
}

Uint8 MainSDL::GetAxisXKey(){
  return axisXKey;
}
Uint8 MainSDL::GetAxisYKey(){
  return axisYKey;
}
Uint8 MainSDL::GetOkKey(){
  return okKey;
}
Uint8 MainSDL::GetCancelKey(){
  return cancelKey;
}

void MainSDL::SetAxisXKey(Uint8 key0){
  axisXKey=key0;
}
void MainSDL::SetAxisYKey(Uint8 key0){
  axisYKey=key0;
}
void MainSDL::SetOkKey(Uint8 key0){
  okKey=key0;
}
void MainSDL::SetCancelKey(Uint8 key0){
  cancelKey=key0;
}

void MainSDL::ChangeJSFlag(int flag0){
  jsFlag=flag0;
  jsValue=-1;
}

int MainSDL::GetJSValue(int &value0){
  value0=jsValue;

  return jsFlag;
}

void MainSDL::ReceiveEvent(){
  SDL_Event event0;
  
  while(SDL_PollEvent(&event0)){
    // std::cout<<"EVENT TYPE:"<<(int)event0.type<<std::endl;
    if(event0.type==SDL_JOYAXISMOTION){
      if(jsFlag==MAINSDL_JSFLAG_JAXIS){
	JSAxisReceive(&(event0.jaxis));
      }
      else{
	JSAxisEvent(&(event0.jaxis));
      }
    }
    else if(event0.type==SDL_JOYBUTTONDOWN){
      if(jsFlag==MAINSDL_JSFLAG_JBUTTON){
	JSButtonPressReceive(&(event0.jbutton));
      }
      else{
	JSButtonPressEvent(&(event0.jbutton));
      }
    }
    else if(event0.type==SDL_JOYBUTTONUP){
      JSButtonReleaseEvent(&(event0.jbutton));
    }
  }
}

void MainSDL::JSAxisReceive(SDL_JoyAxisEvent *jaxis0){
  if(jaxis0->value>3200||jaxis0->value<-3200){
    jsFlag=MAINSDL_JSFLAG_NO;
    jsValue=jaxis0->axis;
  }
}

void MainSDL::JSButtonPressReceive(SDL_JoyButtonEvent *jbutton0){
  jsFlag=MAINSDL_JSFLAG_NO;
  jsValue=jbutton0->button;
}

void MainSDL::JSAxisEvent(SDL_JoyAxisEvent *jaxis0){
  /*
  std::cout<<"JOYAXIS AXIS="<<(int)jaxis0->axis<<"\t"
	   <<"JOYAXIS VALUE="<<(int)jaxis0->value<<"\t";
  */
  if(jaxis0->axis==axisXKey){
    if(jaxis0->value>3200){
      if(rightKeyValue>0){
	
      }
      else{
	*(selectValue)=*(selectValue)|4;
	*(selectValue)-=*(selectValue)&1;
      }
      leftKeyValue=0;
      rightKeyValue++;
      //  std::cout<<"X RIGHT:"<<*(selectValue)<<std::endl;
    }
    else if(jaxis0->value<-3200){
      if(leftKeyValue>0){
      }
      else{
	*(selectValue)=*(selectValue)|1;
	*(selectValue)-=*(selectValue)&4;
      }
      rightKeyValue=0;
      leftKeyValue++;
      // std::cout<<"X LEFT:"<<*(selectValue)<<std::endl;
    }
    else{
      *(selectValue)-=*(selectValue)&1;
      *(selectValue)-=*(selectValue)&4;
      leftKeyValue=0;
      rightKeyValue=0;
      // std::cout<<"X NEUTRAL:"<<*selectValue<<std::endl;
    }
  }
  else if(jaxis0->axis==axisYKey){
    if(jaxis0->value>3200){
      if(downKeyValue>0){
	
      }
      else{
	*(selectValue)=*(selectValue)|8;
	*(selectValue)-=*(selectValue)&2;
      }
      upKeyValue=0;
      downKeyValue++;
      // std::cout<<"Y DOWN:"<<*(selectValue)<<std::endl;
    }
    else if(jaxis0->value<-3200){
      if(upKeyValue>0){

      }
      else{
	*(selectValue)=*(selectValue)|2;
	*(selectValue)-=*(selectValue)&8;
      }
      upKeyValue++;
      downKeyValue=0;
      //  std::cout<<"X UP:"<<*(selectValue)<<std::endl;
    }
    else{
      *(selectValue)-=*(selectValue)&2;
      *(selectValue)-=*(selectValue)&8;
      upKeyValue=0;
      downKeyValue=0;
      // std::cout<<"Y NEUTRAL:"<<*selectValue<<std::endl;
    }
  }
}

void MainSDL::JSButtonPressEvent(SDL_JoyButtonEvent *jbutton0){
  /*
  std::cout
    <<"JOYBUTTON DOWN:"<<"\t"
    <<"JOYBUTTON BUTTON="<<(int)jbutton0->button<<"\t"
    <<"JOYBUTTON STATE="<<(int)jbutton0->state<<"\t"
    <<std::endl;
  */
  if(jbutton0->button==okKey){
    if(okKeyValue>0){
      
    }
    else{
      *okValue=1;
    }
    okKeyValue++;
  }
  else if(jbutton0->button==cancelKey){
    if(cancelKeyValue>0){
      
    }
    else{
      *cancelValue=1;
    }
    cancelKeyValue++;
  }
}

void MainSDL::JSButtonReleaseEvent(SDL_JoyButtonEvent *jbutton0){
  /*
  std::cout
    <<"JOYBUTTON UP:"<<"\t"
    <<"JOYBUTTON BUTTON="<<(int)jbutton0->button<<"\t"
    <<"JOYBUTTON STATE="<<(int)jbutton0->state<<"\t"
    <<std::endl;
  */
  if(jbutton0->button==okKey){
    *okValue=0;
    okKeyValue=0;
  }
  else if(jbutton0->button==cancelKey){
    *cancelValue=0;
    cancelKeyValue=0;
  }  
}
