#include "playerfire.h"
#include "xpm/playerfire.h"

PlayerFire::PlayerFire(){
  CreateSmallPF();
  CreateBigPF();
  CreateWidePF();
  CreateLinePF();

  powHFire[PF_SMALL]=10;
  powVFire[PF_SMALL]=10;
  PF_WIDTH[PF_SMALL]=8;
  PF_HEIGHT[PF_SMALL]=8;
  PF_LIFE[PF_SMALL]=2;
  fireName[PF_SMALL]="SMALL";

  powHFire[PF_BIG]=15;
  powVFire[PF_BIG]=15;
  PF_WIDTH[PF_BIG]=16;
  PF_HEIGHT[PF_BIG]=16;
  PF_LIFE[PF_BIG]=3;
  fireName[PF_BIG]="BIG";

  powHFire[PF_WIDE]=10;
  powVFire[PF_WIDE]=30;
  PF_WIDTH[PF_WIDE]=8;
  PF_HEIGHT[PF_WIDE]=32;
  PF_LIFE[PF_WIDE]=2;
  fireName[PF_WIDE]="WIDE";

  powHFire[PF_LINE]=30;
  powVFire[PF_LINE]=10;
  PF_WIDTH[PF_LINE]=32;
  PF_HEIGHT[PF_LINE]=8;
  PF_LIFE[PF_LINE]=4;
  fireName[PF_LINE]="LINE";
}

PlayerFire::~PlayerFire(){
  delete pfireBox[PF_SMALL];
  delete pfireBox[PF_BIG];
  delete pfireBox[PF_WIDE];
  delete pfireBox[PF_LINE];
}

void PlayerFire::Create(Glib::RefPtr<Gdk::Pixmap> frame0,
			Glib::RefPtr<Gdk::GC> mGC0,
			BirdPlayer *player0,
			BirdEnemy *enemyList0,
			BirdLand *landList0,
			BirdItem *itemList0){
  player=player0;
  enemyList=enemyList0;
  landList=landList0;
  itemList=itemList0;
  frame=frame0;
  mGC=mGC0;
}

std::string PlayerFire::FireName(int type0){
  std::string name0;

  if(type0<PF_TYPE_NUM){
    name0=fireName[type0];
  }
  else{
    name0="ERROR";
  }
  return name0;
}

void PlayerFire::ContactEnemy(BirdActor *act){
  BirdActor *node;
  BirdActor *tmp;
  int enemyFlag=0;
  int flag0,i;

  i=0;
  node=enemyList->first;
  while(node){
    tmp=node->next;
    
    if((node->move!=EN_MOV_BOSS)&&(node->life>0)){
      enemyFlag=ContactRect(node,act);
      
      flag0=EnemyTouchSelect(act,node,enemyFlag);
      if(flag0==PF_TOUCH_FLAG_FIRE){
	break;
      }
      else if(flag0==PF_TOUCH_FLAG_ENEMY){
	player->score+=node->score;
	if(rand()%1000<node->drop){
	  enemyList->ItemDropSelect(node);
	}
      }
    }
    node=tmp;
    i++;
  }
}

int PlayerFire::ContactLand(BirdActor *act,int *tX,int *tY){
  BirdRhoum *node;
  BirdRhoum *tmp;
  int aX=0,aY=0;
  int flag0=0;
  
  node=landList->first;
  while(node){
    tmp=node->next;
    
    flag0=landList->ContactActor(node,act,&aX,&aY);

    if(flag0>0){
      *tX=aX;
      *tY=aY;
      break;
    }
    node=tmp;
  }
  
  return flag0;
}

int PlayerFire::ContactLand(BirdActor *act){
  BirdRhoum *node;
  BirdRhoum *tmp;
  
  int flag0=0;
  int tX=0,tY=0;

  node=landList->first;
  while(node){
    tmp=node->next;
    
    flag0=landList->ContactActor(node,act,&tX,&tY);
    
    if(flag0>0){
      break;
    }
    node=tmp;
  }
  
  return flag0;
}

int PlayerFire::CheckHomingTarget(BirdActor *act){
  int flag=0;

  if(act->life>0){
    if(act->px>0){
      if(act->px<WIDTH){
	if(act->py>0){
	  if(act->py<HEIGHT){
	    flag=1;
	    return flag;
	  }
	}
      }
    }
  }
  return flag;
}

void PlayerFire::SetHomingVariableTarget
(BirdActor *act,BirdActor *target,int flag){
  if(target!=NULL){
    if(CheckHomingTarget(target)){
      act->target=target;
      player->target=target->next;
    }
    else{
      SetHomingVariableTarget(act,target->next,flag);
      }
    
  }
  else{
    if(enemyList->first!=NULL){
      if(CheckHomingTarget(enemyList->first)){
	player->target=(enemyList->first)->next;
	act->target=enemyList->first;
      }
      else{
	if(flag==0){
	  flag=1;
	  SetHomingVariableTarget(act,(enemyList->first)->next,flag);
	}
	else{
	  player->target=NULL;
	  act->target=NULL;
	}
      }
    }
    else{
      player->target=NULL;
      act->target=NULL;
    }
  }
}

void PlayerFire::SetHomingFixedTarget
(BirdActor *act,BirdActor *target,int flag){
  if(target!=NULL){
    if(CheckHomingTarget(target)){
      act->target=target;
      player->target=target;
    }
    else{
      SetHomingFixedTarget(act,target->next,flag);
    }
   
  }
  else{
    
    if(enemyList->first!=NULL){
      if(CheckHomingTarget(enemyList->first)){
	player->target=(enemyList->first);
	act->target=enemyList->first;
      }
      else{
	if(flag==0){
	  flag=1;
	  SetHomingFixedTarget(act,(enemyList->first)->next,flag);
	}
	else{
	  player->target=NULL;
	  act->target=NULL;
	}
      }
      
    }
    else{
      player->target=NULL;
      act->target=NULL;
    }
  }
}

void PlayerFire::NoSetMove(BirdActor *act,int value){
  
}
void PlayerFire::SetHomingMove(BirdActor *act,int value){
  if(value==PF_TARGET_VARIABLE){
    SetHomingVariableTarget(act,player->target,0);
  }
  else if(value==PF_TARGET_FIXED){
    SetHomingFixedTarget(act,player->target,0);
  }
}
void PlayerFire::SetHomUnLock(BirdActor *act,int value){
  SetHomingMove(act,value);
  
  if((act->target)==NULL){
    
  }
  else{
    if(player->px<(act->target)->px){
      if(player->py<(act->target)->py){
	act->tmp=1;
	
      }
      else{
	act->tmp=3;
      }
    }
    else{
      if(player->py<(act->target)->py){
	act->tmp=2;
      }
      else{
	act->tmp=4;
      }
    }
  }
}
void (PlayerFire::*PlayerFire::PF_SETMOVE_SELECT[PF_MOV_NUM])
  (BirdActor *act,int value)={
    &PlayerFire::NoSetMove,
    &PlayerFire::NoSetMove,
    &PlayerFire::SetHomingMove,
    &PlayerFire::NoSetMove,
    &PlayerFire::SetHomingMove,
    &PlayerFire::SetHomingMove,
    &PlayerFire::SetHomUnLock,
    &PlayerFire::NoSetMove,
    &PlayerFire::NoSetMove
};

void PlayerFire::Appear(int px,int py,int mx,int my,int tx,int ty,
			int move,int touch,int form,int value){
    BirdActor *act;

  act= new BirdActor();

  act->px=px;
  act->py=py;
  act->width=PF_WIDTH[player->fire];
  act->height=PF_HEIGHT[player->fire];
  act->mx=mx;
  act->my=my;
  act->tx=tx;
  act->ty=ty;
  act->life=PF_LIFE[player->fire];
  act->style=player->fire;
  act->move=move;
  act->touch=touch;
  act->form=form;
  act->tcount=0;
  
  act->dcount=0;
  act->direct=0;
  act->seq=0;
  act->tmp=0;

  act->target=NULL;
  act->next=NULL;
  act->prev=NULL;

  (this->*PF_SETMOVE_SELECT[move])(act,value);
  
  Append(act);
}

void PlayerFire::Appear(int px,int py,int width,int height,
			int mx,int my,int life,
			int style,int move,int touch,
			int form,int tcount){
  BirdActor *act;
  act= new BirdActor();
  act->px=px;
  act->py=py;
  act->width=width;
  act->height=height;
  act->mx=mx;
  act->my=my;
  act->tx=0;
  act->ty=0;
  act->life=life;  
  act->style=style;
  act->move=move;
  act->touch=touch;
  act->form=form;
  act->tcount=tcount;
  act->dcount=0;
  act->direct=0;
  act->seq=0;

  if(move==PF_MOV_HOM){
    act->tmp=abs(mx);
    SetHomingVariableTarget(act,player->target,0);
  }
  else if(move==PF_MOV_HOM_XACCE){
    act->tmp=abs(my);
    SetHomingFixedTarget(act,player->target,0);
    if(act->target!=NULL){
      if((act->target)->px<act->px){
	act->mx*=-1;
      }
    }
  }
  else if(move==PF_MOV_HOM_XYACCE){
    act->tmp=act->mx;
    act->mx=0;
    act->my=0;
    SetHomingVariableTarget(act,player->target,0);
    if(act->target==NULL){
      act->mx=mx;
    }
  }
  else{
    act->tmp=0;
    act->target=NULL;
  }
  
  act->next=NULL;
  act->prev=NULL;
  Append(act); 
}

int PlayerFire::Animate(){
  BirdActor *node;
  BirdActor *tmp;
  SpriteBox *spriteBox0;
  int i;
  int landFlag=0;

  i=0;
  node=first;
  while(node){
    tmp=node->next;
    spriteBox0=pfireBox[node->style];

    if(node->life>0){
      // ContactEnemy(node);
      
      (this->*PLAYER_FIRE_MOVE[node->move])(node,landFlag);
    }

    if(node->life>0){
      node->seq++;
      if(node->seq>=spriteBox0->nSeq){
	node->seq=0;
      }
      spriteBox0->DrawSprite(frame,mGC,node->px,node->py,
			     node->seq+node->direct*spriteBox0->nSeq);
    }
    else{
      Reject(node);
      delete node;
      node=NULL;
    }
    node=tmp;
    i++;
  }
  return i;
}

void PlayerFire::Disparse8Way(BirdActor *act){
  Appear(act->px,act->py,
		    PF_WIDTH[act->style],
		    PF_HEIGHT[act->style],
		    10,0,PF_LIFE[act->style],
		    act->style,PF_MOV_STR,PF_TOUCH_PAIN,
		    PF_FORM_LR,0);
  Appear(act->px,act->py,
		    PF_WIDTH[act->style],
		    PF_HEIGHT[act->style],
		    -10,0,PF_LIFE[act->style],
		    act->style,PF_MOV_STR,PF_TOUCH_PAIN,
		    PF_FORM_LR,0);

  Appear(act->px,act->py,
		    PF_WIDTH[act->style],
		    PF_HEIGHT[act->style],
		    0,10,PF_LIFE[act->style],
		    act->style,PF_MOV_STR,PF_TOUCH_PAIN,
		    PF_FORM_UD,0);
  Appear(act->px,act->py,
		    PF_WIDTH[act->style],
		    PF_HEIGHT[act->style],
		    0,-10,PF_LIFE[act->style],
		    act->style,PF_MOV_STR,PF_TOUCH_PAIN,
		    PF_FORM_UD,0);

  Appear(act->px,act->py,
		    PF_WIDTH[act->style],
		    PF_HEIGHT[act->style],
		    8,8,PF_LIFE[act->style],
		    act->style,PF_MOV_STR,PF_TOUCH_PAIN,
		    PF_FORM_LR,0);
  Appear(act->px,act->py,
		    PF_WIDTH[act->style],
		    PF_HEIGHT[act->style],
		    8,-8,PF_LIFE[act->style],
		    act->style,PF_MOV_STR,PF_TOUCH_PAIN,
		    PF_FORM_LR,0);

  Appear(act->px,act->py,
		    PF_WIDTH[act->style],
		    PF_HEIGHT[act->style],
		    -8,8,PF_LIFE[act->style],
		    act->style,PF_MOV_STR,PF_TOUCH_PAIN,
		    PF_FORM_LR,0);
  Appear(act->px,act->py,
		    PF_WIDTH[act->style],
		    PF_HEIGHT[act->style],
		    -8,-8,PF_LIFE[act->style],
		    act->style,PF_MOV_STR,PF_TOUCH_PAIN,
		    PF_FORM_LR,0);
}

void PlayerFire::StraightMove(BirdActor *act,int landFlag){
 
  if(act->life>0){
    if(act->form==PF_FORM_LR){
      act->px+=act->mx*powHFire[act->style]/PF_POW_WIDTH;
      act->py+=act->my*powVFire[act->style]/PF_POW_HEIGHT;
      if(act->mx<0){
	act->direct=PF_DIRECT_L;
      }
      else{
	act->direct=PF_DIRECT_R;
      }
    }
    else if(act->form==PF_FORM_UD){
      act->px+=act->mx*powVFire[act->style]/PF_POW_WIDTH;
      act->py+=act->my*powHFire[act->style]/PF_POW_HEIGHT;
      if(act->my<0){
	act->direct=PF_DIRECT_U;
      }
      else{
	act->direct=PF_DIRECT_D;
      }
    }
  }

  if(act->px<0){
    act->dcount=0;
    act->life=0;
  }
  else if(act->px>WIDTH){
    act->dcount=0;
    act->life=0;      
  }
  if(act->py<0){
    act->dcount=0;
    act->life=0;
  }
  else if(act->py>HEIGHT){
    act->dcount=0;
    act->life=0;
  }

}
void PlayerFire::NoStrMove(BirdActor *act,int landFlag){
 
  if(act->life>0){

    if(act->form==EF_FORM_LR){
      act->px+=act->mx*powHFire[act->style]/PF_POW_WIDTH;
      act->py+=act->my*powVFire[act->style]/PF_POW_HEIGHT;
      if(act->mx<0){
	act->direct=PF_DIRECT_L;
      }
      else{
	act->direct=PF_DIRECT_R;
      }
    }
    else if(act->form==EF_FORM_UD){
      act->px+=act->mx*powVFire[act->style]/PF_POW_HEIGHT;
      act->py+=act->my*powHFire[act->style]/PF_POW_WIDTH;
      if(act->my<0){
	act->direct=PF_DIRECT_U;
      }
      else{
	act->direct=PF_DIRECT_D;
      }
    }
  }

  if(act->px<0){
    act->dcount=0;
    act->life=0;
  }
  else if(act->px>WIDTH){
    act->dcount=0;
    act->life=0;      
  }
  if(act->py<0){
    act->dcount=0;
    act->life=0;
  }
  else if(act->py>HEIGHT){
    act->dcount=0;
    act->life=0;
  }

  if(player->item==PLAYER_MODE_PASS){
    landFlag=0;
  }
  else{
    landFlag=ContactLand(act);
  }
  
  if(landFlag){
    act->life=0;
  }
}
void PlayerFire::ReverseMove(BirdActor *act,int landFlag){
  int tX,tY;

  if(act->life>0){

    if(act->form==EF_FORM_LR){
      act->px+=act->mx*powHFire[act->style]/PF_POW_WIDTH;
      act->py+=act->my*powVFire[act->style]/PF_POW_HEIGHT;
      if(act->mx<0){
	act->direct=PF_DIRECT_L;
      }
      else{
	act->direct=PF_DIRECT_R;
      }
    }
    else if(act->form==EF_FORM_UD){
      act->px+=act->mx*powVFire[act->style]/PF_POW_HEIGHT;
      act->py+=act->my*powHFire[act->style]/PF_POW_WIDTH;
      if(act->my<0){
	act->direct=PF_DIRECT_U;
      }
      else{
	act->direct=PF_DIRECT_D;
      }
    }

  }

  if(act->px<0){
    act->dcount=0;
    act->life=0;
  }
  else if(act->px>WIDTH){
    act->dcount=0;
    act->life=0;
  }
  
  if(act->py<0){
    act->py=0;
    act->my=abs(act->my);
  }
  else if(act->py>HEIGHT){
    act->py=HEIGHT;
    act->my=abs(act->my)*-1;
  }

  if(player->item==PLAYER_MODE_PASS){
    landFlag=0;
  }
  else{
    landFlag=ContactLand(act,&tX,&tY);
  }


  if(landFlag>0){
    if(act->tcount>0){
      act->tcount--;
    }
  }

  if(landFlag==1){
    if(abs(act->my*powVFire[act->style]/PF_POW_HEIGHT)>abs(tY-act->py)){
      act->py=tY;
      act->my=abs(act->my);
    }
    else{
      act->px+=abs(act->mx)*powHFire[act->style]/PF_POW_WIDTH;
      act->py+=abs(act->my)*powVFire[act->style]/PF_POW_HEIGHT;
      act->mx*=-1;
      act->my=abs(act->my);
    }
  }
  else if(landFlag==2){
    if(abs(act->my*powVFire[act->style]/PF_POW_HEIGHT)>abs(tY-act->py)){
      act->py=tY;
      act->my=abs(act->my);
    }
    else{
      act->px-=abs(act->mx)*powHFire[act->style]/PF_POW_WIDTH;
      act->py+=abs(act->my)*powVFire[act->style]/PF_POW_HEIGHT;
      act->mx*=-1;
      act->my=abs(act->my);
    }
  }
  else if(landFlag==3){
    if(abs(act->my*powVFire[act->style]/PF_POW_HEIGHT)>abs(tY-act->py)){
      act->py=tY;
      act->my=abs(act->my)*-1;
    }
    else{
      act->px+=abs(act->mx)*powHFire[act->style]/PF_POW_WIDTH;
      act->py-=abs(act->my)*powVFire[act->style]/PF_POW_HEIGHT;
      act->mx*=-1;
      act->my=abs(act->my)*-1;
    }
  }
  else if(landFlag==4){
    if(abs(act->my*powVFire[act->style]/PF_POW_HEIGHT)>abs(tY-act->py)){
      act->py=tY;
      act->my=abs(act->my)*-1;
    }
    else{
      act->px-=abs(act->mx)*powHFire[act->style]/PF_POW_WIDTH;
      act->py-=abs(act->my)*powVFire[act->style]/PF_POW_HEIGHT;
      act->mx*=-1;
      act->my=abs(act->my)*-1;
    }
  }

  if(act->tcount==0){
    act->dcount=0;
    act->life=0;
  }

}
void PlayerFire::HomingMove(BirdActor *act,int landFlag){
  int sx,sy;
  int tX,tY;

  if(act->life>0){
    if(act->target!=NULL&&(act->target)->life>0){
      sx=act->px;
      sy=act->py;
      DistApprox
	(&sx,&sy,(act->target)->px,(act->target)->py,act->tx);
      act->mx=sx;
      act->my=sy;
    }
    else{
      act->target=NULL;
      if((abs(act->mx)<act->tx)
	 &&(abs(act->my)<act->tx)){
	if(act->mx<0){
	  act->mx=act->tx*-1;
	}
	else{
	  act->mx=act->tx;
	}
      }
      act->move=PF_MOV_NOSTR;
    }
    
    if(act->form==EF_FORM_LR){
      act->px+=act->mx*powHFire[act->style]/PF_POW_WIDTH;
      act->py+=act->my*powVFire[act->style]/PF_POW_HEIGHT;
      if(act->mx<0){
	act->direct=PF_DIRECT_L;
      }
      else{
	act->direct=PF_DIRECT_R;
      }
    }
    else if(act->form==EF_FORM_UD){
      act->px+=act->mx*powVFire[act->style]/PF_POW_HEIGHT;
      act->py+=act->my*powHFire[act->style]/PF_POW_WIDTH;
      if(act->my<0){
	act->direct=PF_DIRECT_U;
      }
      else{
	act->direct=PF_DIRECT_D;
      }
    }
  }
 
  if(act->px<0){
    act->dcount=0;
    act->life=0;
  }
  else if(act->px>WIDTH){
    act->dcount=0;
    act->life=0;
  }
  
  if(act->py<0){
    act->dcount=0;
    act->life=0;
  }
  else if(act->py>HEIGHT){
    act->dcount=0;
    act->life=0;
  }
 

  if(player->item==PLAYER_MODE_PASS){
    landFlag=0;
  }
  else{
    landFlag=ContactLand(act);
  }

  if(landFlag){
    act->life=0;
  }

}
void PlayerFire::HomXAcceMove(BirdActor *act,int landFlag){
  int sx,sy;

  if(act->life>0){
    if(act->target!=NULL&&(act->target)->life>0){
      sx=act->px;
      sy=act->py;
      DistApprox
	(&sx,&sy,(act->target)->px,(act->target)->py,act->ty);
      act->my+=sy;
      
      if(abs(act->my)>act->tx){
	if(act->my>0){
	  act->my=act->tx;
	}
	else{
	  act->my=act->tx*-1;
	}
      }
    }
    else{
      act->target=NULL;
      act->move=PF_MOV_NOSTR;
    }
    
    act->px+=act->mx*powHFire[act->style]/PF_POW_WIDTH;
    act->py+=act->my*powVFire[act->style]/PF_POW_HEIGHT;
    
    if(act->mx<0){
      act->direct=PF_DIRECT_L;
    }
    else{
      act->direct=PF_DIRECT_R;
    }
  }

  if(act->px<0){
    act->dcount=0;
    act->life=0;
  }
  else if(act->px>WIDTH){
    act->dcount=0;
    act->life=0;
  }

  if(player->item==PLAYER_MODE_PASS){
    landFlag=0;
  }
  else{
    landFlag=ContactLand(act);
  }

  if(landFlag){
    act->life=0;
  }
}
void PlayerFire::HomXYAcceMove(BirdActor *act,int landFlag){
  int sx,sy;

  if(act->life>0){
    if(act->target!=NULL&&(act->target)->life>0){
      sx=act->px;
      sy=act->py;
      DistApprox
	(&sx,&sy,(act->target)->px,(act->target)->py,act->ty);
      act->mx+=sx;
      act->my+=sy;
      
      if(abs(act->mx)>act->tx){
	if(act->mx<0){
	  act->mx=act->tx*-1;
	}
	else{
	  act->mx=act->tx;
	}
      }
      if(abs(act->my)>act->tx){
	if(act->my<0){
	  act->my=act->tx*-1;	  
	}
	else{
	  act->my=act->tx;
	}
      }
    }
    else{
      if((abs(act->mx)<act->tx)
	 &&(abs(act->my)<act->tx)){
	if(act->mx<0){
	  act->mx=act->tx*-1;
	}
	else{
	  act->mx=act->tx;
	}
      }
      act->target=NULL;
      act->move=PF_MOV_NOSTR;
    }
    
    act->px+=act->mx*powHFire[act->style]/PF_POW_WIDTH;
    act->py+=act->my*powVFire[act->style]/PF_POW_HEIGHT;
    
    if(act->mx<0){
      act->direct=PF_DIRECT_L;
    }
    else{
      act->direct=PF_DIRECT_R;
    }
  }

  if(player->item==PLAYER_MODE_PASS){
    landFlag=0;
  }
  else{
    landFlag=ContactLand(act);
  }

  if(landFlag){
    act->life=0;
  }
}

void PlayerFire::AccelerateMove(BirdActor *act,int landFlag){
  int sx,sy;
  int ttx;

  if(act->life>0){
    ttx=act->tx;
    if(act->target!=NULL&&(act->target)->life>0){
      sx=act->px;
      sy=act->py;
      DistApprox
	(&sx,&sy,(act->target)->px,(act->target)->py,act->ty);
      act->mx+=sx;
      act->my+=sy;
      
      if(abs(act->mx)>act->tx){
	if(act->mx<0){
	  act->mx=act->tx*-1;
	}
	else{
	  act->mx=act->tx;
	}
      }
      else{
	
      }

      if(abs(act->my)>act->tx){
	if(act->my<0){
	  act->my=act->tx*-1;
	}
	else{
	  act->my=act->tx;
	}
      }
      else{
	
      }
      if(act->form==EF_FORM_LR){
	act->px+=act->mx*powHFire[act->style]/PF_POW_WIDTH;
	act->py+=act->my*powVFire[act->style]/PF_POW_HEIGHT;
	if(act->mx<0){
	  act->direct=PF_DIRECT_L;
	}
	else{
	  act->direct=PF_DIRECT_R;
	}
      }
      else if(act->form==EF_FORM_UD){
	act->px+=act->mx*powVFire[act->style]/PF_POW_HEIGHT;
	act->py+=act->my*powHFire[act->style]/PF_POW_WIDTH;
	if(act->my<0){
	  act->direct=PF_DIRECT_U;
	}
	else{
	  act->direct=PF_DIRECT_D;
	}
      }
      if(act->tmp==1){
	if((act->px>(act->target)->px)
	   &&(act->py>(act->target)->py)){  
	  act->move=EF_MOV_NOSTR;
	  if((abs(act->mx)<ttx)
	     &&(abs(act->my)<ttx)){
	    if(act->mx<0){
	      act->mx=ttx*-1;
	    }
	    else{
	      act->mx=ttx;
	    }
	  }
	}
      }
      else if(act->tmp==2){
	if((act->px<(act->target)->px)
	   &&(act->py>(act->target)->py)){
	  act->move=EF_MOV_NOSTR;
	  if((abs(act->mx)<ttx)
	     &&(abs(act->my)<ttx)){
	    if(act->mx<0){
	      act->mx=ttx*-1;
	    }
	    else{
	      act->mx=ttx;
	    }
	  }
	}
      }
      else if(act->tmp==3){
	if((act->px>(act->target)->px)
	   &&(act->py<(act->target)->py)){
	  act->move=EF_MOV_NOSTR;
	  if((abs(act->mx)<ttx)
	     &&(abs(act->my)<ttx)){
	    if(act->mx<0){
	      act->mx=ttx*-1;
	    }
	    else{
	      act->mx=ttx;
	    }
	  }
	}
      }
      else if(act->tmp==4){
	if((act->px<(act->target)->px)
	   &&(act->py<(act->target)->py)){
	  act->move=EF_MOV_NOSTR;
	  if((abs(act->mx)<ttx)
	     &&(abs(act->my)<ttx)){
	    if(act->mx<0){
	      act->mx=ttx*-1;
	    }
	    else{
	      act->mx=ttx;
	    }
	  }
	}
      } 
    }
    else{
      if((abs(act->mx)<ttx)
	 &&(abs(act->my)<ttx)){
	if(act->mx<0){
	  act->mx=ttx*-1;
	}
	else{
	  act->mx=ttx;
	}
      }
      act->target=NULL;
      act->move=PF_MOV_NOSTR;
    }
  }

  if(player->item==PLAYER_MODE_PASS){
    landFlag=0;
  }
  else{
    landFlag=ContactLand(act);
  }

  if(landFlag){
    act->life=0;
  }

}
void PlayerFire::DisparseMove(BirdActor *act,int landFlag){
 
  if(act->life>0){    
    if(act->form==EF_FORM_LR){
      act->px+=act->mx*powHFire[act->style]/PF_POW_WIDTH;
      act->py+=act->my*powVFire[act->style]/PF_POW_HEIGHT;
      if(act->mx<0){
	act->direct=PF_DIRECT_L;
      }
      else{
	act->direct=PF_DIRECT_R;
      }
    }
    else if(act->form==EF_FORM_UD){
      act->px+=act->mx*powVFire[act->style]/PF_POW_HEIGHT;
      act->py+=act->my*powHFire[act->style]/PF_POW_WIDTH;
      if(act->my<0){
	act->direct=PF_DIRECT_U;
      }
      else{
	act->direct=PF_DIRECT_D;
      }
    }
  }

  if(act->px<0){
    act->dcount=0;
    act->life=0;
  }
  else if(act->px>WIDTH){
    act->dcount=0;
    act->life=0;      
  }
  if(act->py<0){
    act->dcount=0;
    act->life=0;
  }
  else if(act->py>HEIGHT){
    act->dcount=0;
    act->life=0;
  }

  if(player->item==PLAYER_MODE_PASS){
    landFlag=0;
  }
  else{
    landFlag=ContactLand(act);
  }
  
  if(landFlag){
    act->life=0;
    act->dcount=0;
    Disparse8Way(act);
  }
}
void PlayerFire::GroundMove(BirdActor *act,int landFlag){
  int tX,tY;

  if(act->life>0){
    
    if(act->form==EF_FORM_LR){
      act->px+=act->mx*powHFire[act->style]/PF_POW_WIDTH;
      act->py+=act->my*powVFire[act->style]/PF_POW_HEIGHT;
      if(act->mx<0){
	act->direct=PF_DIRECT_L;
      }
      else{
	act->direct=PF_DIRECT_R;
      }
    }
    else if(act->form==EF_FORM_UD){
      act->px+=act->mx*powVFire[act->style]/PF_POW_HEIGHT;
      act->py+=act->my*powHFire[act->style]/PF_POW_WIDTH;
      if(act->my<0){
	act->direct=PF_DIRECT_U;
      }
      else{
	act->direct=PF_DIRECT_D;
      }
    }

    if(player->item==PLAYER_MODE_PASS){
      landFlag=0;
    }
    else{
      landFlag=ContactLand(act,&tX,&tY);
    }
    
    if(landFlag==1||landFlag==2){
      act->py=tY+5;
      if(act->my>0){
	act->my=act->my*2;
      }
      else{
	act->my=act->my*-1;
      }
    }
    else if(landFlag==3||landFlag==4){
      act->py=tY-2;
      act->my=act->tx*-1;
    }
    else{
      act->my+=act->ty;
    }
  }
  
  if(act->px<0){
    act->dcount=0;
    act->life=0;
  }
  else if(act->px>WIDTH){
    act->dcount=0;
    act->life=0;      
  }

  if(act->py>HEIGHT){
    act->dcount=0;
    act->life=0;
  }
}
void (PlayerFire::*PlayerFire::PLAYER_FIRE_MOVE[PF_MOV_NUM])
  (BirdActor *act,int landFlag)={
    &PlayerFire::StraightMove,
    &PlayerFire::ReverseMove,
    &PlayerFire::HomingMove,
    &PlayerFire::NoStrMove,
    &PlayerFire::HomXAcceMove,
    &PlayerFire::HomXYAcceMove,
    &PlayerFire::AccelerateMove,
    &PlayerFire::DisparseMove,
    &PlayerFire::GroundMove
  };

int PlayerFire::PainTouch(BirdActor *fire,BirdActor *enemy,
			  int enemyFlag){
  int flag0=PF_TOUCH_FLAG_FALSE;
  if(enemyFlag){
    if(enemy->life>fire->life){
      enemy->life-=fire->life;
      fire->life=0;
      enemy->dcount=ENEMY_T_DMG;
      flag0=PF_TOUCH_FLAG_FIRE;
    }
    else{
      fire->life-=enemy->life;
      enemy->life=0;
      enemy->dcount=ENEMY_T_DEAD;
      flag0=PF_TOUCH_FLAG_ENEMY;
    }
  }

  return flag0;
}
int PlayerFire::ReverseTouch(BirdActor *fire,BirdActor *enemy,
			     int enemyFlag){
  int flag0=PF_TOUCH_FLAG_FALSE;

  if(enemyFlag>0){

    fire->my*=-1;
    
    if(enemy->life>fire->life){
      enemy->life-=fire->life;
      fire->life=0;
      enemy->dcount=ENEMY_T_DMG;
      flag0=PF_TOUCH_FLAG_FIRE;
    }
    else{
      fire->life-=enemy->life;
      enemy->life=0;
      enemy->dcount=ENEMY_T_DEAD;
      flag0=PF_TOUCH_FLAG_ENEMY;
    }
  }

  return flag0;
}
int PlayerFire::HomingTouch(BirdActor *fire,BirdActor *enemy,
			    int enemyFlag){
  int sx,sy;
  int flag0=PF_TOUCH_FLAG_FALSE;

  if(enemyFlag>0){
    fire->move=PF_MOV_NOSTR;
    if((abs(fire->mx)<fire->tx)
       &&(abs(fire->my)<fire->tx)){
      if(fire->mx<0){
	fire->mx=fire->tx*-1;
      }
      else{
	fire->mx=fire->tx;
      }

    }
    
    if(enemy->life>fire->life){
      enemy->life-=fire->life;
      fire->life=0;
      enemy->dcount=ENEMY_T_DMG;
      flag0=PF_TOUCH_FLAG_FIRE;
    }
    else{
      fire->life-=enemy->life;
      enemy->life=0;
      enemy->dcount=ENEMY_T_DEAD;
      flag0=PF_TOUCH_FLAG_ENEMY;
    }
  }
  return flag0;
}
int PlayerFire::BlowTouch(BirdActor *fire,BirdActor *enemy,
			  int enemyFlag){
  int flag0=PF_TOUCH_FLAG_FALSE;

  if(enemyFlag>0){
    if(enemy->px>fire->px){
      enemy->px+=fire->width;
    }
    else{
      enemy->px-=fire->width;
    }
    if(enemy->py>fire->py){
      enemy->py+=fire->height;
    }
    else{
      enemy->py-=fire->height;
    }
    
    if(enemy->life>fire->life){
      enemy->life-=fire->life;
      fire->life=0;
      enemy->dcount=ENEMY_T_DMG;
      flag0=PF_TOUCH_FLAG_FIRE;
    }
    else{
      fire->life-=enemy->life;
      enemy->life=0;
      enemy->dcount=ENEMY_T_DEAD;
      flag0=PF_TOUCH_FLAG_ENEMY;
    }
  }

  return flag0;
}
int PlayerFire::DisparseTouch(BirdActor *fire,BirdActor *enemy,
			      int enemyFlag){
  int flag0=PF_TOUCH_FLAG_FALSE;

  if(enemyFlag>0){
    if(enemy->life>fire->life){
      enemy->life-=fire->life;
      fire->life=0;
      enemy->dcount=ENEMY_T_DMG;
      flag0=PF_TOUCH_FLAG_FIRE;

      Disparse8Way(fire);
    }
    else if(enemy->life<fire->life){
      fire->life-=enemy->life;
      enemy->life=0;
      enemy->dcount=ENEMY_T_DEAD;
      flag0=PF_TOUCH_FLAG_ENEMY;
    }
    else{
      fire->life-=enemy->life;
      enemy->life=0;
      enemy->dcount=ENEMY_T_DEAD;
      
      Disparse8Way(fire);
      flag0=PF_TOUCH_FLAG_ENEMY;
    }
  }

  return flag0;
}
int PlayerFire::GroundTouch(BirdActor *fire,BirdActor *enemy,
			    int enemyFlag){
  int flag0=PF_TOUCH_FLAG_FALSE;

  if(enemyFlag>0){
    if(enemy->life>fire->life){
      enemy->life-=fire->life;
      fire->life=0;
      enemy->dcount=ENEMY_T_DMG;
      flag0=PF_TOUCH_FLAG_FIRE;
    }
    else{
      fire->life-=enemy->life;
      enemy->life=0;
      enemy->dcount=ENEMY_T_DEAD;
      flag0=PF_TOUCH_FLAG_ENEMY;

      fire->my=fire->tx*-1/2;
    }
  }

  return flag0;
}
int (PlayerFire::*PlayerFire::PLAYER_FIRE_TOUCH[PF_TOUCH_NUM])
  (BirdActor *fire,BirdActor *enemy,int enemyFlag)={
    &PlayerFire::PainTouch,
    &PlayerFire::ReverseTouch,
    &PlayerFire::HomingTouch,
    &PlayerFire::BlowTouch,
    &PlayerFire::DisparseTouch,
    &PlayerFire::GroundTouch
  };

int PlayerFire::EnemyTouchSelect
(BirdActor *fire,BirdActor *enemy,int enemyFlag){
  int flag0;
  flag0=(this->*PLAYER_FIRE_TOUCH[fire->touch])
    (fire,enemy,enemyFlag);
  return flag0;
}

void PlayerFire::NormalItemDrop(BirdActor *act){
  int random,fireitem,formitem,modeitem;
  random=rand()%1000;
  fireitem=random%(ITEM_LINE-ITEM_BIG)+ITEM_BIG;
  formitem=random%(ITEM_CROSS-ITEM_HOM)+ITEM_CROSS;
  modeitem=random%(ITEM_PASS-ITEM_BOOST)+ITEM_BOOST;
  
  if(random<450){
    itemList->Appear(act->px,act->py,16,16,fireitem,fireitem,0);
  }
  else if(random<900){
    itemList->Appear(act->px,act->py,16,16,formitem,formitem,0);
  }
  else if(random<910){
    itemList->Appear(act->px,act->py,16,16,ITEM_HEART,ITEM_HEART,0);
  }
  else{
    itemList->Appear(act->px,act->py,16,16,modeitem,modeitem,0);
  }
}
void PlayerFire::MainWeponItemDrop(BirdActor *act){
  int random,fireitem,formitem;
  random=rand()%1000;
  fireitem=random%(3)+ITEM_BIG;
  formitem=random%(4)+ITEM_CROSS;
  
  if(random>500){
    itemList->Appear(act->px,act->py,16,16,fireitem,fireitem,0);
  }
  else{
    itemList->Appear(act->px,act->py,16,16,formitem,formitem,0);
  }
}
void (PlayerFire::*PlayerFire::PLAYER_FIRE_ITEMDROP[PF_ITEMDROP_NUM])
  (BirdActor *act)={
    &PlayerFire::NormalItemDrop,
    &PlayerFire::MainWeponItemDrop,
  };

void PlayerFire::CreateSmallPF(){
  smallPF[0].xpm=(char **)smallPF_fb1_xpm;
  smallPF[1].xpm=(char **)smallPF_fb1_xpm;
  smallPF[2].xpm=(char **)smallPF_ud1_xpm;
  smallPF[3].xpm=(char **)smallPF_ud1_xpm;
  smallPF[4].xpm=(char **)smallPF_fb1_xpm;
  smallPF[5].xpm=(char **)smallPF_fb1_xpm;
  smallPF[6].xpm=(char **)smallPF_ud1_xpm;
  smallPF[7].xpm=(char **)smallPF_ud1_xpm;
  pfireBox[PF_SMALL]= new SpriteBox(smallPF,1,8);
  pfireBox[PF_SMALL]->SetSprite();
}

void PlayerFire::CreateBigPF(){
  bigPF[0].xpm=(char **)bigPF_fb1_xpm;
  bigPF[1].xpm=(char **)bigPF_fb1_xpm;
  bigPF[2].xpm=(char **)bigPF_ud1_xpm;
  bigPF[3].xpm=(char **)bigPF_ud1_xpm;
  bigPF[4].xpm=(char **)bigPF_fb1_xpm;
  bigPF[5].xpm=(char **)bigPF_fb1_xpm;
  bigPF[6].xpm=(char **)bigPF_ud1_xpm;
  bigPF[7].xpm=(char **)bigPF_ud1_xpm;
  pfireBox[PF_BIG]= new SpriteBox(bigPF,1,8);
  pfireBox[PF_BIG]->SetSprite();
}

void PlayerFire::CreateWidePF(){
  widePF[0].xpm=(char **)widePF_f1_xpm;
  widePF[1].xpm=(char **)widePF_b1_xpm;
  widePF[2].xpm=(char **)widePF_u1_xpm;
  widePF[3].xpm=(char **)widePF_d1_xpm;
  widePF[4].xpm=(char **)widePF_f1_xpm;
  widePF[5].xpm=(char **)widePF_b1_xpm;
  widePF[6].xpm=(char **)widePF_u1_xpm;
  widePF[7].xpm=(char **)widePF_d1_xpm;
  pfireBox[PF_WIDE]= new SpriteBox(widePF,1,8);
  pfireBox[PF_WIDE]->SetSprite();
}

void PlayerFire::CreateLinePF(){
  linePF[0].xpm=(char **)linePF_fb1_xpm;
  linePF[1].xpm=(char **)linePF_fb1_xpm;
  linePF[2].xpm=(char **)linePF_ud1_xpm;
  linePF[3].xpm=(char **)linePF_ud1_xpm;
  linePF[4].xpm=(char **)linePF_fb1_xpm;
  linePF[5].xpm=(char **)linePF_fb1_xpm;
  linePF[6].xpm=(char **)linePF_ud1_xpm;
  linePF[7].xpm=(char **)linePF_ud1_xpm;
  pfireBox[PF_LINE]= new SpriteBox(linePF,1,8);
  pfireBox[PF_LINE]->SetSprite();
}
