#include "sprite.h"

SpriteBox::SpriteBox(BirdSprite *sprite0,int nSeq0,int nLength0){
  sprite=sprite0;
  nSeq=nSeq0;
  nLength=nLength0;
}

SpriteBox::~SpriteBox(){
  
}

void SpriteBox::SetSprite(){
  int i;
  i=0;
  while(i<nLength){
    (sprite+i)->pixbuf=Gdk::Pixbuf::create_from_xpm_data
      ((sprite+i)->xpm);
    (sprite+i)->width=((sprite+i)->pixbuf)->get_width();
    (sprite+i)->height=((sprite+i)->pixbuf)->get_height();

    i++;
  }
}

Glib::RefPtr<Gdk::Pixbuf> SpriteBox::SpriteScale
(char **xpm0,
 int width0,int height0){
  Glib::RefPtr<Gdk::Pixbuf> tBuf;
  Glib::RefPtr<Gdk::Pixbuf> pixBuf;
  
  tBuf=Gdk::Pixbuf::create_from_xpm_data((char **)xpm0);
  pixBuf=(tBuf)->scale_simple(width0,height0,Gdk::INTERP_TILES);

  return pixBuf;
}

void SpriteBox::SetSprite(int width0,int height0){
  int i;
  i=0;
  while(i<nLength){
    (sprite+i)->pixbuf=SpriteScale((sprite+i)->xpm,width0,height0);
    (sprite+i)->width=((sprite+i)->pixbuf)->get_width();
    (sprite+i)->height=((sprite+i)->pixbuf)->get_height();
    i++;
  }
}

void SpriteBox::DrawSprite(Glib::RefPtr<Gdk::Pixmap> frame,
			   Glib::RefPtr<Gdk::GC> gc,
			   int px,int py,int seq){
  BirdSprite *sprite0;

  sprite0=sprite+seq;

  frame->draw_pixbuf(gc,sprite0->pixbuf,0,0,
		     px-(sprite0->width/2),py-(sprite0->height/2),
		     sprite0->width,sprite0->height,
		     Gdk::RGB_DITHER_NONE,0,0);
}

void SpriteBox::DrawScale(Glib::RefPtr<Gdk::Pixmap> frame,
			  Glib::RefPtr<Gdk::GC> gc,
			  int px,int py,int seq,
			  int width,int height){
  BirdSprite *sprite0;
  Glib::RefPtr<Gdk::Pixbuf> tBuf;

  sprite0=sprite+seq;

  tBuf=(sprite0->pixbuf)->scale_simple(width,height,Gdk::INTERP_NEAREST);

  frame->draw_pixbuf(gc,tBuf,0,0,
		     px-(width/2),py-(height/2),
		     width,height,
		     Gdk::RGB_DITHER_NONE,0,0);
}
