#ifndef BIRD_STREAM_STAGE_H_
#define BIRD_STREAM_STAGE_H_

#include "basestage.h"
#include "bosssilkhat.h"
#include "bosscrowd.h"
#include "bosseagle.h"
#include "namedialog.h"

#define STREAM_STAGE_MAX 10

#define STREAM_STATE_MODESELECT 0
#define STREAM_STATE_SHIFTINIT 1
#define STREAM_STATE_SHIFTSTAGE 2
#define STREAM_STATE_PAUSE 3
#define STREAM_STATE_GAME 4
#define STREAM_STATE_BOSS 5
#define STREAM_STATE_GAMEOVER 6
#define STREAM_STATE_GAMEEND 7
#define STREAM_STATE_NUM 8

#define STREAM_BOSS_NO 0
#define STREAM_BOSS_SILKHAT 1
#define STREAM_BOSS_CROWD 2
#define STREAM_BOSS_EAGLE 3
#define STREAM_BOSS_NUM 4

#define STREAM_MODE_PX1 420
#define STREAM_MODE_PY1 500
#define STREAM_MODE_MX1 0
#define STREAM_MODE_MY1 60
#define STREAM_MODE_SX1 0
#define STREAM_MODE_SY1 0
#define STREAM_MODE_SF1 12
#define STREAM_MODE_LF1 FONT_LINE_LEFT
#define STREAM_MODE_TF1 FONT_SERIF
#define STREAM_MODE_FF1 FONT_FACE_BOLD

#define STREAM_MODE_VEASY 0
#define STREAM_MODE_EASY 1
#define STREAM_MODE_NORMAL 2
#define STREAM_MODE_HARD 3
#define STREAM_MODE_VHARD 4
#define STREAM_MODE_NUM 5

#define STREAM_VY_STATE_PAUSE 0
#define STREAM_VY_STATE_MODESELECT 1

class BirdStream{
 public:
  std::string stage[STREAM_STAGE_MAX];
  int boss[STREAM_STAGE_MAX];
  int bossMode[STREAM_STAGE_MAX];
  int nStage;
  BirdStream(){
    int i;
    i=0;
    while(i<STREAM_STAGE_MAX){
      stage[i]="";
      boss[i]=0;
      i++;
    }
    nStage=0;
  }
};

class StreamStage : public BaseStage{
 public:
  int waitCount;
  int stageNum;
  int stageMode;
  BirdStream streamList[STREAM_MODE_NUM];
  BossSilkHat *silkhat;
  BossCrowd *bossCrowd;
  BossEagle *bossEagle;
  StreamStage();
  ~StreamStage();
  void Create();

  void WriteScore();
  void SetModal();

  void ModeSelect();
  void ShiftInit();
  void ShiftStage();
  void PauseMap();
  void GameMap();

  int NoBossAction();
  int BossSilkHatAction();
  int BossCrowdAction();
  int BossEagleAction();
  static int(StreamStage::*STREAM_BOSS_SELECT[STREAM_BOSS_NUM])();
  void BossMap();
  void GameOverMap();
  void GameEndMap();
  static void(StreamStage::*STREAM_STATE_SELECT[STREAM_STATE_NUM])();

  void ViewMap();
};

#endif
