#ifndef BIRD_TEXT_H_
#define BIRD_TEXT_H_

#include <gtkmm.h>
#include <iostream>
#include <sstream>

#define FONT_CLEAN 0
#define FONT_TERMINAL 1
#define FONT_TIMES 2
#define FONT_FIXED 3
#define FONT_NEWSPAPER 4
#define FONT_SANS 5
#define FONT_SERIF 6
#define FONT_MONOSPACE 7
#define FONT_TYPE_NUM 8

#define FONT_FACE_REGULAR 0
#define FONT_FACE_BOLD 1
#define FONT_FACE_ITALIC 2
#define FONT_FACE_NUM 3

#define FONT_LINE_UPLEFT 0
#define FONT_LINE_UPCENTER 1
#define FONT_LINE_UPRIGHT 2
#define FONT_LINE_LEFT 3
#define FONT_LINE_CENTER 4
#define FONT_LINE_RIGHT 5
#define FONT_LINE_DOWNLEFT 6
#define FONT_LINE_DOWNCENTER 7
#define FONT_LINE_DOWNRIGHT 8
#define FONT_LINE_NUM 9

#define FONT_POW_WIDTH 1024
#define FONT_POW_HEIGHT 1024

class BirdText{
  typedef Glib::RefPtr< Pango::FontFamily > FFAM;
  typedef Glib::RefPtr< Pango::FontFace > FFACE;
 public:
  Glib::ustring fontName[FONT_TYPE_NUM];
  Glib::ustring fontFace[FONT_FACE_NUM];
  //  Pango::FontDescription *font;
  Glib::RefPtr<Pango::Layout> mLayout;
  Glib::RefPtr<Gdk::GC> GC;
  Glib::RefPtr<Gdk::Pixmap> frame;
  BirdText(Gtk::Widget *widget);
  ~BirdText();
  void Create(Glib::RefPtr<Gdk::Window> window0,
	      Glib::RefPtr<Gdk::Pixmap> frame0);
  void DrawLeft(Glib::ustring text,Gdk::Color color,
		  int px,int py,int size,int type);
  void DrawCenter(Glib::ustring text,Gdk::Color color,
	    int px,int py,int size,int type);
  void DrawRight(Glib::ustring text,Gdk::Color color,
		  int px,int py,int size,int type);

  void DrawUpLeft(Glib::ustring text,Gdk::Color color,
		  int px,int py,int size,int type);
  void DrawUpCenter(Glib::ustring text,Gdk::Color color,
	    int px,int py,int size,int type);
  void DrawUpRight(Glib::ustring text,Gdk::Color color,
		  int px,int py,int size,int type);

  void DrawDownLeft(Glib::ustring text,Gdk::Color color,
		  int px,int py,int size,int type);
  void DrawDownCenter(Glib::ustring text,Gdk::Color color,
	    int px,int py,int size,int type);
  void DrawDownRight(Glib::ustring text,Gdk::Color color,
		  int px,int py,int size,int type);

  void UpLeftLineSet(int *px,int *py,int width0,int height0);
  void UpCenterLineSet(int *px,int *py,int width0,int height0);
  void UpRightLineSet(int *px,int *py,int width0,int height0);
  void LeftLineSet(int *px,int *py,int width0,int height0);
  void CenterLineSet(int *px,int *py,int width0,int height0);
  void RightLineSet(int *px,int *py,int width0,int height0);
  void DownLeftLineSet(int *px,int *py,int width0,int height0);
  void DownCenterLineSet(int *px,int *py,int width0,int height0);
  void DownRightLineSet(int *px,int *py,int width0,int height0);
  static void(BirdText::*FONT_LINE_SELECT[FONT_LINE_NUM])
    (int *px,int *py,int width0,int height0);

  void DrawString(Glib::ustring text,Gdk::Color *color,
		  int &px,int &py,int line,int size,
		  int type,int face);
};

#endif
